/*
 * JsSIP v3.0.13
 * the Javascript SIP library
 * Copyright: 2012-2017 José Luis Millán <jmillan@aliax.net> (https://github.com/jmillan)
 * Homepage: http://jssip.net
 * License: MIT
 */

!function(e) {
    if ("object" == typeof exports && "undefined" != typeof module)
        module.exports = e();
    else if ("function" == typeof define && define.amd)
        define([], e);
    else {
        var t;
        t = "undefined" != typeof window
            ? window
            : "undefined" != typeof global
                ? global
                : "undefined" != typeof self
                    ? self
                    : this,
        t.JsSIP = e()
    }
}(function() {
    return function e(t, n, r) {
        function s(l, o) {
            if (!n[l]) {
                if (!t[l]) {
                    var a = "function" == typeof require && require;
                    if (!o && a)
                        return a(l, !0);
                    if (i)
                        return i(l, !0);
                    var u = new Error("Cannot find module '" + l + "'");
                    throw u.code = "MODULE_NOT_FOUND",
                    u
                }
                var c = n[l] = {
                    exports: {}
                };
                t[l][0].call(c.exports, function(e) {
                    var n = t[l][1][e];
                    return s(n
                        ? n
                        : e)
                }, c, c.exports, e, t, n, r)
            }
            return n[l].exports
        }
        for (var i = "function" == typeof require && require, l = 0; l < r.length; l++)
            s(r[l]);
        return s
    }({
        1: [
            function(e, t, n) {
                var r = e("../package.json"),
                    s = {
                        USER_AGENT: r.title + " " + r.version,
                        SIP: "sip",
                        SIPS: "sips",
                        causes: {
                            CONNECTION_ERROR: "Connection Error",
                            REQUEST_TIMEOUT: "Request Timeout",
                            SIP_FAILURE_CODE: "SIP Failure Code",
                            INTERNAL_ERROR: "Internal Error",
                            BUSY: "Busy",
                            REJECTED: "Rejected",
                            REDIRECTED: "Redirected",
                            UNAVAILABLE: "Unavailable",
                            NOT_FOUND: "Not Found",
                            ADDRESS_INCOMPLETE: "Address Incomplete",
                            INCOMPATIBLE_SDP: "Incompatible SDP",
                            MISSING_SDP: "Missing SDP",
                            AUTHENTICATION_ERROR: "Authentication Error",
                            BYE: "Terminated",
                            WEBRTC_ERROR: "WebRTC Error",
                            CANCELED: "Canceled",
                            NO_ANSWER: "No Answer",
                            EXPIRES: "Expires",
                            NO_ACK: "No ACK",
                            DIALOG_ERROR: "Dialog Error",
                            USER_DENIED_MEDIA_ACCESS: "User Denied Media Access",
                            BAD_MEDIA_DESCRIPTION: "Bad Media Description",
                            RTP_TIMEOUT: "RTP Timeout"
                        },
                        SIP_ERROR_CAUSES: {
                            REDIRECTED: [
                                300, 301, 302, 305, 380
                            ],
                            BUSY: [
                                486, 600
                            ],
                            REJECTED: [
                                403, 603
                            ],
                            NOT_FOUND: [
                                404, 604
                            ],
                            UNAVAILABLE: [
                                480, 410, 408, 430
                            ],
                            ADDRESS_INCOMPLETE: [
                                484, 424
                            ],
                            INCOMPATIBLE_SDP: [
                                488, 606
                            ],
                            AUTHENTICATION_ERROR: [401, 407]
                        },
                        ACK: "ACK",
                        BYE: "BYE",
                        CANCEL: "CANCEL",
                        INFO: "INFO",
                        INVITE: "INVITE",
                        MESSAGE: "MESSAGE",
                        NOTIFY: "NOTIFY",
                        OPTIONS: "OPTIONS",
                        REGISTER: "REGISTER",
                        REFER: "REFER",
                        UPDATE: "UPDATE",
                        SUBSCRIBE: "SUBSCRIBE",
                        REASON_PHRASE: {
                            100: "Trying",
                            180: "Ringing",
                            181: "Call Is Being Forwarded",
                            182: "Queued",
                            183: "Session Progress",
                            199: "Early Dialog Terminated",
                            200: "OK",
                            202: "Accepted",
                            204: "No Notification",
                            300: "Multiple Choices",
                            301: "Moved Permanently",
                            302: "Moved Temporarily",
                            305: "Use Proxy",
                            380: "Alternative Service",
                            400: "Bad Request",
                            401: "Unauthorized",
                            402: "Payment Required",
                            403: "Forbidden",
                            404: "Not Found",
                            405: "Method Not Allowed",
                            406: "Not Acceptable",
                            407: "Proxy Authentication Required",
                            408: "Request Timeout",
                            410: "Gone",
                            412: "Conditional Request Failed",
                            413: "Request Entity Too Large",
                            414: "Request-URI Too Long",
                            415: "Unsupported Media Type",
                            416: "Unsupported URI Scheme",
                            417: "Unknown Resource-Priority",
                            420: "Bad Extension",
                            421: "Extension Required",
                            422: "Session Interval Too Small",
                            423: "Interval Too Brief",
                            424: "Bad Location Information",
                            428: "Use Identity Header",
                            429: "Provide Referrer Identity",
                            430: "Flow Failed",
                            433: "Anonymity Disallowed",
                            436: "Bad Identity-Info",
                            437: "Unsupported Certificate",
                            438: "Invalid Identity Header",
                            439: "First Hop Lacks Outbound Support",
                            440: "Max-Breadth Exceeded",
                            469: "Bad Info Package",
                            470: "Consent Needed",
                            478: "Unresolvable Destination",
                            480: "Temporarily Unavailable",
                            481: "Call/Transaction Does Not Exist",
                            482: "Loop Detected",
                            483: "Too Many Hops",
                            484: "Address Incomplete",
                            485: "Ambiguous",
                            486: "Busy Here",
                            487: "Request Terminated",
                            488: "Not Acceptable Here",
                            489: "Bad Event",
                            491: "Request Pending",
                            493: "Undecipherable",
                            494: "Security Agreement Required",
                            500: "JsSIP Internal Error",
                            501: "Not Implemented",
                            502: "Bad Gateway",
                            503: "Service Unavailable",
                            504: "Server Time-out",
                            505: "Version Not Supported",
                            513: "Message Too Large",
                            580: "Precondition Failure",
                            600: "Busy Everywhere",
                            603: "Decline",
                            604: "Does Not Exist Anywhere",
                            606: "Not Acceptable"
                        },
                        ALLOWED_METHODS: "INVITE,ACK,CANCEL,BYE,UPDATE,MESSAGE,OPTIONS,REFER,INFO",
                        ACCEPTED_BODY_TYPES: "application/sdp, application/dtmf-relay",
                        MAX_FORWARDS: 69,
                        SESSION_EXPIRES: 90,
                        MIN_SESSION_EXPIRES: 60
                    };
                t.exports = s
            }, {
                "../package.json": 51
            }
        ],
        2: [
            function(e, t, n) {
                function r(e, t, n, r) {
                    var o;
                    return this.uac_pending_reply = !1,
                    this.uas_pending_reply = !1,
                    t.hasHeader("contact")
                        ? (r = t instanceof l.IncomingResponse
                            ? t.status_code < 200
                                ? s.STATUS_EARLY
                                : s.STATUS_CONFIRMED
                            : r || s.STATUS_CONFIRMED, o = t.parseHeader("contact"), "UAS" === n
                            ? (this.id = {
                                call_id: t.call_id,
                                local_tag: t.to_tag,
                                remote_tag: t.from_tag,
                                toString: function() {
                                    return this.call_id + this.local_tag + this.remote_tag
                                }
                            }, this.state = r, this.remote_seqnum = t.cseq, this.local_uri = t.parseHeader("to").uri, this.remote_uri = t.parseHeader("from").uri, this.remote_target = o.uri, this.route_set = t.getHeaders("record-route"))
                            : "UAC" === n && (this.id = {
                                call_id: t.call_id,
                                local_tag: t.from_tag,
                                remote_tag: t.to_tag,
                                toString: function() {
                                    return this.call_id + this.local_tag + this.remote_tag
                                }
                            }, this.state = r, this.local_seqnum = t.cseq, this.local_uri = t.parseHeader("from").uri, this.remote_uri = t.parseHeader("to").uri, this.remote_target = o.uri, this.route_set = t.getHeaders("record-route").reverse()), this.owner = e, e.ua.dialogs[this.id.toString()] = this, void i("new " + n + " dialog created with status " + (this.state === s.STATUS_EARLY
                            ? "EARLY"
                            : "CONFIRMED")))
                        : {
                            error: "unable to create a Dialog without Contact header field"
                        }
                }
                t.exports = r;
                var s = {
                    STATUS_EARLY: 1,
                    STATUS_CONFIRMED: 2
                };
                r.C = s;
                var i = e("debug")("JsSIP:Dialog"),
                    l = e("./SIPMessage"),
                    o = e("./Constants"),
                    a = e("./Transactions"),
                    u = e("./Dialog/RequestSender");
                r.prototype = {
                    update: function(e, t) {
                        this.state = s.STATUS_CONFIRMED,
                        i("dialog " + this.id.toString() + "  changed to CONFIRMED state"),
                        "UAC" === t && (this.route_set = e.getHeaders("record-route").reverse())
                    },
                    terminate: function() {
                        i("dialog " + this.id.toString() + " deleted"),
                        delete this.owner.ua.dialogs[this.id.toString()]
                    },
                    createRequest: function(e, t, n) {
                        var r,
                            s;
                        return t = t && t.slice() || [],
                        this.local_seqnum || (this.local_seqnum = Math.floor(1e4 * Math.random())),
                        r = e === o.CANCEL || e === o.ACK
                            ? this.local_seqnum
                            : this.local_seqnum += 1,
                        s = new l.OutgoingRequest(e, this.remote_target, this.owner.ua, {
                            cseq: r,
                            call_id: this.id.call_id,
                            from_uri: this.local_uri,
                            from_tag: this.id.local_tag,
                            to_uri: this.remote_uri,
                            to_tag: this.id.remote_tag,
                            route_set: this.route_set
                        }, t, n),
                        s.dialog = this,
                        s
                    },
                    checkInDialogRequest: function(e) {
                        var t = this;
                        if (this.remote_seqnum) {
                            if (e.cseq < this.remote_seqnum)
                                return e.method !== o.ACK && e.reply(500),
                                !1;
                            e.cseq > this.remote_seqnum && (this.remote_seqnum = e.cseq)
                        } else
                            this.remote_seqnum = e.cseq;
                        if (e.method === o.INVITE || e.method === o.UPDATE && e.body) {
                            if (this.uac_pending_reply === !0)
                                e.reply(491);
                            else {
                                if (this.uas_pending_reply === !0) {
                                    var n = (10 * Math.random() | 0) + 1;
                                    return e.reply(500, null, ["Retry-After:" + n]),
                                    !1
                                }
                                this.uas_pending_reply = !0,
                                e.server_transaction.on("stateChanged", function n() {
                                    this.state !== a.C.STATUS_ACCEPTED && this.state !== a.C.STATUS_COMPLETED && this.state !== a.C.STATUS_TERMINATED || (e.server_transaction.removeListener("stateChanged", n), t.uas_pending_reply = !1)
                                })
                            }
                            e.hasHeader("contact") && e.server_transaction.on("stateChanged", function() {
                                this.state === a.C.STATUS_ACCEPTED && (t.remote_target = e.parseHeader("contact").uri)
                            })
                        } else
                            e.method === o.NOTIFY && e.hasHeader("contact") && e.server_transaction.on("stateChanged", function() {
                                this.state === a.C.STATUS_COMPLETED && (t.remote_target = e.parseHeader("contact").uri)
                            });
                        return !0
                    },
                    sendRequest: function(e, t, n) {
                        n = n || {};
                        var r = n.extraHeaders && n.extraHeaders.slice() || [],
                            s = n.body || null,
                            i = this.createRequest(t, r, s),
                            l = new u(this, e, i);
                        return l.send(),
                        i
                    },
                    receiveRequest: function(e) {
                        this.checkInDialogRequest(e) && this.owner.receiveRequest(e)
                    }
                }
            }, {
                "./Constants": 1,
                "./Dialog/RequestSender": 3,
                "./SIPMessage": 19,
                "./Transactions": 22,
                debug: 35
            }
        ],
        3: [
            function(e, t, n) {
                function r(e, t, n) {
                    this.dialog = e,
                    this.applicant = t,
                    this.request = n,
                    this.reattempt = !1,
                    this.reattemptTimer = null
                }
                t.exports = r;
                var s = e("../Constants"),
                    i = e("../Transactions"),
                    l = e("../RTCSession"),
                    o = e("../RequestSender");
                r.prototype = {
                    send: function() {
                        var e = this,
                            t = new o(this, this.dialog.owner.ua);
                        t.send(),
                        (this.request.method === s.INVITE || this.request.method === s.UPDATE && this.request.body) && t.clientTransaction.state !== i.C.STATUS_TERMINATED && (this.dialog.uac_pending_reply = !0, t.clientTransaction.on("stateChanged", function n() {
                            this.state !== i.C.STATUS_ACCEPTED && this.state !== i.C.STATUS_COMPLETED && this.state !== i.C.STATUS_TERMINATED || (t.clientTransaction.removeListener("stateChanged", n), e.dialog.uac_pending_reply = !1)
                        }))
                    },
                    onRequestTimeout: function() {
                        this.applicant.onRequestTimeout()
                    },
                    onTransportError: function() {
                        this.applicant.onTransportError()
                    },
                    receiveResponse: function(e) {
                        var t = this;
                        408 === e.status_code || 481 === e.status_code
                            ? this.applicant.onDialogError(e)
                            : e.method === s.INVITE && 491 === e.status_code
                                ? this.reattempt
                                    ? this.applicant.receiveResponse(e)
                                    : (this.request.cseq.value = this.dialog.local_seqnum += 1, this.reattemptTimer = setTimeout(function() {
                                        t.applicant.owner.status !== l.C.STATUS_TERMINATED && (t.reattempt = !0, t.request_sender.send())
                                    }, 1e3))
                                : this.applicant.receiveResponse(e)
                    }
                }
            }, {
                "../Constants": 1,
                "../RTCSession": 11,
                "../RequestSender": 18,
                "../Transactions": 22
            }
        ],
        4: [
            function(e, t, n) {
                function r(e) {
                    this.credentials = e,
                    this.cnonce = null,
                    this.nc = 0,
                    this.ncHex = "00000000",
                    this.algorithm = null,
                    this.realm = null,
                    this.nonce = null,
                    this.opaque = null,
                    this.stale = null,
                    this.qop = null,
                    this.method = null,
                    this.uri = null,
                    this.ha1 = null,
                    this.response = null
                }
                t.exports = r;
                var s = e("debug")("JsSIP:DigestAuthentication"),
                    i = e("debug")("JsSIP:ERROR:DigestAuthentication");
                i.log = console.warn.bind(console);
                var l = e("./Utils");
                r.prototype.get = function(e) {
                    switch (e) {
                        case "realm":
                            return this.realm;
                        case "ha1":
                            return this.ha1;
                        default:
                            return void i('get() | cannot get "%s" parameter', e)
                    }
                },
                r.prototype.authenticate = function(e, t) {
                    var n,
                        r;
                    if (this.algorithm = t.algorithm, this.realm = t.realm, this.nonce = t.nonce, this.opaque = t.opaque, this.stale = t.stale, this.algorithm) {
                        if ("MD5" !== this.algorithm)
                            return i('authenticate() | challenge with Digest algorithm different than "MD5", authentication aborted'),
                            !1
                    } else
                        this.algorithm = "MD5";
                    if (!this.nonce)
                        return i("authenticate() | challenge without Digest nonce, authentication aborted"),
                        !1;
                    if (!this.realm)
                        return i("authenticate() | challenge without Digest realm, authentication aborted"),
                        !1;
                    if (!this.credentials.password) {
                        if (!this.credentials.ha1)
                            return i("authenticate() | no plain SIP password nor ha1 provided, authentication aborted"),
                            !1;
                        if (this.credentials.realm !== this.realm)
                            return i('authenticate() | no plain SIP password, and stored `realm` does not match the given `realm`, cannot authenticate [stored:"%s", given:"%s"]', this.credentials.realm, this.realm),
                            !1
                    }
                    if (t.qop)
                        if (t.qop.indexOf("auth") > -1)
                            this.qop = "auth";
                        else {
                            if (!(t.qop.indexOf("auth-int") > -1))
                                return i('authenticate() | challenge without Digest qop different than "auth" or "auth-int", authentication aborted'),
                                !1;
                            this.qop = "auth-int"
                        } else
                            this.qop = null;
                return this.method = e.method,
                    this.uri = e.ruri,
                    this.cnonce = l.createRandomToken(12),
                    this.nc += 1,
                    r = Number(this.nc).toString(16),
                    this.ncHex = "00000000".substr(0, 8 - r.length) + r,
                    4294967296 === this.nc && (this.nc = 1, this.ncHex = "00000001"),
                    this.credentials.password
                        ? this.ha1 = l.calculateMD5(this.credentials.username + ":" + this.realm + ":" + this.credentials.password)
                        : this.ha1 = this.credentials.ha1,
                    "auth" === this.qop
                        ? (n = l.calculateMD5(this.method + ":" + this.uri), this.response = l.calculateMD5(this.ha1 + ":" + this.nonce + ":" + this.ncHex + ":" + this.cnonce + ":auth:" + n))
                        : "auth-int" === this.qop
                            ? (n = l.calculateMD5(this.method + ":" + this.uri + ":" + l.calculateMD5(this.body
                                ? this.body
                                : "")), this.response = l.calculateMD5(this.ha1 + ":" + this.nonce + ":" + this.ncHex + ":" + this.cnonce + ":auth-int:" + n))
                            : null === this.qop && (n = l.calculateMD5(this.method + ":" + this.uri), this.response = l.calculateMD5(this.ha1 + ":" + this.nonce + ":" + n)),
                    s("authenticate() | response generated"),
                    !0
                },
                r.prototype.toString = function() {
                    var e = [];
                    if (!this.response)
                        throw new Error("response field does not exist, cannot generate Authorization header");
                    return e.push("algorithm=" + this.algorithm),
                    e.push('username="' + this.credentials.username + '"'),
                    e.push('realm="' + this.realm + '"'),
                    e.push('nonce="' + this.nonce + '"'),
                    e.push('uri="' + this.uri + '"'),
                    e.push('response="' + this.response + '"'),
                    this.opaque && e.push('opaque="' + this.opaque + '"'),
                    this.qop && (e.push("qop=" + this.qop), e.push('cnonce="' + this.cnonce + '"'), e.push("nc=" + this.ncHex)),
                    "Digest " + e.join(", ")
                }
            }, {
                "./Utils": 26,
                debug: 35
            }
        ],
        5: [
            function(e, t, n) {
                var r = {
                    ConfigurationError: function() {
                        var e = function(e, t) {
                            this.code = 1,
                            this.name = "CONFIGURATION_ERROR",
                            this.parameter = e,
                            this.value = t,
                            this.message = this.value
                                ? "Invalid value " + JSON.stringify(this.value) + ' for parameter "' + this.parameter + '"'
                                : "Missing parameter: " + this.parameter
                        };
                        return e.prototype = new Error,
                        e
                    }(),
                    InvalidStateError: function() {
                        var e = function(e) {
                            this.code = 2,
                            this.name = "INVALID_STATE_ERROR",
                            this.status = e,
                            this.message = "Invalid status: " + e
                        };
                        return e.prototype = new Error,
                        e
                    }(),
                    NotSupportedError: function() {
                        var e = function(e) {
                            this.code = 3,
                            this.name = "NOT_SUPPORTED_ERROR",
                            this.message = e
                        };
                        return e.prototype = new Error,
                        e
                    }(),
                    NotReadyError: function() {
                        var e = function(e) {
                            this.code = 4,
                            this.name = "NOT_READY_ERROR",
                            this.message = e
                        };
                        return e.prototype = new Error,
                        e
                    }()
                };
                t.exports = r
            }, {}
        ],
        6: [
            function(e, t, n) {
                t.exports = function() {
                    function t(e) {
                        return '"' + e.replace(/\\/g, "\\\\").replace(/"/g, '\\"').replace(/\x08/g, "\\b").replace(/\t/g, "\\t").replace(/\n/g, "\\n").replace(/\f/g, "\\f").replace(/\r/g, "\\r").replace(/[\x00-\x07\x0B\x0E-\x1F\x80-\uFFFF]/g, escape) + '"'
                    }
                    var n = {
                        parse: function(n, r) {
                            function s(e) {
                                Tr < Cr || (Tr > Cr && (Cr = Tr, Sr = []), Sr.push(e))
                            }
                            function i() {
                                var e;
                                return "\r\n" === n.substr(Tr, 2)
                                    ? (e = "\r\n", Tr += 2)
                                    : (e = null, 0 === _r && s('"\\r\\n"')),
                                e
                            }
                            function l() {
                                var e;
                                return /^[0-9]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[0-9]")),
                                e
                            }
                            function o() {
                                var e;
                                return /^[a-zA-Z]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[a-zA-Z]")),
                                e
                            }
                            function a() {
                                var e;
                                return /^[0-9a-fA-F]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[0-9a-fA-F]")),
                                e
                            }
                            function u() {
                                var e;
                                return e = h(),
                                null === e && (e = p()),
                                e
                            }
                            function c() {
                                var e;
                                return /^[\0-\xFF]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[\\0-\\xFF]")),
                                e
                            }
                            function d() {
                                var e;
                                return /^["]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s('["]')),
                                e
                            }
                            function h() {
                                var e;
                                return 32 === n.charCodeAt(Tr)
                                    ? (e = " ", Tr++)
                                    : (e = null, 0 === _r && s('" "')),
                                e
                            }
                            function p() {
                                var e;
                                return 9 === n.charCodeAt(Tr)
                                    ? (e = "\t", Tr++)
                                    : (e = null, 0 === _r && s('"\\t"')),
                                e
                            }
                            function f() {
                                var e;
                                return /^[a-zA-Z0-9]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[a-zA-Z0-9]")),
                                e
                            }
                            function m() {
                                var e;
                                return 59 === n.charCodeAt(Tr)
                                    ? (e = ";", Tr++)
                                    : (e = null, 0 === _r && s('";"')),
                                null === e && (47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"')), null === e && (63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (64 === n.charCodeAt(Tr)
                                    ? (e = "@", Tr++)
                                    : (e = null, 0 === _r && s('"@"')), null === e && (38 === n.charCodeAt(Tr)
                                    ? (e = "&", Tr++)
                                    : (e = null, 0 === _r && s('"&"')), null === e && (61 === n.charCodeAt(Tr)
                                    ? (e = "=", Tr++)
                                    : (e = null, 0 === _r && s('"="')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')), null === e && (44 === n.charCodeAt(Tr)
                                    ? (e = ",", Tr++)
                                    : (e = null, 0 === _r && s('","'))))))))))),
                                e
                            }
                            function g() {
                                var e;
                                return e = f(),
                                null === e && (e = v()),
                                e
                            }
                            function v() {
                                var e;
                                return 45 === n.charCodeAt(Tr)
                                    ? (e = "-", Tr++)
                                    : (e = null, 0 === _r && s('"-"')),
                                null === e && (95 === n.charCodeAt(Tr)
                                    ? (e = "_", Tr++)
                                    : (e = null, 0 === _r && s('"_"')), null === e && (46 === n.charCodeAt(Tr)
                                    ? (e = ".", Tr++)
                                    : (e = null, 0 === _r && s('"."')), null === e && (33 === n.charCodeAt(Tr)
                                    ? (e = "!", Tr++)
                                    : (e = null, 0 === _r && s('"!"')), null === e && (126 === n.charCodeAt(Tr)
                                    ? (e = "~", Tr++)
                                    : (e = null, 0 === _r && s('"~"')), null === e && (42 === n.charCodeAt(Tr)
                                    ? (e = "*", Tr++)
                                    : (e = null, 0 === _r && s('"*"')), null === e && (39 === n.charCodeAt(Tr)
                                    ? (e = "'", Tr++)
                                    : (e = null, 0 === _r && s('"\'"')), null === e && (40 === n.charCodeAt(Tr)
                                    ? (e = "(", Tr++)
                                    : (e = null, 0 === _r && s('"("')), null === e && (41 === n.charCodeAt(Tr)
                                    ? (e = ")", Tr++)
                                    : (e = null, 0 === _r && s('")"')))))))))),
                                e
                            }
                            function T() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                37 === n.charCodeAt(Tr)
                                    ? (e = "%", Tr++)
                                    : (e = null, 0 === _r && s('"%"')),
                                null !== e
                                    ? (t = a(), null !== t
                                        ? (r = a(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    return t.join("")
                                }(i, e)),
                                null === e && (Tr = i),
                                e
                            }
                            function _() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    l;
                                for (r = Tr, s = Tr, l = Tr, e = [], t = u(); null !== t;)
                                    e.push(t),
                                    t = u();
                                if (null !== e
                                    ? (t = i(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l), e = null !== e
                                    ? e
                                    : "", null !== e) {
                                    if (n = u(), null !== n)
                                        for (t = []; null !== n;)
                                            t.push(n),
                                            n = u();
                                else
                                        t = null;
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return null !== e && (e = function(e) {
                                    return " "
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function C() {
                                var e;
                                return e = _(),
                                e = null !== e
                                    ? e
                                    : ""
                            }
                            function S() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                for (i = Tr, l = Tr, e = [], t = h(), null === t && (t = p()); null !== t;)
                                    e.push(t),
                                    t = h(),
                                    null === t && (t = p());
                                return null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return ":"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function E() {
                                var e,
                                    t,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o;
                                if (i = Tr, l = Tr, t = y(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = y();
                            else
                                    e = null;
                                if (null !== e) {
                                    for (t = [], o = Tr, r = [], s = _(); null !== s;)
                                        r.push(s),
                                        s = _();
                                    for (null !== r
                                        ? (s = y(), null !== s
                                            ? r = [r, s]
                                            : (r = null, Tr = o))
                                        : (r = null, Tr = o); null !== r;) {
                                        for (t.push(r), o = Tr, r = [], s = _(); null !== s;)
                                            r.push(s),
                                            s = _();
                                        null !== r
                                            ? (s = y(), null !== s
                                                ? r = [r, s]
                                                : (r = null, Tr = o))
                                            : (r = null, Tr = o)
                                    }
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l)
                                } else
                                    e = null,
                                    Tr = l;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function y() {
                                var e;
                                return /^[!-~]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[!-~]")),
                                null === e && (e = A()),
                                e
                            }
                            function A() {
                                var e;
                                return /^[\x80-\uFFFF]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[\\x80-\\uFFFF]")),
                                e
                            }
                            function R() {
                                var e;
                                return /^[\x80-\xBF]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[\\x80-\\xBF]")),
                                e
                            }
                            function w() {
                                var e;
                                return e = l(),
                                null === e && (/^[a-f]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[a-f]"))),
                                e
                            }
                            function b() {
                                var e,
                                    t,
                                    r;
                                if (r = Tr, t = f(), null === t && (45 === n.charCodeAt(Tr)
                                    ? (t = "-", Tr++)
                                    : (t = null, 0 === _r && s('"-"')), null === t && (46 === n.charCodeAt(Tr)
                                    ? (t = ".", Tr++)
                                    : (t = null, 0 === _r && s('"."')), null === t && (33 === n.charCodeAt(Tr)
                                    ? (t = "!", Tr++)
                                    : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                    ? (t = "%", Tr++)
                                    : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                    ? (t = "*", Tr++)
                                    : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                    ? (t = "_", Tr++)
                                    : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                    ? (t = "+", Tr++)
                                    : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                    ? (t = "`", Tr++)
                                    : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                    ? (t = "'", Tr++)
                                    : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                    ? (t = "~", Tr++)
                                    : (t = null, 0 === _r && s('"~"')))))))))))), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = f(),
                                        null === t && (45 === n.charCodeAt(Tr)
                                            ? (t = "-", Tr++)
                                            : (t = null, 0 === _r && s('"-"')), null === t && (46 === n.charCodeAt(Tr)
                                            ? (t = ".", Tr++)
                                            : (t = null, 0 === _r && s('"."')), null === t && (33 === n.charCodeAt(Tr)
                                            ? (t = "!", Tr++)
                                            : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                            ? (t = "%", Tr++)
                                            : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                            ? (t = "*", Tr++)
                                            : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                            ? (t = "_", Tr++)
                                            : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                            ? (t = "+", Tr++)
                                            : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                            ? (t = "`", Tr++)
                                            : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                            ? (t = "'", Tr++)
                                            : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                            ? (t = "~", Tr++)
                                            : (t = null, 0 === _r && s('"~"'))))))))))));
                                else
                                    e = null;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr, e)
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function I() {
                                var e,
                                    t,
                                    r;
                                if (r = Tr, t = f(), null === t && (45 === n.charCodeAt(Tr)
                                    ? (t = "-", Tr++)
                                    : (t = null, 0 === _r && s('"-"')), null === t && (33 === n.charCodeAt(Tr)
                                    ? (t = "!", Tr++)
                                    : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                    ? (t = "%", Tr++)
                                    : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                    ? (t = "*", Tr++)
                                    : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                    ? (t = "_", Tr++)
                                    : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                    ? (t = "+", Tr++)
                                    : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                    ? (t = "`", Tr++)
                                    : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                    ? (t = "'", Tr++)
                                    : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                    ? (t = "~", Tr++)
                                    : (t = null, 0 === _r && s('"~"'))))))))))), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = f(),
                                        null === t && (45 === n.charCodeAt(Tr)
                                            ? (t = "-", Tr++)
                                            : (t = null, 0 === _r && s('"-"')), null === t && (33 === n.charCodeAt(Tr)
                                            ? (t = "!", Tr++)
                                            : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                            ? (t = "%", Tr++)
                                            : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                            ? (t = "*", Tr++)
                                            : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                            ? (t = "_", Tr++)
                                            : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                            ? (t = "+", Tr++)
                                            : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                            ? (t = "`", Tr++)
                                            : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                            ? (t = "'", Tr++)
                                            : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                            ? (t = "~", Tr++)
                                            : (t = null, 0 === _r && s('"~"')))))))))));
                                else
                                    e = null;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr, e)
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function N() {
                                var e;
                                return 40 === n.charCodeAt(Tr)
                                    ? (e = "(", Tr++)
                                    : (e = null, 0 === _r && s('"("')),
                                null === e && (41 === n.charCodeAt(Tr)
                                    ? (e = ")", Tr++)
                                    : (e = null, 0 === _r && s('")"')), null === e && (60 === n.charCodeAt(Tr)
                                    ? (e = "<", Tr++)
                                    : (e = null, 0 === _r && s('"<"')), null === e && (62 === n.charCodeAt(Tr)
                                    ? (e = ">", Tr++)
                                    : (e = null, 0 === _r && s('">"')), null === e && (64 === n.charCodeAt(Tr)
                                    ? (e = "@", Tr++)
                                    : (e = null, 0 === _r && s('"@"')), null === e && (44 === n.charCodeAt(Tr)
                                    ? (e = ",", Tr++)
                                    : (e = null, 0 === _r && s('","')), null === e && (59 === n.charCodeAt(Tr)
                                    ? (e = ";", Tr++)
                                    : (e = null, 0 === _r && s('";"')), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (92 === n.charCodeAt(Tr)
                                    ? (e = "\\", Tr++)
                                    : (e = null, 0 === _r && s('"\\\\"')), null === e && (e = d(), null === e && (47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"')), null === e && (91 === n.charCodeAt(Tr)
                                    ? (e = "[", Tr++)
                                    : (e = null, 0 === _r && s('"["')), null === e && (93 === n.charCodeAt(Tr)
                                    ? (e = "]", Tr++)
                                    : (e = null, 0 === _r && s('"]"')), null === e && (63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null === e && (61 === n.charCodeAt(Tr)
                                    ? (e = "=", Tr++)
                                    : (e = null, 0 === _r && s('"="')), null === e && (123 === n.charCodeAt(Tr)
                                    ? (e = "{", Tr++)
                                    : (e = null, 0 === _r && s('"{"')), null === e && (125 === n.charCodeAt(Tr)
                                    ? (e = "}", Tr++)
                                    : (e = null, 0 === _r && s('"}"')), null === e && (e = h(), null === e && (e = p())))))))))))))))))),
                                e
                            }
                            function O() {
                                var e,
                                    t,
                                    r;
                                if (r = Tr, t = f(), null === t && (45 === n.charCodeAt(Tr)
                                    ? (t = "-", Tr++)
                                    : (t = null, 0 === _r && s('"-"')), null === t && (46 === n.charCodeAt(Tr)
                                    ? (t = ".", Tr++)
                                    : (t = null, 0 === _r && s('"."')), null === t && (33 === n.charCodeAt(Tr)
                                    ? (t = "!", Tr++)
                                    : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                    ? (t = "%", Tr++)
                                    : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                    ? (t = "*", Tr++)
                                    : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                    ? (t = "_", Tr++)
                                    : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                    ? (t = "+", Tr++)
                                    : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                    ? (t = "`", Tr++)
                                    : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                    ? (t = "'", Tr++)
                                    : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                    ? (t = "~", Tr++)
                                    : (t = null, 0 === _r && s('"~"')), null === t && (40 === n.charCodeAt(Tr)
                                    ? (t = "(", Tr++)
                                    : (t = null, 0 === _r && s('"("')), null === t && (41 === n.charCodeAt(Tr)
                                    ? (t = ")", Tr++)
                                    : (t = null, 0 === _r && s('")"')), null === t && (60 === n.charCodeAt(Tr)
                                    ? (t = "<", Tr++)
                                    : (t = null, 0 === _r && s('"<"')), null === t && (62 === n.charCodeAt(Tr)
                                    ? (t = ">", Tr++)
                                    : (t = null, 0 === _r && s('">"')), null === t && (58 === n.charCodeAt(Tr)
                                    ? (t = ":", Tr++)
                                    : (t = null, 0 === _r && s('":"')), null === t && (92 === n.charCodeAt(Tr)
                                    ? (t = "\\", Tr++)
                                    : (t = null, 0 === _r && s('"\\\\"')), null === t && (t = d(), null === t && (47 === n.charCodeAt(Tr)
                                    ? (t = "/", Tr++)
                                    : (t = null, 0 === _r && s('"/"')), null === t && (91 === n.charCodeAt(Tr)
                                    ? (t = "[", Tr++)
                                    : (t = null, 0 === _r && s('"["')), null === t && (93 === n.charCodeAt(Tr)
                                    ? (t = "]", Tr++)
                                    : (t = null, 0 === _r && s('"]"')), null === t && (63 === n.charCodeAt(Tr)
                                    ? (t = "?", Tr++)
                                    : (t = null, 0 === _r && s('"?"')), null === t && (123 === n.charCodeAt(Tr)
                                    ? (t = "{", Tr++)
                                    : (t = null, 0 === _r && s('"{"')), null === t && (125 === n.charCodeAt(Tr)
                                    ? (t = "}", Tr++)
                                    : (t = null, 0 === _r && s('"}"'))))))))))))))))))))))))), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = f(),
                                        null === t && (45 === n.charCodeAt(Tr)
                                            ? (t = "-", Tr++)
                                            : (t = null, 0 === _r && s('"-"')), null === t && (46 === n.charCodeAt(Tr)
                                            ? (t = ".", Tr++)
                                            : (t = null, 0 === _r && s('"."')), null === t && (33 === n.charCodeAt(Tr)
                                            ? (t = "!", Tr++)
                                            : (t = null, 0 === _r && s('"!"')), null === t && (37 === n.charCodeAt(Tr)
                                            ? (t = "%", Tr++)
                                            : (t = null, 0 === _r && s('"%"')), null === t && (42 === n.charCodeAt(Tr)
                                            ? (t = "*", Tr++)
                                            : (t = null, 0 === _r && s('"*"')), null === t && (95 === n.charCodeAt(Tr)
                                            ? (t = "_", Tr++)
                                            : (t = null, 0 === _r && s('"_"')), null === t && (43 === n.charCodeAt(Tr)
                                            ? (t = "+", Tr++)
                                            : (t = null, 0 === _r && s('"+"')), null === t && (96 === n.charCodeAt(Tr)
                                            ? (t = "`", Tr++)
                                            : (t = null, 0 === _r && s('"`"')), null === t && (39 === n.charCodeAt(Tr)
                                            ? (t = "'", Tr++)
                                            : (t = null, 0 === _r && s('"\'"')), null === t && (126 === n.charCodeAt(Tr)
                                            ? (t = "~", Tr++)
                                            : (t = null, 0 === _r && s('"~"')), null === t && (40 === n.charCodeAt(Tr)
                                            ? (t = "(", Tr++)
                                            : (t = null, 0 === _r && s('"("')), null === t && (41 === n.charCodeAt(Tr)
                                            ? (t = ")", Tr++)
                                            : (t = null, 0 === _r && s('")"')), null === t && (60 === n.charCodeAt(Tr)
                                            ? (t = "<", Tr++)
                                            : (t = null, 0 === _r && s('"<"')), null === t && (62 === n.charCodeAt(Tr)
                                            ? (t = ">", Tr++)
                                            : (t = null, 0 === _r && s('">"')), null === t && (58 === n.charCodeAt(Tr)
                                            ? (t = ":", Tr++)
                                            : (t = null, 0 === _r && s('":"')), null === t && (92 === n.charCodeAt(Tr)
                                            ? (t = "\\", Tr++)
                                            : (t = null, 0 === _r && s('"\\\\"')), null === t && (t = d(), null === t && (47 === n.charCodeAt(Tr)
                                            ? (t = "/", Tr++)
                                            : (t = null, 0 === _r && s('"/"')), null === t && (91 === n.charCodeAt(Tr)
                                            ? (t = "[", Tr++)
                                            : (t = null, 0 === _r && s('"["')), null === t && (93 === n.charCodeAt(Tr)
                                            ? (t = "]", Tr++)
                                            : (t = null, 0 === _r && s('"]"')), null === t && (63 === n.charCodeAt(Tr)
                                            ? (t = "?", Tr++)
                                            : (t = null, 0 === _r && s('"?"')), null === t && (123 === n.charCodeAt(Tr)
                                            ? (t = "{", Tr++)
                                            : (t = null, 0 === _r && s('"{"')), null === t && (125 === n.charCodeAt(Tr)
                                            ? (t = "}", Tr++)
                                            : (t = null, 0 === _r && s('"}"')))))))))))))))))))))))));
                                else
                                    e = null;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr, e)
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function x() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (42 === n.charCodeAt(Tr)
                                        ? (t = "*", Tr++)
                                        : (t = null, 0 === _r && s('"*"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return "*"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function D() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (47 === n.charCodeAt(Tr)
                                        ? (t = "/", Tr++)
                                        : (t = null, 0 === _r && s('"/"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return "/"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function P() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (61 === n.charCodeAt(Tr)
                                        ? (t = "=", Tr++)
                                        : (t = null, 0 === _r && s('"="')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return "="
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function U() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (40 === n.charCodeAt(Tr)
                                        ? (t = "(", Tr++)
                                        : (t = null, 0 === _r && s('"("')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return "("
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function M() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (41 === n.charCodeAt(Tr)
                                        ? (t = ")", Tr++)
                                        : (t = null, 0 === _r && s('")"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return ")"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function k() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                62 === n.charCodeAt(Tr)
                                    ? (e = ">", Tr++)
                                    : (e = null, 0 === _r && s('">"')),
                                null !== e
                                    ? (t = C(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e) {
                                    return ">"
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function L() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                e = C(),
                                null !== e
                                    ? (60 === n.charCodeAt(Tr)
                                        ? (t = "<", Tr++)
                                        : (t = null, 0 === _r && s('"<"')), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e) {
                                    return "<"
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function q() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (44 === n.charCodeAt(Tr)
                                        ? (t = ",", Tr++)
                                        : (t = null, 0 === _r && s('","')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return ","
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function H() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (59 === n.charCodeAt(Tr)
                                        ? (t = ";", Tr++)
                                        : (t = null, 0 === _r && s('";"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return ";"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function F() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = C(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = C(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return ":"
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function G() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return n = Tr,
                                r = Tr,
                                e = C(),
                                null !== e
                                    ? (t = d(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                null !== e && (e = function(e) {
                                    return '"'
                                }(n)),
                                null === e && (Tr = n),
                                e
                            }
                            function j() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return n = Tr,
                                r = Tr,
                                e = d(),
                                null !== e
                                    ? (t = C(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                null !== e && (e = function(e) {
                                    return '"'
                                }(n)),
                                null === e && (Tr = n),
                                e
                            }
                            function B() {
                                var e,
                                    t,
                                    n,
                                    r;
                                if (r = Tr, e = U(), null !== e) {
                                    for (t = [], n = V(), null === n && (n = K(), null === n && (n = B())); null !== n;)
                                        t.push(n),
                                        n = V(),
                                        null === n && (n = K(), null === n && (n = B()));
                                    null !== t
                                        ? (n = M(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r)
                                } else
                                    e = null,
                                    Tr = r;
                                return e
                            }
                            function V() {
                                var e;
                                return /^[!-']/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[!-']")),
                                null === e && (/^[*-[]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[*-[]")), null === e && (/^[\]-~]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[\\]-~]")), null === e && (e = A(), null === e && (e = _())))),
                                e
                            }
                            function W() {
                                var e,
                                    t,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (i = Tr, l = Tr, e = C(), null !== e)
                                    if (t = d(), null !== t) {
                                        for (r = [], s = z(), null === s && (s = K()); null !== s;)
                                            r.push(s),
                                            s = z(),
                                            null === s && (s = K());
                                        null !== r
                                            ? (s = d(), null !== s
                                                ? e = [e, t, r, s]
                                                : (e = null, Tr = l))
                                            : (e = null, Tr = l)
                                    } else
                                        e = null,
                                        Tr = l;
                            else
                                    e = null,
                                    Tr = l;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function J() {
                                var e,
                                    t,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (i = Tr, l = Tr, e = C(), null !== e)
                                    if (t = d(), null !== t) {
                                        for (r = [], s = z(), null === s && (s = K()); null !== s;)
                                            r.push(s),
                                            s = z(),
                                            null === s && (s = K());
                                        null !== r
                                            ? (s = d(), null !== s
                                                ? e = [e, t, r, s]
                                                : (e = null, Tr = l))
                                            : (e = null, Tr = l)
                                    } else
                                        e = null,
                                        Tr = l;
                            else
                                    e = null,
                                    Tr = l;
                                return null !== e && (e = function(e) {
                                    return n.substring(Tr - 1, e + 1)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function z() {
                                var e;
                                return e = _(),
                                null === e && (33 === n.charCodeAt(Tr)
                                    ? (e = "!", Tr++)
                                    : (e = null, 0 === _r && s('"!"')), null === e && (/^[#-[]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[#-[]")), null === e && (/^[\]-~]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[\\]-~]")), null === e && (e = A())))),
                                e
                            }
                            function K() {
                                var e,
                                    t,
                                    r;
                                return r = Tr,
                                92 === n.charCodeAt(Tr)
                                    ? (e = "\\", Tr++)
                                    : (e = null, 0 === _r && s('"\\\\"')),
                                null !== e
                                    ? (/^[\0-\t]/.test(n.charAt(Tr))
                                        ? (t = n.charAt(Tr), Tr++)
                                        : (t = null, 0 === _r && s("[\\0-\\t]")), null === t && (/^[\x0B-\f]/.test(n.charAt(Tr))
                                        ? (t = n.charAt(Tr), Tr++)
                                        : (t = null, 0 === _r && s("[\\x0B-\\f]")), null === t && (/^[\x0E-]/.test(n.charAt(Tr))
                                        ? (t = n.charAt(Tr), Tr++)
                                        : (t = null, 0 === _r && s("[\\x0E-]")))), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function Y() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return l = Tr,
                                o = Tr,
                                e = X(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = ee(), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (i = se(), null !== i
                                                ? e = [e, t, r, i]
                                                : (e = null, Tr = o))
                                            : (e = null, Tr = o))
                                        : (e = null, Tr = o))
                                    : (e = null, Tr = o),
                                null !== e && (e = function(e) {
                                    try {
                                        Ar.uri = new Er(Ar.scheme, Ar.user, Ar.host, Ar.port),
                                        delete Ar.scheme,
                                        delete Ar.user,
                                        delete Ar.host,
                                        delete Ar.host_type,
                                        delete Ar.port
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(l)),
                                null === e && (Tr = l),
                                e
                            }
                            function $() {
                                var e,
                                    t,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c;
                                return u = Tr,
                                c = Tr,
                                e = X(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (i = ee(), i = null !== i
                                            ? i
                                            : "", null !== i
                                            ? (l = se(), null !== l
                                                ? (o = ge(), null !== o
                                                    ? (a = Ne(), a = null !== a
                                                        ? a
                                                        : "", null !== a
                                                        ? e = [
                                                            e,
                                                            t,
                                                            i,
                                                            l,
                                                            o,
                                                            a
                                                        ]
                                                        : (e = null, Tr = c))
                                                    : (e = null, Tr = c))
                                                : (e = null, Tr = c))
                                            : (e = null, Tr = c))
                                        : (e = null, Tr = c))
                                    : (e = null, Tr = c),
                                null !== e && (e = function(e) {
                                    try {
                                        Ar.uri = new Er(Ar.scheme, Ar.user, Ar.host, Ar.port, Ar.uri_params, Ar.uri_headers),
                                        delete Ar.scheme,
                                        delete Ar.user,
                                        delete Ar.host,
                                        delete Ar.host_type,
                                        delete Ar.port,
                                        delete Ar.uri_params,
                                        "SIP_URI" === r && (Ar = Ar.uri)
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(u)),
                                null === e && (Tr = u),
                                e
                            }
                            function X() {
                                var e;
                                return e = Q(),
                                null === e && (e = Z()),
                                e
                            }
                            function Q() {
                                var e,
                                    t;
                                return t = Tr,
                                "sips" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"sips"')),
                                null !== e && (e = function(e, t) {
                                    Ar.scheme = t.toLowerCase()
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Z() {
                                var e,
                                    t;
                                return t = Tr,
                                "sip" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"sip"')),
                                null !== e && (e = function(e, t) {
                                    Ar.scheme = t.toLowerCase()
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function ee() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return i = Tr,
                                l = Tr,
                                e = te(),
                                null !== e
                                    ? (o = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = re(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (64 === n.charCodeAt(Tr)
                                            ? (r = "@", Tr++)
                                            : (r = null, 0 === _r && s('"@"')), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    Ar.user = decodeURIComponent(n.substring(Tr - 1, e))
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function te() {
                                var e,
                                    t;
                                if (t = g(), null === t && (t = T(), null === t && (t = ne())), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = g(),
                                        null === t && (t = T(), null === t && (t = ne()));
                            else
                                    e = null;
                                return e
                            }
                            function ne() {
                                var e;
                                return 38 === n.charCodeAt(Tr)
                                    ? (e = "&", Tr++)
                                    : (e = null, 0 === _r && s('"&"')),
                                null === e && (61 === n.charCodeAt(Tr)
                                    ? (e = "=", Tr++)
                                    : (e = null, 0 === _r && s('"="')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')), null === e && (44 === n.charCodeAt(Tr)
                                    ? (e = ",", Tr++)
                                    : (e = null, 0 === _r && s('","')), null === e && (59 === n.charCodeAt(Tr)
                                    ? (e = ";", Tr++)
                                    : (e = null, 0 === _r && s('";"')), null === e && (63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null === e && (47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"'))))))))),
                                e
                            }
                            function re() {
                                var e,
                                    t,
                                    r;
                                for (r = Tr, e = [], t = g(), null === t && (t = T(), null === t && (38 === n.charCodeAt(Tr)
                                    ? (t = "&", Tr++)
                                    : (t = null, 0 === _r && s('"&"')), null === t && (61 === n.charCodeAt(Tr)
                                    ? (t = "=", Tr++)
                                    : (t = null, 0 === _r && s('"="')), null === t && (43 === n.charCodeAt(Tr)
                                    ? (t = "+", Tr++)
                                    : (t = null, 0 === _r && s('"+"')), null === t && (36 === n.charCodeAt(Tr)
                                    ? (t = "$", Tr++)
                                    : (t = null, 0 === _r && s('"$"')), null === t && (44 === n.charCodeAt(Tr)
                                    ? (t = ",", Tr++)
                                    : (t = null, 0 === _r && s('","')))))))); null !== t;)
                                    e.push(t),
                                    t = g(),
                                    null === t && (t = T(), null === t && (38 === n.charCodeAt(Tr)
                                        ? (t = "&", Tr++)
                                        : (t = null, 0 === _r && s('"&"')), null === t && (61 === n.charCodeAt(Tr)
                                        ? (t = "=", Tr++)
                                        : (t = null, 0 === _r && s('"="')), null === t && (43 === n.charCodeAt(Tr)
                                        ? (t = "+", Tr++)
                                        : (t = null, 0 === _r && s('"+"')), null === t && (36 === n.charCodeAt(Tr)
                                        ? (t = "$", Tr++)
                                        : (t = null, 0 === _r && s('"$"')), null === t && (44 === n.charCodeAt(Tr)
                                        ? (t = ",", Tr++)
                                        : (t = null, 0 === _r && s('","'))))))));
                                return null !== e && (e = function(e) {
                                    Ar.password = n.substring(Tr, e)
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function se() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                e = ie(),
                                null !== e
                                    ? (l = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = me(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = l))
                                        : (t = null, Tr = l), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function ie() {
                                var e,
                                    t;
                                return t = Tr,
                                e = le(),
                                null === e && (e = pe(), null === e && (e = ue())),
                                null !== e && (e = function(e) {
                                    return Ar.host = n.substring(Tr, e).toLowerCase(),
                                    Ar.host
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function le() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                for (i = Tr, l = Tr, e = [], o = Tr, t = oe(), null !== t
                                    ? (46 === n.charCodeAt(Tr)
                                        ? (r = ".", Tr++)
                                        : (r = null, 0 === _r && s('"."')), null !== r
                                        ? t = [t, r]
                                        : (t = null, Tr = o))
                                    : (t = null, Tr = o); null !== t;)
                                    e.push(t),
                                    o = Tr,
                                    t = oe(),
                                    null !== t
                                        ? (46 === n.charCodeAt(Tr)
                                            ? (r = ".", Tr++)
                                            : (r = null, 0 === _r && s('"."')), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o);
                                return null !== e
                                    ? (t = ae(), null !== t
                                        ? (46 === n.charCodeAt(Tr)
                                            ? (r = ".", Tr++)
                                            : (r = null, 0 === _r && s('"."')), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return Ar.host_type = "domain",
                                    n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function oe() {
                                var e,
                                    t,
                                    r,
                                    i;
                                if (i = Tr, e = f(), null !== e) {
                                    for (t = [], r = f(), null === r && (45 === n.charCodeAt(Tr)
                                        ? (r = "-", Tr++)
                                        : (r = null, 0 === _r && s('"-"')), null === r && (95 === n.charCodeAt(Tr)
                                        ? (r = "_", Tr++)
                                        : (r = null, 0 === _r && s('"_"')))); null !== r;)
                                        t.push(r),
                                        r = f(),
                                        null === r && (45 === n.charCodeAt(Tr)
                                            ? (r = "-", Tr++)
                                            : (r = null, 0 === _r && s('"-"')), null === r && (95 === n.charCodeAt(Tr)
                                            ? (r = "_", Tr++)
                                            : (r = null, 0 === _r && s('"_"'))));
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return e
                            }
                            function ae() {
                                var e,
                                    t,
                                    r,
                                    i;
                                if (i = Tr, e = o(), null !== e) {
                                    for (t = [], r = f(), null === r && (45 === n.charCodeAt(Tr)
                                        ? (r = "-", Tr++)
                                        : (r = null, 0 === _r && s('"-"')), null === r && (95 === n.charCodeAt(Tr)
                                        ? (r = "_", Tr++)
                                        : (r = null, 0 === _r && s('"_"')))); null !== r;)
                                        t.push(r),
                                        r = f(),
                                        null === r && (45 === n.charCodeAt(Tr)
                                            ? (r = "-", Tr++)
                                            : (r = null, 0 === _r && s('"-"')), null === r && (95 === n.charCodeAt(Tr)
                                            ? (r = "_", Tr++)
                                            : (r = null, 0 === _r && s('"_"'))));
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return e
                            }
                            function ue() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                91 === n.charCodeAt(Tr)
                                    ? (e = "[", Tr++)
                                    : (e = null, 0 === _r && s('"["')),
                                null !== e
                                    ? (t = ce(), null !== t
                                        ? (93 === n.charCodeAt(Tr)
                                            ? (r = "]", Tr++)
                                            : (r = null, 0 === _r && s('"]"')), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    return Ar.host_type = "IPv6",
                                    n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function ce() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c,
                                    d,
                                    h,
                                    p,
                                    f,
                                    m,
                                    g,
                                    v;
                                return m = Tr,
                                g = Tr,
                                e = de(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? (58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? (58 === n.charCodeAt(Tr)
                                                        ? (o = ":", Tr++)
                                                        : (o = null, 0 === _r && s('":"')), null !== o
                                                        ? (a = de(), null !== a
                                                            ? (58 === n.charCodeAt(Tr)
                                                                ? (u = ":", Tr++)
                                                                : (u = null, 0 === _r && s('":"')), null !== u
                                                                ? (c = de(), null !== c
                                                                    ? (58 === n.charCodeAt(Tr)
                                                                        ? (d = ":", Tr++)
                                                                        : (d = null, 0 === _r && s('":"')), null !== d
                                                                        ? (h = de(), null !== h
                                                                            ? (58 === n.charCodeAt(Tr)
                                                                                ? (p = ":", Tr++)
                                                                                : (p = null, 0 === _r && s('":"')), null !== p
                                                                                ? (f = he(), null !== f
                                                                                    ? e = [
                                                                                        e,
                                                                                        t,
                                                                                        r,
                                                                                        i,
                                                                                        l,
                                                                                        o,
                                                                                        a,
                                                                                        u,
                                                                                        c,
                                                                                        d,
                                                                                        h,
                                                                                        p,
                                                                                        f
                                                                                    ]
                                                                                    : (e = null, Tr = g))
                                                                                : (e = null, Tr = g))
                                                                            : (e = null, Tr = g))
                                                                        : (e = null, Tr = g))
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g),
                                null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? (58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? (58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? (58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = de(), null !== u
                                                                ? (58 === n.charCodeAt(Tr)
                                                                    ? (c = ":", Tr++)
                                                                    : (c = null, 0 === _r && s('":"')), null !== c
                                                                    ? (d = de(), null !== d
                                                                        ? (58 === n.charCodeAt(Tr)
                                                                            ? (h = ":", Tr++)
                                                                            : (h = null, 0 === _r && s('":"')), null !== h
                                                                            ? (p = he(), null !== p
                                                                                ? e = [
                                                                                    e,
                                                                                    t,
                                                                                    r,
                                                                                    i,
                                                                                    l,
                                                                                    o,
                                                                                    a,
                                                                                    u,
                                                                                    c,
                                                                                    d,
                                                                                    h,
                                                                                    p
                                                                                ]
                                                                                : (e = null, Tr = g))
                                                                            : (e = null, Tr = g))
                                                                        : (e = null, Tr = g))
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? (58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? (58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? (58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = de(), null !== u
                                                                ? (58 === n.charCodeAt(Tr)
                                                                    ? (c = ":", Tr++)
                                                                    : (c = null, 0 === _r && s('":"')), null !== c
                                                                    ? (d = he(), null !== d
                                                                        ? e = [
                                                                            e,
                                                                            t,
                                                                            r,
                                                                            i,
                                                                            l,
                                                                            o,
                                                                            a,
                                                                            u,
                                                                            c,
                                                                            d
                                                                        ]
                                                                        : (e = null, Tr = g))
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? (58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? (58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? (58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = he(), null !== u
                                                                ? e = [
                                                                    e,
                                                                    t,
                                                                    r,
                                                                    i,
                                                                    l,
                                                                    o,
                                                                    a,
                                                                    u
                                                                ]
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? (58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? (58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = he(), null !== o
                                                        ? e = [
                                                            e,
                                                            t,
                                                            r,
                                                            i,
                                                            l,
                                                            o
                                                        ]
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? (58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = he(), null !== i
                                                ? e = [e, t, r, i]
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = he(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, "::" === n.substr(Tr, 2)
                                    ? (e = "::", Tr += 2)
                                    : (e = null, 0 === _r && s('"::"')), null !== e
                                    ? (t = de(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? ("::" === n.substr(Tr, 2)
                                        ? (t = "::", Tr += 2)
                                        : (t = null, 0 === _r && s('"::"')), null !== t
                                        ? (r = de(), null !== r
                                            ? (58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? (58 === n.charCodeAt(Tr)
                                                        ? (o = ":", Tr++)
                                                        : (o = null, 0 === _r && s('":"')), null !== o
                                                        ? (a = de(), null !== a
                                                            ? (58 === n.charCodeAt(Tr)
                                                                ? (u = ":", Tr++)
                                                                : (u = null, 0 === _r && s('":"')), null !== u
                                                                ? (c = de(), null !== c
                                                                    ? (58 === n.charCodeAt(Tr)
                                                                        ? (d = ":", Tr++)
                                                                        : (d = null, 0 === _r && s('":"')), null !== d
                                                                        ? (h = he(), null !== h
                                                                            ? e = [
                                                                                e,
                                                                                t,
                                                                                r,
                                                                                i,
                                                                                l,
                                                                                o,
                                                                                a,
                                                                                u,
                                                                                c,
                                                                                d,
                                                                                h
                                                                            ]
                                                                            : (e = null, Tr = g))
                                                                        : (e = null, Tr = g))
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? ("::" === n.substr(Tr, 2)
                                            ? (r = "::", Tr += 2)
                                            : (r = null, 0 === _r && s('"::"')), null !== r
                                            ? (i = de(), null !== i
                                                ? (58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? (58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = de(), null !== u
                                                                ? (58 === n.charCodeAt(Tr)
                                                                    ? (c = ":", Tr++)
                                                                    : (c = null, 0 === _r && s('":"')), null !== c
                                                                    ? (d = he(), null !== d
                                                                        ? e = [
                                                                            e,
                                                                            t,
                                                                            r,
                                                                            i,
                                                                            l,
                                                                            o,
                                                                            a,
                                                                            u,
                                                                            c,
                                                                            d
                                                                        ]
                                                                        : (e = null, Tr = g))
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = v))
                                            : (r = null, Tr = v), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? ("::" === n.substr(Tr, 2)
                                                ? (i = "::", Tr += 2)
                                                : (i = null, 0 === _r && s('"::"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? (58 === n.charCodeAt(Tr)
                                                        ? (o = ":", Tr++)
                                                        : (o = null, 0 === _r && s('":"')), null !== o
                                                        ? (a = de(), null !== a
                                                            ? (58 === n.charCodeAt(Tr)
                                                                ? (u = ":", Tr++)
                                                                : (u = null, 0 === _r && s('":"')), null !== u
                                                                ? (c = he(), null !== c
                                                                    ? e = [
                                                                        e,
                                                                        t,
                                                                        r,
                                                                        i,
                                                                        l,
                                                                        o,
                                                                        a,
                                                                        u,
                                                                        c
                                                                    ]
                                                                    : (e = null, Tr = g))
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = v))
                                            : (r = null, Tr = v), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = v))
                                                : (i = null, Tr = v), i = null !== i
                                                ? i
                                                : "", null !== i
                                                ? ("::" === n.substr(Tr, 2)
                                                    ? (l = "::", Tr += 2)
                                                    : (l = null, 0 === _r && s('"::"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? (58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = he(), null !== u
                                                                ? e = [
                                                                    e,
                                                                    t,
                                                                    r,
                                                                    i,
                                                                    l,
                                                                    o,
                                                                    a,
                                                                    u
                                                                ]
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = v))
                                            : (r = null, Tr = v), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = v))
                                                : (i = null, Tr = v), i = null !== i
                                                ? i
                                                : "", null !== i
                                                ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? l = [l, o]
                                                        : (l = null, Tr = v))
                                                    : (l = null, Tr = v), l = null !== l
                                                    ? l
                                                    : "", null !== l
                                                    ? ("::" === n.substr(Tr, 2)
                                                        ? (o = "::", Tr += 2)
                                                        : (o = null, 0 === _r && s('"::"')), null !== o
                                                        ? (a = he(), null !== a
                                                            ? e = [
                                                                e,
                                                                t,
                                                                r,
                                                                i,
                                                                l,
                                                                o,
                                                                a
                                                            ]
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = v))
                                            : (r = null, Tr = v), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = v))
                                                : (i = null, Tr = v), i = null !== i
                                                ? i
                                                : "", null !== i
                                                ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? l = [l, o]
                                                        : (l = null, Tr = v))
                                                    : (l = null, Tr = v), l = null !== l
                                                    ? l
                                                    : "", null !== l
                                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                        ? (o = ":", Tr++)
                                                        : (o = null, 0 === _r && s('":"')), null !== o
                                                        ? (a = de(), null !== a
                                                            ? o = [o, a]
                                                            : (o = null, Tr = v))
                                                        : (o = null, Tr = v), o = null !== o
                                                        ? o
                                                        : "", null !== o
                                                        ? ("::" === n.substr(Tr, 2)
                                                            ? (a = "::", Tr += 2)
                                                            : (a = null, 0 === _r && s('"::"')), null !== a
                                                            ? (u = de(), null !== u
                                                                ? e = [
                                                                    e,
                                                                    t,
                                                                    r,
                                                                    i,
                                                                    l,
                                                                    o,
                                                                    a,
                                                                    u
                                                                ]
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g), null === e && (g = Tr, e = de(), null !== e
                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = v))
                                        : (t = null, Tr = v), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                            ? (r = ":", Tr++)
                                            : (r = null, 0 === _r && s('":"')), null !== r
                                            ? (i = de(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = v))
                                            : (r = null, Tr = v), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                ? (i = ":", Tr++)
                                                : (i = null, 0 === _r && s('":"')), null !== i
                                                ? (l = de(), null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = v))
                                                : (i = null, Tr = v), i = null !== i
                                                ? i
                                                : "", null !== i
                                                ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                    ? (l = ":", Tr++)
                                                    : (l = null, 0 === _r && s('":"')), null !== l
                                                    ? (o = de(), null !== o
                                                        ? l = [l, o]
                                                        : (l = null, Tr = v))
                                                    : (l = null, Tr = v), l = null !== l
                                                    ? l
                                                    : "", null !== l
                                                    ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                        ? (o = ":", Tr++)
                                                        : (o = null, 0 === _r && s('":"')), null !== o
                                                        ? (a = de(), null !== a
                                                            ? o = [o, a]
                                                            : (o = null, Tr = v))
                                                        : (o = null, Tr = v), o = null !== o
                                                        ? o
                                                        : "", null !== o
                                                        ? (v = Tr, 58 === n.charCodeAt(Tr)
                                                            ? (a = ":", Tr++)
                                                            : (a = null, 0 === _r && s('":"')), null !== a
                                                            ? (u = de(), null !== u
                                                                ? a = [a, u]
                                                                : (a = null, Tr = v))
                                                            : (a = null, Tr = v), a = null !== a
                                                            ? a
                                                            : "", null !== a
                                                            ? ("::" === n.substr(Tr, 2)
                                                                ? (u = "::", Tr += 2)
                                                                : (u = null, 0 === _r && s('"::"')), null !== u
                                                                ? e = [
                                                                    e,
                                                                    t,
                                                                    r,
                                                                    i,
                                                                    l,
                                                                    o,
                                                                    a,
                                                                    u
                                                                ]
                                                                : (e = null, Tr = g))
                                                            : (e = null, Tr = g))
                                                        : (e = null, Tr = g))
                                                    : (e = null, Tr = g))
                                                : (e = null, Tr = g))
                                            : (e = null, Tr = g))
                                        : (e = null, Tr = g))
                                    : (e = null, Tr = g))))))))))))))),
                                null !== e && (e = function(e) {
                                    return Ar.host_type = "IPv6",
                                    n.substring(Tr, e)
                                }(m)),
                                null === e && (Tr = m),
                                e
                            }
                            function de() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s;
                                return s = Tr,
                                e = a(),
                                null !== e
                                    ? (t = a(), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (n = a(), n = null !== n
                                            ? n
                                            : "", null !== n
                                            ? (r = a(), r = null !== r
                                                ? r
                                                : "", null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = s))
                                            : (e = null, Tr = s))
                                        : (e = null, Tr = s))
                                    : (e = null, Tr = s),
                                e
                            }
                            function he() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                e = de(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = de(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null === e && (e = pe()),
                                e
                            }
                            function pe() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c;
                                return u = Tr,
                                c = Tr,
                                e = fe(),
                                null !== e
                                    ? (46 === n.charCodeAt(Tr)
                                        ? (t = ".", Tr++)
                                        : (t = null, 0 === _r && s('"."')), null !== t
                                        ? (r = fe(), null !== r
                                            ? (46 === n.charCodeAt(Tr)
                                                ? (i = ".", Tr++)
                                                : (i = null, 0 === _r && s('"."')), null !== i
                                                ? (l = fe(), null !== l
                                                    ? (46 === n.charCodeAt(Tr)
                                                        ? (o = ".", Tr++)
                                                        : (o = null, 0 === _r && s('"."')), null !== o
                                                        ? (a = fe(), null !== a
                                                            ? e = [
                                                                e,
                                                                t,
                                                                r,
                                                                i,
                                                                l,
                                                                o,
                                                                a
                                                            ]
                                                            : (e = null, Tr = c))
                                                        : (e = null, Tr = c))
                                                    : (e = null, Tr = c))
                                                : (e = null, Tr = c))
                                            : (e = null, Tr = c))
                                        : (e = null, Tr = c))
                                    : (e = null, Tr = c),
                                null !== e && (e = function(e) {
                                    return Ar.host_type = "IPv4",
                                    n.substring(Tr, e)
                                }(u)),
                                null === e && (Tr = u),
                                e
                            }
                            function fe() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                "25" === n.substr(Tr, 2)
                                    ? (e = "25", Tr += 2)
                                    : (e = null, 0 === _r && s('"25"')),
                                null !== e
                                    ? (/^[0-5]/.test(n.charAt(Tr))
                                        ? (t = n.charAt(Tr), Tr++)
                                        : (t = null, 0 === _r && s("[0-5]")), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null === e && (i = Tr, 50 === n.charCodeAt(Tr)
                                    ? (e = "2", Tr++)
                                    : (e = null, 0 === _r && s('"2"')), null !== e
                                    ? (/^[0-4]/.test(n.charAt(Tr))
                                        ? (t = n.charAt(Tr), Tr++)
                                        : (t = null, 0 === _r && s("[0-4]")), null !== t
                                        ? (r = l(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i), null === e && (i = Tr, 49 === n.charCodeAt(Tr)
                                    ? (e = "1", Tr++)
                                    : (e = null, 0 === _r && s('"1"')), null !== e
                                    ? (t = l(), null !== t
                                        ? (r = l(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i), null === e && (i = Tr, /^[1-9]/.test(n.charAt(Tr))
                                    ? (e = n.charAt(Tr), Tr++)
                                    : (e = null, 0 === _r && s("[1-9]")), null !== e
                                    ? (t = l(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i), null === e && (e = l())))),
                                e
                            }
                            function me() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    o;
                                return i = Tr,
                                o = Tr,
                                e = l(),
                                e = null !== e
                                    ? e
                                    : "",
                                null !== e
                                    ? (t = l(), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (n = l(), n = null !== n
                                            ? n
                                            : "", null !== n
                                            ? (r = l(), r = null !== r
                                                ? r
                                                : "", null !== r
                                                ? (s = l(), s = null !== s
                                                    ? s
                                                    : "", null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = o))
                                                : (e = null, Tr = o))
                                            : (e = null, Tr = o))
                                        : (e = null, Tr = o))
                                    : (e = null, Tr = o),
                                null !== e && (e = function(e, t) {
                                    return t = parseInt(t.join("")),
                                    Ar.port = t,
                                    t
                                }(i, e)),
                                null === e && (Tr = i),
                                e
                            }
                            function ge() {
                                var e,
                                    t,
                                    r,
                                    i;
                                for (e = [], i = Tr, 59 === n.charCodeAt(Tr)
                                    ? (t = ";", Tr++)
                                    : (t = null, 0 === _r && s('";"')), null !== t
                                    ? (r = ve(), null !== r
                                        ? t = [t, r]
                                        : (t = null, Tr = i))
                                    : (t = null, Tr = i); null !== t;)
                                    e.push(t),
                                    i = Tr,
                                    59 === n.charCodeAt(Tr)
                                        ? (t = ";", Tr++)
                                        : (t = null, 0 === _r && s('";"')),
                                    null !== t
                                        ? (r = ve(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = i))
                                        : (t = null, Tr = i);
                                return e
                            }
                            function ve() {
                                var e;
                                return e = Te(),
                                null === e && (e = _e(), null === e && (e = Ce(), null === e && (e = Se(), null === e && (e = Ee(), null === e && (e = ye(), null === e && (e = Ae())))))),
                                e
                            }
                            function Te() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                "transport=" === n.substr(Tr, 10).toLowerCase()
                                    ? (e = n.substr(Tr, 10), Tr += 10)
                                    : (e = null, 0 === _r && s('"transport="')),
                                null !== e
                                    ? ("udp" === n.substr(Tr, 3).toLowerCase()
                                        ? (t = n.substr(Tr, 3), Tr += 3)
                                        : (t = null, 0 === _r && s('"udp"')), null === t && ("tcp" === n.substr(Tr, 3).toLowerCase()
                                        ? (t = n.substr(Tr, 3), Tr += 3)
                                        : (t = null, 0 === _r && s('"tcp"')), null === t && ("sctp" === n.substr(Tr, 4).toLowerCase()
                                        ? (t = n.substr(Tr, 4), Tr += 4)
                                        : (t = null, 0 === _r && s('"sctp"')), null === t && ("tls" === n.substr(Tr, 3).toLowerCase()
                                        ? (t = n.substr(Tr, 3), Tr += 3)
                                        : (t = null, 0 === _r && s('"tls"')), null === t && (t = b())))), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e, t) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    Ar.uri_params.transport = t.toLowerCase()
                                }(r, e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function _e() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                "user=" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"user="')),
                                null !== e
                                    ? ("phone" === n.substr(Tr, 5).toLowerCase()
                                        ? (t = n.substr(Tr, 5), Tr += 5)
                                        : (t = null, 0 === _r && s('"phone"')), null === t && ("ip" === n.substr(Tr, 2).toLowerCase()
                                        ? (t = n.substr(Tr, 2), Tr += 2)
                                        : (t = null, 0 === _r && s('"ip"')), null === t && (t = b())), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e, t) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    Ar.uri_params.user = t.toLowerCase()
                                }(r, e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function Ce() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                "method=" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"method="')),
                                null !== e
                                    ? (t = ut(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e, t) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    Ar.uri_params.method = t
                                }(r, e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function Se() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                "ttl=" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"ttl="')),
                                null !== e
                                    ? (t = Kn(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e, t) {
                                    Ar.params || (Ar.params = {}),
                                    Ar.params.ttl = t
                                }(r, e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function Ee() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                "maddr=" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"maddr="')),
                                null !== e
                                    ? (t = ie(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                null !== e && (e = function(e, t) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    Ar.uri_params.maddr = t
                                }(r, e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function ye() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return i = Tr,
                                l = Tr,
                                "lr" === n.substr(Tr, 2).toLowerCase()
                                    ? (e = n.substr(Tr, 2), Tr += 2)
                                    : (e = null, 0 === _r && s('"lr"')),
                                null !== e
                                    ? (o = Tr, 61 === n.charCodeAt(Tr)
                                        ? (t = "=", Tr++)
                                        : (t = null, 0 === _r && s('"="')), null !== t
                                        ? (r = b(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    Ar.uri_params.lr = void 0
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function Ae() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return i = Tr,
                                l = Tr,
                                e = Re(),
                                null !== e
                                    ? (o = Tr, 61 === n.charCodeAt(Tr)
                                        ? (t = "=", Tr++)
                                        : (t = null, 0 === _r && s('"="')), null !== t
                                        ? (r = we(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t, n) {
                                    Ar.uri_params || (Ar.uri_params = {}),
                                    n = "undefined" == typeof n
                                        ? void 0
                                        : n[1],
                                    Ar.uri_params[t.toLowerCase()] = n
                                }(i, e[0], e[1])),
                                null === e && (Tr = i),
                                e
                            }
                            function Re() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = be(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = be();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    return t.join("")
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function we() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = be(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = be();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    return t.join("")
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function be() {
                                var e;
                                return e = Ie(),
                                null === e && (e = g(), null === e && (e = T())),
                                e
                            }
                            function Ie() {
                                var e;
                                return 91 === n.charCodeAt(Tr)
                                    ? (e = "[", Tr++)
                                    : (e = null, 0 === _r && s('"["')),
                                null === e && (93 === n.charCodeAt(Tr)
                                    ? (e = "]", Tr++)
                                    : (e = null, 0 === _r && s('"]"')), null === e && (47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"')), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (38 === n.charCodeAt(Tr)
                                    ? (e = "&", Tr++)
                                    : (e = null, 0 === _r && s('"&"')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')))))))),
                                e
                            }
                            function Ne() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a;
                                if (o = Tr, 63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null !== e)
                                    if (t = Oe(), null !== t) {
                                        for (r = [], a = Tr, 38 === n.charCodeAt(Tr)
                                            ? (i = "&", Tr++)
                                            : (i = null, 0 === _r && s('"&"')), null !== i
                                            ? (l = Oe(), null !== l
                                                ? i = [i, l]
                                                : (i = null, Tr = a))
                                            : (i = null, Tr = a); null !== i;)
                                            r.push(i),
                                            a = Tr,
                                            38 === n.charCodeAt(Tr)
                                                ? (i = "&", Tr++)
                                                : (i = null, 0 === _r && s('"&"')),
                                            null !== i
                                                ? (l = Oe(), null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = a))
                                                : (i = null, Tr = a);
                                        null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = o)
                                    } else
                                        e = null,
                                        Tr = o;
                            else
                                    e = null,
                                    Tr = o;
                                return e
                            }
                            function Oe() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                e = xe(),
                                null !== e
                                    ? (61 === n.charCodeAt(Tr)
                                        ? (t = "=", Tr++)
                                        : (t = null, 0 === _r && s('"="')), null !== t
                                        ? (r = De(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t, n) {
                                    t = t.join("").toLowerCase(),
                                    n = n.join(""),
                                    Ar.uri_headers || (Ar.uri_headers = {}),
                                    Ar.uri_headers[t]
                                        ? Ar.uri_headers[t].push(n)
                                        : Ar.uri_headers[t] = [n]
                                }(i, e[0], e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function xe() {
                                var e,
                                    t;
                                if (t = Pe(), null === t && (t = g(), null === t && (t = T())), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = Pe(),
                                        null === t && (t = g(), null === t && (t = T()));
                            else
                                    e = null;
                                return e
                            }
                            function De() {
                                var e,
                                    t;
                                for (e = [], t = Pe(), null === t && (t = g(), null === t && (t = T())); null !== t;)
                                    e.push(t),
                                    t = Pe(),
                                    null === t && (t = g(), null === t && (t = T()));
                                return e
                            }
                            function Pe() {
                                var e;
                                return 91 === n.charCodeAt(Tr)
                                    ? (e = "[", Tr++)
                                    : (e = null, 0 === _r && s('"["')),
                                null === e && (93 === n.charCodeAt(Tr)
                                    ? (e = "]", Tr++)
                                    : (e = null, 0 === _r && s('"]"')), null === e && (47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"')), null === e && (63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')))))))),
                                e
                            }
                            function Ue() {
                                var e;
                                return e = ct(),
                                null === e && (e = Me()),
                                e
                            }
                            function Me() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                return i = Tr,
                                e = ut(),
                                null !== e
                                    ? (t = h(), null !== t
                                        ? (n = ke(), null !== n
                                            ? (r = h(), null !== r
                                                ? (s = Ze(), null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = i))
                                                : (e = null, Tr = i))
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function ke() {
                                var e;
                                return e = $(),
                                null === e && (e = Le()),
                                e
                            }
                            function Le() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                e = Ke(),
                                null !== e
                                    ? (58 === n.charCodeAt(Tr)
                                        ? (t = ":", Tr++)
                                        : (t = null, 0 === _r && s('":"')), null !== t
                                        ? (r = qe(), null === r && (r = Ge()), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function qe() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                e = He(),
                                null === e && (e = Fe()),
                                null !== e
                                    ? (l = Tr, 63 === n.charCodeAt(Tr)
                                        ? (t = "?", Tr++)
                                        : (t = null, 0 === _r && s('"?"')), null !== t
                                        ? (r = Qe(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = l))
                                        : (t = null, Tr = l), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function He() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                "//" === n.substr(Tr, 2)
                                    ? (e = "//", Tr += 2)
                                    : (e = null, 0 === _r && s('"//"')),
                                null !== e
                                    ? (t = Ye(), null !== t
                                        ? (r = Fe(), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function Fe() {
                                var e,
                                    t,
                                    r;
                                return r = Tr,
                                47 === n.charCodeAt(Tr)
                                    ? (e = "/", Tr++)
                                    : (e = null, 0 === _r && s('"/"')),
                                null !== e
                                    ? (t = Ve(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function Ge() {
                                var e,
                                    t,
                                    n,
                                    r;
                                if (r = Tr, e = Be(), null !== e) {
                                    for (t = [], n = je(); null !== n;)
                                        t.push(n),
                                        n = je();
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r)
                                } else
                                    e = null,
                                    Tr = r;
                                return e
                            }
                            function je() {
                                var e;
                                return e = m(),
                                null === e && (e = g(), null === e && (e = T())),
                                e
                            }
                            function Be() {
                                var e;
                                return e = g(),
                                null === e && (e = T(), null === e && (59 === n.charCodeAt(Tr)
                                    ? (e = ";", Tr++)
                                    : (e = null, 0 === _r && s('";"')), null === e && (63 === n.charCodeAt(Tr)
                                    ? (e = "?", Tr++)
                                    : (e = null, 0 === _r && s('"?"')), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (64 === n.charCodeAt(Tr)
                                    ? (e = "@", Tr++)
                                    : (e = null, 0 === _r && s('"@"')), null === e && (38 === n.charCodeAt(Tr)
                                    ? (e = "&", Tr++)
                                    : (e = null, 0 === _r && s('"&"')), null === e && (61 === n.charCodeAt(Tr)
                                    ? (e = "=", Tr++)
                                    : (e = null, 0 === _r && s('"="')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')), null === e && (44 === n.charCodeAt(Tr)
                                    ? (e = ",", Tr++)
                                    : (e = null, 0 === _r && s('","')))))))))))),
                                e
                            }
                            function Ve() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                if (l = Tr, e = We(), null !== e) {
                                    for (t = [], o = Tr, 47 === n.charCodeAt(Tr)
                                        ? (r = "/", Tr++)
                                        : (r = null, 0 === _r && s('"/"')), null !== r
                                        ? (i = We(), null !== i
                                            ? r = [r, i]
                                            : (r = null, Tr = o))
                                        : (r = null, Tr = o); null !== r;)
                                        t.push(r),
                                        o = Tr,
                                        47 === n.charCodeAt(Tr)
                                            ? (r = "/", Tr++)
                                            : (r = null, 0 === _r && s('"/"')),
                                        null !== r
                                            ? (i = We(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = o))
                                            : (r = null, Tr = o);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l)
                                } else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function We() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                for (l = Tr, e = [], t = ze(); null !== t;)
                                    e.push(t),
                                    t = ze();
                                if (null !== e) {
                                    for (t = [], o = Tr, 59 === n.charCodeAt(Tr)
                                        ? (r = ";", Tr++)
                                        : (r = null, 0 === _r && s('";"')), null !== r
                                        ? (i = Je(), null !== i
                                            ? r = [r, i]
                                            : (r = null, Tr = o))
                                        : (r = null, Tr = o); null !== r;)
                                        t.push(r),
                                        o = Tr,
                                        59 === n.charCodeAt(Tr)
                                            ? (r = ";", Tr++)
                                            : (r = null, 0 === _r && s('";"')),
                                        null !== r
                                            ? (i = Je(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = o))
                                            : (r = null, Tr = o);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l)
                                } else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function Je() {
                                var e,
                                    t;
                                for (e = [], t = ze(); null !== t;)
                                    e.push(t),
                                    t = ze();
                                return e
                            }
                            function ze() {
                                var e;
                                return e = g(),
                                null === e && (e = T(), null === e && (58 === n.charCodeAt(Tr)
                                    ? (e = ":", Tr++)
                                    : (e = null, 0 === _r && s('":"')), null === e && (64 === n.charCodeAt(Tr)
                                    ? (e = "@", Tr++)
                                    : (e = null, 0 === _r && s('"@"')), null === e && (38 === n.charCodeAt(Tr)
                                    ? (e = "&", Tr++)
                                    : (e = null, 0 === _r && s('"&"')), null === e && (61 === n.charCodeAt(Tr)
                                    ? (e = "=", Tr++)
                                    : (e = null, 0 === _r && s('"="')), null === e && (43 === n.charCodeAt(Tr)
                                    ? (e = "+", Tr++)
                                    : (e = null, 0 === _r && s('"+"')), null === e && (36 === n.charCodeAt(Tr)
                                    ? (e = "$", Tr++)
                                    : (e = null, 0 === _r && s('"$"')), null === e && (44 === n.charCodeAt(Tr)
                                    ? (e = ",", Tr++)
                                    : (e = null, 0 === _r && s('","')))))))))),
                                e
                            }
                            function Ke() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    a;
                                if (i = Tr, a = Tr, e = o(), null !== e) {
                                    for (t = [], r = o(), null === r && (r = l(), null === r && (43 === n.charCodeAt(Tr)
                                        ? (r = "+", Tr++)
                                        : (r = null, 0 === _r && s('"+"')), null === r && (45 === n.charCodeAt(Tr)
                                        ? (r = "-", Tr++)
                                        : (r = null, 0 === _r && s('"-"')), null === r && (46 === n.charCodeAt(Tr)
                                        ? (r = ".", Tr++)
                                        : (r = null, 0 === _r && s('"."')))))); null !== r;)
                                        t.push(r),
                                        r = o(),
                                        null === r && (r = l(), null === r && (43 === n.charCodeAt(Tr)
                                            ? (r = "+", Tr++)
                                            : (r = null, 0 === _r && s('"+"')), null === r && (45 === n.charCodeAt(Tr)
                                            ? (r = "-", Tr++)
                                            : (r = null, 0 === _r && s('"-"')), null === r && (46 === n.charCodeAt(Tr)
                                            ? (r = ".", Tr++)
                                            : (r = null, 0 === _r && s('"."'))))));
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = a)
                                } else
                                    e = null,
                                    Tr = a;
                                return null !== e && (e = function(e) {
                                    Ar.scheme = n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function Ye() {
                                var e;
                                return e = $e(),
                                null === e && (e = Xe()),
                                e
                            }
                            function $e() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return r = Tr,
                                i = Tr,
                                e = ee(),
                                null !== e
                                    ? (64 === n.charCodeAt(Tr)
                                        ? (t = "@", Tr++)
                                        : (t = null, 0 === _r && s('"@"')), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e = null !== e
                                    ? e
                                    : "",
                                null !== e
                                    ? (t = se(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e = null !== e
                                    ? e
                                    : ""
                            }
                            function Xe() {
                                var e,
                                    t;
                                if (t = g(), null === t && (t = T(), null === t && (36 === n.charCodeAt(Tr)
                                    ? (t = "$", Tr++)
                                    : (t = null, 0 === _r && s('"$"')), null === t && (44 === n.charCodeAt(Tr)
                                    ? (t = ",", Tr++)
                                    : (t = null, 0 === _r && s('","')), null === t && (59 === n.charCodeAt(Tr)
                                    ? (t = ";", Tr++)
                                    : (t = null, 0 === _r && s('";"')), null === t && (58 === n.charCodeAt(Tr)
                                    ? (t = ":", Tr++)
                                    : (t = null, 0 === _r && s('":"')), null === t && (64 === n.charCodeAt(Tr)
                                    ? (t = "@", Tr++)
                                    : (t = null, 0 === _r && s('"@"')), null === t && (38 === n.charCodeAt(Tr)
                                    ? (t = "&", Tr++)
                                    : (t = null, 0 === _r && s('"&"')), null === t && (61 === n.charCodeAt(Tr)
                                    ? (t = "=", Tr++)
                                    : (t = null, 0 === _r && s('"="')), null === t && (43 === n.charCodeAt(Tr)
                                    ? (t = "+", Tr++)
                                    : (t = null, 0 === _r && s('"+"'))))))))))), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = g(),
                                        null === t && (t = T(), null === t && (36 === n.charCodeAt(Tr)
                                            ? (t = "$", Tr++)
                                            : (t = null, 0 === _r && s('"$"')), null === t && (44 === n.charCodeAt(Tr)
                                            ? (t = ",", Tr++)
                                            : (t = null, 0 === _r && s('","')), null === t && (59 === n.charCodeAt(Tr)
                                            ? (t = ";", Tr++)
                                            : (t = null, 0 === _r && s('";"')), null === t && (58 === n.charCodeAt(Tr)
                                            ? (t = ":", Tr++)
                                            : (t = null, 0 === _r && s('":"')), null === t && (64 === n.charCodeAt(Tr)
                                            ? (t = "@", Tr++)
                                            : (t = null, 0 === _r && s('"@"')), null === t && (38 === n.charCodeAt(Tr)
                                            ? (t = "&", Tr++)
                                            : (t = null, 0 === _r && s('"&"')), null === t && (61 === n.charCodeAt(Tr)
                                            ? (t = "=", Tr++)
                                            : (t = null, 0 === _r && s('"="')), null === t && (43 === n.charCodeAt(Tr)
                                            ? (t = "+", Tr++)
                                            : (t = null, 0 === _r && s('"+"')))))))))));
                                else
                                    e = null;
                                return e
                            }
                            function Qe() {
                                var e,
                                    t;
                                for (e = [], t = je(); null !== t;)
                                    e.push(t),
                                    t = je();
                                return e
                            }
                            function Ze() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    o,
                                    a,
                                    u,
                                    c;
                                if (u = Tr, c = Tr, "sip" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"SIP"')), null !== e)
                                    if (47 === n.charCodeAt(Tr)
                                        ? (t = "/", Tr++)
                                        : (t = null, 0 === _r && s('"/"')), null !== t) {
                                        if (i = l(), null !== i)
                                            for (r = []; null !== i;)
                                                r.push(i),
                                                i = l();
                                    else
                                            r = null;
                                        if (null !== r)
                                            if (46 === n.charCodeAt(Tr)
                                                ? (i = ".", Tr++)
                                                : (i = null, 0 === _r && s('"."')), null !== i) {
                                                if (a = l(), null !== a)
                                                    for (o = []; null !== a;)
                                                        o.push(a),
                                                        a = l();
                                            else
                                                    o = null;
                                                null !== o
                                                    ? e = [e, t, r, i, o]
                                                    : (e = null, Tr = c)
                                            } else
                                                e = null,
                                                Tr = c;
                                    else
                                            e = null,
                                            Tr = c
                                    } else
                                        e = null,
                                        Tr = c;
                            else
                                    e = null,
                                    Tr = c;
                                return null !== e && (e = function(e) {
                                    Ar.sip_version = n.substring(Tr, e)
                                }(u)),
                                null === e && (Tr = u),
                                e
                            }
                            function et() {
                                var e;
                                return "INVITE" === n.substr(Tr, 6)
                                    ? (e = "INVITE", Tr += 6)
                                    : (e = null, 0 === _r && s('"INVITE"')),
                                e
                            }
                            function tt() {
                                var e;
                                return "ACK" === n.substr(Tr, 3)
                                    ? (e = "ACK", Tr += 3)
                                    : (e = null, 0 === _r && s('"ACK"')),
                                e
                            }
                            function nt() {
                                var e;
                                return "OPTIONS" === n.substr(Tr, 7)
                                    ? (e = "OPTIONS", Tr += 7)
                                    : (e = null, 0 === _r && s('"OPTIONS"')),
                                e
                            }
                            function rt() {
                                var e;
                                return "BYE" === n.substr(Tr, 3)
                                    ? (e = "BYE", Tr += 3)
                                    : (e = null, 0 === _r && s('"BYE"')),
                                e
                            }
                            function st() {
                                var e;
                                return "CANCEL" === n.substr(Tr, 6)
                                    ? (e = "CANCEL", Tr += 6)
                                    : (e = null, 0 === _r && s('"CANCEL"')),
                                e
                            }
                            function it() {
                                var e;
                                return "REGISTER" === n.substr(Tr, 8)
                                    ? (e = "REGISTER", Tr += 8)
                                    : (e = null, 0 === _r && s('"REGISTER"')),
                                e
                            }
                            function lt() {
                                var e;
                                return "SUBSCRIBE" === n.substr(Tr, 9)
                                    ? (e = "SUBSCRIBE", Tr += 9)
                                    : (e = null, 0 === _r && s('"SUBSCRIBE"')),
                                e
                            }
                            function ot() {
                                var e;
                                return "NOTIFY" === n.substr(Tr, 6)
                                    ? (e = "NOTIFY", Tr += 6)
                                    : (e = null, 0 === _r && s('"NOTIFY"')),
                                e
                            }
                            function at() {
                                var e;
                                return "REFER" === n.substr(Tr, 5)
                                    ? (e = "REFER", Tr += 5)
                                    : (e = null, 0 === _r && s('"REFER"')),
                                e
                            }
                            function ut() {
                                var e,
                                    t;
                                return t = Tr,
                                e = et(),
                                null === e && (e = tt(), null === e && (e = nt(), null === e && (e = rt(), null === e && (e = st(), null === e && (e = it(), null === e && (e = lt(), null === e && (e = ot(), null === e && (e = at(), null === e && (e = b()))))))))),
                                null !== e && (e = function(e) {
                                    return Ar.method = n.substring(Tr, e),
                                    Ar.method
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function ct() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                return i = Tr,
                                e = Ze(),
                                null !== e
                                    ? (t = h(), null !== t
                                        ? (n = dt(), null !== n
                                            ? (r = h(), null !== r
                                                ? (s = pt(), null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = i))
                                                : (e = null, Tr = i))
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function dt() {
                                var e,
                                    t;
                                return t = Tr,
                                e = ht(),
                                null !== e && (e = function(e, t) {
                                    Ar.status_code = parseInt(t.join(""))
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function ht() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = l(),
                                null !== e
                                    ? (t = l(), null !== t
                                        ? (n = l(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function pt() {
                                var e,
                                    t,
                                    r;
                                for (r = Tr, e = [], t = m(), null === t && (t = g(), null === t && (t = T(), null === t && (t = A(), null === t && (t = R(), null === t && (t = h(), null === t && (t = p())))))); null !== t;)
                                    e.push(t),
                                    t = m(),
                                    null === t && (t = g(), null === t && (t = T(), null === t && (t = A(), null === t && (t = R(), null === t && (t = h(), null === t && (t = p()))))));
                                return null !== e && (e = function(e) {
                                    Ar.reason_phrase = n.substring(Tr, e)
                                }(r)),
                                null === e && (Tr = r),
                                e
                            }
                            function ft() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = zt(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = zt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = zt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function mt() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return i = Tr,
                                l = Tr,
                                e = O(),
                                null !== e
                                    ? (o = Tr, 64 === n.charCodeAt(Tr)
                                        ? (t = "@", Tr++)
                                        : (t = null, 0 === _r && s('"@"')), null !== t
                                        ? (r = O(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    Ar = n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function gt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, e = x(), null === e)
                                    if (i = Tr, e = vt(), null !== e) {
                                        for (t = [], l = Tr, n = q(), null !== n
                                            ? (r = vt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l); null !== n;)
                                            t.push(n),
                                            l = Tr,
                                            n = q(),
                                            null !== n
                                                ? (r = vt(), null !== r
                                                    ? n = [n, r]
                                                    : (n = null, Tr = l))
                                                : (n = null, Tr = l);
                                        null !== t
                                            ? e = [e, t]
                                            : (e = null, Tr = i)
                                    } else
                                        e = null,
                                        Tr = i;
                            return null !== e && (e = function(e) {
                                    var t,
                                        n;
                                    for (n = Ar.multi_header.length, t = 0; t < n; t++)
                                        if (null === Ar.multi_header[t].parsed) {
                                            Ar = null;
                                            break
                                        }
                                    Ar = null !== Ar
                                        ? Ar.multi_header
                                        : -1
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function vt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = Y(), null === e && (e = Tt()), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Ct(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Ct(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    var t;
                                    Ar.multi_header || (Ar.multi_header = []);
                                    try {
                                        t = new yr(Ar.uri, Ar.display_name, Ar.params),
                                        delete Ar.uri,
                                        delete Ar.display_name,
                                        delete Ar.params
                                    } catch (e) {
                                        t = null
                                    }
                                    Ar.multi_header.push({possition: Tr, offset: e, parsed: t})
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function Tt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s;
                                return s = Tr,
                                e = _t(),
                                e = null !== e
                                    ? e
                                    : "",
                                null !== e
                                    ? (t = L(), null !== t
                                        ? (n = $(), null !== n
                                            ? (r = k(), null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = s))
                                            : (e = null, Tr = s))
                                        : (e = null, Tr = s))
                                    : (e = null, Tr = s),
                                e
                            }
                            function _t() {
                                var e,
                                    t,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o;
                                if (i = Tr, l = Tr, e = b(), null !== e) {
                                    for (t = [], o = Tr, r = _(), null !== r
                                        ? (s = b(), null !== s
                                            ? r = [r, s]
                                            : (r = null, Tr = o))
                                        : (r = null, Tr = o); null !== r;)
                                        t.push(r),
                                        o = Tr,
                                        r = _(),
                                        null !== r
                                            ? (s = b(), null !== s
                                                ? r = [r, s]
                                                : (r = null, Tr = o))
                                            : (r = null, Tr = o);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l)
                                } else
                                    e = null,
                                    Tr = l;
                                return null === e && (e = W()),
                                null !== e && (e = function(e, t) {
                                    t = n.substring(Tr, e).trim(),
                                    '"' === t[0] && (t = t.substring(1, t.length - 1)),
                                    Ar.display_name = t
                                }(i, e)),
                                null === e && (Tr = i),
                                e
                            }
                            function Ct() {
                                var e;
                                return e = St(),
                                null === e && (e = Et(), null === e && (e = Rt())),
                                e
                            }
                            function St() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "q" === n.substr(Tr, 1).toLowerCase()
                                    ? (e = n.substr(Tr, 1), Tr++)
                                    : (e = null, 0 === _r && s('"q"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = At(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.params || (Ar.params = {}),
                                    Ar.params.q = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function Et() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "expires" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"expires"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = yt(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.params || (Ar.params = {}),
                                    Ar.params.expires = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function yt() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = l(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = l();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    return parseInt(t.join(""))
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function At() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    o,
                                    a,
                                    u,
                                    c;
                                return a = Tr,
                                u = Tr,
                                48 === n.charCodeAt(Tr)
                                    ? (e = "0", Tr++)
                                    : (e = null, 0 === _r && s('"0"')),
                                null !== e
                                    ? (c = Tr, 46 === n.charCodeAt(Tr)
                                        ? (t = ".", Tr++)
                                        : (t = null, 0 === _r && s('"."')), null !== t
                                        ? (r = l(), r = null !== r
                                            ? r
                                            : "", null !== r
                                            ? (i = l(), i = null !== i
                                                ? i
                                                : "", null !== i
                                                ? (o = l(), o = null !== o
                                                    ? o
                                                    : "", null !== o
                                                    ? t = [t, r, i, o]
                                                    : (t = null, Tr = c))
                                                : (t = null, Tr = c))
                                            : (t = null, Tr = c))
                                        : (t = null, Tr = c), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = u))
                                    : (e = null, Tr = u),
                                null !== e && (e = function(e) {
                                    return parseFloat(n.substring(Tr, e))
                                }(a)),
                                null === e && (Tr = a),
                                e
                            }
                            function Rt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                return r = Tr,
                                s = Tr,
                                e = b(),
                                null !== e
                                    ? (i = Tr, t = P(), null !== t
                                        ? (n = wt(), null !== n
                                            ? t = [t, n]
                                            : (t = null, Tr = i))
                                        : (t = null, Tr = i), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s))
                                    : (e = null, Tr = s),
                                null !== e && (e = function(e, t, n) {
                                    Ar.params || (Ar.params = {}),
                                    n = "undefined" == typeof n
                                        ? void 0
                                        : n[1],
                                    Ar.params[t.toLowerCase()] = n
                                }(r, e[0], e[1])),
                                null === e && (Tr = r),
                                e
                            }
                            function wt() {
                                var e;
                                return e = b(),
                                null === e && (e = ie(), null === e && (e = W())),
                                e
                            }
                            function bt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = It(), null !== e) {
                                    for (t = [], i = Tr, n = H(), null !== n
                                        ? (r = Nt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Nt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function It() {
                                var e;
                                return "render" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"render"')),
                                null === e && ("session" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"session"')), null === e && ("icon" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"icon"')), null === e && ("alert" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"alert"')), null === e && (e = b())))),
                                e
                            }
                            function Nt() {
                                var e;
                                return e = Ot(),
                                null === e && (e = Rt()),
                                e
                            }
                            function Ot() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                "handling" === n.substr(Tr, 8).toLowerCase()
                                    ? (e = n.substr(Tr, 8), Tr += 8)
                                    : (e = null, 0 === _r && s('"handling"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? ("optional" === n.substr(Tr, 8).toLowerCase()
                                            ? (r = n.substr(Tr, 8), Tr += 8)
                                            : (r = null, 0 === _r && s('"optional"')), null === r && ("required" === n.substr(Tr, 8).toLowerCase()
                                            ? (r = n.substr(Tr, 8), Tr += 8)
                                            : (r = null, 0 === _r && s('"required"')), null === r && (r = b())), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function xt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = b(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = b(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = b(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function Dt() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = l(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = l();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    Ar = parseInt(t.join(""))
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function Pt() {
                                var e,
                                    t;
                                return t = Tr,
                                e = Ut(),
                                null !== e && (e = function(e) {
                                    Ar = n.substring(Tr, e)
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function Ut() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o;
                                if (l = Tr, e = Mt(), null !== e)
                                    if (t = D(), null !== t)
                                        if (n = Ft(), null !== n) {
                                            for (r = [], o = Tr, s = H(), null !== s
                                                ? (i = Gt(), null !== i
                                                    ? s = [s, i]
                                                    : (s = null, Tr = o))
                                                : (s = null, Tr = o); null !== s;)
                                                r.push(s),
                                                o = Tr,
                                                s = H(),
                                                null !== s
                                                    ? (i = Gt(), null !== i
                                                        ? s = [s, i]
                                                        : (s = null, Tr = o))
                                                    : (s = null, Tr = o);
                                            null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = l)
                                        }
                                    else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function Mt() {
                                var e;
                                return e = kt(),
                                null === e && (e = Lt()),
                                e
                            }
                            function kt() {
                                var e;
                                return "text" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"text"')),
                                null === e && ("image" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"image"')), null === e && ("audio" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"audio"')), null === e && ("video" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"video"')), null === e && ("application" === n.substr(Tr, 11).toLowerCase()
                                    ? (e = n.substr(Tr, 11), Tr += 11)
                                    : (e = null, 0 === _r && s('"application"')), null === e && (e = qt()))))),
                                e
                            }
                            function Lt() {
                                var e;
                                return "message" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"message"')),
                                null === e && ("multipart" === n.substr(Tr, 9).toLowerCase()
                                    ? (e = n.substr(Tr, 9), Tr += 9)
                                    : (e = null, 0 === _r && s('"multipart"')), null === e && (e = qt())),
                                e
                            }
                            function qt() {
                                var e;
                                return e = b(),
                                null === e && (e = Ht()),
                                e
                            }
                            function Ht() {
                                var e,
                                    t,
                                    r;
                                return r = Tr,
                                "x-" === n.substr(Tr, 2).toLowerCase()
                                    ? (e = n.substr(Tr, 2), Tr += 2)
                                    : (e = null, 0 === _r && s('"x-"')),
                                null !== e
                                    ? (t = b(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function Ft() {
                                var e;
                                return e = qt(),
                                null === e && (e = b()),
                                e
                            }
                            function Gt() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = b(),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (n = jt(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function jt() {
                                var e;
                                return e = b(),
                                null === e && (e = W()),
                                e
                            }
                            function Bt() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = Vt(),
                                null !== e
                                    ? (t = _(), null !== t
                                        ? (n = ut(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function Vt() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = l(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = l();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    Ar.value = parseInt(t.join(""))
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function Wt() {
                                var e,
                                    t;
                                return t = Tr,
                                e = yt(),
                                null !== e && (e = function(e, t) {
                                    Ar = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Jt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = zt(), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Rt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Rt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e, t) {
                                    Ar.event = t.join("").toLowerCase()
                                }(s, e[0])),
                                null === e && (Tr = s),
                                e
                            }
                            function zt() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                if (l = Tr, e = I(), null !== e) {
                                    for (t = [], o = Tr, 46 === n.charCodeAt(Tr)
                                        ? (r = ".", Tr++)
                                        : (r = null, 0 === _r && s('"."')), null !== r
                                        ? (i = I(), null !== i
                                            ? r = [r, i]
                                            : (r = null, Tr = o))
                                        : (r = null, Tr = o); null !== r;)
                                        t.push(r),
                                        o = Tr,
                                        46 === n.charCodeAt(Tr)
                                            ? (r = ".", Tr++)
                                            : (r = null, 0 === _r && s('"."')),
                                        null !== r
                                            ? (i = I(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = o))
                                            : (r = null, Tr = o);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l)
                                } else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function Kt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = Y(), null === e && (e = Tt()), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Yt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Yt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    var t = Ar.tag;
                                    try {
                                        Ar = new yr(Ar.uri, Ar.display_name, Ar.params),
                                        t && Ar.setParam("tag", t)
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function Yt() {
                                var e;
                                return e = $t(),
                                null === e && (e = Rt()),
                                e
                            }
                            function $t() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "tag" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"tag"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = b(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.tag = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function Xt() {
                                var e,
                                    t,
                                    n;
                                if (n = Tr, t = l(), null !== t)
                                    for (e = []; null !== t;)
                                        e.push(t),
                                        t = l();
                            else
                                    e = null;
                                return null !== e && (e = function(e, t) {
                                    Ar = parseInt(t.join(""))
                                }(n, e)),
                                null === e && (Tr = n),
                                e
                            }
                            function Qt() {
                                var e,
                                    t;
                                return t = Tr,
                                e = yt(),
                                null !== e && (e = function(e, t) {
                                    Ar = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Zt() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u;
                                for (o = Tr, a = Tr, e = [], t = _t(); null !== t;)
                                    e.push(t),
                                    t = _t();
                                if (null !== e)
                                    if (t = L(), null !== t)
                                        if (n = $(), null !== n)
                                            if (r = k(), null !== r) {
                                                for (s = [], u = Tr, i = H(), null !== i
                                                    ? (l = Rt(), null !== l
                                                        ? i = [i, l]
                                                        : (i = null, Tr = u))
                                                    : (i = null, Tr = u); null !== i;)
                                                    s.push(i),
                                                    u = Tr,
                                                    i = H(),
                                                    null !== i
                                                        ? (l = Rt(), null !== l
                                                            ? i = [i, l]
                                                            : (i = null, Tr = u))
                                                        : (i = null, Tr = u);
                                                null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = a)
                                            }
                                        else
                                    e = null,
                                    Tr = a;
                                else
                                    e = null,
                                    Tr = a;
                                else
                                    e = null,
                                    Tr = a;
                                else
                                    e = null,
                                    Tr = a;
                                return null !== e && (e = function(e) {
                                    try {
                                        Ar = new yr(Ar.uri, Ar.display_name, Ar.params)
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(o)),
                                null === e && (Tr = o),
                                e
                            }
                            function en() {
                                var e;
                                return e = tn()
                            }
                            function tn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u;
                                if (a = Tr, "digest" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"Digest"')), null !== e)
                                    if (t = _(), null !== t)
                                        if (r = sn(), null !== r) {
                                            for (i = [], u = Tr, l = q(), null !== l
                                                ? (o = sn(), null !== o
                                                    ? l = [l, o]
                                                    : (l = null, Tr = u))
                                                : (l = null, Tr = u); null !== l;)
                                                i.push(l),
                                                u = Tr,
                                                l = q(),
                                                null !== l
                                                    ? (o = sn(), null !== o
                                                        ? l = [l, o]
                                                        : (l = null, Tr = u))
                                                    : (l = null, Tr = u);
                                            null !== i
                                                ? e = [e, t, r, i]
                                                : (e = null, Tr = a)
                                        }
                                    else
                                    e = null,
                                    Tr = a;
                                else
                                    e = null,
                                    Tr = a;
                                else
                                    e = null,
                                    Tr = a;
                                return null === e && (e = nn()),
                                e
                            }
                            function nn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o;
                                if (l = Tr, e = b(), null !== e)
                                    if (t = _(), null !== t)
                                        if (n = rn(), null !== n) {
                                            for (r = [], o = Tr, s = q(), null !== s
                                                ? (i = rn(), null !== i
                                                    ? s = [s, i]
                                                    : (s = null, Tr = o))
                                                : (s = null, Tr = o); null !== s;)
                                                r.push(s),
                                                o = Tr,
                                                s = q(),
                                                null !== s
                                                    ? (i = rn(), null !== i
                                                        ? s = [s, i]
                                                        : (s = null, Tr = o))
                                                    : (s = null, Tr = o);
                                            null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = l)
                                        }
                                    else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function rn() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = b(),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (n = b(), null === n && (n = W()), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function sn() {
                                var e;
                                return e = ln(),
                                null === e && (e = an(), null === e && (e = cn(), null === e && (e = hn(), null === e && (e = pn(), null === e && (e = fn(), null === e && (e = mn(), null === e && (e = rn()))))))),
                                e
                            }
                            function ln() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                "realm" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"realm"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = on(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function on() {
                                var e,
                                    t;
                                return t = Tr,
                                e = J(),
                                null !== e && (e = function(e, t) {
                                    Ar.realm = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function an() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c;
                                if (u = Tr, "domain" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"domain"')), null !== e)
                                    if (t = P(), null !== t)
                                        if (r = G(), null !== r)
                                            if (i = un(), null !== i) {
                                                if (l = [], c = Tr, a = h(), null !== a)
                                                    for (o = []; null !== a;)
                                                        o.push(a),
                                                        a = h();
                                            else
                                                    o = null;
                                                for (null !== o
                                                    ? (a = un(), null !== a
                                                        ? o = [o, a]
                                                        : (o = null, Tr = c))
                                                    : (o = null, Tr = c); null !== o;) {
                                                    if (l.push(o), c = Tr, a = h(), null !== a)
                                                        for (o = []; null !== a;)
                                                            o.push(a),
                                                            a = h();
                                                else
                                                        o = null;
                                                    null !== o
                                                        ? (a = un(), null !== a
                                                            ? o = [o, a]
                                                            : (o = null, Tr = c))
                                                        : (o = null, Tr = c)
                                                }
                                                null !== l
                                                    ? (o = j(), null !== o
                                                        ? e = [
                                                            e,
                                                            t,
                                                            r,
                                                            i,
                                                            l,
                                                            o
                                                        ]
                                                        : (e = null, Tr = u))
                                                    : (e = null, Tr = u)
                                            }
                                        else
                                    e = null,
                                    Tr = u;
                                else
                                    e = null,
                                    Tr = u;
                                else
                                    e = null,
                                    Tr = u;
                                else
                                    e = null,
                                    Tr = u;
                                return e
                            }
                            function un() {
                                var e;
                                return e = Le(),
                                null === e && (e = Fe()),
                                e
                            }
                            function cn() {
                                var e,
                                    t,
                                    r,
                                    i;
                                return i = Tr,
                                "nonce" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"nonce"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = dn(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function dn() {
                                var e,
                                    t;
                                return t = Tr,
                                e = J(),
                                null !== e && (e = function(e, t) {
                                    Ar.nonce = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function hn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "opaque" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"opaque"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = J(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.opaque = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function pn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                "stale" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"stale"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (l = Tr, "true" === n.substr(Tr, 4).toLowerCase()
                                            ? (r = n.substr(Tr, 4), Tr += 4)
                                            : (r = null, 0 === _r && s('"true"')), null !== r && (r = function(e) {
                                            Ar.stale = !0
                                        }(l)), null === r && (Tr = l), null === r && (l = Tr, "false" === n.substr(Tr, 5).toLowerCase()
                                            ? (r = n.substr(Tr, 5), Tr += 5)
                                            : (r = null, 0 === _r && s('"false"')), null !== r && (r = function(e) {
                                            Ar.stale = !1
                                        }(l)), null === r && (Tr = l)), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function fn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "algorithm" === n.substr(Tr, 9).toLowerCase()
                                    ? (e = n.substr(Tr, 9), Tr += 9)
                                    : (e = null, 0 === _r && s('"algorithm"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? ("md5" === n.substr(Tr, 3).toLowerCase()
                                            ? (r = n.substr(Tr, 3), Tr += 3)
                                            : (r = null, 0 === _r && s('"MD5"')), null === r && ("md5-sess" === n.substr(Tr, 8).toLowerCase()
                                            ? (r = n.substr(Tr, 8), Tr += 8)
                                            : (r = null, 0 === _r && s('"MD5-sess"')), null === r && (r = b())), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.algorithm = t.toUpperCase()
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function mn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c,
                                    d;
                                if (u = Tr, "qop" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"qop"')), null !== e)
                                    if (t = P(), null !== t)
                                        if (r = G(), null !== r) {
                                            if (c = Tr, i = gn(), null !== i) {
                                                for (l = [], d = Tr, 44 === n.charCodeAt(Tr)
                                                    ? (o = ",", Tr++)
                                                    : (o = null, 0 === _r && s('","')), null !== o
                                                    ? (a = gn(), null !== a
                                                        ? o = [o, a]
                                                        : (o = null, Tr = d))
                                                    : (o = null, Tr = d); null !== o;)
                                                    l.push(o),
                                                    d = Tr,
                                                    44 === n.charCodeAt(Tr)
                                                        ? (o = ",", Tr++)
                                                        : (o = null, 0 === _r && s('","')),
                                                    null !== o
                                                        ? (a = gn(), null !== a
                                                            ? o = [o, a]
                                                            : (o = null, Tr = d))
                                                        : (o = null, Tr = d);
                                                null !== l
                                                    ? i = [i, l]
                                                    : (i = null, Tr = c)
                                            } else
                                                i = null,
                                                Tr = c;
                                            null !== i
                                                ? (l = j(), null !== l
                                                    ? e = [e, t, r, i, l]
                                                    : (e = null, Tr = u))
                                                : (e = null, Tr = u)
                                        }
                                    else
                                    e = null,
                                    Tr = u;
                                else
                                    e = null,
                                    Tr = u;
                                else
                                    e = null,
                                    Tr = u;
                                return e
                            }
                            function gn() {
                                var e,
                                    t;
                                return t = Tr,
                                "auth-int" === n.substr(Tr, 8).toLowerCase()
                                    ? (e = n.substr(Tr, 8), Tr += 8)
                                    : (e = null, 0 === _r && s('"auth-int"')),
                                null === e && ("auth" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"auth"')), null === e && (e = b())),
                                null !== e && (e = function(e, t) {
                                    Ar.qop || (Ar.qop = []),
                                    Ar.qop.push(t.toLowerCase())
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function vn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = b(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = b(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = b(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function Tn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = _n(), null !== e) {
                                    for (t = [], l = Tr, n = q(), null !== n
                                        ? (r = _n(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = _n(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    var t,
                                        n;
                                    for (n = Ar.multi_header.length, t = 0; t < n; t++)
                                        if (null === Ar.multi_header[t].parsed) {
                                            Ar = null;
                                            break
                                        }
                                    Ar = null !== Ar
                                        ? Ar.multi_header
                                        : -1
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function _n() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = Tt(), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Rt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Rt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    var t;
                                    Ar.multi_header || (Ar.multi_header = []);
                                    try {
                                        t = new yr(Ar.uri, Ar.display_name, Ar.params),
                                        delete Ar.uri,
                                        delete Ar.display_name,
                                        delete Ar.params
                                    } catch (e) {
                                        t = null
                                    }
                                    Ar.multi_header.push({possition: Tr, offset: e, parsed: t})
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function Cn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a;
                                if (l = Tr, o = Tr, "sip" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"SIP"')), null === e && (e = b()), null !== e) {
                                    for (t = [], a = Tr, r = H(), null !== r
                                        ? (i = Sn(), null !== i
                                            ? r = [r, i]
                                            : (r = null, Tr = a))
                                        : (r = null, Tr = a); null !== r;)
                                        t.push(r),
                                        a = Tr,
                                        r = H(),
                                        null !== r
                                            ? (i = Sn(), null !== i
                                                ? r = [r, i]
                                                : (r = null, Tr = a))
                                            : (r = null, Tr = a);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = o)
                                } else
                                    e = null,
                                    Tr = o;
                                return null !== e && (e = function(e, t) {
                                    if (Ar.protocol = t.toLowerCase(), Ar.params || (Ar.params = {}), Ar.params.text && '"' === Ar.params.text[0]) {
                                        var n = Ar.params.text;
                                        Ar.text = n.substring(1, n.length - 1),
                                        delete Ar.params.text
                                    }
                                }(l, e[0])),
                                null === e && (Tr = l),
                                e
                            }
                            function Sn() {
                                var e;
                                return e = En(),
                                null === e && (e = Rt()),
                                e
                            }
                            function En() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    o,
                                    a;
                                if (o = Tr, a = Tr, "cause" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"cause"')), null !== e)
                                    if (t = P(), null !== t) {
                                        if (i = l(), null !== i)
                                            for (r = []; null !== i;)
                                                r.push(i),
                                                i = l();
                                    else
                                            r = null;
                                        null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = a)
                                    } else
                                        e = null,
                                        Tr = a;
                            else
                                    e = null,
                                    Tr = a;
                                return null !== e && (e = function(e, t) {
                                    Ar.cause = parseInt(t.join(""))
                                }(o, e[2])),
                                null === e && (Tr = o),
                                e
                            }
                            function yn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = b(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = b(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = b(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function An() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = Rn(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = Rn(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = Rn(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function Rn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = Tt(), null !== e) {
                                    for (t = [], i = Tr, n = H(), null !== n
                                        ? (r = Rt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Rt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function wn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = bn(), null !== e) {
                                    for (t = [], i = Tr, n = H(), null !== n
                                        ? (r = In(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = In(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function bn() {
                                var e,
                                    t;
                                return t = Tr,
                                "active" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"active"')),
                                null === e && ("pending" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"pending"')), null === e && ("terminated" === n.substr(Tr, 10).toLowerCase()
                                    ? (e = n.substr(Tr, 10), Tr += 10)
                                    : (e = null, 0 === _r && s('"terminated"')), null === e && (e = b()))),
                                null !== e && (e = function(e) {
                                    Ar.state = n.substring(Tr, e)
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function In() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "reason" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"reason"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = Nn(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    "undefined" != typeof t && (Ar.reason = t)
                                }(i, e[2])),
                                null === e && (Tr = i),
                                null === e && (i = Tr, l = Tr, "expires" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"expires"')), null !== e
                                    ? (t = P(), null !== t
                                        ? (r = yt(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l), null !== e && (e = function(e, t) {
                                    "undefined" != typeof t && (Ar.expires = t)
                                }(i, e[2])), null === e && (Tr = i), null === e && (i = Tr, l = Tr, "retry_after" === n.substr(Tr, 11).toLowerCase()
                                    ? (e = n.substr(Tr, 11), Tr += 11)
                                    : (e = null, 0 === _r && s('"retry_after"')), null !== e
                                    ? (t = P(), null !== t
                                        ? (r = yt(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l), null !== e && (e = function(e, t) {
                                    "undefined" != typeof t && (Ar.retry_after = t)
                                }(i, e[2])), null === e && (Tr = i), null === e && (e = Rt()))),
                                e
                            }
                            function Nn() {
                                var e;
                                return "deactivated" === n.substr(Tr, 11).toLowerCase()
                                    ? (e = n.substr(Tr, 11), Tr += 11)
                                    : (e = null, 0 === _r && s('"deactivated"')),
                                null === e && ("probation" === n.substr(Tr, 9).toLowerCase()
                                    ? (e = n.substr(Tr, 9), Tr += 9)
                                    : (e = null, 0 === _r && s('"probation"')), null === e && ("rejected" === n.substr(Tr, 8).toLowerCase()
                                    ? (e = n.substr(Tr, 8), Tr += 8)
                                    : (e = null, 0 === _r && s('"rejected"')), null === e && ("timeout" === n.substr(Tr, 7).toLowerCase()
                                    ? (e = n.substr(Tr, 7), Tr += 7)
                                    : (e = null, 0 === _r && s('"timeout"')), null === e && ("giveup" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"giveup"')), null === e && ("noresource" === n.substr(Tr, 10).toLowerCase()
                                    ? (e = n.substr(Tr, 10), Tr += 10)
                                    : (e = null, 0 === _r && s('"noresource"')), null === e && ("invariant" === n.substr(Tr, 9).toLowerCase()
                                    ? (e = n.substr(Tr, 9), Tr += 9)
                                    : (e = null, 0 === _r && s('"invariant"')), null === e && (e = b()))))))),
                                e
                            }
                            function On() {
                                var e;
                                return e = E(),
                                e = null !== e
                                    ? e
                                    : ""
                            }
                            function xn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = b(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = b(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = b(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e = null !== e
                                    ? e
                                    : ""
                            }
                            function Dn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = Y(), null === e && (e = Tt()), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Pn(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Pn(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    var t = Ar.tag;
                                    try {
                                        Ar = new yr(Ar.uri, Ar.display_name, Ar.params),
                                        t && Ar.setParam("tag", t)
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function Pn() {
                                var e;
                                return e = $t(),
                                null === e && (e = Rt()),
                                e
                            }
                            function Un() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = Mn(), null !== e) {
                                    for (t = [], i = Tr, n = q(), null !== n
                                        ? (r = Mn(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = q(),
                                        null !== n
                                            ? (r = Mn(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function Mn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l,
                                    o;
                                if (l = Tr, e = jn(), null !== e)
                                    if (t = _(), null !== t)
                                        if (n = Wn(), null !== n) {
                                            for (r = [], o = Tr, s = H(), null !== s
                                                ? (i = kn(), null !== i
                                                    ? s = [s, i]
                                                    : (s = null, Tr = o))
                                                : (s = null, Tr = o); null !== s;)
                                                r.push(s),
                                                o = Tr,
                                                s = H(),
                                                null !== s
                                                    ? (i = kn(), null !== i
                                                        ? s = [s, i]
                                                        : (s = null, Tr = o))
                                                    : (s = null, Tr = o);
                                            null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = l)
                                        }
                                    else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                else
                                    e = null,
                                    Tr = l;
                                return e
                            }
                            function kn() {
                                var e;
                                return e = Ln(),
                                null === e && (e = qn(), null === e && (e = Hn(), null === e && (e = Fn(), null === e && (e = Gn(), null === e && (e = Rt()))))),
                                e
                            }
                            function Ln() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "ttl" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"ttl"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = Kn(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.ttl = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function qn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "maddr" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"maddr"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = ie(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.maddr = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function Hn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "received" === n.substr(Tr, 8).toLowerCase()
                                    ? (e = n.substr(Tr, 8), Tr += 8)
                                    : (e = null, 0 === _r && s('"received"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = pe(), null === r && (r = ce()), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.received = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function Fn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "branch" === n.substr(Tr, 6).toLowerCase()
                                    ? (e = n.substr(Tr, 6), Tr += 6)
                                    : (e = null, 0 === _r && s('"branch"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = b(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.branch = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function Gn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    o,
                                    a,
                                    u;
                                if (o = Tr, a = Tr, "rport" === n.substr(Tr, 5).toLowerCase()
                                    ? (e = n.substr(Tr, 5), Tr += 5)
                                    : (e = null, 0 === _r && s('"rport"')), null !== e) {
                                    if (u = Tr, t = P(), null !== t) {
                                        for (r = [], i = l(); null !== i;)
                                            r.push(i),
                                            i = l();
                                        null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = u)
                                    } else
                                        t = null,
                                        Tr = u;
                                    t = null !== t
                                        ? t
                                        : "",
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = a)
                                } else
                                    e = null,
                                    Tr = a;
                                return null !== e && (e = function(e) {
                                    "undefined" != typeof response_port && (Ar.rport = response_port.join(""))
                                }(o)),
                                null === e && (Tr = o),
                                e
                            }
                            function jn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                return i = Tr,
                                e = Bn(),
                                null !== e
                                    ? (t = D(), null !== t
                                        ? (n = b(), null !== n
                                            ? (r = D(), null !== r
                                                ? (s = Vn(), null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = i))
                                                : (e = null, Tr = i))
                                            : (e = null, Tr = i))
                                        : (e = null, Tr = i))
                                    : (e = null, Tr = i),
                                e
                            }
                            function Bn() {
                                var e,
                                    t;
                                return t = Tr,
                                "sip" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"SIP"')),
                                null === e && (e = b()),
                                null !== e && (e = function(e, t) {
                                    Ar.protocol = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Vn() {
                                var e,
                                    t;
                                return t = Tr,
                                "udp" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"UDP"')),
                                null === e && ("tcp" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"TCP"')), null === e && ("tls" === n.substr(Tr, 3).toLowerCase()
                                    ? (e = n.substr(Tr, 3), Tr += 3)
                                    : (e = null, 0 === _r && s('"TLS"')), null === e && ("sctp" === n.substr(Tr, 4).toLowerCase()
                                    ? (e = n.substr(Tr, 4), Tr += 4)
                                    : (e = null, 0 === _r && s('"SCTP"')), null === e && (e = b())))),
                                null !== e && (e = function(e, t) {
                                    Ar.transport = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Wn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s;
                                return r = Tr,
                                e = Jn(),
                                null !== e
                                    ? (s = Tr, t = F(), null !== t
                                        ? (n = zn(), null !== n
                                            ? t = [t, n]
                                            : (t = null, Tr = s))
                                        : (t = null, Tr = s), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function Jn() {
                                var e,
                                    t;
                                return t = Tr,
                                e = pe(),
                                null === e && (e = ue(), null === e && (e = le())),
                                null !== e && (e = function(e) {
                                    Ar.host = n.substring(Tr, e)
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function zn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    o;
                                return i = Tr,
                                o = Tr,
                                e = l(),
                                e = null !== e
                                    ? e
                                    : "",
                                null !== e
                                    ? (t = l(), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (n = l(), n = null !== n
                                            ? n
                                            : "", null !== n
                                            ? (r = l(), r = null !== r
                                                ? r
                                                : "", null !== r
                                                ? (s = l(), s = null !== s
                                                    ? s
                                                    : "", null !== s
                                                    ? e = [e, t, n, r, s]
                                                    : (e = null, Tr = o))
                                                : (e = null, Tr = o))
                                            : (e = null, Tr = o))
                                        : (e = null, Tr = o))
                                    : (e = null, Tr = o),
                                null !== e && (e = function(e, t) {
                                    Ar.port = parseInt(t.join(""))
                                }(i, e)),
                                null === e && (Tr = i),
                                e
                            }
                            function Kn() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s;
                                return r = Tr,
                                s = Tr,
                                e = l(),
                                null !== e
                                    ? (t = l(), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? (n = l(), n = null !== n
                                            ? n
                                            : "", null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = s))
                                        : (e = null, Tr = s))
                                    : (e = null, Tr = s),
                                null !== e && (e = function(e, t) {
                                    return parseInt(t.join(""))
                                }(r, e)),
                                null === e && (Tr = r),
                                e
                            }
                            function Yn() {
                                var e;
                                return e = tn()
                            }
                            function $n() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = Xn(), null !== e) {
                                    for (t = [], i = Tr, n = H(), null !== n
                                        ? (r = Qn(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Qn(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function Xn() {
                                var e,
                                    t;
                                return t = Tr,
                                e = yt(),
                                null !== e && (e = function(e, t) {
                                    Ar.expires = t
                                }(t, e)),
                                null === e && (Tr = t),
                                e
                            }
                            function Qn() {
                                var e;
                                return e = Zn(),
                                null === e && (e = Rt()),
                                e
                            }
                            function Zn() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "refresher" === n.substr(Tr, 9).toLowerCase()
                                    ? (e = n.substr(Tr, 9), Tr += 9)
                                    : (e = null, 0 === _r && s('"refresher"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? ("uac" === n.substr(Tr, 3).toLowerCase()
                                            ? (r = n.substr(Tr, 3), Tr += 3)
                                            : (r = null, 0 === _r && s('"uac"')), null === r && ("uas" === n.substr(Tr, 3).toLowerCase()
                                            ? (r = n.substr(Tr, 3), Tr += 3)
                                            : (r = null, 0 === _r && s('"uas"'))), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.refresher = t.toLowerCase()
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function er() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = b(),
                                null !== e
                                    ? (t = S(), null !== t
                                        ? (n = tr(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function tr() {
                                var e,
                                    t;
                                for (e = [], t = y(), null === t && (t = R(), null === t && (t = _())); null !== t;)
                                    e.push(t),
                                    t = y(),
                                    null === t && (t = R(), null === t && (t = _()));
                                return e
                            }
                            function nr() {
                                var e,
                                    t;
                                for (e = [], t = c(); null !== t;)
                                    e.push(t),
                                    t = c();
                                return e
                            }
                            function rr() {
                                var e,
                                    t,
                                    r;
                                return r = Tr,
                                "uuid:" === n.substr(Tr, 5)
                                    ? (e = "uuid:", Tr += 5)
                                    : (e = null, 0 === _r && s('"uuid:"')),
                                null !== e
                                    ? (t = sr(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function sr() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o,
                                    a,
                                    u,
                                    c,
                                    d,
                                    h;
                                return d = Tr,
                                h = Tr,
                                e = lr(),
                                null !== e
                                    ? (45 === n.charCodeAt(Tr)
                                        ? (t = "-", Tr++)
                                        : (t = null, 0 === _r && s('"-"')), null !== t
                                        ? (r = ir(), null !== r
                                            ? (45 === n.charCodeAt(Tr)
                                                ? (i = "-", Tr++)
                                                : (i = null, 0 === _r && s('"-"')), null !== i
                                                ? (l = ir(), null !== l
                                                    ? (45 === n.charCodeAt(Tr)
                                                        ? (o = "-", Tr++)
                                                        : (o = null, 0 === _r && s('"-"')), null !== o
                                                        ? (a = ir(), null !== a
                                                            ? (45 === n.charCodeAt(Tr)
                                                                ? (u = "-", Tr++)
                                                                : (u = null, 0 === _r && s('"-"')), null !== u
                                                                ? (c = or(), null !== c
                                                                    ? e = [
                                                                        e,
                                                                        t,
                                                                        r,
                                                                        i,
                                                                        l,
                                                                        o,
                                                                        a,
                                                                        u,
                                                                        c
                                                                    ]
                                                                    : (e = null, Tr = h))
                                                                : (e = null, Tr = h))
                                                            : (e = null, Tr = h))
                                                        : (e = null, Tr = h))
                                                    : (e = null, Tr = h))
                                                : (e = null, Tr = h))
                                            : (e = null, Tr = h))
                                        : (e = null, Tr = h))
                                    : (e = null, Tr = h),
                                null !== e && (e = function(e, t) {
                                    Ar = n.substring(Tr + 5, e)
                                }(d, e[0])),
                                null === e && (Tr = d),
                                e
                            }
                            function ir() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s;
                                return s = Tr,
                                e = a(),
                                null !== e
                                    ? (t = a(), null !== t
                                        ? (n = a(), null !== n
                                            ? (r = a(), null !== r
                                                ? e = [e, t, n, r]
                                                : (e = null, Tr = s))
                                            : (e = null, Tr = s))
                                        : (e = null, Tr = s))
                                    : (e = null, Tr = s),
                                e
                            }
                            function lr() {
                                var e,
                                    t,
                                    n;
                                return n = Tr,
                                e = ir(),
                                null !== e
                                    ? (t = ir(), null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = n))
                                    : (e = null, Tr = n),
                                e
                            }
                            function or() {
                                var e,
                                    t,
                                    n,
                                    r;
                                return r = Tr,
                                e = ir(),
                                null !== e
                                    ? (t = ir(), null !== t
                                        ? (n = ir(), null !== n
                                            ? e = [e, t, n]
                                            : (e = null, Tr = r))
                                        : (e = null, Tr = r))
                                    : (e = null, Tr = r),
                                e
                            }
                            function ar() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i,
                                    l;
                                if (s = Tr, i = Tr, e = Y(), null === e && (e = Tt()), null !== e) {
                                    for (t = [], l = Tr, n = H(), null !== n
                                        ? (r = Rt(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = l))
                                        : (n = null, Tr = l); null !== n;)
                                        t.push(n),
                                        l = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = Rt(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = l))
                                            : (n = null, Tr = l);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = i)
                                } else
                                    e = null,
                                    Tr = i;
                                return null !== e && (e = function(e) {
                                    try {
                                        Ar = new yr(Ar.uri, Ar.display_name, Ar.params)
                                    } catch (e) {
                                        Ar = -1
                                    }
                                }(s)),
                                null === e && (Tr = s),
                                e
                            }
                            function ur() {
                                var e,
                                    t,
                                    n,
                                    r,
                                    s,
                                    i;
                                if (s = Tr, e = cr(), null !== e) {
                                    for (t = [], i = Tr, n = H(), null !== n
                                        ? (r = dr(), null !== r
                                            ? n = [n, r]
                                            : (n = null, Tr = i))
                                        : (n = null, Tr = i); null !== n;)
                                        t.push(n),
                                        i = Tr,
                                        n = H(),
                                        null !== n
                                            ? (r = dr(), null !== r
                                                ? n = [n, r]
                                                : (n = null, Tr = i))
                                            : (n = null, Tr = i);
                                    null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = s)
                                } else
                                    e = null,
                                    Tr = s;
                                return e
                            }
                            function cr() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l,
                                    o;
                                return i = Tr,
                                l = Tr,
                                e = O(),
                                null !== e
                                    ? (o = Tr, 64 === n.charCodeAt(Tr)
                                        ? (t = "@", Tr++)
                                        : (t = null, 0 === _r && s('"@"')), null !== t
                                        ? (r = O(), null !== r
                                            ? t = [t, r]
                                            : (t = null, Tr = o))
                                        : (t = null, Tr = o), t = null !== t
                                        ? t
                                        : "", null !== t
                                        ? e = [e, t]
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e) {
                                    Ar.call_id = n.substring(Tr, e)
                                }(i)),
                                null === e && (Tr = i),
                                e
                            }
                            function dr() {
                                var e;
                                return e = hr(),
                                null === e && (e = pr(), null === e && (e = fr(), null === e && (e = Rt()))),
                                e
                            }
                            function hr() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "to-tag" === n.substr(Tr, 6)
                                    ? (e = "to-tag", Tr += 6)
                                    : (e = null, 0 === _r && s('"to-tag"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = b(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.to_tag = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function pr() {
                                var e,
                                    t,
                                    r,
                                    i,
                                    l;
                                return i = Tr,
                                l = Tr,
                                "from-tag" === n.substr(Tr, 8)
                                    ? (e = "from-tag", Tr += 8)
                                    : (e = null, 0 === _r && s('"from-tag"')),
                                null !== e
                                    ? (t = P(), null !== t
                                        ? (r = b(), null !== r
                                            ? e = [e, t, r]
                                            : (e = null, Tr = l))
                                        : (e = null, Tr = l))
                                    : (e = null, Tr = l),
                                null !== e && (e = function(e, t) {
                                    Ar.from_tag = t
                                }(i, e[2])),
                                null === e && (Tr = i),
                                e
                            }
                            function fr() {
                                var e,
                                    t;
                                return t = Tr,
                                "early-only" === n.substr(Tr, 10)
                                    ? (e = "early-only", Tr += 10)
                                    : (e = null, 0 === _r && s('"early-only"')),
                                null !== e && (e = function(e) {
                                    Ar.early_only = !0
                                }(t)),
                                null === e && (Tr = t),
                                e
                            }
                            function mr(e) {
                                e.sort();
                                for (var t = null, n = [], r = 0; r < e.length; r++)
                                    e[r] !== t && (n.push(e[r]), t = e[r]);
                                return n
                            }
                            function gr() {
                                for (var e = 1, t = 1, r = !1, s = 0; s < Math.max(Tr, Cr); s++) {
                                    var i = n.charAt(s);
                                    "\n" === i
                                        ? (r || e++, t = 1, r = !1)
                                        : "\r" === i || "\u2028" === i || "\u2029" === i
                                            ? (e++, t = 1, r = !0)
                                            : (t++, r = !1)
                                }
                                return {line: e, column: t}
                            }
                            var vr = {
                                CRLF: i,
                                DIGIT: l,
                                ALPHA: o,
                                HEXDIG: a,
                                WSP: u,
                                OCTET: c,
                                DQUOTE: d,
                                SP: h,
                                HTAB: p,
                                alphanum: f,
                                reserved: m,
                                unreserved: g,
                                mark: v,
                                escaped: T,
                                LWS: _,
                                SWS: C,
                                HCOLON: S,
                                TEXT_UTF8_TRIM: E,
                                TEXT_UTF8char: y,
                                UTF8_NONASCII: A,
                                UTF8_CONT: R,
                                LHEX: w,
                                token: b,
                                token_nodot: I,
                                separators: N,
                                word: O,
                                STAR: x,
                                SLASH: D,
                                EQUAL: P,
                                LPAREN: U,
                                RPAREN: M,
                                RAQUOT: k,
                                LAQUOT: L,
                                COMMA: q,
                                SEMI: H,
                                COLON: F,
                                LDQUOT: G,
                                RDQUOT: j,
                                comment: B,
                                ctext: V,
                                quoted_string: W,
                                quoted_string_clean: J,
                                qdtext: z,
                                quoted_pair: K,
                                SIP_URI_noparams: Y,
                                SIP_URI: $,
                                uri_scheme: X,
                                uri_scheme_sips: Q,
                                uri_scheme_sip: Z,
                                userinfo: ee,
                                user: te,
                                user_unreserved: ne,
                                password: re,
                                hostport: se,
                                host: ie,
                                hostname: le,
                                domainlabel: oe,
                                toplabel: ae,
                                IPv6reference: ue,
                                IPv6address: ce,
                                h16: de,
                                ls32: he,
                                IPv4address: pe,
                                dec_octet: fe,
                                port: me,
                                uri_parameters: ge,
                                uri_parameter: ve,
                                transport_param: Te,
                                user_param: _e,
                                method_param: Ce,
                                ttl_param: Se,
                                maddr_param: Ee,
                                lr_param: ye,
                                other_param: Ae,
                                pname: Re,
                                pvalue: we,
                                paramchar: be,
                                param_unreserved: Ie,
                                headers: Ne,
                                header: Oe,
                                hname: xe,
                                hvalue: De,
                                hnv_unreserved: Pe,
                                Request_Response: Ue,
                                Request_Line: Me,
                                Request_URI: ke,
                                absoluteURI: Le,
                                hier_part: qe,
                                net_path: He,
                                abs_path: Fe,
                                opaque_part: Ge,
                                uric: je,
                                uric_no_slash: Be,
                                path_segments: Ve,
                                segment: We,
                                param: Je,
                                pchar: ze,
                                scheme: Ke,
                                authority: Ye,
                                srvr: $e,
                                reg_name: Xe,
                                query: Qe,
                                SIP_Version: Ze,
                                INVITEm: et,
                                ACKm: tt,
                                OPTIONSm: nt,
                                BYEm: rt,
                                CANCELm: st,
                                REGISTERm: it,
                                SUBSCRIBEm: lt,
                                NOTIFYm: ot,
                                REFERm: at,
                                Method: ut,
                                Status_Line: ct,
                                Status_Code: dt,
                                extension_code: ht,
                                Reason_Phrase: pt,
                                Allow_Events: ft,
                                Call_ID: mt,
                                Contact: gt,
                                contact_param: vt,
                                name_addr: Tt,
                                display_name: _t,
                                contact_params: Ct,
                                c_p_q: St,
                                c_p_expires: Et,
                                delta_seconds: yt,
                                qvalue: At,
                                generic_param: Rt,
                                gen_value: wt,
                                Content_Disposition: bt,
                                disp_type: It,
                                disp_param: Nt,
                                handling_param: Ot,
                                Content_Encoding: xt,
                                Content_Length: Dt,
                                Content_Type: Pt,
                                media_type: Ut,
                                m_type: Mt,
                                discrete_type: kt,
                                composite_type: Lt,
                                extension_token: qt,
                                x_token: Ht,
                                m_subtype: Ft,
                                m_parameter: Gt,
                                m_value: jt,
                                CSeq: Bt,
                                CSeq_value: Vt,
                                Expires: Wt,
                                Event: Jt,
                                event_type: zt,
                                From: Kt,
                                from_param: Yt,
                                tag_param: $t,
                                Max_Forwards: Xt,
                                Min_Expires: Qt,
                                Name_Addr_Header: Zt,
                                Proxy_Authenticate: en,
                                challenge: tn,
                                other_challenge: nn,
                                auth_param: rn,
                                digest_cln: sn,
                                realm: ln,
                                realm_value: on,
                                domain: an,
                                URI: un,
                                nonce: cn,
                                nonce_value: dn,
                                opaque: hn,
                                stale: pn,
                                algorithm: fn,
                                qop_options: mn,
                                qop_value: gn,
                                Proxy_Require: vn,
                                Record_Route: Tn,
                                rec_route: _n,
                                Reason: Cn,
                                reason_param: Sn,
                                reason_cause: En,
                                Require: yn,
                                Route: An,
                                route_param: Rn,
                                Subscription_State: wn,
                                substate_value: bn,
                                subexp_params: In,
                                event_reason_value: Nn,
                                Subject: On,
                                Supported: xn,
                                To: Dn,
                                to_param: Pn,
                                Via: Un,
                                via_param: Mn,
                                via_params: kn,
                                via_ttl: Ln,
                                via_maddr: qn,
                                via_received: Hn,
                                via_branch: Fn,
                                response_port: Gn,
                                sent_protocol: jn,
                                protocol_name: Bn,
                                transport: Vn,
                                sent_by: Wn,
                                via_host: Jn,
                                via_port: zn,
                                ttl: Kn,
                                WWW_Authenticate: Yn,
                                Session_Expires: $n,
                                s_e_expires: Xn,
                                s_e_params: Qn,
                                s_e_refresher: Zn,
                                extension_header: er,
                                header_value: tr,
                                message_body: nr,
                                uuid_URI: rr,
                                uuid: sr,
                                hex4: ir,
                                hex8: lr,
                                hex12: or,
                                Refer_To: ar,
                                Replaces: ur,
                                call_id: cr,
                                replaces_param: dr,
                                to_tag: hr,
                                from_tag: pr,
                                early_flag: fr
                            };
                            if (void 0 !== r) {
                                if (void 0 === vr[r])
                                    throw new Error("Invalid rule name: " + t(r) + ".")
                            } else
                                r = "CRLF";
                            var Tr = 0,
                                _r = 0,
                                Cr = 0,
                                Sr = [],
                                Er = e("./URI"),
                                yr = e("./NameAddrHeader"),
                                Ar = {},
                                Rr = vr[r]();
                            if (null === Rr || Tr !== n.length) {
                                var wr = Math.max(Tr, Cr),
                                    br = wr < n.length
                                        ? n.charAt(wr)
                                        : null,
                                    Ir = gr();
                                return new this.SyntaxError(mr(Sr), br, wr, Ir.line, Ir.column),
                                -1
                            }
                            return Ar
                        },
                        toSource: function() {
                            return this._source
                        }
                    };
                    return n.SyntaxError = function(e, n, r, s, i) {
                        function l(e, n) {
                            var r,
                                s;
                            switch (e.length) {
                                case 0:
                                    r = "end of input";
                                    break;
                                case 1:
                                    r = e[0];
                                    break;
                                default:
                                    r = e.slice(0, e.length - 1).join(", ") + " or " + e[e.length - 1]
                            }
                            return s = n
                                ? t(n)
                                : "end of input",
                            "Expected " + r + " but " + s + " found."
                        }
                        this.name = "SyntaxError",
                        this.expected = e,
                        this.found = n,
                        this.message = l(e, n),
                        this.offset = r,
                        this.line = s,
                        this.column = i
                    },
                    n.SyntaxError.prototype = Error.prototype,
                    n
                }()
            }, {
                "./NameAddrHeader": 9,
                "./URI": 25
            }
        ],
        7: [
            function(e, t, n) {
                var r = e("debug")("JsSIP"),
                    s = e("webrtc-adapter"),
                    i = e("../package.json");
                r("version %s", i.version);
                var l = e("./Constants"),
                    o = e("./Exceptions"),
                    a = e("./Utils"),
                    u = e("./UA"),
                    c = e("./URI"),
                    d = e("./NameAddrHeader"),
                    h = e("./Grammar"),
                    p = e("./WebSocketInterface"),
                    f = t.exports = {
                        C: l,
                        Exceptions: o,
                        Utils: a,
                        UA: u,
                        URI: c,
                        NameAddrHeader: d,
                        WebSocketInterface: p,
                        Grammar: h,
                        debug: e("debug"),
                        adapter: s
                    };
                Object.defineProperties(f, {
                    name: {
                        get: function() {
                            return i.title
                        }
                    },
                    version: {
                        get: function() {
                            return i.version
                        }
                    }
                })
            }, {
                "../package.json": 51,
                "./Constants": 1,
                "./Exceptions": 5,
                "./Grammar": 6,
                "./NameAddrHeader": 9,
                "./UA": 24,
                "./URI": 25,
                "./Utils": 26,
                "./WebSocketInterface": 27,
                debug: 35,
                "webrtc-adapter": 42
            }
        ],
        8: [
            function(e, t, n) {
                function r(e) {
                    this.ua = e,
                    this.data = {},
                    i.EventEmitter.call(this)
                }
                t.exports = r;
                var s = e("util"),
                    i = e("events"),
                    l = e("./Constants"),
                    o = e("./SIPMessage"),
                    a = e("./Utils"),
                    u = e("./RequestSender"),
                    c = e("./Transactions"),
                    d = e("./Exceptions");
                s.inherits(r, i.EventEmitter),
                r.prototype.send = function(e, t, n) {
                    var r,
                        s,
                        i,
                        a,
                        c,
                        d = e;
                    if (void 0 === e || void 0 === t)
                        throw new TypeError("Not enough arguments");
                    if (e = this.ua.normalizeTarget(e), !e)
                        throw new TypeError("Invalid target: " + d);
                    n = n || {},
                    c = n.extraHeaders && n.extraHeaders.slice() || [],
                    a = n.eventHandlers || {},
                    i = n.contentType || "text/plain",
                    this.content_type = i;
                    for (s in a)
                        this.on(s, a[s]);
                    this.closed = !1,
                    this.ua.applicants[this] = this,
                    c.push("Content-Type: " + i),
                    this.request = new o.OutgoingRequest(l.MESSAGE, e, this.ua, null, c),
                    t
                        ? (this.request.body = t, this.content = t)
                        : this.content = null,
                    r = new u(this, this.ua),
                    this.newMessage("local", this.request),
                    r.send()
                },
                r.prototype.receiveResponse = function(e) {
                    var t;
                    if (!this.closed)
                        switch (!0) {
                            case /^ 1 [0 - 9]{
                                    2
                                }
                                $ /.test(e.status_code):
                                break;
                            case /^ 2 [0 - 9]{
                                    2
                                }
                                $ /.test(e.status_code):
                                delete this.ua.applicants[this],
                                this.emit("succeeded", {
                                    originator: "remote",
                                    response: e
                                });
                                break;
                            default:
                                delete this.ua.applicants[this],
                                t = a.sipErrorCause(e.status_code),
                                this.emit("failed", {
                                    originator: "remote",
                                    response: e,
                                    cause: t
                                })
                        }
                    },
                r.prototype.onRequestTimeout = function() {
                    this.closed || this.emit("failed", {
                        originator: "system",
                        cause: l.causes.REQUEST_TIMEOUT
                    })
                },
                r.prototype.onTransportError = function() {
                    this.closed || this.emit("failed", {
                        originator: "system",
                        cause: l.causes.CONNECTION_ERROR
                    })
                },
                r.prototype.close = function() {
                    this.closed = !0,
                    delete this.ua.applicants[this]
                },
                r.prototype.init_incoming = function(e) {
                    var t;
                    this.request = e,
                    this.content_type = e.getHeader("Content-Type"),
                    e.body
                        ? this.content = e.body
                        : this.content = null,
                    this.newMessage("remote", e),
                    t = this.ua.transactions.nist[e.via_branch],
                    !t || t.state !== c.C.STATUS_TRYING && t.state !== c.C.STATUS_PROCEEDING || e.reply(200)
                },
                r.prototype.accept = function(e) {
                    e = e || {};
                    var t = e.extraHeaders && e.extraHeaders.slice() || [],
                        n = e.body;
                    if ("incoming" !== this.direction)
                        throw new d.NotSupportedError('"accept" not supported for outgoing Message');
                    this.request.reply(200, null, t, n)
                },
                r.prototype.reject = function(e) {
                    e = e || {};
                    var t = e.status_code || 480,
                        n = e.reason_phrase,
                        r = e.extraHeaders && e.extraHeaders.slice() || [],
                        s = e.body;
                    if ("incoming" !== this.direction)
                        throw new d.NotSupportedError('"reject" not supported for outgoing Message');
                    if (t < 300 || t >= 700)
                        throw new TypeError("Invalid status_code: " + t);
                    this.request.reply(t, n, r, s)
                },
                r.prototype.newMessage = function(e, t) {
                    "remote" === e
                        ? (this.direction = "incoming", this.local_identity = t.to, this.remote_identity = t.from)
                        : "local" === e && (this.direction = "outgoing", this.local_identity = t.from, this.remote_identity = t.to),
                    this.ua.newMessage({originator: e, message: this, request: t})
                }
            }, {
                "./Constants": 1,
                "./Exceptions": 5,
                "./RequestSender": 18,
                "./SIPMessage": 19,
                "./Transactions": 22,
                "./Utils": 26,
                events: 29,
                util: 33
            }
        ],
        9: [
            function(e, t, n) {
                function r(e, t, n) {
                    var r;
                    if (!(e && e instanceof s))
                        throw new TypeError('missing or invalid "uri" parameter');
                    this.uri = e,
                    this.parameters = {};
                    for (r in n)
                        this.setParam(r, n[r]);
                    Object.defineProperties(this, {
                        display_name: {
                            get: function() {
                                return t
                            },
                            set: function(e) {
                                t = 0 === e
                                    ? "0"
                                    : e
                            }
                        }
                    })
                }
                t.exports = r;
                var s = e("./URI"),
                    i = e("./Grammar");
                r.prototype = {
                    setParam: function(e, t) {
                        e && (this.parameters[e.toLowerCase()] = "undefined" == typeof t || null === t
                            ? null
                            : t.toString())
                    },
                    getParam: function(e) {
                        if (e)
                            return this.parameters[e.toLowerCase()]
                    },
                    hasParam: function(e) {
                        if (e)
                            return this.parameters.hasOwnProperty(e.toLowerCase()) && !0 || !1
                    },
                    deleteParam: function(e) {
                        var t;
                        if (e = e.toLowerCase(), this.parameters.hasOwnProperty(e))
                            return t = this.parameters[e],
                            delete this.parameters[e],
                            t
                    },
                    clearParams: function() {
                        this.parameters = {}
                    },
                    clone: function() {
                        return new r(this.uri.clone(), this.display_name, JSON.parse(JSON.stringify(this.parameters)))
                    },
                    toString: function() {
                        var e,
                            t;
                        e = this.display_name || 0 === this.display_name
                            ? '"' + this.display_name + '" '
                            : "",
                        e += "<" + this.uri.toString() + ">";
                        for (t in this.parameters)
                            e += ";" + t,
                            null !== this.parameters[t] && (e += "=" + this.parameters[t]);
                        return e
                    }
                },
                r.parse = function(e) {
                    return e = i.parse(e, "Name_Addr_Header"),
                    e !== -1
                        ? e
                        : void 0
                }
            }, {
                "./Grammar": 6,
                "./URI": 25
            }
        ],
        10: [
            function(e, t, n) {
                function r(e, t) {
                    var n = t,
                        r = 0,
                        s = 0;
                    if (e.substring(n, n + 2).match(/(^\r\n)/))
                        return -2;
                    for (; 0 === r;) {
                        if (s = e.indexOf("\r\n", n), s === -1)
                            return s;

                        !e.substring(s + 2, s + 4).match(/(^\r\n)/) && e.charAt(s + 2).match(/(^\s+)/)
                            ? n = s + 2
                            : r = s
                    }
                    return r
                }
                function s(e, t, n, r) {
                    var s,
                        i,
                        l,
                        u,
                        c = t.indexOf(":", n),
                        d = t.substring(n, c).trim(),
                        h = t.substring(c + 1, r).trim();
                    switch (d.toLowerCase()) {
                        case "via":
                        case "v":
                            e.addHeader("via", h),
                            1 === e.getHeaders("via").length
                                ? (u = e.parseHeader("Via"), u && (e.via = u, e.via_branch = u.branch))
                                : u = 0;
                            break;
                        case "from":
                        case "f":
                            e.setHeader("from", h),
                            u = e.parseHeader("from"),
                            u && (e.from = u, e.from_tag = u.getParam("tag"));
                            break;
                        case "to":
                        case "t":
                            e.setHeader("to", h),
                            u = e.parseHeader("to"),
                            u && (e.to = u, e.to_tag = u.getParam("tag"));
                            break;
                        case "record-route":
                            if (u = o.parse(h, "Record_Route"), u === -1)
                                u = void 0;
                            else
                                for (l = u.length, i = 0; i < l; i++)
                                    s = u[i],
                                    e.addHeader("record-route", h.substring(s.possition, s.offset)),
                                    e.headers["Record-Route"][e.getHeaders("record-route").length - 1].parsed = s.parsed;
                        break;
                        case "call-id":
                        case "i":
                            e.setHeader("call-id", h),
                            u = e.parseHeader("call-id"),
                            u && (e.call_id = h);
                            break;
                        case "contact":
                        case "m":
                            if (u = o.parse(h, "Contact"), u === -1)
                                u = void 0;
                            else
                                for (l = u.length, i = 0; i < l; i++)
                                    s = u[i],
                                    e.addHeader("contact", h.substring(s.possition, s.offset)),
                                    e.headers.Contact[e.getHeaders("contact").length - 1].parsed = s.parsed;
                        break;
                        case "content-length":
                        case "l":
                            e.setHeader("content-length", h),
                            u = e.parseHeader("content-length");
                            break;
                        case "content-type":
                        case "c":
                            e.setHeader("content-type", h),
                            u = e.parseHeader("content-type");
                            break;
                        case "cseq":
                            e.setHeader("cseq", h),
                            u = e.parseHeader("cseq"),
                            u && (e.cseq = u.value),
                            e instanceof a.IncomingResponse && (e.method = u.method);
                            break;
                        case "max-forwards":
                            e.setHeader("max-forwards", h),
                            u = e.parseHeader("max-forwards");
                            break;
                        case "www-authenticate":
                            e.setHeader("www-authenticate", h),
                            u = e.parseHeader("www-authenticate");
                            break;
                        case "proxy-authenticate":
                            e.setHeader("proxy-authenticate", h),
                            u = e.parseHeader("proxy-authenticate");
                            break;
                        case "session-expires":
                        case "x":
                            e.setHeader("session-expires", h),
                            u = e.parseHeader("session-expires"),
                            u && (e.session_expires = u.expires, e.session_expires_refresher = u.refresher);
                            break;
                        case "refer-to":
                        case "r":
                            e.setHeader("refer-to", h),
                            u = e.parseHeader("refer-to"),
                            u && (e.refer_to = u);
                            break;
                        case "replaces":
                            e.setHeader("replaces", h),
                            u = e.parseHeader("replaces"),
                            u && (e.replaces = u);
                            break;
                        case "event":
                        case "o":
                            e.setHeader("event", h),
                            u = e.parseHeader("event"),
                            u && (e.event = u);
                            break;
                        default:
                            e.setHeader(d, h),
                            u = 0
                    }
                    return void 0 !== u || {
                        error: 'error parsing header "' + d + '"'
                    }
                }
                var i = {};
                t.exports = i;
                var l = e("debug")("JsSIP:ERROR:Parser");
                l.log = console.warn.bind(console);
                var o = e("./Grammar"),
                    a = e("./SIPMessage");
                i.parseMessage = function(e, t) {
                    var n,
                        i,
                        u,
                        c,
                        d,
                        h = 0,
                        p = e.indexOf("\r\n");
                    if (p === -1)
                        return void l("parseMessage() | no CRLF found, not a SIP message");
                    if (i = e.substring(0, p), d = o.parse(i, "Request_Response"), d === -1)
                        return void l('parseMessage() | error parsing first line of SIP message: "' + i + '"');
                    for (d.status_code
                        ? (n = new a.IncomingResponse, n.status_code = d.status_code, n.reason_phrase = d.reason_phrase)
                        : (n = new a.IncomingRequest(t), n.method = d.method, n.ruri = d.uri), n.data = e, h = p + 2;;) {
                        if (p = r(e, h), p === -2) {
                            c = h + 2;
                            break
                        }
                        if (p === -1)
                            return void l("parseMessage() | malformed message");
                        if (d = s(n, e, h, p), d !== !0)
                            return void l("parseMessage() |", d.error);
                        h = p + 2
                    }
                    return n.hasHeader("content-length")
                        ? (u = n.getHeader("content-length"), n.body = e.substr(c, u))
                        : n.body = e.substring(c),
                    n
                }
            }, {
                "./Grammar": 6,
                "./SIPMessage": 19,
                debug: 35
            }
        ],
        11: [
            function(e, t, n) {
                function r(e) {
                    G("new"),
                    this.ua = e,
                    this.status = q.STATUS_NULL,
                    this.dialog = null,
                    this.earlyDialogs = {},
                    this.connection = null,
                    this.is_confirmed = !1,
                    this.late_sdp = !1,
                    this.rtcOfferConstraints = null,
                    this.rtcAnswerConstraints = null,
                    this.localMediaStream = null,
                    this.localMediaStreamLocallyGenerated = !1,
                    this.rtcReady = !0,
                    this.timers = {
                        ackTimer: null,
                        expiresTimer: null,
                        invite2xxTimer: null,
                        userNoAnswerTimer: null
                    },
                    this.direction = null,
                    this.local_identity = null,
                    this.remote_identity = null,
                    this.start_time = null,
                    this.end_time = null,
                    this.tones = null,
                    this.audioMuted = !1,
                    this.videoMuted = !1,
                    this.localHold = !1,
                    this.remoteHold = !1,
                    this.sessionTimers = {
                        enabled: this.ua.configuration.session_timers,
                        defaultExpires: V.SESSION_EXPIRES,
                        currentExpires: null,
                        running: !1,
                        refresher: !1,
                        timer: null
                    },
                    this.referSubscribers = {},
                    this.data = {},
                    this.causes = V.causes,
                    F.EventEmitter.call(this)
                }
                function s(e, t) {
                    var n = this,
                        r = K.T1;
                    this.timers.invite2xxTimer = setTimeout(function s() {
                        n.status === q.STATUS_WAITING_FOR_ACK && (e.reply(200, null, ["Contact: " + n.contact], t), r < K.T2 && (r = 2 * r, r > K.T2 && (r = K.T2)), n.timers.invite2xxTimer = setTimeout(s, r))
                    }, r)
                }
                function i() {
                    var e = this;
                    this.timers.ackTimer = setTimeout(function() {
                        e.status === q.STATUS_WAITING_FOR_ACK && (G("no ACK received, terminating the session"), clearTimeout(e.timers.invite2xxTimer), _.call(e, V.BYE), D.call(e, "remote", null, V.causes.NO_ACK))
                    }, K.TIMER_H)
                }
                function l(e, t) {
                    var n = this;
                    this.connection = new RTCPeerConnection(e, t),
                    this.connection.addEventListener("iceconnectionstatechange", function() {
                        var e = n.connection.iceConnectionState;
                        "failed" === e && n.terminate({cause: V.causes.RTP_TIMEOUT, status_code: 408, reason_phrase: V.causes.RTP_TIMEOUT})
                    })
                }
                function o(e, t, n, r) {
                    function s(r) {
                        var s;
                        l.addEventListener("icecandidate", s = function(n) {
                            var r = n.candidate;
                            if (!r) {
                                if (l.removeEventListener("icecandidate", s), i.rtcReady = !0, t) {
                                    var o = {
                                        originator: "local",
                                        type: e,
                                        sdp: l.localDescription.sdp
                                    };
                                    G('emit "sdp"'),
                                    i.emit("sdp", o),
                                    t(o.sdp)
                                }
                                t = null
                            }
                        }),
                        l.setLocalDescription(r).then(function() {
                            if ("complete" === l.iceGatheringState && (i.rtcReady = !0, t)) {
                                var n = {
                                    originator: "local",
                                    type: e,
                                    sdp: l.localDescription.sdp
                                };
                                G('emit "sdp"'),
                                i.emit("sdp", n),
                                t(n.sdp),
                                t = null
                            }
                        }).catch(function(e) {
                            i.rtcReady = !0,
                            n && n(e),
                            j('emit "peerconnection:setlocaldescriptionfailed" [error:%o]', e),
                            i.emit("peerconnection:setlocaldescriptionfailed", e)
                        })
                    }
                    G("createLocalDescription()");
                    var i = this,
                        l = this.connection;
                    if (this.rtcReady = !1, "offer" === e)
                        l.createOffer(r).then(s).catch(function(e) {
                            i.rtcReady = !0,
                            n && n(e),
                            j('emit "peerconnection:createofferfailed" [error:%o]', e),
                            i.emit("peerconnection:createofferfailed", e)
                        });
                    else {
                        if ("answer" !== e)
                            throw new Error('createLocalDescription() | type must be "offer" or "answer", but "' + e + '" was given');
                        l.createAnswer(r).then(s).catch(function(e) {
                            i.rtcReady = !0,
                            n && n(e),
                            j('emit "peerconnection:createanswerfailed" [error:%o]', e),
                            i.emit("peerconnection:createanswerfailed", e)
                        })
                    }
                }
                function a(e, t, n) {
                    var r,
                        s,
                        i = "UAS" === t
                            ? e.to_tag
                            : e.from_tag,
                        l = "UAS" === t
                            ? e.from_tag
                            : e.to_tag,
                        o = e.call_id + i + l;
                    return s = this.earlyDialogs[o],
                    n
                        ? !!s || (s = new $(this, e, t, $.C.STATUS_EARLY), s.error
                            ? (G(s.error), P.call(this, "remote", e, V.causes.INTERNAL_ERROR), !1)
                            : (this.earlyDialogs[o] = s, !0))
                        : (this.from_tag = e.from_tag, this.to_tag = e.to_tag, s
                            ? (s.update(e, t), this.dialog = s, delete this.earlyDialogs[o], !0)
                            : (r = new $(this, e, t), r.error
                                ? (G(r.error), P.call(this, "remote", e, V.causes.INTERNAL_ERROR), !1)
                                : (this.dialog = r, !0)))
                }
                function u(e) {
                    function t(t) {
                        t = t || {},
                        f = !0;
                        var n = t.status_code || 403,
                            r = t.reason_phrase || "",
                            s = t.extraHeaders && t.extraHeaders.slice() || [];
                        if (this.status !== q.STATUS_CONFIRMED)
                            return !1;
                        if (n < 300 || n >= 700)
                            throw new TypeError("Invalid status_code: " + n);
                        e.reply(n, r, s)
                    }
                    function n() {
                        r(function(t) {
                            var n = ["Contact: " + d.contact];
                            E.call(d, e, n),
                            d.late_sdp && (t = C.call(d, t)),
                            e.reply(200, null, n, t, function() {
                                d.status = q.STATUS_WAITING_FOR_ACK,
                                s.call(d, e, t),
                                i.call(d)
                            }),
                            "function" == typeof m.callback && m.callback()
                        }, function() {
                            e.reply(500)
                        })
                    }
                    function r(e, t) {
                        d.late_sdp
                            ? o.call(d, "offer", e, t, d.rtcOfferConstraints)
                            : (d.remoteHold === !0 && p === !1
                                ? (d.remoteHold = !1, M.call(d, "remote"))
                                : d.remoteHold === !1 && p === !0 && (d.remoteHold = !0, U.call(d, "remote")), o.call(d, "answer", e, t, d.rtcAnswerConstraints))
                    }
                    G("receiveReinvite()");
                    var l,
                        a,
                        u,
                        c,
                        d = this,
                        h = e.getHeader("Content-Type"),
                        p = !1,
                        f = !1,
                        m = {
                            request: e,
                            callback: void 0,
                            reject: t.bind(this)
                        };
                    if (this.emit("reinvite", m), !f)
                        if (e.body) {
                            if (this.late_sdp = !1, "application/sdp" !== h)
                                return G("invalid Content-Type"),
                                void e.reply(415);
                            for (l = e.parseSDP(), a = 0; a < l.media.length; a++)
                                if (c = l.media[a], re.indexOf(c.type) !== -1) {
                                    if (u = c.direction || l.direction || "sendrecv", "sendonly" !== u && "inactive" !== u) {
                                        p = !1;
                                        break
                                    }
                                    p = !0
                                }
                            var g = {
                                    originator: "remote",
                                    type: "offer",
                                    sdp: e.body
                                },
                                v = new RTCSessionDescription({type: "offer", sdp: g.sdp});
                            this.emit("sdp", g),
                            this.connection.setRemoteDescription(v).then(n).catch(function(t) {
                                e.reply(488),
                                j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', t),
                                d.emit("peerconnection:setremotedescriptionfailed", t)
                            })
                        } else
                            this.late_sdp = !0,
                            n()
                }
                function c(e) {
                    function t(t) {
                        t = t || {},
                        u = !0;
                        var n = t.status_code || 403,
                            r = t.reason_phrase || "",
                            s = t.extraHeaders && t.extraHeaders.slice() || [];
                        if (this.status !== q.STATUS_CONFIRMED)
                            return !1;
                        if (n < 300 || n >= 700)
                            throw new TypeError("Invalid status_code: " + n);
                        e.reply(n, r, s)
                    }
                    G("receiveUpdate()");
                    var n,
                        r,
                        s,
                        i,
                        l = this,
                        a = e.getHeader("Content-Type"),
                        u = !1,
                        c = !1,
                        d = {
                            request: e,
                            callback: void 0,
                            reject: t.bind(this)
                        };
                    if (this.emit("update", d), !u) {
                        if (!e.body) {
                            var h = [];
                            return E.call(this, e, h),
                            void e.reply(200, null, h)
                        }
                        if ("application/sdp" !== a)
                            return G("invalid Content-Type"),
                            void e.reply(415);
                        for (n = e.parseSDP(), r = 0; r < n.media.length; r++)
                            if (i = n.media[r], re.indexOf(i.type) !== -1) {
                                if (s = i.direction || n.direction || "sendrecv", "sendonly" !== s && "inactive" !== s) {
                                    c = !1;
                                    break
                                }
                                c = !0
                            }
                        var p = {
                            originator: "remote",
                            type: "offer",
                            sdp: e.body
                        };
                        G('emit "sdp"'),
                        this.emit("sdp", p);
                        var f = new RTCSessionDescription({type: "offer", sdp: p.sdp});
                        this.connection.setRemoteDescription(f).then(function() {
                            l.remoteHold === !0 && c === !1
                                ? (l.remoteHold = !1, M.call(l, "remote"))
                                : l.remoteHold === !1 && c === !0 && (l.remoteHold = !0, U.call(l, "remote")),
                            o.call(l, "answer", function(t) {
                                var n = ["Contact: " + l.contact];
                                E.call(l, e, n),
                                e.reply(200, null, n, t),
                                "function" == typeof d.callback && d.callback()
                            }, function() {
                                e.reply(500)
                            })
                        }).catch(function(t) {
                            e.reply(488),
                            j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', t),
                            l.emit("peerconnection:setremotedescriptionfailed", t)
                        })
                    }
                }
                function d(e) {
                    function t(t, n) {
                        var i,
                            l;
                        return n = n || {},
                        t = "function" == typeof t
                            ? t
                            : null,
                        (this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_CONFIRMED) && (i = new r(this.ua), i.on("progress", function(e) {
                            s.notify(e.response.status_code, e.response.reason_phrase)
                        }), i.on("accepted", function(e) {
                            s.notify(e.response.status_code, e.response.reason_phrase)
                        }), i.on("failed", function(e) {
                            e.message
                                ? s.notify(e.message.status_code, e.message.reason_phrase)
                                : s.notify(487, e.cause)
                        }), e.refer_to.uri.hasHeader("replaces") && (l = decodeURIComponent(e.refer_to.uri.getHeader("replaces")), n.extraHeaders = n.extraHeaders || [], n.extraHeaders.push("Replaces: " + l)), void i.connect(e.refer_to.uri.toAor(), n, t))
                    }
                    function n() {
                        s.notify(603)
                    }
                    G("receiveRefer()");
                    var s,
                        i = this;
                    return void 0 === typeof e.refer_to
                        ? (G("no Refer-To header field present in REFER"), void e.reply(400))
                        : e.refer_to.uri.scheme !== V.SIP
                            ? (G("Refer-To header field points to a non-SIP URI scheme"), void e.reply(416))
                            : (e.reply(202), s = new te(this, e.cseq), G('emit "refer"'), void this.emit("refer", {
                                request: e,
                                accept: function(e, n) {
                                    t.call(i, e, n)
                                },
                                reject: function() {
                                    n.call(i)
                                }
                            }))
                }
                function h(e) {
                    switch (G("receiveNotify()"), void 0 === typeof e.event && e.reply(400), e.event.event) {
                        case "refer":
                            var t = e.event.params.id,
                                n = this.referSubscribers[t];
                            if (!n)
                                return void e.reply(481, "Subscription does not exist");
                            n.receiveNotify(e),
                            e.reply(200);
                            break;
                        default:
                            e.reply(489)
                    }
                }
                function p(e) {
                    function t(t) {
                        var n;
                        return (this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_CONFIRMED) && (n = new r(this.ua), n.on("confirmed", function() {
                            s.terminate()
                        }), void n.init_incoming(e, t))
                    }
                    function n() {
                        G("Replaced INVITE rejected by the user"),
                        e.reply(486)
                    }
                    G("receiveReplaces()");
                    var s = this;
                    this.emit("replaces", {
                        request: e,
                        accept: function(e) {
                            t.call(s, e)
                        },
                        reject: function() {
                            n.call(s)
                        }
                    })
                }
                function f(e, t, n) {
                    function r(e) {
                        a.status !== q.STATUS_TERMINATED && (a.localMediaStream = e, e && a.connection.addStream(e), G('emit "peerconnection"'), a.emit("peerconnection", {peerconnection: a.connection}), I.call(a, a.request), o.call(a, "offer", i, l, t))
                    }
                    function s() {
                        a.status !== q.STATUS_TERMINATED && P.call(a, "local", null, V.causes.USER_DENIED_MEDIA_ACCESS)
                    }
                    function i(e) {
                        a.isCanceled || a.status === q.STATUS_TERMINATED || (a.request.body = e, a.status = q.STATUS_INVITE_SENT, G('emit "sending" [request:%o]', a.request), a.emit("sending", {request: a.request}), u.send())
                    }
                    function l() {
                        a.status !== q.STATUS_TERMINATED && P.call(a, "system", null, V.causes.WEBRTC_ERROR)
                    }
                    var a = this,
                        u = new X(a, this.ua);
                    this.receiveResponse = function(e) {
                        m.call(a, e)
                    },
                    n
                        ? setTimeout(function() {
                            r(n)
                        })
                        : e.audio || e.video
                            ? (this.localMediaStreamLocallyGenerated = !0, navigator.mediaDevices.getUserMedia(e).then(r).catch(function(e) {
                                s(e),
                                j('emit "getusermediafailed" [error:%o]', e),
                                a.emit("getusermediafailed", e)
                            }))
                            : r(null)
                }
                function m(e) {
                    G("receiveInviteResponse()");
                    var t,
                        n,
                        r,
                        s,
                        i = this;
                    if (this.dialog && e.status_code >= 200 && e.status_code <= 299)
                        return this.dialog.id.call_id === e.call_id && this.dialog.id.local_tag === e.from_tag && this.dialog.id.remote_tag === e.to_tag
                            ? void _.call(this, V.ACK)
                            : (n = new $(this, e, "UAC"), void 0 !== n.error
                                ? void G(n.error)
                                : (n.sendRequest({
                                    owner: {
                                        status: q.STATUS_TERMINATED
                                    },
                                    onRequestTimeout: function() {},
                                    onTransportError: function() {},
                                    onDialogError: function() {},
                                    receiveResponse: function() {}
                                }, V.ACK), void n.sendRequest({
                                    owner: {
                                        status: q.STATUS_TERMINATED
                                    },
                                    onRequestTimeout: function() {},
                                    onTransportError: function() {},
                                    onDialogError: function() {},
                                    receiveResponse: function() {}
                                }, V.BYE)));
                    if (this.isCanceled)
                        return this.isCanceled = !1,
                        void(e.status_code >= 100 && e.status_code < 200
                            ? this.request.cancel(this.cancelReason)
                            : e.status_code >= 200 && e.status_code < 299 && T.call(this, e));
                    if (this.status === q.STATUS_INVITE_SENT || this.status === q.STATUS_1XX_RECEIVED)
                        switch (!0) {
                            case /^ 100 $ /.test(e.status_code):
                                this.status = q.STATUS_1XX_RECEIVED;
                                break;
                            case /^ 1 [0 - 9]{
                                    2
                                }
                                $ /.test(e.status_code):
                                if (!e.to_tag) {
                                    G("1xx response received without to tag");
                                    break
                                }
                                if (e.hasHeader("contact") && !a.call(this, e, "UAC", !0))
                                    break;
                                if (this.status = q.STATUS_1XX_RECEIVED, N.call(this, "remote", e), !e.body)
                                    break;
                                r = {
                                    originator: "remote",
                                    type: "answer",
                                    sdp: e.body
                                },
                                G('emit "sdp"'),
                                this.emit("sdp", r),
                                s = new RTCSessionDescription({type: "answer", sdp: r.sdp}),
                                this.connection.setRemoteDescription(s).catch(function(e) {
                                    j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', e),
                                    i.emit("peerconnection:setremotedescriptionfailed", e)
                                });
                                break;
                            case /^ 2 [0 - 9]{
                                    2
                                }
                                $ /.test(e.status_code):
                                if (this.status = q.STATUS_CONFIRMED, !e.body) {
                                    T.call(this, e, 400, V.causes.MISSING_SDP),
                                    P.call(this, "remote", e, V.causes.BAD_MEDIA_DESCRIPTION);
                                    break
                                }
                                if (!a.call(this, e, "UAC"))
                                    break;
                                r = {
                                    originator: "remote",
                                    type: "answer",
                                    sdp: e.body
                                },
                                G('emit "sdp"'),
                                this.emit("sdp", r),
                                s = new RTCSessionDescription({type: "answer", sdp: r.sdp}),
                                Promise.resolve().then(function() {
                                    if ("stable" === i.connection.signalingState)
                                        return i.connection.createOffer().then(function(e) {
                                            return i.connection.setLocalDescription(e)
                                        }).catch(function(t) {
                                            T.call(i, e, 500, t.toString()),
                                            P.call(i, "local", e, V.causes.WEBRTC_ERROR),
                                            j('emit "peerconnection:setlocaldescriptionfailed" [error:%o]', t),
                                            i.emit("peerconnection:setlocaldescriptionfailed", t)
                                        })
                                    }
                                ).then(function() {
                                    i.connection.setRemoteDescription(s).then(function() {
                                        y.call(i, e),
                                        O.call(i, "remote", e),
                                        _.call(i, V.ACK),
                                        x.call(i, "local", null)
                                    }).catch(function(t) {
                                        T.call(i, e, 488, "Not Acceptable Here"),
                                        P.call(i, "remote", e, V.causes.BAD_MEDIA_DESCRIPTION),
                                        j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', t),
                                        i.emit("peerconnection:setremotedescriptionfailed", t)
                                    })
                                });
                                break;
                            default:
                                t = z.sipErrorCause(e.status_code),
                                P.call(this, "remote", e, t)
                        }
                    }
                function g(e) {
                    function t(e) {
                        if (r.status !== q.STATUS_TERMINATED && (_.call(r, V.ACK), !a)) {
                            if (y.call(r, e), !e.body)
                                return void n();
                            if ("application/sdp" !== e.getHeader("Content-Type"))
                                return void n();
                            var t = {
                                originator: "remote",
                                type: "answer",
                                sdp: e.body
                            };
                            G('emit "sdp"'),
                            r.emit("sdp", t);
                            var s = new RTCSessionDescription({type: "answer", sdp: t.sdp});
                            r.connection.setRemoteDescription(s).then(function() {
                                i.succeeded && i.succeeded(e)
                            }).catch(function(e) {
                                n(),
                                j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', e),
                                r.emit("peerconnection:setremotedescriptionfailed", e)
                            })
                        }
                    }
                    function n(e) {
                        i.failed && i.failed(e)
                    }
                    G("sendReinvite()"),
                    e = e || {};
                    var r = this,
                        s = e.extraHeaders || [],
                        i = e.eventHandlers || {},
                        l = e.rtcOfferConstraints || this.rtcOfferConstraints || null,
                        a = !1;
                    s.push("Contact: " + this.contact),
                    s.push("Content-Type: application/sdp"),
                    this.sessionTimers.running && s.push("Session-Expires: " + this.sessionTimers.currentExpires + ";refresher=" + (this.sessionTimers.refresher
                        ? "uac"
                        : "uas")),
                    o.call(this, "offer", function(e) {
                        e = C.call(r, e);
                        var i = new Q(r, V.INVITE);
                        i.send({
                            extraHeaders: s,
                            body: e,
                            eventHandlers: {
                                onSuccessResponse: function(e) {
                                    t(e),
                                    a = !0
                                },
                                onErrorResponse: function(e) {
                                    n(e)
                                },
                                onTransportError: function() {
                                    r.onTransportError()
                                },
                                onRequestTimeout: function() {
                                    r.onRequestTimeout()
                                },
                                onDialogError: function() {
                                    r.onDialogError()
                                }
                            }
                        })
                    }, function() {
                        n()
                    }, l)
                }
                function v(e) {
                    function t(e) {
                        if (r.status !== q.STATUS_TERMINATED && !u)
                            if (y.call(r, e), a) {
                                if (!e.body)
                                    return void n();
                                if ("application/sdp" !== e.getHeader("Content-Type"))
                                    return void n();
                                var t = {
                                    originator: "remote",
                                    type: "answer",
                                    sdp: e.body
                                };
                                G('emit "sdp"'),
                                r.emit("sdp", t);
                                var s = new RTCSessionDescription({type: "answer", sdp: t.sdp});
                                r.connection.setRemoteDescription(s).then(function() {
                                    i.succeeded && i.succeeded(e)
                                }).catch(function(e) {
                                    n(),
                                    j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', e),
                                    r.emit("peerconnection:setremotedescriptionfailed", e)
                                })
                            } else
                                i.succeeded && i.succeeded(e)
                    }
                    function n(e) {
                        i.failed && i.failed(e)
                    }
                    G("sendUpdate()"),
                    e = e || {};
                    var r = this,
                        s = e.extraHeaders || [],
                        i = e.eventHandlers || {},
                        l = e.rtcOfferConstraints || this.rtcOfferConstraints || null,
                        a = e.sdpOffer || !1,
                        u = !1;
                    if (s.push("Contact: " + this.contact), this.sessionTimers.running && s.push("Session-Expires: " + this.sessionTimers.currentExpires + ";refresher=" + (this.sessionTimers.refresher
                        ? "uac"
                        : "uas")), a)
                        s.push("Content-Type: application/sdp"),
                        o.call(this, "offer", function(e) {
                            e = C.call(r, e);
                            var i = new Q(r, V.UPDATE);
                            i.send({
                                extraHeaders: s,
                                body: e,
                                eventHandlers: {
                                    onSuccessResponse: function(e) {
                                        t(e),
                                        u = !0
                                    },
                                    onErrorResponse: function(e) {
                                        n(e)
                                    },
                                    onTransportError: function() {
                                        r.onTransportError()
                                    },
                                    onRequestTimeout: function() {
                                        r.onRequestTimeout()
                                    },
                                    onDialogError: function() {
                                        r.onDialogError()
                                    }
                                }
                            })
                        }, function() {
                            n()
                        }, l);
                    else {
                        var c = new Q(r, V.UPDATE);
                        c.send({
                            extraHeaders: s,
                            eventHandlers: {
                                onSuccessResponse: function(e) {
                                    t(e)
                                },
                                onErrorResponse: function(e) {
                                    n(e)
                                },
                                onTransportError: function() {
                                    r.onTransportError()
                                },
                                onRequestTimeout: function() {
                                    r.onRequestTimeout()
                                },
                                onDialogError: function() {
                                    r.onDialogError()
                                }
                            }
                        })
                    }
                }
                function T(e, t, n) {
                    G("acceptAndTerminate()");
                    var r = [];
                    t && (n = n || V.REASON_PHRASE[t] || "", r.push("Reason: SIP ;cause=" + t + '; text="' + n + '"')),
                    (this.dialog || a.call(this, e, "UAC")) && (_.call(this, V.ACK), _.call(this, V.BYE, {extraHeaders: r})),
                    this.status = q.STATUS_TERMINATED
                }
                function _(e, t) {
                    G("sendRequest()");
                    var n = new Q(this, e);
                    n.send(t)
                }
                function C(e) {
                    var t,
                        n,
                        r;
                    if (!this.localHold && !this.remoteHold)
                        return e;
                    if (e = B.parse(e), this.localHold && !this.remoteHold)
                        for (G("mangleOffer() | me on hold, mangling offer"), n = e.media.length, t = 0; t < n; t++)
                            r = e.media[t],
                            re.indexOf(r.type) !== -1 && (r.direction
                                ? "sendrecv" === r.direction
                                    ? r.direction = "sendonly"
                                    : "recvonly" === r.direction && (r.direction = "inactive")
                                : r.direction = "sendonly");
                        else if (this.localHold && this.remoteHold)
                            for (G("mangleOffer() | both on hold, mangling offer"), n = e.media.length, t = 0; t < n; t++)
                                r = e.media[t],
                                re.indexOf(r.type) !== -1 && (r.direction = "inactive");
                else if (this.remoteHold)
                        for (G("mangleOffer() | remote on hold, mangling offer"), n = e.media.length, t = 0; t < n; t++)
                            r = e.media[t],
                            re.indexOf(r.type) !== -1 && (r.direction
                                ? "sendrecv" === r.direction
                                    ? r.direction = "recvonly"
                                    : "recvonly" === r.direction && (r.direction = "inactive")
                                : r.direction = "recvonly");
                    return B.write(e)
                }
                function S() {
                    var e = !0,
                        t = !0;
                    (this.localHold || this.remoteHold) && (e = !1, t = !1),
                    this.audioMuted && (e = !1),
                    this.videoMuted && (t = !1),
                    R.call(this, !e),
                    w.call(this, !t)
                }
                function E(e, t) {
                    if (this.sessionTimers.enabled) {
                        var n;
                        e.session_expires && e.session_expires >= V.MIN_SESSION_EXPIRES
                            ? (this.sessionTimers.currentExpires = e.session_expires, n = e.session_expires_refresher || "uas")
                            : (this.sessionTimers.currentExpires = this.sessionTimers.defaultExpires, n = "uas"),
                        t.push("Session-Expires: " + this.sessionTimers.currentExpires + ";refresher=" + n),
                        this.sessionTimers.refresher = "uas" === n,
                        A.call(this)
                    }
                }
                function y(e) {
                    if (this.sessionTimers.enabled) {
                        var t;
                        e.session_expires && e.session_expires >= V.MIN_SESSION_EXPIRES
                            ? (this.sessionTimers.currentExpires = e.session_expires, t = e.session_expires_refresher || "uac")
                            : (this.sessionTimers.currentExpires = this.sessionTimers.defaultExpires, t = "uac"),
                        this.sessionTimers.refresher = "uac" === t,
                        A.call(this)
                    }
                }
                function A() {
                    var e = this,
                        t = this.sessionTimers.currentExpires;
                    this.sessionTimers.running = !0,
                    clearTimeout(this.sessionTimers.timer),
                    this.sessionTimers.refresher
                        ? this.sessionTimers.timer = setTimeout(function() {
                            e.status !== q.STATUS_TERMINATED && (G("runSessionTimer() | sending session refresh request"), v.call(e, {
                                eventHandlers: {
                                    succeeded: function(t) {
                                        y.call(e, t)
                                    }
                                }
                            }))
                        }, 500 * t)
                        : this.sessionTimers.timer = setTimeout(function() {
                            e.status !== q.STATUS_TERMINATED && (j("runSessionTimer() | timer expired, terminating the session"), e.terminate({cause: V.causes.REQUEST_TIMEOUT, status_code: 408, reason_phrase: "Session Timer Expired"}))
                        }, 1100 * t)
                }
                function R(e) {
                    var t,
                        n,
                        r,
                        s,
                        i,
                        l = this.connection.getLocalStreams();
                    for (r = l.length, t = 0; t < r; t++)
                        for (i = l[t].getAudioTracks(), s = i.length, n = 0; n < s; n++)
                            i[n].enabled = !e
                }
                function w(e) {
                    var t,
                        n,
                        r,
                        s,
                        i,
                        l = this.connection.getLocalStreams();
                    for (r = l.length, t = 0; t < r; t++)
                        for (i = l[t].getVideoTracks(), s = i.length, n = 0; n < s; n++)
                            i[n].enabled = !e
                }
                function b(e, t) {
                    G("newRTCSession()"),
                    this.ua.newRTCSession({originator: e, session: this, request: t})
                }
                function I(e) {
                    G("session connecting"),
                    G('emit "connecting"'),
                    this.emit("connecting", {request: e})
                }
                function N(e, t) {
                    G("session progress"),
                    G('emit "progress"'),
                    this.emit("progress", {
                        originator: e,
                        response: t || null
                    })
                }
                function O(e, t) {
                    G("session accepted"),
                    this.start_time = new Date,
                    G('emit "accepted"'),
                    this.emit("accepted", {
                        originator: e,
                        response: t || null
                    })
                }
                function x(e, t) {
                    G("session confirmed"),
                    this.is_confirmed = !0,
                    G('emit "confirmed"'),
                    this.emit("confirmed", {
                        originator: e,
                        ack: t || null
                    })
                }
                function D(e, t, n) {
                    G("session ended"),
                    this.end_time = new Date,
                    this.close(),
                    G('emit "ended"'),
                    this.emit("ended", {
                        originator: e,
                        message: t || null,
                        cause: n
                    })
                }
                function P(e, t, n) {
                    G("session failed"),
                    this.close(),
                    G('emit "failed"'),
                    this.emit("failed", {
                        originator: e,
                        message: t || null,
                        cause: n
                    })
                }
                function U(e) {
                    G("session onhold"),
                    S.call(this),
                    G('emit "hold"'),
                    this.emit("hold", {originator: e})
                }
                function M(e) {
                    G("session onunhold"),
                    S.call(this),
                    G('emit "unhold"'),
                    this.emit("unhold", {originator: e})
                }
                function k(e) {
                    G("session onmute"),
                    S.call(this),
                    G('emit "muted"'),
                    this.emit("muted", {
                        audio: e.audio,
                        video: e.video
                    })
                }
                function L(e) {
                    G("session onunmute"),
                    S.call(this),
                    G('emit "unmuted"'),
                    this.emit("unmuted", {
                        audio: e.audio,
                        video: e.video
                    })
                }
                t.exports = r;
                var q = {
                    STATUS_NULL: 0,
                    STATUS_INVITE_SENT: 1,
                    STATUS_1XX_RECEIVED: 2,
                    STATUS_INVITE_RECEIVED: 3,
                    STATUS_WAITING_FOR_ANSWER: 4,
                    STATUS_ANSWERED: 5,
                    STATUS_WAITING_FOR_ACK: 6,
                    STATUS_CANCELED: 7,
                    STATUS_TERMINATED: 8,
                    STATUS_CONFIRMED: 9
                };
                r.C = q;
                var H = e("util"),
                    F = e("events"),
                    G = e("debug")("JsSIP:RTCSession"),
                    j = e("debug")("JsSIP:ERROR:RTCSession");
                j.log = console.warn.bind(console);
                var B = e("sdp-transform"),
                    V = e("./Constants"),
                    W = e("./Exceptions"),
                    J = e("./Transactions"),
                    z = e("./Utils"),
                    K = e("./Timers"),
                    Y = e("./SIPMessage"),
                    $ = e("./Dialog"),
                    X = e("./RequestSender"),
                    Q = e("./RTCSession/Request"),
                    Z = e("./RTCSession/DTMF"),
                    ee = e("./RTCSession/Info"),
                    te = e("./RTCSession/ReferNotifier"),
                    ne = e("./RTCSession/ReferSubscriber"),
                    re = ["audio", "video"];
                H.inherits(r, F.EventEmitter),
                r.prototype.isInProgress = function() {
                    switch (this.status) {
                        case q.STATUS_NULL:
                        case q.STATUS_INVITE_SENT:
                        case q.STATUS_1XX_RECEIVED:
                        case q.STATUS_INVITE_RECEIVED:
                        case q.STATUS_WAITING_FOR_ANSWER:
                            return !0;
                        default:
                            return !1
                    }
                },
                r.prototype.isEstablished = function() {
                    switch (this.status) {
                        case q.STATUS_ANSWERED:
                        case q.STATUS_WAITING_FOR_ACK:
                        case q.STATUS_CONFIRMED:
                            return !0;
                        default:
                            return !1
                    }
                },
                r.prototype.isEnded = function() {
                    switch (this.status) {
                        case q.STATUS_CANCELED:
                        case q.STATUS_TERMINATED:
                            return !0;
                        default:
                            return !1
                    }
                },
                r.prototype.isMuted = function() {
                    return {audio: this.audioMuted, video: this.videoMuted}
                },
                r.prototype.isOnHold = function() {
                    return {local: this.localHold, remote: this.remoteHold}
                },
                r.prototype.isReadyToReOffer = function() {
                    return this.rtcReady
                        ? this.dialog
                            ? this.dialog.uac_pending_reply !== !0 && this.dialog.uas_pending_reply !== !0 || (G("isReadyToReOffer() | there is another INVITE/UPDATE transaction in progress"), !1)
                            : (G("isReadyToReOffer() | session not established yet"), !1)
                        : (G("isReadyToReOffer() | internal WebRTC status not ready"), !1)
                },
                r.prototype.connect = function(e, t, n) {
                    G("connect()"),
                    t = t || {};
                    var r,
                        s,
                        i = e,
                        o = t.eventHandlers || {},
                        a = t.extraHeaders && t.extraHeaders.slice() || [],
                        u = t.mediaConstraints || {
                            audio: !0,
                            video: !0
                        },
                        c = t.mediaStream || null,
                        d = t.pcConfig || {
                            iceServers: []
                        },
                        h = t.rtcConstraints || null,
                        p = t.rtcOfferConstraints || null;
                    if (this.rtcOfferConstraints = p, this.rtcAnswerConstraints = t.rtcAnswerConstraints || null, this.sessionTimers.enabled && z.isDecimal(t.sessionTimersExpires) && (t.sessionTimersExpires >= V.MIN_SESSION_EXPIRES
                        ? this.sessionTimers.defaultExpires = t.sessionTimersExpires
                        : this.sessionTimers.defaultExpires = V.SESSION_EXPIRES), this.data = t.data || this.data, void 0 === e)
                        throw new TypeError("Not enough arguments");
                    if (!window.RTCPeerConnection)
                        throw new W.NotSupportedError("WebRTC not supported");
                    if (e = this.ua.normalizeTarget(e), !e)
                        throw new TypeError("Invalid target: " + i);
                    if (this.status !== q.STATUS_NULL)
                        throw new W.InvalidStateError(this.status);
                    for (r in o)
                        this.on(r, o[r]);
                    this.from_tag = z.newTag(),
                    this.anonymous = t.anonymous || !1,
                    this.isCanceled = !1,
                    s = {
                        from_tag: this.from_tag
                    },
                    this.contact = this.ua.contact.toString({
                        anonymous: this.anonymous,
                        outbound: !0
                    }),
                    this.anonymous && (s.from_display_name = "Anonymous", s.from_uri = "sip:anonymous@anonymous.invalid", a.push("P-Preferred-Identity: " + this.ua.configuration.uri.toString()), a.push("Privacy: id")),
                    a.push("Contact: " + this.contact),
                    a.push("Content-Type: application/sdp"),
                    this.sessionTimers.enabled && a.push("Session-Expires: " + this.sessionTimers.defaultExpires),
                    this.request = new Y.OutgoingRequest(V.INVITE, e, this.ua, s, a),
                    this.id = this.request.call_id + this.from_tag,
                    l.call(this, d, h),
                    this.ua.sessions[this.id] = this,
                    this.direction = "outgoing",
                    this.local_identity = this.request.from,
                    this.remote_identity = this.request.to,
                    n
                        ? n(this)
                        : b.call(this, "local", this.request),
                    f.call(this, u, p, c)
                },
                r.prototype.init_incoming = function(e, t) {
                    G("init_incoming()");
                    var n,
                        r = this,
                        s = e.getHeader("Content-Type");
                    return e.body && "application/sdp" !== s
                        ? void e.reply(415)
                        : (this.status = q.STATUS_INVITE_RECEIVED, this.from_tag = e.from_tag, this.id = e.call_id + this.from_tag, this.request = e, this.contact = this.ua.contact.toString(), this.ua.sessions[this.id] = this, e.hasHeader("expires") && (n = 1e3 * e.getHeader("expires")), e.to_tag = z.newTag(), a.call(this, e, "UAS", !0)
                            ? (e.body
                                ? this.late_sdp = !1
                                : this.late_sdp = !0, this.status = q.STATUS_WAITING_FOR_ANSWER, this.timers.userNoAnswerTimer = setTimeout(function() {
                                e.reply(408),
                                P.call(r, "local", null, V.causes.NO_ANSWER)
                            }, this.ua.configuration.no_answer_timeout), n && (this.timers.expiresTimer = setTimeout(function() {
                                r.status === q.STATUS_WAITING_FOR_ANSWER && (e.reply(487), P.call(r, "system", null, V.causes.EXPIRES))
                            }, n)), this.direction = "incoming", this.local_identity = e.to, this.remote_identity = e.from, t
                                ? t(this)
                                : b.call(this, "remote", e), void(this.status !== q.STATUS_TERMINATED && (e.reply(180, null, ["Contact: " + r.contact]), N.call(r, "local", null))))
                            : void e.reply(500, "Missing Contact header field"))
                },
                r.prototype.answer = function(e) {
                    function t(e) {
                        if (_.status !== q.STATUS_TERMINATED)
                            if (_.localMediaStream = e, e && _.connection.addStream(e), G('emit "peerconnection"'), _.emit("peerconnection", {peerconnection: _.connection}), _.late_sdp)
                                r();
                            else {
                                var t = {
                                    originator: "remote",
                                    type: "offer",
                                    sdp: C.body
                                };
                                G('emit "sdp"'),
                                _.emit("sdp", t);
                                var n = new RTCSessionDescription({type: "offer", sdp: t.sdp});
                                _.connection.setRemoteDescription(n).then(r).catch(function(e) {
                                    C.reply(488),
                                    P.call(_, "system", null, V.causes.WEBRTC_ERROR),
                                    j('emit "peerconnection:setremotedescriptionfailed" [error:%o]', e),
                                    _.emit("peerconnection:setremotedescriptionfailed", e)
                                })
                            }
                        }
                    function n() {
                        _.status !== q.STATUS_TERMINATED && (C.reply(480), P.call(_, "local", null, V.causes.USER_DENIED_MEDIA_ACCESS))
                    }
                    function r() {
                        I.call(_, C),
                        _.late_sdp
                            ? o.call(_, "offer", u, c, _.rtcOfferConstraints)
                            : o.call(_, "answer", u, c, b)
                    }
                    function u(e) {
                        function t() {
                            _.status = q.STATUS_WAITING_FOR_ACK,
                            s.call(_, C, e),
                            i.call(_),
                            O.call(_, "local")
                        }
                        function n() {
                            P.call(_, "system", null, V.causes.CONNECTION_ERROR)
                        }
                        _.status !== q.STATUS_TERMINATED && (E.call(_, C, S), C.reply(200, null, S, e, t, n))
                    }
                    function c() {
                        _.status !== q.STATUS_TERMINATED && (C.reply(500), P.call(_, "system", null, V.causes.WEBRTC_ERROR))
                    }
                    G("answer()"),
                    e = e || {};
                    var d,
                        h,
                        p,
                        f,
                        m = !1,
                        g = !1,
                        v = !1,
                        T = !1,
                        _ = this,
                        C = this.request,
                        S = e.extraHeaders && e.extraHeaders.slice() || [],
                        y = e.mediaConstraints || {},
                        A = e.mediaStream || null,
                        R = e.pcConfig || {
                            iceServers: []
                        },
                        w = e.rtcConstraints || null,
                        b = e.rtcAnswerConstraints || null;
                    if (this.rtcAnswerConstraints = b, this.rtcOfferConstraints = e.rtcOfferConstraints || null, this.sessionTimers.enabled && z.isDecimal(e.sessionTimersExpires) && (e.sessionTimersExpires >= V.MIN_SESSION_EXPIRES
                        ? this.sessionTimers.defaultExpires = e.sessionTimersExpires
                        : this.sessionTimers.defaultExpires = V.SESSION_EXPIRES), this.data = e.data || this.data, "incoming" !== this.direction)
                        throw new W.NotSupportedError('"answer" not supported for outgoing RTCSession');
                    if (this.status !== q.STATUS_WAITING_FOR_ANSWER)
                        throw new W.InvalidStateError(this.status);
                    if (this.status = q.STATUS_ANSWERED, !a.call(this, C, "UAS"))
                        return void C.reply(500, "Error creating dialog");
                    for (clearTimeout(this.timers.userNoAnswerTimer), S.unshift("Contact: " + _.contact), p = C.parseSDP(), Array.isArray(p.media) || (p.media = [p.media]), d = p.media.length; d--;) {
                        var N = p.media[d];
                        "audio" === N.type && (m = !0, N.direction && "sendrecv" !== N.direction || (v = !0)),
                        "video" === N.type && (g = !0, N.direction && "sendrecv" !== N.direction || (T = !0))
                    }
                    if (A && y.audio === !1)
                        for (f = A.getAudioTracks(), h = f.length, d = 0; d < h; d++)
                            A.removeTrack(f[d]);
                if (A && y.video === !1)
                        for (f = A.getVideoTracks(), h = f.length, d = 0; d < h; d++)
                            A.removeTrack(f[d]);
                A || void 0 !== y.audio || (y.audio = v),
                    A || void 0 !== y.video || (y.video = T),
                    A || m || (y.audio = !1),
                    A || g || (y.video = !1),
                    l.call(this, R, w),
                    A
                        ? t(A)
                        : y.audio || y.video
                            ? (_.localMediaStreamLocallyGenerated = !0, navigator.mediaDevices.getUserMedia(y).then(t).catch(function(e) {
                                n(e),
                                j('emit "getusermediafailed" [error:%o]', e),
                                _.emit("getusermediafailed", e)
                            }))
                            : t(null)
                },
                r.prototype.terminate = function(e) {
                    G("terminate()"),
                    e = e || {};
                    var t,
                        n,
                        r = e.cause || V.causes.BYE,
                        s = e.status_code,
                        i = e.reason_phrase,
                        l = e.extraHeaders && e.extraHeaders.slice() || [],
                        o = e.body,
                        a = this;
                    if (this.status === q.STATUS_TERMINATED)
                        throw new W.InvalidStateError(this.status);
                    switch (this.status) {
                        case q.STATUS_NULL:
                        case q.STATUS_INVITE_SENT:
                        case q.STATUS_1XX_RECEIVED:
                            if (G("canceling session"), s && (s < 200 || s >= 700))
                                throw new TypeError("Invalid status_code: " + s);
                            s && (i = i || V.REASON_PHRASE[s] || "", t = "SIP ;cause=" + s + ' ;text="' + i + '"'),
                            this.status === q.STATUS_NULL
                                ? (this.isCanceled = !0, this.cancelReason = t)
                                : this.status === q.STATUS_INVITE_SENT
                                    ? (this.isCanceled = !0, this.cancelReason = t)
                                    : this.status === q.STATUS_1XX_RECEIVED && this.request.cancel(t),
                            this.status = q.STATUS_CANCELED,
                            P.call(this, "local", null, V.causes.CANCELED);
                            break;
                        case q.STATUS_WAITING_FOR_ANSWER:
                        case q.STATUS_ANSWERED:
                            if (G("rejecting session"), s = s || 480, s < 300 || s >= 700)
                                throw new TypeError("Invalid status_code: " + s);
                            this.request.reply(s, i, l, o),
                            P.call(this, "local", null, V.causes.REJECTED);
                            break;
                        case q.STATUS_WAITING_FOR_ACK:
                        case q.STATUS_CONFIRMED:
                            if (G("terminating session"), i = e.reason_phrase || V.REASON_PHRASE[s] || "", s && (s < 200 || s >= 700))
                                throw new TypeError("Invalid status_code: " + s);
                            s && l.push("Reason: SIP ;cause=" + s + '; text="' + i + '"'),
                            this.status === q.STATUS_WAITING_FOR_ACK && "incoming" === this.direction && this.request.server_transaction.state !== J.C.STATUS_TERMINATED
                                ? (n = this.dialog, this.receiveRequest = function(e) {
                                    e.method === V.ACK && (_.call(this, V.BYE, {
                                        extraHeaders: l,
                                        body: o
                                    }), n.terminate())
                                },
                                this.request.server_transaction.on("stateChanged", function() {
                                    this.state === J.C.STATUS_TERMINATED && (_.call(a, V.BYE, {
                                        extraHeaders: l,
                                        body: o
                                    }), n.terminate())
                                }),
                                D.call(this, "local", null, r),
                                this.dialog = n,
                                this.ua.dialogs[n.id.toString()] = n)
                                : (_.call(this, V.BYE, {
                                    extraHeaders: l,
                                    body: o
                                }), D.call(this, "local", null, r))
                    }
                },
                r.prototype.close = function() {
                    G("close()");
                    var e;
                    if (this.status !== q.STATUS_TERMINATED) {
                        if (this.connection)
                            try {
                                this.connection.close()
                            } catch (e) {
                                j("close() | error closing the RTCPeerConnection: %o", e)
                            }
                        this.localMediaStream && this.localMediaStreamLocallyGenerated && (G("close() | closing local MediaStream"), z.closeMediaStream(this.localMediaStream));
                        for (e in this.timers)
                            clearTimeout(this.timers[e]);
                        clearTimeout(this.sessionTimers.timer),
                        this.dialog && (this.dialog.terminate(), delete this.dialog);
                        for (e in this.earlyDialogs)
                            this.earlyDialogs[e].terminate(),
                            delete this.earlyDialogs[e];
                        this.status = q.STATUS_TERMINATED,
                        delete this.ua.sessions[this.id]
                    }
                },
                r.prototype.sendDTMF = function(e, t) {
                    function n() {
                        var e,
                            o;
                        if (l.status === q.STATUS_TERMINATED || !l.tones || i >= l.tones.length)
                            return void(l.tones = null);
                        if (e = l.tones[i], i += 1, "," === e)
                            o = 2e3;
                        else {
                            var a = new Z(l);
                            t.eventHandlers = {
                                onFailed: function() {
                                    l.tones = null
                                }
                            },
                            a.send(e, t),
                            o = r + s
                        }
                        setTimeout(n, o)
                    }
                    G("sendDTMF() | tones: %s", e);
                    var r,
                        s,
                        i = 0,
                        l = this;
                    if (t = t || {}, r = t.duration || null, s = t.interToneGap || null, void 0 === e)
                        throw new TypeError("Not enough arguments");
                    if (this.status !== q.STATUS_CONFIRMED && this.status !== q.STATUS_WAITING_FOR_ACK)
                        throw new W.InvalidStateError(this.status);
                    if ("number" == typeof e && (e = e.toString()), !e || "string" != typeof e || !e.match(/^[0-9A-DR#*,]+$/i))
                        throw new TypeError("Invalid tones: " + e);
                    if (r && !z.isDecimal(r))
                        throw new TypeError("Invalid tone duration: " + r);
                    if (r
                        ? r < Z.C.MIN_DURATION
                            ? (G('"duration" value is lower than the minimum allowed, setting it to ' + Z.C.MIN_DURATION + " milliseconds"), r = Z.C.MIN_DURATION)
                            : r > Z.C.MAX_DURATION
                                ? (G('"duration" value is greater than the maximum allowed, setting it to ' + Z.C.MAX_DURATION + " milliseconds"), r = Z.C.MAX_DURATION)
                                : r = Math.abs(r)
                        : r = Z.C.DEFAULT_DURATION, t.duration = r, s && !z.isDecimal(s))
                        throw new TypeError("Invalid interToneGap: " + s);
                    return s
                        ? s < Z.C.MIN_INTER_TONE_GAP
                            ? (G('"interToneGap" value is lower than the minimum allowed, setting it to ' + Z.C.MIN_INTER_TONE_GAP + " milliseconds"), s = Z.C.MIN_INTER_TONE_GAP)
                            : s = Math.abs(s)
                        : s = Z.C.DEFAULT_INTER_TONE_GAP,
                    this.tones
                        ? void(this.tones += e)
                        : (this.tones = e, void n())
                },
                r.prototype.sendInfo = function(e, t, n) {
                    if (G("sendInfo()"), n = n || {}, this.status !== q.STATUS_CONFIRMED && this.status !== q.STATUS_WAITING_FOR_ACK)
                        throw new W.InvalidStateError(this.status);
                    var r = new ee(this);
                    r.send(e, t, n)
                },
                r.prototype.mute = function(e) {
                    G("mute()"),
                    e = e || {
                        audio: !0,
                        video: !1
                    };
                    var t = !1,
                        n = !1;
                    this.audioMuted === !1 && e.audio && (t = !0, this.audioMuted = !0, R.call(this, !0)),
                    this.videoMuted === !1 && e.video && (n = !0, this.videoMuted = !0, w.call(this, !0)),
                    t !== !0 && n !== !0 || k.call(this, {
                        audio: t,
                        video: n
                    })
                },
                r.prototype.unmute = function(e) {
                    G("unmute()"),
                    e = e || {
                        audio: !0,
                        video: !0
                    };
                    var t = !1,
                        n = !1;
                    this.audioMuted === !0 && e.audio && (t = !0, this.audioMuted = !1, this.localHold === !1 && R.call(this, !1)),
                    this.videoMuted === !0 && e.video && (n = !0, this.videoMuted = !1, this.localHold === !1 && w.call(this, !1)),
                    t !== !0 && n !== !0 || L.call(this, {
                        audio: t,
                        video: n
                    })
                },
                r.prototype.hold = function(e, t) {
                    G("hold()"),
                    e = e || {};
                    var n,
                        r = this;
                    return (this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_CONFIRMED) && (this.localHold !== !0 && (!!this.isReadyToReOffer() && (this.localHold = !0, U.call(this, "local"), n = {
                        succeeded: function() {
                            t && t()
                        },
                        failed: function() {
                            r.terminate({cause: V.causes.WEBRTC_ERROR, status_code: 500, reason_phrase: "Hold Failed"})
                        }
                    }, e.useUpdate
                        ? v.call(this, {
                            sdpOffer: !0,
                            eventHandlers: n,
                            extraHeaders: e.extraHeaders
                        })
                        : g.call(this, {
                            eventHandlers: n,
                            extraHeaders: e.extraHeaders
                        }), !0)))
                },
                r.prototype.unhold = function(e, t) {
                    G("unhold()"),
                    e = e || {};
                    var n,
                        r = this;
                    return (this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_CONFIRMED) && (this.localHold !== !1 && (!!this.isReadyToReOffer() && (this.localHold = !1, M.call(this, "local"), n = {
                        succeeded: function() {
                            t && t()
                        },
                        failed: function() {
                            r.terminate({cause: V.causes.WEBRTC_ERROR, status_code: 500, reason_phrase: "Unhold Failed"})
                        }
                    }, e.useUpdate
                        ? v.call(this, {
                            sdpOffer: !0,
                            eventHandlers: n,
                            extraHeaders: e.extraHeaders
                        })
                        : g.call(this, {
                            eventHandlers: n,
                            extraHeaders: e.extraHeaders
                        }), !0)))
                },
                r.prototype.renegotiate = function(e, t) {
                    G("renegotiate()"),
                    e = e || {};
                    var n,
                        r = this,
                        s = e.rtcOfferConstraints || null;
                    return (this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_CONFIRMED) && (!!this.isReadyToReOffer() && (n = {
                        succeeded: function() {
                            t && t()
                        },
                        failed: function() {
                            r.terminate({cause: V.causes.WEBRTC_ERROR, status_code: 500, reason_phrase: "Media Renegotiation Failed"})
                        }
                    }, S.call(this), e.useUpdate
                        ? v.call(this, {
                            sdpOffer: !0,
                            eventHandlers: n,
                            rtcOfferConstraints: s,
                            extraHeaders: e.extraHeaders
                        })
                        : g.call(this, {
                            eventHandlers: n,
                            rtcOfferConstraints: s,
                            extraHeaders: e.extraHeaders
                        }), !0))
                },
                r.prototype.refer = function(e, t) {
                    G("refer()");
                    var n,
                        r,
                        s = this,
                        i = e;
                    if (this.status !== q.STATUS_WAITING_FOR_ACK && this.status !== q.STATUS_CONFIRMED)
                        return !1;
                    if (e = this.ua.normalizeTarget(e), !e)
                        throw new TypeError("Invalid target: " + i);
                    return n = new ne(this),
                    n.sendRefer(e, t),
                    r = n.outgoingRequest.cseq,
                    this.referSubscribers[r] = n,
                    n.on("requestFailed", function() {
                        delete s.referSubscribers[r]
                    }),
                    n.on("accepted", function() {
                        delete s.referSubscribers[r]
                    }),
                    n.on("failed", function() {
                        delete s.referSubscribers[r]
                    }),
                    n
                },
                r.prototype.receiveRequest = function(e) {
                    G("receiveRequest()");
                    var t,
                        n = this;
                    if (e.method === V.CANCEL)
                        this.status !== q.STATUS_WAITING_FOR_ANSWER && this.status !== q.STATUS_ANSWERED || (this.status = q.STATUS_CANCELED, this.request.reply(487), P.call(this, "remote", e, V.causes.CANCELED));
                    else
                        switch (e.method) {
                            case V.ACK:
                                if (this.status !== q.STATUS_WAITING_FOR_ACK)
                                    return;
                                if (this.status = q.STATUS_CONFIRMED, clearTimeout(this.timers.ackTimer), clearTimeout(this.timers.invite2xxTimer), this.late_sdp) {
                                    if (!e.body) {
                                        this.terminate({cause: V.causes.MISSING_SDP, status_code: 400});
                                        break
                                    }
                                    var r = {
                                            originator: "remote",
                                            type: "answer",
                                            sdp: e.body
                                        },
                                        s = new RTCSessionDescription({type: "answer", sdp: r.sdp});
                                    this.emit("sdp", r),
                                    this.connection.setRemoteDescription(s).then(function() {
                                        n.is_confirmed || x.call(n, "remote", e)
                                    }).catch(function(e) {
                                        n.terminate({cause: V.causes.BAD_MEDIA_DESCRIPTION, status_code: 488}),
                                        n.emit("peerconnection:setremotedescriptionfailed", e)
                                    })
                                } else
                                    this.is_confirmed || x.call(this, "remote", e);
                                break;
                            case V.BYE:
                                this.status === q.STATUS_CONFIRMED
                                    ? (e.reply(200), D.call(this, "remote", e, V.causes.BYE))
                                    : this.status === q.STATUS_INVITE_RECEIVED
                                        ? (e.reply(200), this.request.reply(487, "BYE Received"), D.call(this, "remote", e, V.causes.BYE))
                                        : e.reply(403, "Wrong Status");
                                break;
                            case V.INVITE:
                                this.status === q.STATUS_CONFIRMED
                                    ? e.hasHeader("replaces")
                                        ? p.call(this, e)
                                        : u.call(this, e)
                                    : e.reply(403, "Wrong Status");
                                break;
                            case V.INFO:
                                this.status === q.STATUS_CONFIRMED || this.status === q.STATUS_WAITING_FOR_ACK || this.status === q.STATUS_INVITE_RECEIVED
                                    ? (t = e.getHeader("content-type"), t && t.match(/^application\/dtmf-relay/i)
                                        ? new Z(this).init_incoming(e)
                                        : void 0 !== t
                                            ? new ee(this).init_incoming(e)
                                            : e.reply(415))
                                    : e.reply(403, "Wrong Status");
                                break;
                            case V.UPDATE:
                                this.status === q.STATUS_CONFIRMED
                                    ? c.call(this, e)
                                    : e.reply(403, "Wrong Status");
                                break;
                            case V.REFER:
                                this.status === q.STATUS_CONFIRMED
                                    ? d.call(this, e)
                                    : e.reply(403, "Wrong Status");
                                break;
                            case V.NOTIFY:
                                this.status === q.STATUS_CONFIRMED
                                    ? h.call(this, e)
                                    : e.reply(403, "Wrong Status");
                                break;
                            default:
                                e.reply(501)
                        }
                    },
                r.prototype.onTransportError = function() {
                    j("onTransportError()"),
                    this.status !== q.STATUS_TERMINATED && this.terminate({status_code: 500, reason_phrase: V.causes.CONNECTION_ERROR, cause: V.causes.CONNECTION_ERROR})
                },
                r.prototype.onRequestTimeout = function() {
                    j("onRequestTimeout()"),
                    this.status !== q.STATUS_TERMINATED && this.terminate({status_code: 408, reason_phrase: V.causes.REQUEST_TIMEOUT, cause: V.causes.REQUEST_TIMEOUT})
                },
                r.prototype.onDialogError = function() {
                    j("onDialogError()"),
                    this.status !== q.STATUS_TERMINATED && this.terminate({status_code: 500, reason_phrase: V.causes.DIALOG_ERROR, cause: V.causes.DIALOG_ERROR})
                },
                r.prototype.newDTMF = function(e) {
                    G("newDTMF()"),
                    this.emit("newDTMF", e)
                },
                r.prototype.newInfo = function(e) {
                    G("newInfo()"),
                    this.emit("newInfo", e)
                },
                r.prototype.resetLocalMedia = function() {
                    G("resetLocalMedia()"),
                    this.localHold = !1,
                    this.audioMuted = !1,
                    this.videoMuted = !1,
                    S.call(this)
                }
            }, {
                "./Constants": 1,
                "./Dialog": 2,
                "./Exceptions": 5,
                "./RTCSession/DTMF": 12,
                "./RTCSession/Info": 13,
                "./RTCSession/ReferNotifier": 14,
                "./RTCSession/ReferSubscriber": 15,
                "./RTCSession/Request": 16,
                "./RequestSender": 18,
                "./SIPMessage": 19,
                "./Timers": 21,
                "./Transactions": 22,
                "./Utils": 26,
                debug: 35,
                events: 29,
                "sdp-transform": 38,
                util: 33
            }
        ],
        12: [
            function(e, t, n) {
                function r(e) {
                    this.owner = e,
                    this.direction = null,
                    this.tone = null,
                    this.duration = null,
                    l.EventEmitter.call(this)
                }
                t.exports = r;
                var s = {
                    MIN_DURATION: 70,
                    MAX_DURATION: 6e3,
                    DEFAULT_DURATION: 100,
                    MIN_INTER_TONE_GAP: 50,
                    DEFAULT_INTER_TONE_GAP: 500
                };
                r.C = s;
                var i = e("util"),
                    l = e("events"),
                    o = e("debug")("JsSIP:RTCSession:DTMF"),
                    a = e("debug")("JsSIP:ERROR:RTCSession:DTMF");
                a.log = console.warn.bind(console);
                var u = e("../Constants"),
                    c = e("../Exceptions"),
                    d = e("../RTCSession");
                i.inherits(r, l.EventEmitter),
                r.prototype.send = function(e, t) {
                    var n,
                        r;
                    if (void 0 === e)
                        throw new TypeError("Not enough arguments");
                    if (this.direction = "outgoing", this.owner.status !== d.C.STATUS_CONFIRMED && this.owner.status !== d.C.STATUS_WAITING_FOR_ACK)
                        throw new c.InvalidStateError(this.owner.status);
                    if (t = t || {}, n = t.extraHeaders
                        ? t.extraHeaders.slice()
                        : [], this.eventHandlers = t.eventHandlers || {}, "string" == typeof e)
                        e = e.toUpperCase();
                    else {
                        if ("number" != typeof e)
                            throw new TypeError("Invalid tone: " + e);
                        e = e.toString()
                    }
                    if (!e.match(/^[0-9A-DR#*]$/))
                        throw new TypeError("Invalid tone: " + e);
                    this.tone = e,
                    this.duration = t.duration,
                    n.push("Content-Type: application/dtmf-relay"),
                    r = "Signal=" + this.tone + "\r\n",
                    r += "Duration=" + this.duration,
                    this.owner.newDTMF({originator: "local", dtmf: this, request: this.request}),
                    this.owner.dialog.sendRequest(this, u.INFO, {
                        extraHeaders: n,
                        body: r
                    })
                },
                r.prototype.receiveResponse = function(e) {
                    switch (!0) {
                        case /^ 1 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            break;
                        case /^ 2 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            this.emit("succeeded", {
                                originator: "remote",
                                response: e
                            });
                            break;
                        default:
                            this.eventHandlers.onFailed && this.eventHandlers.onFailed(),
                            this.emit("failed", {
                                originator: "remote",
                                response: e
                            })
                    }
                },
                r.prototype.onRequestTimeout = function() {
                    a("onRequestTimeout"),
                    this.owner.onRequestTimeout()
                },
                r.prototype.onTransportError = function() {
                    a("onTransportError"),
                    this.owner.onTransportError()
                },
                r.prototype.onDialogError = function() {
                    a("onDialogError"),
                    this.owner.onDialogError()
                },
                r.prototype.init_incoming = function(e) {
                    var t,
                        n = /^(Signal\s*?=\s*?)([0-9A-D#*]{1})(\s)?.*/,
                        r = /^(Duration\s?=\s?)([0-9]{1,4})(\s)?.*/;
                    this.direction = "incoming",
                    this.request = e,
                    e.reply(200),
                    e.body && (t = e.body.split("\n"), t.length >= 1 && n.test(t[0]) && (this.tone = t[0].replace(n, "$2")), t.length >= 2 && r.test(t[1]) && (this.duration = parseInt(t[1].replace(r, "$2"), 10))),
                    this.duration || (this.duration = s.DEFAULT_DURATION),
                    this.tone
                        ? this.owner.newDTMF({originator: "remote", dtmf: this, request: e})
                        : o("invalid INFO DTMF received, discarded")
                }
            }, {
                "../Constants": 1,
                "../Exceptions": 5,
                "../RTCSession": 11,
                debug: 35,
                events: 29,
                util: 33
            }
        ],
        13: [
            function(e, t, n) {
                function r(e) {
                    this.owner = e,
                    this.direction = null,
                    this.contentType = null,
                    this.body = null,
                    i.EventEmitter.call(this)
                }
                t.exports = r;
                var s = e("util"),
                    i = e("events"),
                    l = e("debug")("JsSIP:ERROR:RTCSession:Info");
                l.log = console.warn.bind(console);
                var o = e("../Constants"),
                    a = e("../Exceptions"),
                    u = e("../RTCSession");
                s.inherits(r, i.EventEmitter),
                r.prototype.send = function(e, t, n) {
                    var r;
                    if (this.direction = "outgoing", void 0 === e)
                        throw new TypeError("Not enough arguments");
                    if (this.owner.status !== u.C.STATUS_CONFIRMED && this.owner.status !== u.C.STATUS_WAITING_FOR_ACK)
                        throw new a.InvalidStateError(this.owner.status);
                    this.contentType = e,
                    this.body = t,
                    n = n || {},
                    r = n.extraHeaders
                        ? n.extraHeaders.slice()
                        : [],
                    r.push("Content-Type: " + e),
                    this.owner.newInfo({originator: "local", info: this, request: this.request}),
                    this.owner.dialog.sendRequest(this, o.INFO, {
                        extraHeaders: r,
                        body: t
                    })
                },
                r.prototype.receiveResponse = function(e) {
                    switch (!0) {
                        case /^ 1 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            break;
                        case /^ 2 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            this.emit("succeeded", {
                                originator: "remote",
                                response: e
                            });
                            break;
                        default:
                            this.emit("failed", {
                                originator: "remote",
                                response: e
                            })
                    }
                },
                r.prototype.onRequestTimeout = function() {
                    l("onRequestTimeout"),
                    this.owner.onRequestTimeout()
                },
                r.prototype.onTransportError = function() {
                    l("onTransportError"),
                    this.owner.onTransportError()
                },
                r.prototype.onDialogError = function() {
                    l("onDialogError"),
                    this.owner.onDialogError()
                },
                r.prototype.init_incoming = function(e) {
                    this.direction = "incoming",
                    this.request = e,
                    e.reply(200),
                    this.contentType = e.getHeader("content-type"),
                    this.body = e.body,
                    this.owner.newInfo({originator: "remote", info: this, request: e})
                }
            }, {
                "../Constants": 1,
                "../Exceptions": 5,
                "../RTCSession": 11,
                debug: 35,
                events: 29,
                util: 33
            }
        ],
        14: [
            function(e, t, n) {
                function r(e, t, n) {
                    this.session = e,
                    this.id = t,
                    this.expires = n || s.expires,
                    this.active = !0,
                    this.notify(100)
                }
                t.exports = r;
                var s = {
                        event_type: "refer",
                        body_type: "message/sipfrag;version=2.0",
                        expires: 300
                    },
                    i = e("debug")("JsSIP:RTCSession:ReferNotifier"),
                    l = e("../Constants"),
                    o = e("./Request");
                r.prototype.notify = function(e, t) {
                    i("notify()");
                    var n,
                        r = this;
                    if (this.active !== !1) {
                        t = t || l.REASON_PHRASE[e] || "",
                        n = e >= 200
                            ? "terminated;reason=noresource"
                            : "active;expires=" + this.expires;
                        var a = new o(this.session, l.NOTIFY);
                        a.send({
                            extraHeaders: [
                                "Event: " + s.event_type + ";id=" + r.id,
                                "Subscription-State: " + n,
                                "Content-Type: " + s.body_type
                            ],
                            body: "SIP/2.0 " + e + " " + t,
                            eventHandlers: {
                                onErrorResponse: function() {
                                    r.active = !1
                                }
                            }
                        })
                    }
                }
            }, {
                "../Constants": 1,
                "./Request": 16,
                debug: 35
            }
        ],
        15: [
            function(e, t, n) {
                function r(e) {
                    this.session = e,
                    this.timer = null,
                    this.outgoingRequest = null,
                    o.EventEmitter.call(this)
                }
                function s() {
                    console.log("removeSubscriber()"),
                    clearTimeout(this.timer),
                    this.session.referSubscriber = null
                }
                t.exports = r;
                var i = {
                        expires: 120
                    },
                    l = e("util"),
                    o = e("events"),
                    a = e("debug")("JsSIP:RTCSession:ReferSubscriber"),
                    u = e("../Constants"),
                    c = e("../Grammar"),
                    d = e("./Request");
                l.inherits(r, o.EventEmitter),
                r.prototype.sendRefer = function(e, t) {
                    a("sendRefer()");
                    var n,
                        r,
                        l,
                        o = null,
                        c = this;
                    t = t || {},
                    n = t.extraHeaders
                        ? t.extraHeaders.slice()
                        : [],
                    r = t.eventHandlers || {};
                    for (var h in r)
                        this.on(h, r[h]);
                    t.replaces && (o = t.replaces.request.call_id, o += ";to-tag=" + t.replaces.to_tag, o += ";from-tag=" + t.replaces.from_tag, o = encodeURIComponent(o)),
                    l = "Refer-To: <" + e + (o
                        ? "?Replaces=" + o
                        : "") + ">",
                    n.push(l);
                    var p = new d(this.session, u.REFER);
                    this.timer = setTimeout(function() {
                        s.call(c)
                    }, 1e3 * i.expires),
                    p.send({
                        extraHeaders: n,
                        eventHandlers: {
                            onSuccessResponse: function(e) {
                                c.emit("requestSucceeded", {response: e})
                            },
                            onErrorResponse: function(e) {
                                c.emit("requestFailed", {
                                    response: e,
                                    cause: u.causes.REJECTED
                                })
                            },
                            onTransportError: function() {
                                s.call(c),
                                c.emit("requestFailed", {
                                    response: null,
                                    cause: u.causes.CONNECTION_ERROR
                                })
                            },
                            onRequestTimeout: function() {
                                s.call(c),
                                c.emit("requestFailed", {
                                    response: null,
                                    cause: u.causes.REQUEST_TIMEOUT
                                })
                            },
                            onDialogError: function() {
                                s.call(c),
                                c.emit("requestFailed", {
                                    response: null,
                                    cause: u.causes.DIALOG_ERROR
                                })
                            }
                        }
                    }),
                    this.outgoingRequest = p.outgoingRequest
                },
                r.prototype.receiveNotify = function(e) {
                    a("receiveNotify()");
                    var t;
                    if (e.body) {
                        if (t = c.parse(e.body, "Status_Line"), t === -1)
                            return void a('receiveNotify() | error parsing NOTIFY body: "' + e.body + '"');
                        switch (!0) {
                            case /^ 100 $ /.test(t.status_code):
                                this.emit("trying", {
                                    request: e,
                                    status_line: t
                                });
                                break;
                            case /^ 1 [0 - 9]{
                                    2
                                }
                                $ /.test(t.status_code):
                                this.emit("progress", {
                                    request: e,
                                    status_line: t
                                });
                                break;
                            case /^ 2 [0 - 9]{
                                    2
                                }
                                $ /.test(t.status_code):
                                s.call(this),
                                this.emit("accepted", {
                                    request: e,
                                    status_line: t
                                });
                                break;
                            default:
                                s.call(this),
                                this.emit("failed", {
                                    request: e,
                                    status_line: t
                                })
                        }
                    }
                }
            }, {
                "../Constants": 1,
                "../Grammar": 6,
                "./Request": 16,
                debug: 35,
                events: 29,
                util: 33
            }
        ],
        16: [
            function(e, t, n) {
                function r(e, t) {
                    if (s("new | %s", t), this.session = e, this.method = t, this.outgoingRequest = null, this.session.status !== a.C.STATUS_1XX_RECEIVED && this.session.status !== a.C.STATUS_WAITING_FOR_ANSWER && this.session.status !== a.C.STATUS_WAITING_FOR_ACK && this.session.status !== a.C.STATUS_CONFIRMED && this.session.status !== a.C.STATUS_TERMINATED)
                        throw new o.InvalidStateError(this.session.status);
                    if (this.session.status === a.C.STATUS_TERMINATED && t !== l.BYE)
                        throw new o.InvalidStateError(this.session.status)
                }
                t.exports = r;
                var s = e("debug")("JsSIP:RTCSession:Request"),
                    i = e("debug")("JsSIP:ERROR:RTCSession:Request");
                i.log = console.warn.bind(console);
                var l = e("../Constants"),
                    o = e("../Exceptions"),
                    a = e("../RTCSession");
                r.prototype.send = function(e) {
                    e = e || {};
                    var t = e.extraHeaders && e.extraHeaders.slice() || [],
                        n = e.body || null;
                    this.eventHandlers = e.eventHandlers || {},
                    this.outgoingRequest = this.session.dialog.sendRequest(this, this.method, {
                        extraHeaders: t,
                        body: n
                    })
                },
                r.prototype.receiveResponse = function(e) {
                    switch (!0) {
                        case /^ 1 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            s("onProgressResponse"),
                            this.eventHandlers.onProgressResponse && this.eventHandlers.onProgressResponse(e);
                            break;
                        case /^ 2 [0 - 9]{
                                2
                            }
                            $ /.test(e.status_code):
                            s("onSuccessResponse"),
                            this.eventHandlers.onSuccessResponse && this.eventHandlers.onSuccessResponse(e);
                            break;
                        default:
                            s("onErrorResponse"),
                            this.eventHandlers.onErrorResponse && this.eventHandlers.onErrorResponse(e)
                    }
                },
                r.prototype.onRequestTimeout = function() {
                    i("onRequestTimeout"),
                    this.eventHandlers.onRequestTimeout && this.eventHandlers.onRequestTimeout()
                },
                r.prototype.onTransportError = function() {
                    i("onTransportError"),
                    this.eventHandlers.onTransportError && this.eventHandlers.onTransportError()
                },
                r.prototype.onDialogError = function() {
                    i("onDialogError"),
                    this.eventHandlers.onDialogError && this.eventHandlers.onDialogError()
                }
            }, {
                "../Constants": 1,
                "../Exceptions": 5,
                "../RTCSession": 11,
                debug: 35
            }
        ],
        17: [
            function(e, t, n) {
                function r(e, t) {
                    var n = 1;
                    this.ua = e,
                    this.transport = t,
                    this.registrar = e.configuration.registrar_server,
                    this.expires = e.configuration.register_expires,
                    this.call_id = i.createRandomToken(22),
                    this.cseq = 0,
                    this.to_uri = e.configuration.uri,
                    this.registrationTimer = null,
                    this.registering = !1,
                    this.registered = !1,
                    this.contact = this.ua.contact.toString(),
                    this.contact += ";+sip.ice",
                    this.extraHeaders = [],
                    this.extraContactParams = "",
                    n && (this.contact += ";reg-id=" + n, this.contact += ';+sip.instance="<urn:uuid:' + this.ua.configuration.instance_id + '>"')
                }
                t.exports = r;
                var s = e("debug")("JsSIP:Registrator"),
                    i = e("./Utils"),
                    l = e("./Constants"),
                    o = e("./SIPMessage"),
                    a = e("./RequestSender");
                r.prototype = {
                    setExtraHeaders: function(e) {
                        Array.isArray(e) || (e = []),
                        this.extraHeaders = e.slice()
                    },
                    setExtraContactParams: function(e) {
                        e instanceof Object || (e = {}),
                        this.extraContactParams = "";
                        for (var t in e) {
                            var n = e[t];
                            this.extraContactParams += ";" + t,
                            n && (this.extraContactParams += "=" + n)
                        }
                    },
                    register: function() {
                        var e,
                            t,
                            n,
                            r = this;
                        return this.registering
                            ? void s("Register request in progress...")
                            : (n = this.extraHeaders.slice(), n.push("Contact: " + this.contact + ";expires=" + this.expires + this.extraContactParams), n.push("Expires: " + this.expires), this.request = new o.OutgoingRequest(l.REGISTER, this.registrar, this.ua, {
                                to_uri: this.to_uri,
                                call_id: this.call_id,
                                cseq: this.cseq += 1
                            }, n), e = new a(this, this.ua), this.receiveResponse = function(e) {
                                var n,
                                    o,
                                    a = e.getHeaders("contact").length;
                                if (e.cseq === this.cseq)
                                    switch (null !== this.registrationTimer && (clearTimeout(this.registrationTimer), this.registrationTimer = null), !0) {
                                        case /^ 1 [0 - 9]{
                                                2
                                            }
                                            $ /.test(e.status_code):
                                            break;
                                        case /^ 2 [0 - 9]{
                                                2
                                            }
                                            $ /.test(e.status_code):
                                            if (this.registering = !1, e.hasHeader("expires") && (o = e.getHeader("expires")), !a) {
                                                s("no Contact header in response to REGISTER, response ignored");
                                                break
                                            }
                                            for (; a--;) {
                                                if (n = e.parseHeader("contact", a), n.uri.user === this.ua.contact.uri.user) {
                                                    o = n.getParam("expires");
                                                    break
                                                }
                                                n = null
                                            }
                                            if (!n) {
                                                s("no Contact header pointing to us, response ignored");
                                                break
                                            }
                                            o || (o = this.expires),
                                            this.registrationTimer = setTimeout(function() {
                                                r.registrationTimer = null,
                                                0 === r.ua.listeners("registrationExpiring").length
                                                    ? r.register()
                                                    : r.ua.emit("registrationExpiring")
                                            }, 1e3 * o - 5e3),
                                            n.hasParam("temp-gruu") && (this.ua.contact.temp_gruu = n.getParam("temp-gruu").replace(/"/g, "")),
                                            n.hasParam("pub-gruu") && (this.ua.contact.pub_gruu = n.getParam("pub-gruu").replace(/"/g, "")),
                                            this.registered || (this.registered = !0, this.ua.registered({response: e}));
                                            break;
                                        case /^ 423 $ /.test(e.status_code):
                                            e.hasHeader("min-expires")
                                                ? (this.expires = e.getHeader("min-expires"), this.register())
                                                : (s("423 response received for REGISTER without Min-Expires"), this.registrationFailure(e, l.causes.SIP_FAILURE_CODE));
                                            break;
                                        default:
                                            t = i.sipErrorCause(e.status_code),
                                            this.registrationFailure(e, t)
                                    }
                                },
                            this.onRequestTimeout = function() {
                                this.registrationFailure(null, l.causes.REQUEST_TIMEOUT)
                            },
                            this.onTransportError = function() {
                                this.registrationFailure(null, l.causes.CONNECTION_ERROR)
                            },
                            this.registering = !0,
                            void e.send())
                    },
                    unregister: function(e) {
                        var t;
                        if (!this.registered)
                            return void s("already unregistered");
                        e = e || {},
                        this.registered = !1,
                        null !== this.registrationTimer && (clearTimeout(this.registrationTimer), this.registrationTimer = null),
                        t = this.extraHeaders.slice(),
                        e.all
                            ? (t.push("Contact: *" + this.extraContactParams), t.push("Expires: 0"), this.request = new o.OutgoingRequest(l.REGISTER, this.registrar, this.ua, {
                                to_uri: this.to_uri,
                                call_id: this.call_id,
                                cseq: this.cseq += 1
                            }, t))
                            : (t.push("Contact: " + this.contact + ";expires=0" + this.extraContactParams), t.push("Expires: 0"), this.request = new o.OutgoingRequest(l.REGISTER, this.registrar, this.ua, {
                                to_uri: this.to_uri,
                                call_id: this.call_id,
                                cseq: this.cseq += 1
                            }, t));
                        var n = new a(this, this.ua);
                        this.receiveResponse = function(e) {
                            var t;
                            switch (!0) {
                                case /^ 1 [0 - 9]{
                                        2
                                    }
                                    $ /.test(e.status_code):
                                    break;
                                case /^ 2 [0 - 9]{
                                        2
                                    }
                                    $ /.test(e.status_code):
                                    this.unregistered(e);
                                    break;
                                default:
                                    t = i.sipErrorCause(e.status_code),
                                    this.unregistered(e, t)
                            }
                        },
                        this.onRequestTimeout = function() {
                            this.unregistered(null, l.causes.REQUEST_TIMEOUT)
                        },
                        this.onTransportError = function() {
                            this.unregistered(null, l.causes.CONNECTION_ERROR)
                        },
                        n.send()
                    },
                    registrationFailure: function(e, t) {
                        this.registering = !1,
                        this.ua.registrationFailed({
                            response: e || null,
                            cause: t
                        }),
                        this.registered && (this.registered = !1, this.ua.unregistered({
                            response: e || null,
                            cause: t
                        }))
                    },
                    unregistered: function(e, t) {
                        this.registering = !1,
                        this.registered = !1,
                        this.ua.unregistered({
                            response: e || null,
                            cause: t || null
                        })
                    },
                    onTransportClosed: function() {
                        this.registering = !1,
                        null !== this.registrationTimer && (clearTimeout(this.registrationTimer), this.registrationTimer = null),
                        this.registered && (this.registered = !1, this.ua.unregistered({}))
                    },
                    close: function() {
                        this.registered && this.unregister()
                    }
                }
            }, {
                "./Constants": 1,
                "./RequestSender": 18,
                "./SIPMessage": 19,
                "./Utils": 26,
                debug: 35
            }
        ],
        18: [
            function(e, t, n) {
                function r(e, t) {
                    this.ua = t,
                    this.applicant = e,
                    this.method = e.request.method,
                    this.request = e.request,
                    this.auth = null,
                    this.challenged = !1,
                    this.staled = !1,
                    t.status !== l.C.STATUS_USER_CLOSED || this.method === i.BYE && this.method === i.ACK || this.onTransportError()
                }
                t.exports = r;
                var s = e("debug")("JsSIP:RequestSender"),
                    i = e("./Constants"),
                    l = e("./UA"),
                    o = e("./DigestAuthentication"),
                    a = e("./Transactions");
                r.prototype = {
                    send: function() {
                        switch (this.method) {
                            case "INVITE":
                                this.clientTransaction = new a.InviteClientTransaction(this, this.request, this.ua.transport);
                                break;
                            case "ACK":
                                this.clientTransaction = new a.AckClientTransaction(this, this.request, this.ua.transport);
                                break;
                            default:
                                this.clientTransaction = new a.NonInviteClientTransaction(this, this.request, this.ua.transport)
                        }
                        this.clientTransaction.send()
                    },
                    onRequestTimeout: function() {
                        this.applicant.onRequestTimeout()
                    },
                    onTransportError: function() {
                        this.applicant.onTransportError()
                    },
                    receiveResponse: function(e) {
                        var t,
                            n,
                            r,
                            l = e.status_code;
                        if (401 !== l && 407 !== l || null === this.ua.configuration.password && null === this.ua.configuration.ha1)
                            this.applicant.receiveResponse(e);
                        else {
                            if (401 === e.status_code
                                ? (n = e.parseHeader("www-authenticate"), r = "authorization")
                                : (n = e.parseHeader("proxy-authenticate"), r = "proxy-authorization"), !n)
                                return s(e.status_code + " with wrong or missing challenge, cannot authenticate"),
                                void this.applicant.receiveResponse(e);
                            if (!this.challenged || !this.staled && n.stale === !0) {
                                if (this.auth || (this.auth = new o({username: this.ua.configuration.authorization_user, password: this.ua.configuration.password, realm: this.ua.configuration.realm, ha1: this.ua.configuration.ha1})), !this.auth.authenticate(this.request, n))
                                    return void this.applicant.receiveResponse(e);
                                this.challenged = !0,
                                this.ua.set("realm", this.auth.get("realm")),
                                this.ua.set("ha1", this.auth.get("ha1")),
                                n.stale && (this.staled = !0),
                                t = e.method === i.REGISTER
                                    ? this.applicant.cseq += 1
                                    : this.request.dialog
                                        ? this.request.dialog.local_seqnum += 1
                                        : this.request.cseq + 1,
                                this.request = this.applicant.request = this.request.clone(),
                                this.request.cseq = t,
                                this.request.setHeader("cseq", t + " " + this.method),
                                this.request.setHeader(r, this.auth.toString()),
                                this.send()
                            } else
                                this.applicant.receiveResponse(e)
                        }
                    }
                }
            }, {
                "./Constants": 1,
                "./DigestAuthentication": 4,
                "./Transactions": 22,
                "./UA": 24,
                debug: 35
            }
        ],
        19: [
            function(e, t, n) {
                function r(e, t, n, r, s, i) {
                    var l,
                        o,
                        a,
                        h;
                    return r = r || {},
                    e && t && n
                        ? (this.ua = n, this.headers = {}, this.method = e, this.ruri = t, this.body = i, this.extraHeaders = s && s.slice() || [], r.route_set
                            ? this.setHeader("route", r.route_set)
                            : n.configuration.use_preloaded_route && this.setHeader("route", "<" + n.transport.sip_uri + ";lr>"), this.setHeader("via", ""), this.setHeader("max-forwards", u.MAX_FORWARDS), l = r.to_display_name || 0 === r.to_display_name
                            ? '"' + r.to_display_name + '" '
                            : "", l += "<" + (r.to_uri || t) + ">", l += r.to_tag
                            ? ";tag=" + r.to_tag
                            : "", this.to = new d.parse(l), this.setHeader("to", l), o = r.from_display_name || 0 === r.from_display_name
                            ? '"' + r.from_display_name + '" '
                            : n.configuration.display_name
                                ? '"' + n.configuration.display_name + '" '
                                : "", o += "<" + (r.from_uri || n.configuration.uri) + ">;tag=", o += r.from_tag || c.newTag(), this.from = new d.parse(o), this.setHeader("from", o), a = r.call_id || n.configuration.jssip_id + c.createRandomToken(15), this.call_id = a, this.setHeader("call-id", a), h = r.cseq || Math.floor(1e4 * Math.random()), this.cseq = h, void this.setHeader("cseq", h + " " + e))
                        : null
                }
                function s() {
                    this.data = null,
                    this.headers = null,
                    this.method = null,
                    this.via = null,
                    this.via_branch = null,
                    this.call_id = null,
                    this.cseq = null,
                    this.from = null,
                    this.from_tag = null,
                    this.to = null,
                    this.to_tag = null,
                    this.body = null,
                    this.sdp = null
                }
                function i(e) {
                    this.ua = e,
                    this.headers = {},
                    this.ruri = null,
                    this.transport = null,
                    this.server_transaction = null
                }
                function l() {
                    this.headers = {},
                    this.status_code = null,
                    this.reason_phrase = null
                }
                t.exports = {
                    OutgoingRequest: r,
                    IncomingRequest: i,
                    IncomingResponse: l
                };
                var o = e("debug")("JsSIP:SIPMessage"),
                    a = e("sdp-transform"),
                    u = e("./Constants"),
                    c = e("./Utils"),
                    d = e("./NameAddrHeader"),
                    h = e("./Grammar");
                r.prototype = {
                    setHeader: function(e, t) {
                        var n,
                            r;
                        for (n = new RegExp("^\\s*" + e + "\\s*:", "i"), r = 0; r < this.extraHeaders.length; r++)
                            n.test(this.extraHeaders[r]) && this.extraHeaders.splice(r, 1);
                        this.headers[c.headerize(e)] = Array.isArray(t)
                            ? t
                            : [t]
                    },
                    getHeader: function(e) {
                        var t,
                            n,
                            r = this.extraHeaders.length,
                            s = this.headers[c.headerize(e)];
                        if (s) {
                            if (s[0])
                                return s[0]
                        } else
                            for (t = new RegExp("^\\s*" + e + "\\s*:", "i"), n = 0; n < r; n++)
                                if (s = this.extraHeaders[n], t.test(s))
                                    return s.substring(s.indexOf(":") + 1).trim()
                    },
                    getHeaders: function(e) {
                        var t,
                            n,
                            r,
                            s = this.headers[c.headerize(e)],
                            i = [];
                        if (s) {
                            for (n = s.length, t = 0; t < n; t++)
                                i.push(s[t]);
                            return i
                        }
                        for (n = this.extraHeaders.length, r = new RegExp("^\\s*" + e + "\\s*:", "i"), t = 0; t < n; t++)
                            s = this.extraHeaders[t],
                            r.test(s) && i.push(s.substring(s.indexOf(":") + 1).trim());
                        return i
                    },
                    hasHeader: function(e) {
                        var t,
                            n,
                            r = this.extraHeaders.length;
                        if (this.headers[c.headerize(e)])
                            return !0;
                        for (t = new RegExp("^\\s*" + e + "\\s*:", "i"), n = 0; n < r; n++)
                            if (t.test(this.extraHeaders[n]))
                                return !0;
                    return !1
                    },
                    parseSDP: function(e) {
                        return !e && this.sdp
                            ? this.sdp
                            : (this.sdp = a.parse(this.body || ""), this.sdp)
                    },
                    toString: function() {
                        var e,
                            t,
                            n,
                            r = "",
                            s = [];
                        r += this.method + " " + this.ruri + " SIP/2.0\r\n";
                        for (e in this.headers)
                            for (t = this.headers[e].length, n = 0; n < t; n++)
                                r += e + ": " + this.headers[e][n] + "\r\n";
                    for (t = this.extraHeaders.length, n = 0; n < t; n++)
                            r += this.extraHeaders[n].trim() + "\r\n";
                        switch (this.method) {
                            case u.REGISTER:
                                s.push("path", "gruu");
                                break;
                            case u.INVITE:
                                this.ua.configuration.session_timers && s.push("timer"),
                                (this.ua.contact.pub_gruu || this.ua.contact.temp_gruu) && s.push("gruu"),
                                s.push("ice", "replaces");
                                break;
                            case u.UPDATE:
                                this.ua.configuration.session_timers && s.push("timer"),
                                s.push("ice")
                        }
                        return s.push("outbound"),
                        r += "Allow: " + u.ALLOWED_METHODS + "\r\n",
                        r += "Supported: " + s + "\r\n",
                        r += "User-Agent: " + u.USER_AGENT + "\r\n",
                        this.body
                            ? (t = c.str_utf8_length(this.body), r += "Content-Length: " + t + "\r\n\r\n", r += this.body)
                            : r += "Content-Length: 0\r\n\r\n",
                        r
                    },
                    clone: function() {
                        var e = new r(this.method, this.ruri, this.ua);
                        return Object.keys(this.headers).forEach(function(t) {
                            e.headers[t] = this.headers[t].slice()
                        }, this),
                        e.body = this.body,
                        e.extraHeaders = this.extraHeaders && this.extraHeaders.slice() || [],
                        e.to = this.to,
                        e.from = this.from,
                        e.call_id = this.call_id,
                        e.cseq = this.cseq,
                        e
                    }
                },
                s.prototype = {
                    addHeader: function(e, t) {
                        var n = {
                            raw: t
                        };
                        e = c.headerize(e),
                        this.headers[e]
                            ? this.headers[e].push(n)
                            : this.headers[e] = [n]
                    },
                    getHeader: function(e) {
                        var t = this.headers[c.headerize(e)];
                        if (t)
                            return t[0]
                                ? t[0].raw
                                : void 0
                        },
                    getHeaders: function(e) {
                        var t,
                            n,
                            r = this.headers[c.headerize(e)],
                            s = [];
                        if (!r)
                            return [];
                        for (n = r.length, t = 0; t < n; t++)
                            s.push(r[t].raw);
                        return s
                    },
                    hasHeader: function(e) {
                        return !!this.headers[c.headerize(e)]
                    },
                    parseHeader: function(e, t) {
                        var n,
                            r,
                            s;
                        return e = c.headerize(e),
                        t = t || 0,
                        this.headers[e]
                            ? t >= this.headers[e].length
                                ? void o('not so many "' + e + '" headers present')
                                : (n = this.headers[e][t], r = n.raw, n.parsed
                                    ? n.parsed
                                    : (s = h.parse(r, e.replace(/-/g, "_")), s === -1
                                        ? (this.headers[e].splice(t, 1), void o('error parsing "' + e + '" header field with value "' + r + '"'))
                                        : (n.parsed = s, s)))
                            : void o('header "' + e + '" not present')
                    },
                    s: function(e, t) {
                        return this.parseHeader(e, t)
                    },
                    setHeader: function(e, t) {
                        var n = {
                            raw: t
                        };
                        this.headers[c.headerize(e)] = [n]
                    },
                    parseSDP: function(e) {
                        return !e && this.sdp
                            ? this.sdp
                            : (this.sdp = a.parse(this.body || ""), this.sdp)
                    },
                    toString: function() {
                        return this.data
                    }
                },
                i.prototype = new s,
                i.prototype.reply = function(e, t, n, r, s, i) {
                    var l,
                        o,
                        a,
                        d,
                        h,
                        p = [],
                        f = this.getHeader("To"),
                        m = 0,
                        g = 0;
                    if (e = e || null, t = t || null, !e || e < 100 || e > 699)
                        throw new TypeError("Invalid status_code: " + e);
                    if (t && "string" != typeof t && !(t instanceof String))
                        throw new TypeError("Invalid reason_phrase: " + t);
                    if (t = t || u.REASON_PHRASE[e] || "", n = n && n.slice() || [], h = "SIP/2.0 " + e + " " + t + "\r\n", this.method === u.INVITE && e > 100 && e <= 200)
                        for (l = this.getHeaders("record-route"), a = l.length, m; m < a; m++)
                            h += "Record-Route: " + l[m] + "\r\n";
                for (o = this.getHeaders("via"), a = o.length, g; g < a; g++)
                        h += "Via: " + o[g] + "\r\n";
                    for (!this.to_tag && e > 100
                        ? f += ";tag=" + c.newTag()
                        : this.to_tag && !this.s("to").hasParam("tag") && (f += ";tag=" + this.to_tag), h += "To: " + f + "\r\n", h += "From: " + this.getHeader("From") + "\r\n", h += "Call-ID: " + this.call_id + "\r\n", h += "CSeq: " + this.cseq + " " + this.method + "\r\n", a = n.length, d = 0; d < a; d++)
                        h += n[d].trim() + "\r\n";
                    switch (this.method) {
                        case u.INVITE:
                            this.ua.configuration.session_timers && p.push("timer"),
                            (this.ua.contact.pub_gruu || this.ua.contact.temp_gruu) && p.push("gruu"),
                            p.push("ice", "replaces");
                            break;
                        case u.UPDATE:
                            this.ua.configuration.session_timers && p.push("timer"),
                            r && p.push("ice"),
                            p.push("replaces")
                    }
                    p.push("outbound"),
                    this.method === u.OPTIONS
                        ? (h += "Allow: " + u.ALLOWED_METHODS + "\r\n", h += "Accept: " + u.ACCEPTED_BODY_TYPES + "\r\n")
                        : 405 === e
                            ? h += "Allow: " + u.ALLOWED_METHODS + "\r\n"
                            : 415 === e && (h += "Accept: " + u.ACCEPTED_BODY_TYPES + "\r\n"),
                    h += "Supported: " + p + "\r\n",
                    r
                        ? (a = c.str_utf8_length(r), h += "Content-Type: application/sdp\r\n", h += "Content-Length: " + a + "\r\n\r\n", h += r)
                        : h += "Content-Length: 0\r\n\r\n",
                    this.server_transaction.receiveResponse(e, h, s, i)
                },
                i.prototype.reply_sl = function(e, t) {
                    var n,
                        r,
                        s = 0,
                        i = this.getHeaders("via"),
                        l = i.length;
                    if (e = e || null, t = t || null, !e || e < 100 || e > 699)
                        throw new TypeError("Invalid status_code: " + e);
                    if (t && "string" != typeof t && !(t instanceof String))
                        throw new TypeError("Invalid reason_phrase: " + t);
                    for (t = t || u.REASON_PHRASE[e] || "", r = "SIP/2.0 " + e + " " + t + "\r\n", s; s < l; s++)
                        r += "Via: " + i[s] + "\r\n";
                    n = this.getHeader("To"),
                    !this.to_tag && e > 100
                        ? n += ";tag=" + c.newTag()
                        : this.to_tag && !this.s("to").hasParam("tag") && (n += ";tag=" + this.to_tag),
                    r += "To: " + n + "\r\n",
                    r += "From: " + this.getHeader("From") + "\r\n",
                    r += "Call-ID: " + this.call_id + "\r\n",
                    r += "CSeq: " + this.cseq + " " + this.method + "\r\n",
                    r += "Content-Length: 0\r\n\r\n",
                    this.transport.send(r)
                },
                l.prototype = new s
            }, {
                "./Constants": 1,
                "./Grammar": 6,
                "./NameAddrHeader": 9,
                "./Utils": 26,
                debug: 35,
                "sdp-transform": 38
            }
        ],
        20: [
            function(e, t, n) {
                function r() {}
                t.exports = r;
                var s = e("./Utils"),
                    i = e("./Grammar"),
                    l = e("debug")("JsSIP:ERROR:Socket");
                l.log = console.warn.bind(console),
                r.isSocket = function(e) {
                    if (Array.isArray(e))
                        return !1;
                    if ("undefined" == typeof e)
                        return l("undefined JsSIP.Socket instance"),
                        !1;
                    try {
                        if (!s.isString(e.url))
                            throw l("missing or invalid JsSIP.Socket url property"),
                            new Error;
                        if (!s.isString(e.via_transport))
                            throw l("missing or invalid JsSIP.Socket via_transport property"),
                            new Error;
                        if (i.parse(e.sip_uri, "SIP_URI") === -1)
                            throw l("missing or invalid JsSIP.Socket sip_uri property"),
                            new Error
                    } catch (e) {
                        return !1
                    }
                    try {
                        ["connect", "disconnect", "send"].forEach(function(t) {
                            if (!s.isFunction(e[t]))
                                throw l("missing or invalid JsSIP.Socket method: " + t),
                                new Error
                        })
                    } catch (e) {
                        return !1
                    }
                    return !0
                }
            }, {
                "./Grammar": 6,
                "./Utils": 26,
                debug: 35
            }
        ],
        21: [
            function(e, t, n) {
                var r = 500,
                    s = 4e3,
                    i = 5e3,
                    l = {
                        T1: r,
                        T2: s,
                        T4: i,
                        TIMER_B: 64 *r,
                        TIMER_D: 0 *r,
                        TIMER_F: 64 *r,
                        TIMER_H: 64 *r,
                        TIMER_I: 0 *r,
                        TIMER_J: 0 *r,
                        TIMER_K: 0 *i,
                        TIMER_L: 64 *r,
                        TIMER_M: 64 *r,
                        PROVISIONAL_RESPONSE_INTERVAL: 6e4
                    };
                t.exports = l
            }, {}
        ],
        22: [
            function(e, t, n) {
                function r(e, t, n) {
                    var r;
                    this.type = u.NON_INVITE_CLIENT,
                    this.transport = n,
                    this.id = "z9hG4bK" + Math.floor(1e7 * Math.random()),
                    this.request_sender = e,
                    this.request = t,
                    r = "SIP/2.0/" + n.via_transport,
                    r += " " + e.ua.configuration.via_host + ";branch=" + this.id,
                    this.request.setHeader("via", r),
                    this.request_sender.ua.newTransaction(this),
                    d.EventEmitter.call(this)
                }
                function s(e, t, n) {
                    var r,
                        s = this;
                    this.type = u.INVITE_CLIENT,
                    this.transport = n,
                    this.id = "z9hG4bK" + Math.floor(1e7 * Math.random()),
                    this.request_sender = e,
                    this.request = t,
                    r = "SIP/2.0/" + n.via_transport,
                    r += " " + e.ua.configuration.via_host + ";branch=" + this.id,
                    this.request.setHeader("via", r),
                    this.request_sender.ua.newTransaction(this),
                    this.request.cancel = function(e) {
                        s.cancel_request(s, e)
                    },
                    d.EventEmitter.call(this)
                }
                function i(e, t, n) {
                    var r;
                    this.transport = n,
                    this.id = "z9hG4bK" + Math.floor(1e7 * Math.random()),
                    this.request_sender = e,
                    this.request = t,
                    r = "SIP/2.0/" + n.via_transport,
                    r += " " + e.ua.configuration.via_host + ";branch=" + this.id,
                    this.request.setHeader("via", r),
                    d.EventEmitter.call(this)
                }
                function l(e, t) {
                    this.type = u.NON_INVITE_SERVER,
                    this.id = e.via_branch,
                    this.request = e,
                    this.transport = e.transport,
                    this.ua = t,
                    this.last_response = "",
                    e.server_transaction = this,
                    this.state = u.STATUS_TRYING,
                    t.newTransaction(this),
                    d.EventEmitter.call(this)
                }
                function o(e, t) {
                    this.type = u.INVITE_SERVER,
                    this.id = e.via_branch,
                    this.request = e,
                    this.transport = e.transport,
                    this.ua = t,
                    this.last_response = "",
                    e.server_transaction = this,
                    this.state = u.STATUS_PROCEEDING,
                    t.newTransaction(this),
                    this.resendProvisionalTimer = null,
                    e.reply(100),
                    d.EventEmitter.call(this)
                }
                function a(e, t) {
                    var n;
                    switch (t.method) {
                        case v.INVITE:
                            if (n = e.transactions.ist[t.via_branch]) {
                                switch (n.state) {
                                    case u.STATUS_PROCEEDING:
                                        n.transport.send(n.last_response);
                                        break;
                                    case u.STATUS_ACCEPTED:
                                }
                                return !0
                            }
                            break;
                        case v.ACK:
                            if (n = e.transactions.ist[t.via_branch], !n)
                                return !1;
                            if (n.state === u.STATUS_ACCEPTED)
                                return !1;
                            if (n.state === u.STATUS_COMPLETED)
                                return n.state = u.STATUS_CONFIRMED,
                                n.I = setTimeout(function() {
                                    n.timer_I()
                                }, T.TIMER_I),
                                !0;
                            break;
                        case v.CANCEL:
                            return n = e.transactions.ist[t.via_branch],
                            n
                                ? (t.reply_sl(200), n.state !== u.STATUS_PROCEEDING)
                                : (t.reply_sl(481), !0);
                        default:
                            if (n = e.transactions.nist[t.via_branch]) {
                                switch (n.state) {
                                    case u.STATUS_TRYING:
                                        break;
                                    case u.STATUS_PROCEEDING:
                                    case u.STATUS_COMPLETED:
                                        n.transport.send(n.last_response)
                                }
                                return !0
                            }
                    }
                }
                t.exports = {
                    C: null,
                    NonInviteClientTransaction: r,
                    InviteClientTransaction: s,
                    AckClientTransaction: i,
                    NonInviteServerTransaction: l,
                    InviteServerTransaction: o,
                    checkTransaction: a
                };
                var u = {
                    STATUS_TRYING: 1,
                    STATUS_PROCEEDING: 2,
                    STATUS_CALLING: 3,
                    STATUS_ACCEPTED: 4,
                    STATUS_COMPLETED: 5,
                    STATUS_TERMINATED: 6,
                    STATUS_CONFIRMED: 7,
                    NON_INVITE_CLIENT: "nict",
                    NON_INVITE_SERVER: "nist",
                    INVITE_CLIENT: "ict",
                    INVITE_SERVER: "ist"
                };
                t.exports.C = u;
                var c = e("util"),
                    d = e("events"),
                    h = e("debug")("JsSIP:NonInviteClientTransaction"),
                    p = e("debug")("JsSIP:InviteClientTransaction"),
                    f = e("debug")("JsSIP:AckClientTransaction"),
                    m = e("debug")("JsSIP:NonInviteServerTransaction"),
                    g = e("debug")("JsSIP:InviteServerTransaction"),
                    v = e("./Constants"),
                    T = e("./Timers");
                c.inherits(r, d.EventEmitter),
                r.prototype.stateChanged = function(e) {
                    this.state = e,
                    this.emit("stateChanged")
                },
                r.prototype.send = function() {
                    var e = this;
                    this.stateChanged(u.STATUS_TRYING),
                    this.F = setTimeout(function() {
                        e.timer_F()
                    }, T.TIMER_F),
                    this.transport.send(this.request) || this.onTransportError()
                },
                r.prototype.onTransportError = function() {
                    h("transport error occurred, deleting transaction " + this.id),
                    clearTimeout(this.F),
                    clearTimeout(this.K),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.request_sender.ua.destroyTransaction(this),
                    this.request_sender.onTransportError()
                },
                r.prototype.timer_F = function() {
                    h("Timer F expired for transaction " + this.id),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.request_sender.ua.destroyTransaction(this),
                    this.request_sender.onRequestTimeout()
                },
                r.prototype.timer_K = function() {
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.request_sender.ua.destroyTransaction(this)
                },
                r.prototype.receiveResponse = function(e) {
                    var t = this,
                        n = e.status_code;
                    if (n < 200)
                        switch (this.state) {
                            case u.STATUS_TRYING:
                            case u.STATUS_PROCEEDING:
                                this.stateChanged(u.STATUS_PROCEEDING),
                                this.request_sender.receiveResponse(e)
                        } else
                            switch (this.state) {
                                case u.STATUS_TRYING:
                                case u.STATUS_PROCEEDING:
                                    this.stateChanged(u.STATUS_COMPLETED),
                                    clearTimeout(this.F),
                                    408 === n
                                        ? this.request_sender.onRequestTimeout()
                                        : this.request_sender.receiveResponse(e),
                                    this.K = setTimeout(function() {
                                        t.timer_K()
                                    }, T.TIMER_K);
                                    break;
                                case u.STATUS_COMPLETED:
                            }
                        },
                c.inherits(s, d.EventEmitter),
                s.prototype.stateChanged = function(e) {
                    this.state = e,
                    this.emit("stateChanged")
                },
                s.prototype.send = function() {
                    var e = this;
                    this.stateChanged(u.STATUS_CALLING),
                    this.B = setTimeout(function() {
                        e.timer_B()
                    }, T.TIMER_B),
                    this.transport.send(this.request) || this.onTransportError()
                },
                s.prototype.onTransportError = function() {
                    clearTimeout(this.B),
                    clearTimeout(this.D),
                    clearTimeout(this.M),
                    this.state !== u.STATUS_ACCEPTED && (p("transport error occurred, deleting transaction " + this.id), this.request_sender.onTransportError()),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.request_sender.ua.destroyTransaction(this)
                },
                s.prototype.timer_M = function() {
                    p("Timer M expired for transaction " + this.id),
                    this.state === u.STATUS_ACCEPTED && (clearTimeout(this.B), this.stateChanged(u.STATUS_TERMINATED), this.request_sender.ua.destroyTransaction(this))
                },
                s.prototype.timer_B = function() {
                    p("Timer B expired for transaction " + this.id),
                    this.state === u.STATUS_CALLING && (this.stateChanged(u.STATUS_TERMINATED), this.request_sender.ua.destroyTransaction(this), this.request_sender.onRequestTimeout())
                },
                s.prototype.timer_D = function() {
                    p("Timer D expired for transaction " + this.id),
                    clearTimeout(this.B),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.request_sender.ua.destroyTransaction(this)
                },
                s.prototype.sendACK = function(e) {
                    var t = this;
                    this.ack = "ACK " + this.request.ruri + " SIP/2.0\r\n",
                    this.ack += "Via: " + this.request.headers.Via.toString() + "\r\n",
                    this.request.headers.Route && (this.ack += "Route: " + this.request.headers.Route.toString() + "\r\n"),
                    this.ack += "To: " + e.getHeader("to") + "\r\n",
                    this.ack += "From: " + this.request.headers.From.toString() + "\r\n",
                    this.ack += "Call-ID: " + this.request.headers["Call-ID"].toString() + "\r\n",
                    this.ack += "CSeq: " + this.request.headers.CSeq.toString().split(" ")[0],
                    this.ack += " ACK\r\n",
                    this.ack += "Content-Length: 0\r\n\r\n",
                    this.D = setTimeout(function() {
                        t.timer_D()
                    }, T.TIMER_D),
                    this.transport.send(this.ack)
                },
                s.prototype.cancel_request = function(e, t) {
                    var n = e.request;
                    this.cancel = v.CANCEL + " " + n.ruri + " SIP/2.0\r\n",
                    this.cancel += "Via: " + n.headers.Via.toString() + "\r\n",
                    this.request.headers.Route && (this.cancel += "Route: " + n.headers.Route.toString() + "\r\n"),
                    this.cancel += "To: " + n.headers.To.toString() + "\r\n",
                    this.cancel += "From: " + n.headers.From.toString() + "\r\n",
                    this.cancel += "Call-ID: " + n.headers["Call-ID"].toString() + "\r\n",
                    this.cancel += "CSeq: " + n.headers.CSeq.toString().split(" ")[0] + " CANCEL\r\n",
                    t && (this.cancel += "Reason: " + t + "\r\n"),
                    this.cancel += "Content-Length: 0\r\n\r\n",
                    this.state === u.STATUS_PROCEEDING && this.transport.send(this.cancel)
                },
                s.prototype.receiveResponse = function(e) {
                    var t = this,
                        n = e.status_code;
                    if (n >= 100 && n <= 199)
                        switch (this.state) {
                            case u.STATUS_CALLING:
                                this.stateChanged(u.STATUS_PROCEEDING),
                                this.request_sender.receiveResponse(e);
                                break;
                            case u.STATUS_PROCEEDING:
                                this.request_sender.receiveResponse(e)
                        }
                    else if (n >= 200 && n <= 299)
                        switch (this.state) {
                            case u.STATUS_CALLING:
                            case u.STATUS_PROCEEDING:
                                this.stateChanged(u.STATUS_ACCEPTED),
                                this.M = setTimeout(function() {
                                    t.timer_M()
                                }, T.TIMER_M),
                                this.request_sender.receiveResponse(e);
                                break;
                            case u.STATUS_ACCEPTED:
                                this.request_sender.receiveResponse(e)
                        }
                    else if (n >= 300 && n <= 699)
                        switch (this.state) {
                            case u.STATUS_CALLING:
                            case u.STATUS_PROCEEDING:
                                this.stateChanged(u.STATUS_COMPLETED),
                                this.sendACK(e),
                                this.request_sender.receiveResponse(e);
                                break;
                            case u.STATUS_COMPLETED:
                                this.sendACK(e)
                        }
                    },
                c.inherits(i, d.EventEmitter),
                i.prototype.send = function() {
                    this.transport.send(this.request) || this.onTransportError()
                },
                i.prototype.onTransportError = function() {
                    f("transport error occurred for transaction " + this.id),
                    this.request_sender.onTransportError()
                },
                c.inherits(l, d.EventEmitter),
                l.prototype.stateChanged = function(e) {
                    this.state = e,
                    this.emit("stateChanged")
                },
                l.prototype.timer_J = function() {
                    m("Timer J expired for transaction " + this.id),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.ua.destroyTransaction(this)
                },
                l.prototype.onTransportError = function() {
                    this.transportError || (this.transportError = !0, m("transport error occurred, deleting transaction " + this.id), clearTimeout(this.J), this.stateChanged(u.STATUS_TERMINATED), this.ua.destroyTransaction(this))
                },
                l.prototype.receiveResponse = function(e, t, n, r) {
                    var s = this;
                    if (100 === e)
                        switch (this.state) {
                            case u.STATUS_TRYING:
                                this.stateChanged(u.STATUS_PROCEEDING),
                                this.transport.send(t) || this.onTransportError();
                                break;
                            case u.STATUS_PROCEEDING:
                                this.last_response = t,
                                this.transport.send(t)
                                    ? n && n()
                                    : (this.onTransportError(), r && r())
                        }
                    else if (e >= 200 && e <= 699)
                        switch (this.state) {
                            case u.STATUS_TRYING:
                            case u.STATUS_PROCEEDING:
                                this.stateChanged(u.STATUS_COMPLETED),
                                this.last_response = t,
                                this.J = setTimeout(function() {
                                    s.timer_J()
                                }, T.TIMER_J),
                                this.transport.send(t)
                                    ? n && n()
                                    : (this.onTransportError(), r && r());
                                break;
                            case u.STATUS_COMPLETED:
                        }
                    },
                c.inherits(o, d.EventEmitter),
                o.prototype.stateChanged = function(e) {
                    this.state = e,
                    this.emit("stateChanged")
                },
                o.prototype.timer_H = function() {
                    g("Timer H expired for transaction " + this.id),
                    this.state === u.STATUS_COMPLETED && g("ACK not received, dialog will be terminated"),
                    this.stateChanged(u.STATUS_TERMINATED),
                    this.ua.destroyTransaction(this)
                },
                o.prototype.timer_I = function() {
                    this.stateChanged(u.STATUS_TERMINATED)
                },
                o.prototype.timer_L = function() {
                    g("Timer L expired for transaction " + this.id),
                    this.state === u.STATUS_ACCEPTED && (this.stateChanged(u.STATUS_TERMINATED), this.ua.destroyTransaction(this))
                },
                o.prototype.onTransportError = function() {
                    this.transportError || (this.transportError = !0, g("transport error occurred, deleting transaction " + this.id), null !== this.resendProvisionalTimer && (clearInterval(this.resendProvisionalTimer), this.resendProvisionalTimer = null), clearTimeout(this.L), clearTimeout(this.H), clearTimeout(this.I), this.stateChanged(u.STATUS_TERMINATED), this.ua.destroyTransaction(this))
                },
                o.prototype.resend_provisional = function() {
                    this.transport.send(this.last_response) || this.onTransportError()
                },
                o.prototype.receiveResponse = function(e, t, n, r) {
                    var s = this;
                    if (e >= 100 && e <= 199)
                        switch (this.state) {
                            case u.STATUS_PROCEEDING:
                                this.transport.send(t) || this.onTransportError(),
                                this.last_response = t
                        }
                    if (e > 100 && e <= 199 && this.state === u.STATUS_PROCEEDING)
                        null === this.resendProvisionalTimer && (this.resendProvisionalTimer = setInterval(function() {
                            s.resend_provisional()
                        }, T.PROVISIONAL_RESPONSE_INTERVAL));
                    else if (e >= 200 && e <= 299)
                        switch (this.state) {
                            case u.STATUS_PROCEEDING:
                                this.stateChanged(u.STATUS_ACCEPTED),
                                this.last_response = t,
                                this.L = setTimeout(function() {
                                    s.timer_L()
                                }, T.TIMER_L),
                                null !== this.resendProvisionalTimer && (clearInterval(this.resendProvisionalTimer), this.resendProvisionalTimer = null);
                            case u.STATUS_ACCEPTED:
                                this.transport.send(t)
                                    ? n && n()
                                    : (this.onTransportError(), r && r())
                        }
                    else if (e >= 300 && e <= 699)
                        switch (this.state) {
                            case u.STATUS_PROCEEDING:
                                null !== this.resendProvisionalTimer && (clearInterval(this.resendProvisionalTimer), this.resendProvisionalTimer = null),
                                this.transport.send(t)
                                    ? (this.stateChanged(u.STATUS_COMPLETED), this.H = setTimeout(function() {
                                        s.timer_H()
                                    }, T.TIMER_H), n && n())
                                    : (this.onTransportError(), r && r())
                        }
                    }
            }, {
                "./Constants": 1,
                "./Timers": 21,
                debug: 35,
                events: 29,
                util: 33
            }
        ],
        23: [
            function(e, t, n) {
                function r(e, t) {
                    if (c("new()"), this.status = h.STATUS_DISCONNECTED, this.socket = null, this.sockets = [], this.recovery_options = t || h.recovery_options, this.recover_attempts = 0, this.recovery_timer = null, this.close_requested = !1, "undefined" == typeof e)
                        throw new TypeError("Invalid argument. undefined 'sockets' argument");
                    e instanceof Array || (e = [e]),
                    e.forEach(function(e) {
                        if (!u.isSocket(e.socket))
                            throw new TypeError("Invalid argument. invalid 'JsSIP.Socket' instance");
                        if (e.weight && !Number(e.weight))
                            throw new TypeError("Invalid argument. 'weight' attribute is not a number");
                        this.sockets.push({
                            socket: e.socket,
                            weight: e.weight || 0,
                            status: h.SOCKET_STATUS_READY
                        })
                    }, this),
                    Object.defineProperties(this, {
                        via_transport: {
                            get: function() {
                                return this.socket.via_transport
                            }
                        },
                        url: {
                            get: function() {
                                return this.socket.url
                            }
                        },
                        sip_uri: {
                            get: function() {
                                return this.socket.sip_uri
                            }
                        }
                    }),
                    a.call(this)
                }
                function s() {
                    this.recover_attempts = 0,
                    this.status = h.STATUS_CONNECTED,
                    null !== this.recovery_timer && (clearTimeout(this.recovery_timer), this.recovery_timer = null),
                    this.onconnect({socket: this})
                }
                function i(e, t, n) {
                    this.status = h.STATUS_DISCONNECTED,
                    this.ondisconnect({socket: this.socket, error: e, code: t, reason: n}),
                    this.close_requested || (this.sockets.forEach(function(e) {
                        this.socket === e.socket && (e.status = h.SOCKET_STATUS_ERROR)
                    }, this), o.call(this, e))
                }
                function l(e) {
                    if ("\r\n" === e)
                        return void c("received message with CRLF Keep Alive response");
                    if ("string" != typeof e) {
                        try {
                            e = String.fromCharCode.apply(null, new Uint8Array(e))
                        } catch (e) {
                            return void c("received binary message failed to be converted into string, message discarded")
                        }
                        c("received binary message:\n\n" + e + "\n")
                    } else
                        c("received text message:\n\n" + e + "\n");
                    this.ondata({transport: this, message: e})
                }
                function o() {
                    var e,
                        t = this;
                    this.recover_attempts += 1,
                    e = Math.floor(Math.random() * Math.pow(2, this.recover_attempts) + 1),
                    e < this.recovery_options.min_interval
                        ? e = this.recovery_options.min_interval
                        : e > this.recovery_options.max_interval && (e = this.recovery_options.max_interval),
                    c("reconnection attempt: " + this.recover_attempts + ". next connection attempt in " + e + " seconds"),
                    this.recovery_timer = setTimeout(function() {
                        t.close_requested || t.isConnected() || t.isConnecting() || (a.call(t), t.connect())
                    }, 1e3 * e)
                }
                function a() {
                    var e = [];
                    if (this.sockets.forEach(function(t) {
                        t.status !== h.SOCKET_STATUS_ERROR && (0 === e.length
                            ? e.push(t)
                            : t.weight > e[0].weight
                                ? e = [t]
                                : t.weight === e[0].weight && e.push(t))
                    }), 0 === e.length)
                        return this.sockets.forEach(function(e) {
                            e.status = h.SOCKET_STATUS_READY
                        }),
                        void a.call(this);
                    var t = Math.floor(Math.random() * e.length);
                    this.socket = e[t].socket
                }
                t.exports = r;
                var u = e("./Socket"),
                    c = e("debug")("JsSIP:Transport"),
                    d = e("debug")("JsSIP:ERROR:Transport"),
                    h = {
                        STATUS_CONNECTED: 0,
                        STATUS_CONNECTING: 1,
                        STATUS_DISCONNECTED: 2,
                        SOCKET_STATUS_READY: 0,
                        SOCKET_STATUS_ERROR: 1,
                        recovery_options: {
                            min_interval: 2,
                            max_interval: 30
                        }
                    };
                r.prototype.connect = function() {
                    return c("connect()"),
                    this.isConnected()
                        ? void c("Transport is already connected")
                        : this.isConnecting()
                            ? void c("Transport is connecting")
                            : (this.close_requested = !1, this.status = h.STATUS_CONNECTING, this.onconnecting({socket: this.socket, attempts: this.recover_attempts}), void(this.close_requested || (this.socket.onconnect = s.bind(this), this.socket.ondisconnect = i.bind(this), this.socket.ondata = l.bind(this), this.socket.connect())))
                },
                r.prototype.disconnect = function() {
                    c("close()"),
                    this.close_requested = !0,
                    this.recover_attempts = 0,
                    this.status = h.STATUS_DISCONNECTED,
                    null !== this.recovery_timer && (clearTimeout(this.recovery_timer), this.recovery_timer = null),
                    this.socket.onconnect = function() {},
                    this.socket.ondisconnect = function() {},
                    this.socket.ondata = function() {},
                    this.socket.disconnect(),
                    this.ondisconnect()
                },
                r.prototype.send = function(e) {
                    if (c("send()"), !this.isConnected())
                        return d("unable to send message, transport is not connected"),
                        !1;
                    var t = e.toString();
                    return c("sending message:\n\n" + t + "\n"),
                    this.socket.send(t)
                },
                r.prototype.isConnected = function() {
                    return this.status === h.STATUS_CONNECTED
                },
                r.prototype.isConnecting = function() {
                    return this.status === h.STATUS_CONNECTING
                }
            }, {
                "./Socket": 20,
                debug: 35
            }
        ],
        24: [
            function(e, t, n) {
                function r(e) {
                    if (d("new() [configuration:%o]", e), this.cache = {
                        credentials: {}
                    }, this.configuration = {}, this.dynConfiguration = {}, this.dialogs = {}, this.applicants = {}, this.sessions = {}, this.transport = null, this.contact = null, this.status = a.STATUS_INIT, this.error = null, this.transactions = {
                        nist: {},
                        nict: {},
                        ist: {},
                        ict: {}
                    }, this.data = {}, this.closeTimer = null, Object.defineProperties(this, {
                        transactionsCount: {
                            get: function() {
                                var e,
                                    t = [
                                        "nist", "nict", "ist", "ict"
                                    ],
                                    n = 0;
                                for (e in t)
                                    n += Object.keys(this.transactions[t[e]]).length;
                                return n
                            }
                        },
                        nictTransactionsCount: {
                            get: function() {
                                return Object.keys(this.transactions.nict).length
                            }
                        },
                        nistTransactionsCount: {
                            get: function() {
                                return Object.keys(this.transactions.nist).length
                            }
                        },
                        ictTransactionsCount: {
                            get: function() {
                                return Object.keys(this.transactions.ict).length
                            }
                        },
                        istTransactionsCount: {
                            get: function() {
                                return Object.keys(this.transactions.ist).length
                            }
                        }
                    }), void 0 === e)
                        throw new TypeError("Not enough arguments");
                    try {
                        this.loadConfig(e)
                    } catch (e) {
                        throw this.status = a.STATUS_NOT_READY,
                        this.error = a.CONFIGURATION_ERROR,
                        e
                    }
                    this._registrator = new f(this),
                    c.EventEmitter.call(this)
                }
                function s(e) {
                    this.emit("connecting", e)
                }
                function i(e) {
                    this.status !== a.STATUS_USER_CLOSED && (this.status = a.STATUS_READY, this.error = null, this.emit("connected", e), this.dynConfiguration.register && this._registrator.register())
                }
                function l(e) {
                    var t,
                        n,
                        r,
                        s = ["nict", "ict", "nist", "ist"];
                    for (r = s.length, t = 0; t < r; t++)
                        for (n in this.transactions[s[t]])
                            this.transactions[s[t]][n].onTransportError();
                this.emit("disconnected", e),
                    this._registrator.onTransportClosed(),
                    this.status !== a.STATUS_USER_CLOSED && (this.status = a.STATUS_NOT_READY, this.error = a.NETWORK_ERROR)
                }
                function o(e) {
                    var t,
                        n = e.transport,
                        s = e.message;
                    if (s = A.parseMessage(s, this), s && !(this.status === r.C.STATUS_USER_CLOSED && s instanceof R.IncomingRequest) && w(s, this, n))
                        if (s instanceof R.IncomingRequest)
                            s.transport = n,
                            this.receiveRequest(s);
                        else if (s instanceof R.IncomingResponse)
                            switch (s.method) {
                                case p.INVITE:
                                    t = this.transactions.ict[s.via_branch],
                                    t && t.receiveResponse(s);
                                    break;
                                case p.ACK:
                                    break;
                                default:
                                    t = this.transactions.nict[s.via_branch],
                                    t && t.receiveResponse(s)
                            }
                        }
                t.exports = r;
                var a = {
                    STATUS_INIT: 0,
                    STATUS_READY: 1,
                    STATUS_USER_CLOSED: 2,
                    STATUS_NOT_READY: 3,
                    CONFIGURATION_ERROR: 1,
                    NETWORK_ERROR: 2
                };
                r.C = a;
                var u = e("util"),
                    c = e("events"),
                    d = e("debug")("JsSIP:UA"),
                    h = e("debug")("JsSIP:ERROR:UA");
                h.log = console.warn.bind(console);
                var p = e("./Constants"),
                    f = e("./Registrator"),
                    m = e("./RTCSession"),
                    g = e("./Message"),
                    v = e("./Transactions"),
                    T = e("./Transport"),
                    _ = e("./Socket"),
                    C = e("./Utils"),
                    S = e("./Exceptions"),
                    E = e("./URI"),
                    y = e("./Grammar"),
                    A = e("./Parser"),
                    R = e("./SIPMessage"),
                    w = e("./sanityCheck");
                u.inherits(r, c.EventEmitter),
                r.prototype.start = function() {
                    d("start()"),
                    this.status === a.STATUS_INIT
                        ? this.transport.connect()
                        : this.status === a.STATUS_USER_CLOSED
                            ? (d("restarting UA"), null !== this.closeTimer && (clearTimeout(this.closeTimer), this.closeTimer = null, this.transport.disconnect()), this.status = a.STATUS_INIT, this.transport.connect())
                            : d(this.status === a.STATUS_READY
                                ? "UA is in READY status, not restarted"
                                : "ERROR: connection is down, Auto-Recovery system is trying to reconnect"),
                    this.dynConfiguration.register = this.configuration.register
                },
                r.prototype.register = function() {
                    d("register()"),
                    this.dynConfiguration.register = !0,
                    this._registrator.register()
                },
                r.prototype.unregister = function(e) {
                    d("unregister()"),
                    this.dynConfiguration.register = !1,
                    this._registrator.unregister(e)
                },
                r.prototype.registrator = function() {
                    return this._registrator
                },
                r.prototype.isRegistered = function() {
                    return !!this._registrator.registered
                },
                r.prototype.isConnected = function() {
                    return this.transport.isConnected()
                },
                r.prototype.call = function(e, t) {
                    d("call()");
                    var n;
                    return n = new m(this),
                    n.connect(e, t),
                    n
                },
                r.prototype.sendMessage = function(e, t, n) {
                    d("sendMessage()");
                    var r;
                    return r = new g(this),
                    r.send(e, t, n),
                    r
                },
                r.prototype.terminateSessions = function(e) {
                    d("terminateSessions()");
                    for (var t in this.sessions)
                        this.sessions[t].isEnded() || this.sessions[t].terminate(e)
                },
                r.prototype.stop = function() {
                    d("stop()");
                    var e,
                        t,
                        n,
                        r = this;
                    if (this.dynConfiguration = {}, this.status === a.STATUS_USER_CLOSED)
                        return void d("UA already closed");
                    this._registrator.close(),
                    n = Object.keys(this.sessions).length;
                    for (e in this.sessions) {
                        d("closing session " + e);
                        try {
                            this.sessions[e].terminate()
                        } catch (e) {}
                    }
                    for (t in this.applicants)
                        try {
                            this.applicants[t].close()
                        } catch (e) {}
                    this.status = a.STATUS_USER_CLOSED,
                    0 === this.nistTransactionsCount && 0 === this.nictTransactionsCount && 0 === this.ictTransactionsCount && 0 === this.istTransactionsCount && 0 === n
                        ? r.transport.disconnect()
                        : this.closeTimer = setTimeout(function() {
                            r.closeTimer = null,
                            r.transport.disconnect()
                        }, 2e3)
                },
                r.prototype.normalizeTarget = function(e) {
                    return C.normalizeTarget(e, this.configuration.hostport_params)
                },
                r.prototype.get = function(e) {
                    switch (e) {
                        case "realm":
                            return this.configuration.realm;
                        case "ha1":
                            return this.configuration.ha1;
                        default:
                            return void h('get() | cannot get "%s" parameter in runtime', e)
                    }
                    return !0
                },
                r.prototype.set = function(e, t) {
                    switch (e) {
                        case "password":
                            this.configuration.password = String(t);
                            break;
                        case "realm":
                            this.configuration.realm = String(t);
                            break;
                        case "ha1":
                            this.configuration.ha1 = String(t),
                            this.configuration.password = null;
                            break;
                        case "display_name":
                            if (y.parse('"' + t + '"', "display_name") === -1)
                                return h('set() | wrong "display_name"'),
                                !1;
                            this.configuration.display_name = t;
                            break;
                        default:
                            return h('set() | cannot set "%s" parameter in runtime', e),
                            !1
                    }
                    return !0
                },
                r.prototype.newTransaction = function(e) {
                    this.transactions[e.type][e.id] = e,
                    this.emit("newTransaction", {transaction: e})
                },
                r.prototype.destroyTransaction = function(e) {
                    delete this.transactions[e.type][e.id],
                    this.emit("transactionDestroyed", {transaction: e})
                },
                r.prototype.newMessage = function(e) {
                    this.emit("newMessage", e)
                },
                r.prototype.newRTCSession = function(e) {
                    this.emit("newRTCSession", e)
                },
                r.prototype.registered = function(e) {
                    this.emit("registered", e)
                },
                r.prototype.unregistered = function(e) {
                    this.emit("unregistered", e)
                },
                r.prototype.registrationFailed = function(e) {
                    this.emit("registrationFailed", e)
                },
                r.prototype.receiveRequest = function(e) {
                    var t,
                        n,
                        r,
                        s,
                        i = e.method;
                    if (e.ruri.user !== this.configuration.uri.user && e.ruri.user !== this.contact.uri.user)
                        return d("Request-URI does not point to us"),
                        void(e.method !== p.ACK && e.reply_sl(404));
                    if (e.ruri.scheme === p.SIPS)
                        return void e.reply_sl(416);
                    if (!v.checkTransaction(this, e)) {
                        if (i === p.INVITE
                            ? new v.InviteServerTransaction(e, this)
                            : i !== p.ACK && i !== p.CANCEL && new v.NonInviteServerTransaction(e, this), i === p.OPTIONS)
                            e.reply(200);
                        else if (i === p.MESSAGE) {
                            if (0 === this.listeners("newMessage").length)
                                return void e.reply(405);
                            r = new g(this),
                            r.init_incoming(e)
                        } else if (i === p.INVITE && !e.to_tag && 0 === this.listeners("newRTCSession").length)
                            return void e.reply(405);
                        if (e.to_tag)
                            t = this.findDialog(e.call_id, e.from_tag, e.to_tag),
                            t
                                ? t.receiveRequest(e)
                                : i === p.NOTIFY
                                    ? (n = this.findSession(e), n
                                        ? n.receiveRequest(e)
                                        : (d("received NOTIFY request for a non existent subscription"), e.reply(481, "Subscription does not exist")))
                                    : i !== p.ACK && e.reply(481);
                        else
                            switch (i) {
                                case p.INVITE:
                                    window.RTCPeerConnection
                                        ? e.hasHeader("replaces")
                                            ? (s = e.replaces, t = this.findDialog(s.call_id, s.from_tag, s.to_tag), t
                                                ? (n = t.owner, n.isEnded()
                                                    ? e.reply(603)
                                                    : n.receiveRequest(e))
                                                : e.reply(481))
                                            : (n = new m(this), n.init_incoming(e))
                                        : (h("INVITE received but WebRTC is not supported"), e.reply(488));
                                    break;
                                case p.BYE:
                                    e.reply(481);
                                    break;
                                case p.CANCEL:
                                    n = this.findSession(e),
                                    n
                                        ? n.receiveRequest(e)
                                        : d("received CANCEL request for a non existent session");
                                    break;
                                case p.ACK:
                                    break;
                                default:
                                    e.reply(405)
                            }
                        }
                },
                r.prototype.findSession = function(e) {
                    var t = e.call_id + e.from_tag,
                        n = this.sessions[t],
                        r = e.call_id + e.to_tag,
                        s = this.sessions[r];
                    return n
                        ? n
                        : s
                            ? s
                            : null
                },
                r.prototype.findDialog = function(e, t, n) {
                    var r = e + t + n,
                        s = this.dialogs[r];
                    return s
                        ? s
                        : (r = e + n + t, s = this.dialogs[r], s
                            ? s
                            : null)
                },
                r.prototype.loadConfig = function(e) {
                    var t,
                        n,
                        a,
                        u,
                        c,
                        p = {
                            via_host: C.createRandomToken(12) + ".invalid",
                            contact_uri: null,
                            password: null,
                            realm: null,
                            ha1: null,
                            register_expires: 600,
                            register: !0,
                            registrar_server: null,
                            use_preloaded_route: !1,
                            no_answer_timeout: 60,
                            session_timers: !0
                        };
                    for (t in r.configuration_check.mandatory) {
                        if (!e.hasOwnProperty(t))
                            throw new S.ConfigurationError(t);
                        if (n = e[t], a = r.configuration_check.mandatory[t].call(this, n), void 0 === a)
                            throw new S.ConfigurationError(t, n);
                        p[t] = a
                    }
                    for (t in r.configuration_check.optional)
                        if (e.hasOwnProperty(t)) {
                            if (n = e[t], C.isEmpty(n))
                                continue;
                            if (a = r.configuration_check.optional[t].call(this, n, e), void 0 === a)
                                throw new S.ConfigurationError(t, n);
                            p[t] = a
                        }
                    0 === p.display_name && (p.display_name = "0"),
                    p.instance_id || (p.instance_id = C.newUUID()),
                    p.jssip_id = C.createRandomToken(5),
                    u = p.uri.clone(),
                    u.user = null,
                    p.hostport_params = u.toString().replace(/^sip:/i, "");
                    var f = [];
                    if (p.sockets && Array.isArray(p.sockets) && (f = f.concat(p.sockets)), 0 === f.length)
                        throw new S.ConfigurationError("sockets");
                    try {
                        this.transport = new T(f, {
                            max_interval: p.connection_recovery_max_interval,
                            min_interval: p.connection_recovery_min_interval
                        }),
                        this.transport.onconnecting = s.bind(this),
                        this.transport.onconnect = i.bind(this),
                        this.transport.ondisconnect = l.bind(this),
                        this.transport.ondata = o.bind(this),
                        delete p.connection_recovery_max_interval,
                        delete p.connection_recovery_min_interval,
                        delete p.sockets
                    } catch (e) {
                        throw h(e),
                        new S.ConfigurationError("sockets", f)
                    }
                    p.authorization_user || (p.authorization_user = p.uri.user),
                    p.registrar_server || (c = p.uri.clone(), c.user = null, c.clearParams(), c.clearHeaders(), p.registrar_server = c),
                    p.no_answer_timeout = 1e3 * p.no_answer_timeout,
                    p.contact_uri
                        ? p.via_host = p.contact_uri.host
                        : p.contact_uri = new E("sip", C.createRandomToken(8), p.via_host, null, {transport: "ws"}),
                    this.contact = {
                        pub_gruu: null,
                        temp_gruu: null,
                        uri: p.contact_uri,
                        toString: function(e) {
                            e = e || {};
                            var t = e.anonymous || null,
                                n = e.outbound || null,
                                r = "<";
                            return r += t
                                ? this.temp_gruu || "sip:anonymous@anonymous.invalid;transport=ws"
                                : this.pub_gruu || this.uri.toString(),
                            !n || (t
                                ? this.temp_gruu
                                : this.pub_gruu) || (r += ";ob"),
                            r += ">"
                        }
                    };
                    for (t in p)
                        r.configuration_skeleton[t].value = p[t];
                    Object.defineProperties(this.configuration, r.configuration_skeleton);
                    for (t in p)
                        r.configuration_skeleton[t].value = "";
                    d("configuration parameters after validation:");
                    for (t in p)
                        switch (t) {
                            case "uri":
                            case "registrar_server":
                                d("- " + t + ": " + p[t]);
                                break;
                            case "password":
                            case "ha1":
                                d("- " + t + ": NOT SHOWN");
                                break;
                            default:
                                d("- " + t + ": " + JSON.stringify(p[t]))
                        }
                    },
                r.configuration_skeleton = function() {
                    var e,
                        t,
                        n,
                        r = {},
                        s = [
                            "jssip_id",
                            "hostport_params",
                            "uri",
                            "authorization_user",
                            "contact_uri",
                            "display_name",
                            "instance_id",
                            "no_answer_timeout",
                            "session_timers",
                            "password",
                            "realm",
                            "ha1",
                            "register_expires",
                            "registrar_server",
                            "sockets",
                            "use_preloaded_route",
                            "via_core_value",
                            "via_host"
                        ],
                        i = ["password", "realm", "ha1", "display_name"];
                    for (e in s)
                        t = s[e],
                        n = i.indexOf(t) !== -1,
                        r[t] = {
                            value: "",
                            writable: n,
                            configurable: !1
                        };
                    return r.register = {
                        value: "",
                        writable: !0,
                        configurable: !1
                    },
                    r
                }(),
                r.configuration_check = {
                    mandatory: {
                        uri: function(e) {
                            var t;
                            return /^sip:/i.test(e) || (e = p.SIP + ":" + e),
                            t = E.parse(e),
                            t && t.user
                                ? t
                                : void 0
                        }
                    },
                    optional: {
                        authorization_user: function(e) {
                            return y.parse('"' + e + '"', "quoted_string") === -1
                                ? void 0
                                : e
                        },
                        connection_recovery_max_interval: function(e) {
                            var t;
                            if (C.isDecimal(e) && (t = Number(e), t > 0))
                                return t
                        },
                        connection_recovery_min_interval: function(e) {
                            var t;
                            if (C.isDecimal(e) && (t = Number(e), t > 0))
                                return t
                        },
                        contact_uri: function(e) {
                            if ("string" == typeof e) {
                                var t = y.parse(e, "SIP_URI");
                                if (t !== -1)
                                    return t
                            }
                        },
                        display_name: function(e) {
                            return y.parse('"' + e + '"', "display_name") === -1
                                ? void 0
                                : e
                        },
                        instance_id: function(e) {
                            return /^uuid:/i.test(e) && (e = e.substr(5)),
                            y.parse(e, "uuid") === -1
                                ? void 0
                                : e
                        },
                        no_answer_timeout: function(e) {
                            var t;
                            if (C.isDecimal(e) && (t = Number(e), t > 0))
                                return t
                        },
                        session_timers: function(e) {
                            if ("boolean" == typeof e)
                                return e
                        },
                        password: function(e) {
                            return String(e)
                        },
                        realm: function(e) {
                            return String(e)
                        },
                        ha1: function(e) {
                            return String(e)
                        },
                        register: function(e) {
                            if ("boolean" == typeof e)
                                return e
                        },
                        register_expires: function(e) {
                            var t;
                            if (C.isDecimal(e) && (t = Number(e), t > 0))
                                return t
                        },
                        registrar_server: function(e) {
                            var t;
                            return /^sip:/i.test(e) || (e = p.SIP + ":" + e),
                            t = E.parse(e),
                            t
                                ? t.user
                                    ? void 0
                                    : t
                                : void 0
                        },
                        sockets: function(e) {
                            var t,
                                n;
                            if (_.isSocket(e))
                                e = [
                                    {
                                        socket: e
                                    }
                                ];
                            else {
                                if (!Array.isArray(e) || !e.length)
                                    return;
                                for (n = e.length, t = 0; t < n; t++)
                                    _.isSocket(e[t]) && (e[t] = {
                                        socket: e[t]
                                    })
                            }
                            return e
                        },
                        use_preloaded_route: function(e) {
                            if ("boolean" == typeof e)
                                return e
                        }
                    }
                }
            }, {
                "./Constants": 1,
                "./Exceptions": 5,
                "./Grammar": 6,
                "./Message": 8,
                "./Parser": 10,
                "./RTCSession": 11,
                "./Registrator": 17,
                "./SIPMessage": 19,
                "./Socket": 20,
                "./Transactions": 22,
                "./Transport": 23,
                "./URI": 25,
                "./Utils": 26,
                "./sanityCheck": 28,
                debug: 35,
                events: 29,
                util: 33
            }
        ],
        25: [
            function(e, t, n) {
                function r(e, t, n, r, i, l) {
                    var o,
                        a;
                    if (!n)
                        throw new TypeError('missing or invalid "host" parameter');
                    e = e || s.SIP,
                    this.parameters = {},
                    this.headers = {};
                    for (o in i)
                        this.setParam(o, i[o]);
                    for (a in l)
                        this.setHeader(a, l[a]);
                    Object.defineProperties(this, {
                        scheme: {
                            get: function() {
                                return e
                            },
                            set: function(t) {
                                e = t.toLowerCase()
                            }
                        },
                        user: {
                            get: function() {
                                return t
                            },
                            set: function(e) {
                                t = e
                            }
                        },
                        host: {
                            get: function() {
                                return n
                            },
                            set: function(e) {
                                n = e.toLowerCase()
                            }
                        },
                        port: {
                            get: function() {
                                return r
                            },
                            set: function(e) {
                                r = 0 === e
                                    ? e
                                    : parseInt(e, 10) || null
                            }
                        }
                    })
                }
                t.exports = r;
                var s = e("./Constants"),
                    i = e("./Utils"),
                    l = e("./Grammar");
                r.prototype = {
                    setParam: function(e, t) {
                        e && (this.parameters[e.toLowerCase()] = "undefined" == typeof t || null === t
                            ? null
                            : t.toString())
                    },
                    getParam: function(e) {
                        if (e)
                            return this.parameters[e.toLowerCase()]
                    },
                    hasParam: function(e) {
                        if (e)
                            return this.parameters.hasOwnProperty(e.toLowerCase()) && !0 || !1
                    },
                    deleteParam: function(e) {
                        var t;
                        if (e = e.toLowerCase(), this.parameters.hasOwnProperty(e))
                            return t = this.parameters[e],
                            delete this.parameters[e],
                            t
                    },
                    clearParams: function() {
                        this.parameters = {}
                    },
                    setHeader: function(e, t) {
                        this.headers[i.headerize(e)] = Array.isArray(t)
                            ? t
                            : [t]
                    },
                    getHeader: function(e) {
                        if (e)
                            return this.headers[i.headerize(e)]
                    },
                    hasHeader: function(e) {
                        if (e)
                            return this.headers.hasOwnProperty(i.headerize(e)) && !0 || !1
                    },
                    deleteHeader: function(e) {
                        var t;
                        if (e = i.headerize(e), this.headers.hasOwnProperty(e))
                            return t = this.headers[e],
                            delete this.headers[e],
                            t
                    },
                    clearHeaders: function() {
                        this.headers = {}
                    },
                    clone: function() {
                        return new r(this.scheme, this.user, this.host, this.port, JSON.parse(JSON.stringify(this.parameters)), JSON.parse(JSON.stringify(this.headers)))
                    },
                    toString: function() {
                        var e,
                            t,
                            n,
                            r,
                            s = [];
                        r = this.scheme + ":",
                        this.user && (r += i.escapeUser(this.user) + "@"),
                        r += this.host,
                        (this.port || 0 === this.port) && (r += ":" + this.port);
                        for (t in this.parameters)
                            r += ";" + t,
                            null !== this.parameters[t] && (r += "=" + this.parameters[t]);
                        for (e in this.headers)
                            for (n = 0; n < this.headers[e].length; n++)
                                s.push(e + "=" + this.headers[e][n]);
                    return s.length > 0 && (r += "?" + s.join("&")),
                        r
                    },
                    toAor: function(e) {
                        var t;
                        return t = this.scheme + ":",
                        this.user && (t += i.escapeUser(this.user) + "@"),
                        t += this.host,
                        e && (this.port || 0 === this.port) && (t += ":" + this.port),
                        t
                    }
                },
                r.parse = function(e) {
                    return e = l.parse(e, "SIP_URI"),
                    e !== -1
                        ? e
                        : void 0
                }
            }, {
                "./Constants": 1,
                "./Grammar": 6,
                "./Utils": 26
            }
        ],
        26: [
            function(e, t, n) {
                var r = {};
                t.exports = r;
                var s = e("./Constants"),
                    i = e("./URI"),
                    l = e("./Grammar");
                r.str_utf8_length = function(e) {
                    return unescape(encodeURIComponent(e)).length
                },
                r.isFunction = function(e) {
                    return void 0 !== e && "[object Function]" === Object.prototype.toString.call(e)
                },
                r.isString = function(e) {
                    return void 0 !== e && "[object String]" === Object.prototype.toString.call(e)
                },
                r.isDecimal = function(e) {
                    return !isNaN(e) && parseFloat(e) === parseInt(e, 10)
                },
                r.isEmpty = function(e) {
                    if (null === e || "" === e || void 0 === e || Array.isArray(e) && 0 === e.length || "number" == typeof e && isNaN(e))
                        return !0
                },
                r.hasMethods = function(e) {
                    for (var t, n = 1; t = arguments[n++];)
                        if (this.isFunction(e[t]))
                            return !1;
                return !0
                },
                r.createRandomToken = function(e, t) {
                    var n,
                        r,
                        s = "";
                    for (t = t || 32, n = 0; n < e; n++)
                        r = Math.random() * t | 0,
                        s += r.toString(t);
                    return s
                },
                r.newTag = function() {
                    return r.createRandomToken(10)
                },
                r.newUUID = function() {
                    var e = "xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx".replace(/[xy]/g, function(e) {
                        var t = 16 * Math.random() | 0,
                            n = "x" === e
                                ? t
                                : 3 & t | 8;
                        return n.toString(16)
                    });
                    return e
                },
                r.hostType = function(e) {
                    if (e)
                        return e = l.parse(e, "host"),
                        e !== -1
                            ? e.host_type
                            : void 0
                    },
                r.normalizeTarget = function(e, t) {
                    var n,
                        l,
                        o,
                        a;
                    if (e) {
                        if (e instanceof i)
                            return e;
                        if ("string" == typeof e) {
                            switch (l = e.split("@"), l.length) {
                                case 1:
                                    if (!t)
                                        return;
                                    o = e,
                                    a = t;
                                    break;
                                case 2:
                                    o = l[0],
                                    a = l[1];
                                    break;
                                default:
                                    o = l.slice(0, l.length - 1).join("@"),
                                    a = l[l.length - 1]
                            }
                            return o = o.replace(/^(sips?|tel):/i, ""),
                            /^[\-\.\(\)]*\+?[0-9\-\.\(\)]+$/.test(o) && (o = o.replace(/[\-\.\(\)]/g, "")),
                            e = s.SIP + ":" + r.escapeUser(o) + "@" + a,
                            (n = i.parse(e))
                                ? n
                                : void 0
                        }
                    } else ;
                    }
                ,
                r.escapeUser = function(e) {
                    return encodeURIComponent(decodeURIComponent(e)).replace(/%3A/gi, ":").replace(/%2B/gi, "+").replace(/%3F/gi, "?").replace(/%2F/gi, "/")
                },
                r.headerize = function(e) {
                    var t,
                        n = {
                            "Call-Id": "Call-ID",
                            Cseq: "CSeq",
                            "Www-Authenticate": "WWW-Authenticate"
                        },
                        r = e.toLowerCase().replace(/_/g, "-").split("-"),
                        s = "",
                        i = r.length;
                    for (t = 0; t < i; t++)
                        0 !== t && (s += "-"),
                        s += r[t].charAt(0).toUpperCase() + r[t].substring(1);
                    return n[s] && (s = n[s]),
                    s
                },
                r.sipErrorCause = function(e) {
                    var t;
                    for (t in s.SIP_ERROR_CAUSES)
                        if (s.SIP_ERROR_CAUSES[t].indexOf(e) !== -1)
                            return s.causes[t];
                return s.causes.SIP_FAILURE_CODE
                },
                r.getRandomTestNetIP = function() {
                    function e(e, t) {
                        return Math.floor(Math.random() * (t - e + 1) + e)
                    }
                    return "192.0.2." + e(1, 254)
                },
                r.calculateMD5 = function(e) {
                    function t(e, t) {
                        return e << t | e >>> 32 - t
                    }
                    function n(e, t) {
                        var n,
                            r,
                            s,
                            i,
                            l;
                        return s = 2147483648 & e,
                        i = 2147483648 & t,
                        n = 1073741824 & e,
                        r = 1073741824 & t,
                        l = (1073741823 & e) + (1073741823 & t),
                        n & r
                            ? 2147483648 ^ l ^ s ^ i
                            : n | r
                                ? 1073741824 & l
                                    ? 3221225472 ^ l ^ s ^ i
                                    : 1073741824 ^ l ^ s ^ i
                                : l ^ s ^ i
                    }
                    function r(e, t, n) {
                        return e & t |~ e & n
                    }
                    function s(e, t, n) {
                        return e & n | t &~ n
                    }
                    function i(e, t, n) {
                        return e ^ t ^ n
                    }
                    function l(e, t, n) {
                        return t ^ (e |~ n)
                    }
                    function o(e, s, i, l, o, a, u) {
                        return e = n(e, n(n(r(s, i, l), o), u)),
                        n(t(e, a), s)
                    }
                    function a(e, r, i, l, o, a, u) {
                        return e = n(e, n(n(s(r, i, l), o), u)),
                        n(t(e, a), r)
                    }
                    function u(e, r, s, l, o, a, u) {
                        return e = n(e, n(n(i(r, s, l), o), u)),
                        n(t(e, a), r)
                    }
                    function c(e, r, s, i, o, a, u) {
                        return e = n(e, n(n(l(r, s, i), o), u)),
                        n(t(e, a), r)
                    }
                    function d(e) {
                        for (var t, n = e.length, r = n + 8, s = (r - r % 64) / 64, i = 16 * (s + 1), l = new Array(i - 1), o = 0, a = 0; a < n;)
                            t = (a - a % 4) / 4,
                            o = a % 4 * 8,
                            l[t] = l[t] | e.charCodeAt(a) << o,
                            a++;
                        return t = (a - a % 4) / 4,
                        o = a % 4 * 8,
                        l[t] = l[t] | 128 << o,
                        l[i - 2] = n << 3,
                        l[i - 1] = n >>> 29,
                        l
                    }
                    function h(e) {
                        var t,
                            n,
                            r = "",
                            s = "";
                        for (n = 0; n <= 3; n++)
                            t = e >>> 8 * n & 255,
                            s = "0" + t.toString(16),
                            r += s.substr(s.length - 2, 2);
                        return r
                    }
                    function p(e) {
                        e = e.replace(/\r\n/g, "\n");
                        for (var t = "", n = 0; n < e.length; n++) {
                            var r = e.charCodeAt(n);
                            r < 128
                                ? t += String.fromCharCode(r)
                                : r > 127 && r < 2048
                                    ? (t += String.fromCharCode(r >> 6 | 192), t += String.fromCharCode(63 & r | 128))
                                    : (t += String.fromCharCode(r >> 12 | 224), t += String.fromCharCode(r >> 6 & 63 | 128), t += String.fromCharCode(63 & r | 128))
                        }
                        return t
                    }
                    var f,
                        m,
                        g,
                        v,
                        T,
                        _,
                        C,
                        S,
                        E,
                        y = [],
                        A = 7,
                        R = 12,
                        w = 17,
                        b = 22,
                        I = 5,
                        N = 9,
                        O = 14,
                        x = 20,
                        D = 4,
                        P = 11,
                        U = 16,
                        M = 23,
                        k = 6,
                        L = 10,
                        q = 15,
                        H = 21;
                    for (e = p(e), y = d(e), _ = 1732584193, C = 4023233417, S = 2562383102, E = 271733878, f = 0; f < y.length; f += 16)
                        m = _,
                        g = C,
                        v = S,
                        T = E,
                        _ = o(_, C, S, E, y[f + 0], A, 3614090360),
                        E = o(E, _, C, S, y[f + 1], R, 3905402710),
                        S = o(S, E, _, C, y[f + 2], w, 606105819),
                        C = o(C, S, E, _, y[f + 3], b, 3250441966),
                        _ = o(_, C, S, E, y[f + 4], A, 4118548399),
                        E = o(E, _, C, S, y[f + 5], R, 1200080426),
                        S = o(S, E, _, C, y[f + 6], w, 2821735955),
                        C = o(C, S, E, _, y[f + 7], b, 4249261313),
                        _ = o(_, C, S, E, y[f + 8], A, 1770035416),
                        E = o(E, _, C, S, y[f + 9], R, 2336552879),
                        S = o(S, E, _, C, y[f + 10], w, 4294925233),
                        C = o(C, S, E, _, y[f + 11], b, 2304563134),
                        _ = o(_, C, S, E, y[f + 12], A, 1804603682),
                        E = o(E, _, C, S, y[f + 13], R, 4254626195),
                        S = o(S, E, _, C, y[f + 14], w, 2792965006),
                        C = o(C, S, E, _, y[f + 15], b, 1236535329),
                        _ = a(_, C, S, E, y[f + 1], I, 4129170786),
                        E = a(E, _, C, S, y[f + 6], N, 3225465664),
                        S = a(S, E, _, C, y[f + 11], O, 643717713),
                        C = a(C, S, E, _, y[f + 0], x, 3921069994),
                        _ = a(_, C, S, E, y[f + 5], I, 3593408605),
                        E = a(E, _, C, S, y[f + 10], N, 38016083),
                        S = a(S, E, _, C, y[f + 15], O, 3634488961),
                        C = a(C, S, E, _, y[f + 4], x, 3889429448),
                        _ = a(_, C, S, E, y[f + 9], I, 568446438),
                        E = a(E, _, C, S, y[f + 14], N, 3275163606),
                        S = a(S, E, _, C, y[f + 3], O, 4107603335),
                        C = a(C, S, E, _, y[f + 8], x, 1163531501),
                        _ = a(_, C, S, E, y[f + 13], I, 2850285829),
                        E = a(E, _, C, S, y[f + 2], N, 4243563512),
                        S = a(S, E, _, C, y[f + 7], O, 1735328473),
                        C = a(C, S, E, _, y[f + 12], x, 2368359562),
                        _ = u(_, C, S, E, y[f + 5], D, 4294588738),
                        E = u(E, _, C, S, y[f + 8], P, 2272392833),
                        S = u(S, E, _, C, y[f + 11], U, 1839030562),
                        C = u(C, S, E, _, y[f + 14], M, 4259657740),
                        _ = u(_, C, S, E, y[f + 1], D, 2763975236),
                        E = u(E, _, C, S, y[f + 4], P, 1272893353),
                        S = u(S, E, _, C, y[f + 7], U, 4139469664),
                        C = u(C, S, E, _, y[f + 10], M, 3200236656),
                        _ = u(_, C, S, E, y[f + 13], D, 681279174),
                        E = u(E, _, C, S, y[f + 0], P, 3936430074),
                        S = u(S, E, _, C, y[f + 3], U, 3572445317),
                        C = u(C, S, E, _, y[f + 6], M, 76029189),
                        _ = u(_, C, S, E, y[f + 9], D, 3654602809),
                        E = u(E, _, C, S, y[f + 12], P, 3873151461),
                        S = u(S, E, _, C, y[f + 15], U, 530742520),
                        C = u(C, S, E, _, y[f + 2], M, 3299628645),
                        _ = c(_, C, S, E, y[f + 0], k, 4096336452),
                        E = c(E, _, C, S, y[f + 7], L, 1126891415),
                        S = c(S, E, _, C, y[f + 14], q, 2878612391),
                        C = c(C, S, E, _, y[f + 5], H, 4237533241),
                        _ = c(_, C, S, E, y[f + 12], k, 1700485571),
                        E = c(E, _, C, S, y[f + 3], L, 2399980690),
                        S = c(S, E, _, C, y[f + 10], q, 4293915773),
                        C = c(C, S, E, _, y[f + 1], H, 2240044497),
                        _ = c(_, C, S, E, y[f + 8], k, 1873313359),
                        E = c(E, _, C, S, y[f + 15], L, 4264355552),
                        S = c(S, E, _, C, y[f + 6], q, 2734768916),
                        C = c(C, S, E, _, y[f + 13], H, 1309151649),
                        _ = c(_, C, S, E, y[f + 4], k, 4149444226),
                        E = c(E, _, C, S, y[f + 11], L, 3174756917),
                        S = c(S, E, _, C, y[f + 2], q, 718787259),
                        C = c(C, S, E, _, y[f + 9], H, 3951481745),
                        _ = n(_, m),
                        C = n(C, g),
                        S = n(S, v),
                        E = n(E, T);
                    var F = h(_) + h(C) + h(S) + h(E);
                    return F.toLowerCase()
                },
                r.closeMediaStream = function(e) {
                    if (e)
                        try {
                            var t,
                                n,
                                r;
                            if (e.getTracks)
                                for (t = e.getTracks(), n = 0, r = t.length; n < r; n += 1)
                                    t[n].stop();
                                else {
                                    for (t = e.getAudioTracks(), n = 0, r = t.length; n < r; n += 1)
                                        t[n].stop();
                            for (t = e.getVideoTracks(), n = 0, r = t.length; n < r; n += 1)
                                    t[n].stop()
                            }
                        } catch (t) {
                            "function" != typeof e.stop && "object" != typeof e.stop || e.stop()
                        }
                    }
            }, {
                "./Constants": 1,
                "./Grammar": 6,
                "./URI": 25
            }
        ],
        27: [
            function(e, t, n) {
                function r(e) {
                    u('new() [url:"%s"]', e);
                    var t = null,
                        n = null;
                    this.ws = null,
                    Object.defineProperties(this, {
                        via_transport: {
                            get: function() {
                                return n
                            },
                            set: function(e) {
                                n = e.toUpperCase()
                            }
                        },
                        sip_uri: {
                            get: function() {
                                return t
                            }
                        },
                        url: {
                            get: function() {
                                return e
                            }
                        }
                    });
                    var r = a.parse(e, "absoluteURI");
                    if (r === -1)
                        throw c("invalid WebSocket URI: " + e),
                        new TypeError("Invalid argument: " + e);
                    if ("wss" !== r.scheme && "ws" !== r.scheme)
                        throw c("invalid WebSocket URI scheme: " + r.scheme),
                        new TypeError("Invalid argument: " + e);
                    t = "sip:" + r.host + (r.port
                        ? ":" + r.port
                        : "") + ";transport=ws",
                    this.via_transport = r.scheme
                }
                function s() {
                    u("WebSocket " + this.url + " connected"),
                    this.onconnect()
                }
                function i(e) {
                    u("WebSocket " + this.url + " closed"),
                    e.wasClean === !1 && u("WebSocket abrupt disconnection");
                    var t = {
                        socket: this,
                        error: !e.wasClean,
                        code: e.code,
                        reason: e.reason
                    };
                    this.ondisconnect(t)
                }
                function l(e) {
                    u("received WebSocket message"),
                    this.ondata(e.data)
                }
                function o(e) {
                    c("WebSocket " + this.url + " error: " + e)
                }
                t.exports = r;
                var a = e("./Grammar"),
                    u = e("debug")("JsSIP:WebSocketInterface"),
                    c = e("debug")("JsSIP:ERROR:WebSocketInterface");
                c.log = console.warn.bind(console),
                r.prototype.connect = function() {
                    if (u("connect()"), this.isConnected())
                        return void u("WebSocket " + this.url + " is already connected");
                    if (this.isConnecting())
                        return void u("WebSocket " + this.url + " is connecting");
                    this.ws && this.disconnect(),
                    u("connecting to WebSocket " + this.url);
                    try {
                        this.ws = new WebSocket(this.url, "sip"),
                        this.ws.binaryType = "arraybuffer",
                        this.ws.onopen = s.bind(this),
                        this.ws.onclose = i.bind(this),
                        this.ws.onmessage = l.bind(this),
                        this.ws.onerror = o.bind(this)
                    } catch (e) {
                        o.call(this, e)
                    }
                },
                r.prototype.disconnect = function() {
                    u("disconnect()"),
                    this.ws && (this.ws.onopen = function() {},
                    this.ws.onclose = function() {},
                    this.ws.onmessage = function() {},
                    this.ws.onerror = function() {},
                    this.ws.close(),
                    this.ws = null)
                },
                r.prototype.send = function(e) {
                    return u("send()"),
                    this.isConnected()
                        ? (this.ws.send(e), !0)
                        : (c("unable to send message, WebSocket is not open"), !1)
                },
                r.prototype.isConnected = function() {
                    return this.ws && this.ws.readyState === this.ws.OPEN
                },
                r.prototype.isConnecting = function() {
                    return this.ws && this.ws.readyState === this.ws.CONNECTING
                }
            }, {
                "./Grammar": 6,
                debug: 35
            }
        ],
        28: [
            function(e, t, n) {
                function r(e, t, n) {
                    var r,
                        s;
                    for (h = e, p = t, f = n, r = S.length; r--;)
                        if (s = S[r](h), s === !1)
                            return !1;
                if (h instanceof v.IncomingRequest) {
                        for (r = _.length; r--;)
                            if (s = _[r](h), s === !1)
                                return !1
                        }
                    else if (h instanceof v.IncomingResponse)
                        for (r = C.length; r--;)
                            if (s = C[r](h), s === !1)
                                return !1;
                return !0
                }
                function s() {
                    if ("sip" !== h.s("to").uri.scheme)
                        return d(416),
                        !1
                }
                function i() {
                    if (!h.to_tag && h.call_id.substr(0, 5) === p.configuration.jssip_id)
                        return d(482),
                        !1
                }
                function l() {
                    var e = T.str_utf8_length(h.body),
                        t = h.getHeader("content-length");
                    if (e < t)
                        return d(400),
                        !1
                }
                function o() {
                    var e,
                        t,
                        n = h.from_tag,
                        r = h.call_id,
                        s = h.cseq;
                    if (!h.to_tag)
                        if (h.method === g.INVITE) {
                            if (p.transactions.ist[h.via_branch])
                                return !1;
                            for (t in p.transactions.ist)
                                if (e = p.transactions.ist[t], e.request.from_tag === n && e.request.call_id === r && e.request.cseq === s)
                                    return d(482),
                                    !1
                            }
                        else {
                            if (p.transactions.nist[h.via_branch])
                                return !1;
                            for (t in p.transactions.nist)
                                if (e = p.transactions.nist[t], e.request.from_tag === n && e.request.call_id === r && e.request.cseq === s)
                                    return d(482),
                                    !1
                        }
                    }
                function a() {
                    if (h.getHeaders("via").length > 1)
                        return m("more than one Via header field present in the response, dropping the response"),
                        !1
                }
                function u() {
                    var e = T.str_utf8_length(h.body),
                        t = h.getHeader("content-length");
                    if (e < t)
                        return m("message body length is lower than the value in Content-Length header field, dropping the response"),
                        !1
                }
                function c() {
                    for (var e = [
                        "from", "to", "call_id", "cseq", "via"
                    ], t = e.length; t--;)
                        if (!h.hasHeader(e[t]))
                            return m("missing mandatory header field : " + e[t] + ", dropping the response"),
                            !1
                }
                function d(e) {
                    var t,
                        n = "SIP/2.0 " + e + " " + g.REASON_PHRASE[e] + "\r\n",
                        r = h.getHeaders("via"),
                        s = r.length,
                        i = 0;
                    for (i; i < s; i++)
                        n += "Via: " + r[i] + "\r\n";
                    t = h.getHeader("To"),
                    h.to_tag || (t += ";tag=" + T.newTag()),
                    n += "To: " + t + "\r\n",
                    n += "From: " + h.getHeader("From") + "\r\n",
                    n += "Call-ID: " + h.call_id + "\r\n",
                    n += "CSeq: " + h.cseq + " " + h.method + "\r\n",
                    n += "\r\n",
                    f.send(n)
                }
                t.exports = r;
                var h,
                    p,
                    f,
                    m = e("debug")("JsSIP:sanityCheck"),
                    g = e("./Constants"),
                    v = e("./SIPMessage"),
                    T = e("./Utils"),
                    _ = [],
                    C = [],
                    S = [];
                _.push(s),
                _.push(i),
                _.push(l),
                _.push(o),
                C.push(a),
                C.push(u),
                S.push(c)
            }, {
                "./Constants": 1,
                "./SIPMessage": 19,
                "./Utils": 26,
                debug: 35
            }
        ],
        29: [
            function(e, t, n) {
                function r() {
                    this._events = this._events || {},
                    this._maxListeners = this._maxListeners || void 0
                }
                function s(e) {
                    return "function" == typeof e
                }
                function i(e) {
                    return "number" == typeof e
                }
                function l(e) {
                    return "object" == typeof e && null !== e
                }
                function o(e) {
                    return void 0 === e
                }
                t.exports = r,
                r.EventEmitter = r,
                r.prototype._events = void 0,
                r.prototype._maxListeners = void 0,
                r.defaultMaxListeners = 10,
                r.prototype.setMaxListeners = function(e) {
                    if (!i(e) || e < 0 || isNaN(e))
                        throw TypeError("n must be a positive number");
                    return this._maxListeners = e,
                    this
                },
                r.prototype.emit = function(e) {
                    var t,
                        n,
                        r,
                        i,
                        a,
                        u;
                    if (this._events || (this._events = {}), "error" === e && (!this._events.error || l(this._events.error) && !this._events.error.length)) {
                        if (t = arguments[1], t instanceof Error)
                            throw t;
                        var c = new Error('Uncaught, unspecified "error" event. (' + t + ")");
                        throw c.context = t,
                        c
                    }
                    if (n = this._events[e], o(n))
                        return !1;
                    if (s(n))
                        switch (arguments.length) {
                            case 1:
                                n.call(this);
                                break;
                            case 2:
                                n.call(this, arguments[1]);
                                break;
                            case 3:
                                n.call(this, arguments[1], arguments[2]);
                                break;
                            default:
                                i = Array.prototype.slice.call(arguments, 1),
                                n.apply(this, i)
                        }
                    else if (l(n))
                        for (i = Array.prototype.slice.call(arguments, 1), u = n.slice(), r = u.length, a = 0; a < r; a++)
                            u[a].apply(this, i);
                return !0
                },
                r.prototype.addListener = function(e, t) {
                    var n;
                    if (!s(t))
                        throw TypeError("listener must be a function");
                    return this._events || (this._events = {}),
                    this._events.newListener && this.emit("newListener", e, s(t.listener)
                        ? t.listener
                        : t),
                    this._events[e]
                        ? l(this._events[e])
                            ? this._events[e].push(t)
                            : this._events[e] = [this._events[e], t]
                        : this._events[e] = t,
                    l(this._events[e]) && !this._events[e].warned && (n = o(this._maxListeners)
                        ? r.defaultMaxListeners
                        : this._maxListeners, n && n > 0 && this._events[e].length > n && (this._events[e].warned = !0, console.error("(node) warning: possible EventEmitter memory leak detected. %d listeners added. Use emitter.setMaxListeners() to increase limit.", this._events[e].length), "function" == typeof console.trace && console.trace())),
                    this
                },
                r.prototype.on = r.prototype.addListener,
                r.prototype.once = function(e, t) {
                    function n() {
                        this.removeListener(e, n),
                        r || (r = !0, t.apply(this, arguments))
                    }
                    if (!s(t))
                        throw TypeError("listener must be a function");
                    var r = !1;
                    return n.listener = t,
                    this.on(e, n),
                    this
                },
                r.prototype.removeListener = function(e, t) {
                    var n,
                        r,
                        i,
                        o;
                    if (!s(t))
                        throw TypeError("listener must be a function");
                    if (!this._events || !this._events[e])
                        return this;
                    if (n = this._events[e], i = n.length, r = -1, n === t || s(n.listener) && n.listener === t)
                        delete this._events[e],
                        this._events.removeListener && this.emit("removeListener", e, t);
                    else if (l(n)) {
                        for (o = i; o-- > 0;)
                            if (n[o] === t || n[o].listener && n[o].listener === t) {
                                r = o;
                                break
                            }
                        if (r < 0)
                            return this;

                        1 === n.length
                            ? (n.length = 0, delete this._events[e])
                            : n.splice(r, 1),
                        this._events.removeListener && this.emit("removeListener", e, t)
                    }
                    return this
                },
                r.prototype.removeAllListeners = function(e) {
                    var t,
                        n;
                    if (!this._events)
                        return this;
                    if (!this._events.removeListener)
                        return 0 === arguments.length
                            ? this._events = {}
                    : this._events[e] && delete this._events[e],
                    this;
                    if (0 === arguments.length) {
                        for (t in this._events)
                            "removeListener" !== t && this.removeAllListeners(t);
                        return this.removeAllListeners("removeListener"),
                        this._events = {},
                        this
                    }
                    if (n = this._events[e], s(n))
                        this.removeListener(e, n);
                    else if (n)
                        for (; n.length;)
                            this.removeListener(e, n[n.length - 1]);
                return delete this._events[e],
                    this
                },
                r.prototype.listeners = function(e) {
                    var t;
                    return t = this._events && this._events[e]
                        ? s(this._events[e])
                            ? [this._events[e]]
                            : this._events[e].slice()
                        : []
                },
                r.prototype.listenerCount = function(e) {
                    if (this._events) {
                        var t = this._events[e];
                        if (s(t))
                            return 1;
                        if (t)
                            return t.length
                    }
                    return 0
                },
                r.listenerCount = function(e, t) {
                    return e.listenerCount(t)
                }
            }, {}
        ],
        30: [
            function(e, t, n) {
                function r() {
                    throw new Error("setTimeout has not been defined")
                }
                function s() {
                    throw new Error("clearTimeout has not been defined")
                }
                function i(e) {
                    if (d === setTimeout)
                        return setTimeout(e, 0);
                    if ((d === r || !d) && setTimeout)
                        return d = setTimeout,
                        setTimeout(e, 0);
                    try {
                        return d(e, 0)
                    } catch (t) {
                        try {
                            return d.call(null, e, 0)
                        } catch (t) {
                            return d.call(this, e, 0)
                        }
                    }
                }
                function l(e) {
                    if (h === clearTimeout)
                        return clearTimeout(e);
                    if ((h === s || !h) && clearTimeout)
                        return h = clearTimeout,
                        clearTimeout(e);
                    try {
                        return h(e)
                    } catch (t) {
                        try {
                            return h.call(null, e)
                        } catch (t) {
                            return h.call(this, e)
                        }
                    }
                }
                function o() {
                    g && f && (g = !1, f.length
                        ? m = f.concat(m)
                        : v = -1, m.length && a())
                }
                function a() {
                    if (!g) {
                        var e = i(o);
                        g = !0;
                        for (var t = m.length; t;) {
                            for (f = m, m = []; ++v < t;)
                                f && f[v].run();
                            v = -1,
                            t = m.length
                        }
                        f = null,
                        g = !1,
                        l(e)
                    }
                }
                function u(e, t) {
                    this.fun = e,
                    this.array = t
                }
                function c() {}
                var d,
                    h,
                    p = t.exports = {};
                !function() {
                    try {
                        d = "function" == typeof setTimeout
                            ? setTimeout
                            : r
                    } catch (e) {
                        d = r
                    }
                    try {
                        h = "function" == typeof clearTimeout
                            ? clearTimeout
                            : s
                    } catch (e) {
                        h = s
                    }
                }();
                var f,
                    m = [],
                    g = !1,
                    v = -1;
                p.nextTick = function(e) {
                    var t = new Array(arguments.length - 1);
                    if (arguments.length > 1)
                        for (var n = 1; n < arguments.length; n++)
                            t[n - 1] = arguments[n];
                m.push(new u(e, t)),
                    1 !== m.length || g || i(a)
                },
                u.prototype.run = function() {
                    this.fun.apply(null, this.array)
                },
                p.title = "browser",
                p.browser = !0,
                p.env = {},
                p.argv = [],
                p.version = "",
                p.versions = {},
                p.on = c,
                p.addListener = c,
                p.once = c,
                p.off = c,
                p.removeListener = c,
                p.removeAllListeners = c,
                p.emit = c,
                p.binding = function(e) {
                    throw new Error("process.binding is not supported")
                },
                p.cwd = function() {
                    return "/"
                },
                p.chdir = function(e) {
                    throw new Error("process.chdir is not supported")
                },
                p.umask = function() {
                    return 0
                }
            }, {}
        ],
        31: [
            function(e, t, n) {
                "function" == typeof Object.create
                    ? t.exports = function(e, t) {
                        e.super_ = t,
                        e.prototype = Object.create(t.prototype, {
                            constructor: {
                                value: e,
                                enumerable: !1,
                                writable: !0,
                                configurable: !0
                            }
                        })
                    }
                    : t.exports = function(e, t) {
                        e.super_ = t;
                        var n = function() {};
                        n.prototype = t.prototype,
                        e.prototype = new n,
                        e.prototype.constructor = e
                    }
            }, {}
        ],
        32: [
            function(e, t, n) {
                t.exports = function(e) {
                    return e && "object" == typeof e && "function" == typeof e.copy && "function" == typeof e.fill && "function" == typeof e.readUInt8
                }
            }, {}
        ],
        33: [
            function(e, t, n) {
                (function(t, r) {
                    function s(e, t) {
                        var r = {
                            seen: [],
                            stylize: l
                        };
                        return arguments.length >= 3 && (r.depth = arguments[2]),
                        arguments.length >= 4 && (r.colors = arguments[3]),
                        m(t)
                            ? r.showHidden = t
                            : t && n._extend(r, t),
                        S(r.showHidden) && (r.showHidden = !1),
                        S(r.depth) && (r.depth = 2),
                        S(r.colors) && (r.colors = !1),
                        S(r.customInspect) && (r.customInspect = !0),
                        r.colors && (r.stylize = i),
                        a(r, e, r.depth)
                    }
                    function i(e, t) {
                        var n = s.styles[t];
                        return n
                            ? "[" + s.colors[n][0] + "m" + e + "[" + s.colors[n][1] + "m"
                            : e
                    }
                    function l(e, t) {
                        return e
                    }
                    function o(e) {
                        var t = {};
                        return e.forEach(function(e, n) {
                            t[e] = !0
                        }),
                        t
                    }
                    function a(e, t, r) {
                        if (e.customInspect && t && w(t.inspect) && t.inspect !== n.inspect && (!t.constructor || t.constructor.prototype !== t)) {
                            var s = t.inspect(r, e);
                            return _(s) || (s = a(e, s, r)),
                            s
                        }
                        var i = u(e, t);
                        if (i)
                            return i;
                        var l = Object.keys(t),
                            m = o(l);
                        if (e.showHidden && (l = Object.getOwnPropertyNames(t)), R(t) && (l.indexOf("message") >= 0 || l.indexOf("description") >= 0))
                            return c(t);
                        if (0 === l.length) {
                            if (w(t)) {
                                var g = t.name
                                    ? ": " + t.name
                                    : "";
                                return e.stylize("[Function" + g + "]", "special")
                            }
                            if (E(t))
                                return e.stylize(RegExp.prototype.toString.call(t), "regexp");
                            if (A(t))
                                return e.stylize(Date.prototype.toString.call(t), "date");
                            if (R(t))
                                return c(t)
                        }
                        var v = "",
                            T = !1,
                            C = ["{", "}"];
                        if (f(t) && (T = !0, C = ["[", "]"]), w(t)) {
                            var S = t.name
                                ? ": " + t.name
                                : "";
                            v = " [Function" + S + "]"
                        }
                        if (E(t) && (v = " " + RegExp.prototype.toString.call(t)), A(t) && (v = " " + Date.prototype.toUTCString.call(t)), R(t) && (v = " " + c(t)), 0 === l.length && (!T || 0 == t.length))
                            return C[0] + v + C[1];
                        if (r < 0)
                            return E(t)
                                ? e.stylize(RegExp.prototype.toString.call(t), "regexp")
                                : e.stylize("[Object]", "special");
                        e.seen.push(t);
                        var y;
                        return y = T
                            ? d(e, t, r, m, l)
                            : l.map(function(n) {
                                return h(e, t, r, m, n, T)
                            }),
                        e.seen.pop(),
                        p(y, v, C)
                    }
                    function u(e, t) {
                        if (S(t))
                            return e.stylize("undefined", "undefined");
                        if (_(t)) {
                            var n = "'" + JSON.stringify(t).replace(/^"|"$/g, "").replace(/'/g, "\\'").replace(/\\"/g, '"') + "'";
                            return e.stylize(n, "string")
                        }
                        return T(t)
                            ? e.stylize("" + t, "number")
                            : m(t)
                                ? e.stylize("" + t, "boolean")
                                : g(t)
                                    ? e.stylize("null", "null")
                                    : void 0
                    }
                    function c(e) {
                        return "[" + Error.prototype.toString.call(e) + "]"
                    }
                    function d(e, t, n, r, s) {
                        for (var i = [], l = 0, o = t.length; l < o; ++l)
                            x(t, String(l))
                                ? i.push(h(e, t, n, r, String(l), !0))
                                : i.push("");
                        return s.forEach(function(s) {
                            s.match(/^\d+$/) || i.push(h(e, t, n, r, s, !0))
                        }),
                        i
                    }
                    function h(e, t, n, r, s, i) {
                        var l,
                            o,
                            u;
                        if (u = Object.getOwnPropertyDescriptor(t, s) || {
                            value: t[s]
                        }, u.get
                            ? o = u.set
                                ? e.stylize("[Getter/Setter]", "special")
                                : e.stylize("[Getter]", "special")
                            : u.set && (o = e.stylize("[Setter]", "special")), x(r, s) || (l = "[" + s + "]"), o || (e.seen.indexOf(u.value) < 0
                            ? (o = g(n)
                                ? a(e, u.value, null)
                                : a(e, u.value, n - 1), o.indexOf("\n") > -1 && (o = i
                                ? o.split("\n").map(function(e) {
                                    return "  " + e
                                }).join("\n").substr(2)
                                : "\n" + o.split("\n").map(function(e) {
                                    return "   " + e
                                }).join("\n")))
                            : o = e.stylize("[Circular]", "special")), S(l)) {
                            if (i && s.match(/^\d+$/))
                                return o;
                            l = JSON.stringify("" + s),
                            l.match(/^"([a-zA-Z_][a-zA-Z_0-9]*)"$/)
                                ? (l = l.substr(1, l.length - 2), l = e.stylize(l, "name"))
                                : (l = l.replace(/'/g, "\\'").replace(/\\"/g, '"').replace(/(^"|"$)/g, "'"), l = e.stylize(l, "string"))
                        }
                        return l + ": " + o
                    }
                    function p(e, t, n) {
                        var r = 0,
                            s = e.reduce(function(e, t) {
                                return r++,
                                t.indexOf("\n") >= 0 && r++,
                                e + t.replace(/\u001b\[\d\d?m/g, "").length + 1
                            }, 0);
                        return s > 60
                            ? n[0] + ("" === t
                                ? ""
                                : t + "\n ") + " " + e.join(",\n  ") + " " + n[1]
                            : n[0] + t + " " + e.join(", ") + " " + n[1]
                    }
                    function f(e) {
                        return Array.isArray(e)
                    }
                    function m(e) {
                        return "boolean" == typeof e
                    }
                    function g(e) {
                        return null === e
                    }
                    function v(e) {
                        return null == e
                    }
                    function T(e) {
                        return "number" == typeof e
                    }
                    function _(e) {
                        return "string" == typeof e
                    }
                    function C(e) {
                        return "symbol" == typeof e
                    }
                    function S(e) {
                        return void 0 === e
                    }
                    function E(e) {
                        return y(e) && "[object RegExp]" === I(e)
                    }
                    function y(e) {
                        return "object" == typeof e && null !== e
                    }
                    function A(e) {
                        return y(e) && "[object Date]" === I(e)
                    }
                    function R(e) {
                        return y(e) && ("[object Error]" === I(e) || e instanceof Error)
                    }
                    function w(e) {
                        return "function" == typeof e
                    }
                    function b(e) {
                        return null === e || "boolean" == typeof e || "number" == typeof e || "string" == typeof e || "symbol" == typeof e || "undefined" == typeof e
                    }
                    function I(e) {
                        return Object.prototype.toString.call(e)
                    }
                    function N(e) {
                        return e < 10
                            ? "0" + e.toString(10)
                            : e.toString(10)
                    }
                    function O() {
                        var e = new Date,
                            t = [
                                N(e.getHours()),
                                N(e.getMinutes()),
                                N(e.getSeconds())
                            ].join(":");
                        return [
                            e.getDate(),
                            M[e.getMonth()],
                            t
                        ].join(" ")
                    }
                    function x(e, t) {
                        return Object.prototype.hasOwnProperty.call(e, t)
                    }
                    var D = /%[sdj%]/g;
                    n.format = function(e) {
                        if (!_(e)) {
                            for (var t = [], n = 0; n < arguments.length; n++)
                                t.push(s(arguments[n]));
                            return t.join(" ")
                        }
                        for (var n = 1, r = arguments, i = r.length, l = String(e).replace(D, function(e) {
                            if ("%%" === e)
                                return "%";
                            if (n >= i)
                                return e;
                            switch (e) {
                                case "%s":
                                    return String(r[n++]);
                                case "%d":
                                    return Number(r[n++]);
                                case "%j":
                                    try {
                                        return JSON.stringify(r[n++])
                                    } catch (e) {
                                        return "[Circular]"
                                    }
                                default:
                                    return e
                            }
                        }), o = r[n]; n < i; o = r[++n])
                            l += g(o) || !y(o)
                                ? " " + o
                                : " " + s(o);
                        return l
                    },
                    n.deprecate = function(e, s) {
                        function i() {
                            if (!l) {
                                if (t.throwDeprecation)
                                    throw new Error(s);
                                t.traceDeprecation
                                    ? console.trace(s)
                                    : console.error(s),
                                l = !0
                            }
                            return e.apply(this, arguments)
                        }
                        if (S(r.process))
                            return function() {
                                return n.deprecate(e, s).apply(this, arguments)
                            };
                        if (t.noDeprecation === !0)
                            return e;
                        var l = !1;
                        return i
                    };
                    var P,
                        U = {};
                    n.debuglog = function(e) {
                        if (S(P) && (P = t.env.NODE_DEBUG || ""), e = e.toUpperCase(), !U[e])
                            if (new RegExp("\\b" + e + "\\b", "i").test(P)) {
                                var r = t.pid;
                                U[e] = function() {
                                    var t = n.format.apply(n, arguments);
                                    console.error("%s %d: %s", e, r, t)
                                }
                            } else
                                U[e] = function() {};
                    return U[e]
                    },
                    n.inspect = s,
                    s.colors = {
                        bold: [
                            1, 22
                        ],
                        italic: [
                            3, 23
                        ],
                        underline: [
                            4, 24
                        ],
                        inverse: [
                            7, 27
                        ],
                        white: [
                            37, 39
                        ],
                        grey: [
                            90, 39
                        ],
                        black: [
                            30, 39
                        ],
                        blue: [
                            34, 39
                        ],
                        cyan: [
                            36, 39
                        ],
                        green: [
                            32, 39
                        ],
                        magenta: [
                            35, 39
                        ],
                        red: [
                            31, 39
                        ],
                        yellow: [33, 39]
                    },
                    s.styles = {
                        special: "cyan",
                        number: "yellow",
                        boolean: "yellow",
                        undefined: "grey",
                        null: "bold",
                        string: "green",
                        date: "magenta",
                        regexp: "red"
                    },
                    n.isArray = f,
                    n.isBoolean = m,
                    n.isNull = g,
                    n.isNullOrUndefined = v,
                    n.isNumber = T,
                    n.isString = _,
                    n.isSymbol = C,
                    n.isUndefined = S,
                    n.isRegExp = E,
                    n.isObject = y,
                    n.isDate = A,
                    n.isError = R,
                    n.isFunction = w,
                    n.isPrimitive = b,
                    n.isBuffer = e("./support/isBuffer");
                    var M = [
                        "Jan",
                        "Feb",
                        "Mar",
                        "Apr",
                        "May",
                        "Jun",
                        "Jul",
                        "Aug",
                        "Sep",
                        "Oct",
                        "Nov",
                        "Dec"
                    ];
                    n.log = function() {
                        console.log("%s - %s", O(), n.format.apply(n, arguments))
                    },
                    n.inherits = e("inherits"),
                    n._extend = function(e, t) {
                        if (!t || !y(t))
                            return e;
                        for (var n = Object.keys(t), r = n.length; r--;)
                            e[n[r]] = t[n[r]];
                        return e
                    }
                }).call(this, e("_process"), "undefined" != typeof global
                    ? global
                    : "undefined" != typeof self
                        ? self
                        : "undefined" != typeof window
                            ? window
                            : {})
            }, {
                "./support/isBuffer": 32,
                _process: 30,
                inherits: 31
            }
        ],
        34: [
            function(e, t, n) {
                function r(e) {
                    if (e = String(e), !(e.length > 1e4)) {
                        var t = /^((?:\d+)?\.?\d+) *(milliseconds?|msecs?|ms|seconds?|secs?|s|minutes?|mins?|m|hours?|hrs?|h|days?|d|years?|yrs?|y)?$/i.exec(e);
                        if (t) {
                            var n = parseFloat(t[1]),
                                r = (t[2] || "ms").toLowerCase();
                            switch (r) {
                                case "years":
                                case "year":
                                case "yrs":
                                case "yr":
                                case "y":
                                    return n * d;
                                case "days":
                                case "day":
                                case "d":
                                    return n * c;
                                case "hours":
                                case "hour":
                                case "hrs":
                                case "hr":
                                case "h":
                                    return n * u;
                                case "minutes":
                                case "minute":
                                case "mins":
                                case "min":
                                case "m":
                                    return n * a;
                                case "seconds":
                                case "second":
                                case "secs":
                                case "sec":
                                case "s":
                                    return n * o;
                                case "milliseconds":
                                case "millisecond":
                                case "msecs":
                                case "msec":
                                case "ms":
                                    return n;
                                default:
                                    return
                            }
                        }
                    }
                }
                function s(e) {
                    return e >= c
                        ? Math.round(e / c) + "d"
                        : e >= u
                            ? Math.round(e / u) + "h"
                            : e >= a
                                ? Math.round(e / a) + "m"
                                : e >= o
                                    ? Math.round(e / o) + "s"
                                    : e + "ms"
                }
                function i(e) {
                    return l(e, c, "day") || l(e, u, "hour") || l(e, a, "minute") || l(e, o, "second") || e + " ms"
                }
                function l(e, t, n) {
                    if (!(e < t))
                        return e < 1.5 * t
                            ? Math.floor(e / t) + " " + n
                            : Math.ceil(e / t) + " " + n + "s"
                    }
                var o = 1e3,
                    a = 60 * o,
                    u = 60 * a,
                    c = 24 * u,
                    d = 365.25 * c;
                t.exports = function(e, t) {
                    t = t || {};
                    var n = typeof e;
                    if ("string" === n && e.length > 0)
                        return r(e);
                    if ("number" === n && isNaN(e) === !1)
                        return t.long
                            ? i(e)
                            : s(e);
                    throw new Error("val is not a non-empty string or a valid number. val=" + JSON.stringify(e))
                }
            }, {}
        ],
        35: [
            function(e, t, n) {
                (function(r) {
                    function s() {
                        return !("undefined" == typeof window || !window || "undefined" == typeof window.process || "renderer" !== window.process.type) || ("undefined" != typeof document && document && "WebkitAppearance" in document.documentElement.style || "undefined" != typeof window && window && window.console && (console.firebug || console.exception && console.table) || "undefined" != typeof navigator && navigator && navigator.userAgent && navigator.userAgent.toLowerCase().match(/firefox\/(\d+)/) && parseInt(RegExp.$1, 10) >= 31 || "undefined" != typeof navigator && navigator && navigator.userAgent && navigator.userAgent.toLowerCase().match(/applewebkit\/(\d+)/))
                    }
                    function i(e) {
                        var t = this.useColors;
                        if (e[0] = (t
                            ? "%c"
                            : "") + this.namespace + (t
                            ? " %c"
                            : " ") + e[0] + (t
                            ? "%c "
                            : " ") + "+" + n.humanize(this.diff), t) {
                            var r = "color: " + this.color;
                            e.splice(1, 0, r, "color: inherit");
                            var s = 0,
                                i = 0;
                            e[0].replace(/%[a-zA-Z%]/g, function(e) {
                                "%%" !== e && (s++, "%c" === e && (i = s))
                            }),
                            e.splice(i, 0, r)
                        }
                    }
                    function l() {
                        return "object" == typeof console && console.log && Function.prototype.apply.call(console.log, console, arguments)
                    }
                    function o(e) {
                        try {
                            null == e
                                ? n.storage.removeItem("debug")
                                : n.storage.debug = e
                        } catch (e) {}
                    }
                    function a() {
                        try {
                            return n.storage.debug
                        } catch (e) {}
                        if ("undefined" != typeof r && "env" in r)
                            return r.env.DEBUG
                    }
                    function u() {
                        try {
                            return window.localStorage
                        } catch (e) {}
                    }
                    n = t.exports = e("./debug"),
                    n.log = l,
                    n.formatArgs = i,
                    n.save = o,
                    n.load = a,
                    n.useColors = s,
                    n.storage = "undefined" != typeof chrome && "undefined" != typeof chrome.storage
                        ? chrome.storage.local
                        : u(),
                    n.colors = [
                        "lightseagreen",
                        "forestgreen",
                        "goldenrod",
                        "dodgerblue",
                        "darkorchid",
                        "crimson"
                    ],
                    n.formatters.j = function(e) {
                        try {
                            return JSON.stringify(e)
                        } catch (e) {
                            return "[UnexpectedJSONParseError]: " + e.message
                        }
                    },
                    n.enable(a())
                }).call(this, e("_process"))
            }, {
                "./debug": 36,
                _process: 30
            }
        ],
        36: [
            function(e, t, n) {
                function r(e) {
                    var t,
                        r = 0;
                    for (t in e)
                        r = (r << 5) - r + e.charCodeAt(t),
                        r |= 0;
                    return n.colors[Math.abs(r) % n.colors.length]
                }
                function s(e) {
                    function t() {
                        if (t.enabled) {
                            var e = t,
                                r =+ new Date,
                                s = r - (u || r);
                            e.diff = s,
                            e.prev = u,
                            e.curr = r,
                            u = r;
                            for (var i = new Array(arguments.length), l = 0; l < i.length; l++)
                                i[l] = arguments[l];
                            i[0] = n.coerce(i[0]),
                            "string" != typeof i[0] && i.unshift("%O");
                            var o = 0;
                            i[0] = i[0].replace(/%([a-zA-Z%])/g, function(t, r) {
                                if ("%%" === t)
                                    return t;
                                o++;
                                var s = n.formatters[r];
                                if ("function" == typeof s) {
                                    var l = i[o];
                                    t = s.call(e, l),
                                    i.splice(o, 1),
                                    o--
                                }
                                return t
                            }),
                            n.formatArgs.call(e, i);
                            var a = t.log || n.log || console.log.bind(console);
                            a.apply(e, i)
                        }
                    }
                    return t.namespace = e,
                    t.enabled = n.enabled(e),
                    t.useColors = n.useColors(),
                    t.color = r(e),
                    "function" == typeof n.init && n.init(t),
                    t
                }
                function i(e) {
                    n.save(e);
                    for (var t = (e || "").split(/[\s,]+/), r = t.length, s = 0; s < r; s++)
                        t[s] && (e = t[s].replace(/\*/g, ".*?"), "-" === e[0]
                            ? n.skips.push(new RegExp("^" + e.substr(1) + "$"))
                            : n.names.push(new RegExp("^" + e + "$")));
                    }
                function l() {
                    n.enable("")
                }
                function o(e) {
                    var t,
                        r;
                    for (t = 0, r = n.skips.length; t < r; t++)
                        if (n.skips[t].test(e))
                            return !1;
                for (t = 0, r = n.names.length; t < r; t++)
                        if (n.names[t].test(e))
                            return !0;
                return !1
                }
                function a(e) {
                    return e instanceof Error
                        ? e.stack || e.message
                        : e
                }
                n = t.exports = s.debug = s.default = s,
                n.coerce = a,
                n.disable = l,
                n.enable = i,
                n.enabled = o,
                n.humanize = e("ms"),
                n.names = [],
                n.skips = [],
                n.formatters = {};
                var u
            }, {
                ms: 34
            }
        ],
        37: [
            function(e, t, n) {
                var r = t.exports = {
                    v: [
                        {
                            name: "version",
                            reg: /^(\d*)$/
                        }
                    ],
                    o: [
                        {
                            name: "origin",
                            reg: /^(\S*) (\d*) (\d*) (\S*) IP(\d) (\S*)/,
                            names: [
                                "username",
                                "sessionId",
                                "sessionVersion",
                                "netType",
                                "ipVer",
                                "address"
                            ],
                            format: "%s %s %d %s IP%d %s"
                        }
                    ],
                    s: [
                        {
                            name: "name"
                        }
                    ],
                    i: [
                        {
                            name: "description"
                        }
                    ],
                    u: [
                        {
                            name: "uri"
                        }
                    ],
                    e: [
                        {
                            name: "email"
                        }
                    ],
                    p: [
                        {
                            name: "phone"
                        }
                    ],
                    z: [
                        {
                            name: "timezones"
                        }
                    ],
                    r: [
                        {
                            name: "repeats"
                        }
                    ],
                    t: [
                        {
                            name: "timing",
                            reg: /^(\d*) (\d*)/,
                            names: [
                                "start", "stop"
                            ],
                            format: "%d %d"
                        }
                    ],
                    c: [
                        {
                            name: "connection",
                            reg: /^IN IP(\d) (\S*)/,
                            names: [
                                "version", "ip"
                            ],
                            format: "IN IP%d %s"
                        }
                    ],
                    b: [
                        {
                            push: "bandwidth",
                            reg: /^(TIAS|AS|CT|RR|RS):(\d*)/,
                            names: [
                                "type", "limit"
                            ],
                            format: "%s:%s"
                        }
                    ],
                    m: [
                        {
                            reg: /^(\w*) (\d*) ([\w\/]*)(?: (.*))?/,
                            names: [
                                "type", "port", "protocol", "payloads"
                            ],
                            format: "%s %d %s %s"
                        }
                    ],
                    a: [
                        {
                            push: "rtp",
                            reg: /^rtpmap:(\d*) ([\w\-\.]*)(?:\s*\/(\d*)(?:\s*\/(\S*))?)?/,
                            names: [
                                "payload", "codec", "rate", "encoding"
                            ],
                            format: function(e) {
                                return e.encoding
                                    ? "rtpmap:%d %s/%s/%s"
                                    : e.rate
                                        ? "rtpmap:%d %s/%s"
                                        : "rtpmap:%d %s"
                            }
                        }, {
                            push: "fmtp",
                            reg: /^fmtp:(\d*) ([\S| ]*)/,
                            names: [
                                "payload", "config"
                            ],
                            format: "fmtp:%d %s"
                        }, {
                            name: "control",
                            reg: /^control:(.*)/,
                            format: "control:%s"
                        }, {
                            name: "rtcp",
                            reg: /^rtcp:(\d*)(?: (\S*) IP(\d) (\S*))?/,
                            names: [
                                "port", "netType", "ipVer", "address"
                            ],
                            format: function(e) {
                                return null != e.address
                                    ? "rtcp:%d %s IP%d %s"
                                    : "rtcp:%d"
                            }
                        }, {
                            push: "rtcpFbTrrInt",
                            reg: /^rtcp-fb:(\*|\d*) trr-int (\d*)/,
                            names: [
                                "payload", "value"
                            ],
                            format: "rtcp-fb:%d trr-int %d"
                        }, {
                            push: "rtcpFb",
                            reg: /^rtcp-fb:(\*|\d*) ([\w-_]*)(?: ([\w-_]*))?/,
                            names: [
                                "payload", "type", "subtype"
                            ],
                            format: function(e) {
                                return null != e.subtype
                                    ? "rtcp-fb:%s %s %s"
                                    : "rtcp-fb:%s %s"
                            }
                        }, {
                            push: "ext",
                            reg: /^extmap:([\w_\/]*) (\S*)(?: (\S*))?/,
                            names: [
                                "value", "uri", "config"
                            ],
                            format: function(e) {
                                return null != e.config
                                    ? "extmap:%s %s %s"
                                    : "extmap:%s %s"
                            }
                        }, {
                            push: "crypto",
                            reg: /^crypto:(\d*) ([\w_]*) (\S*)(?: (\S*))?/,
                            names: [
                                "id", "suite", "config", "sessionConfig"
                            ],
                            format: function(e) {
                                return null != e.sessionConfig
                                    ? "crypto:%d %s %s %s"
                                    : "crypto:%d %s %s"
                            }
                        }, {
                            name: "setup",
                            reg: /^setup:(\w*)/,
                            format: "setup:%s"
                        }, {
                            name: "mid",
                            reg: /^mid:([^\s]*)/,
                            format: "mid:%s"
                        }, {
                            name: "msid",
                            reg: /^msid:(.*)/,
                            format: "msid:%s"
                        }, {
                            name: "ptime",
                            reg: /^ptime:(\d*)/,
                            format: "ptime:%d"
                        }, {
                            name: "maxptime",
                            reg: /^maxptime:(\d*)/,
                            format: "maxptime:%d"
                        }, {
                            name: "direction",
                            reg: /^(sendrecv|recvonly|sendonly|inactive)/
                        }, {
                            name: "icelite",
                            reg: /^(ice-lite)/
                        }, {
                            name: "iceUfrag",
                            reg: /^ice-ufrag:(\S*)/,
                            format: "ice-ufrag:%s"
                        }, {
                            name: "icePwd",
                            reg: /^ice-pwd:(\S*)/,
                            format: "ice-pwd:%s"
                        }, {
                            name: "fingerprint",
                            reg: /^fingerprint:(\S*) (\S*)/,
                            names: [
                                "type", "hash"
                            ],
                            format: "fingerprint:%s %s"
                        }, {
                            push: "candidates",
                            reg: /^candidate:(\S*) (\d*) (\S*) (\d*) (\S*) (\d*) typ (\S*)(?: raddr (\S*) rport (\d*))?(?: tcptype (\S*))?(?: generation (\d*))?/,
                            names: [
                                "foundation",
                                "component",
                                "transport",
                                "priority",
                                "ip",
                                "port",
                                "type",
                                "raddr",
                                "rport",
                                "tcptype",
                                "generation"
                            ],
                            format: function(e) {
                                var t = "candidate:%s %d %s %d %s %d typ %s";
                                return t += null != e.raddr
                                    ? " raddr %s rport %d"
                                    : "%v%v",
                                t += null != e.tcptype
                                    ? " tcptype %s"
                                    : "%v",
                                null != e.generation && (t += " generation %d"),
                                t
                            }
                        }, {
                            name: "endOfCandidates",
                            reg: /^(end-of-candidates)/
                        }, {
                            name: "remoteCandidates",
                            reg: /^remote-candidates:(.*)/,
                            format: "remote-candidates:%s"
                        }, {
                            name: "iceOptions",
                            reg: /^ice-options:(\S*)/,
                            format: "ice-options:%s"
                        }, {
                            push: "ssrcs",
                            reg: /^ssrc:(\d*) ([\w_]*):(.*)/,
                            names: [
                                "id", "attribute", "value"
                            ],
                            format: "ssrc:%d %s:%s"
                        }, {
                            push: "ssrcGroups",
                            reg: /^ssrc-group:(\w*) (.*)/,
                            names: [
                                "semantics", "ssrcs"
                            ],
                            format: "ssrc-group:%s %s"
                        }, {
                            name: "msidSemantic",
                            reg: /^msid-semantic:\s?(\w*) (\S*)/,
                            names: [
                                "semantic", "token"
                            ],
                            format: "msid-semantic: %s %s"
                        }, {
                            push: "groups",
                            reg: /^group:(\w*) (.*)/,
                            names: [
                                "type", "mids"
                            ],
                            format: "group:%s %s"
                        }, {
                            name: "rtcpMux",
                            reg: /^(rtcp-mux)/
                        }, {
                            name: "rtcpRsize",
                            reg: /^(rtcp-rsize)/
                        }, {
                            name: "sctpmap",
                            reg: /^sctpmap:([\w_\/]*) (\S*)(?: (\S*))?/,
                            names: [
                                "sctpmapNumber", "app", "maxMessageSize"
                            ],
                            format: function(e) {
                                return null != e.maxMessageSize
                                    ? "sctpmap:%s %s %s"
                                    : "sctpmap:%s %s"
                            }
                        }, {
                            push: "invalid",
                            names: ["value"]
                        }
                    ]
                };
                Object.keys(r).forEach(function(e) {
                    var t = r[e];
                    t.forEach(function(e) {
                        e.reg || (e.reg = /(.*)/),
                        e.format || (e.format = "%s")
                    })
                })
            }, {}
        ],
        38: [
            function(e, t, n) {
                var r = e("./parser"),
                    s = e("./writer");
                n.write = s,
                n.parse = r.parse,
                n.parseFmtpConfig = r.parseFmtpConfig,
                n.parsePayloads = r.parsePayloads,
                n.parseRemoteCandidates = r.parseRemoteCandidates
            }, {
                "./parser": 39,
                "./writer": 40
            }
        ],
        39: [
            function(e, t, n) {
                var r = function(e) {
                        return String(Number(e)) === e
                            ? Number(e)
                            : e
                    },
                    s = function(e, t, n, s) {
                        if (s && !n)
                            t[s] = r(e[1]);
                        else
                            for (var i = 0; i < n.length; i += 1)
                                null != e[i + 1] && (t[n[i]] = r(e[i + 1]))
                    },
                    i = function(e, t, n) {
                        var r = e.name && e.names;
                        e.push && !t[e.push]
                            ? t[e.push] = []
                            : r && !t[e.name] && (t[e.name] = {});
                        var i = e.push
                            ? {}
                            : r
                                ? t[e.name]
                                : t;
                        s(n.match(e.reg), i, e.names, e.name),
                        e.push && t[e.push].push(i)
                    },
                    l = e("./grammar"),
                    o = RegExp.prototype.test.bind(/^([a-z])=(.*)/);
                n.parse = function(e) {
                    var t = {},
                        n = [],
                        r = t;
                    return e.split(/(\r\n|\r|\n)/).filter(o).forEach(function(e) {
                        var t = e[0],
                            s = e.slice(2);
                        "m" === t && (n.push({rtp: [], fmtp: []}), r = n[n.length - 1]);
                        for (var o = 0; o < (l[t] || []).length; o += 1) {
                            var a = l[t][o];
                            if (a.reg.test(s))
                                return i(a, r, s)
                        }
                    }),
                    t.media = n,
                    t
                };
                var a = function(e, t) {
                    var n = t.split(/=(.+)/, 2);
                    return 2 === n.length && (e[n[0]] = r(n[1])),
                    e
                };
                n.parseFmtpConfig = function(e) {
                    return e.split(/\;\s?/).reduce(a, {})
                },
                n.parsePayloads = function(e) {
                    return e.split(" ").map(Number)
                },
                n.parseRemoteCandidates = function(e) {
                    for (var t = [], n = e.split(" ").map(r), s = 0; s < n.length; s += 3)
                        t.push({
                            component: n[s],
                            ip: n[s + 1],
                            port: n[s + 2]
                        });
                    return t
                }
            }, {
                "./grammar": 37
            }
        ],
        40: [
            function(e, t, n) {
                var r = e("./grammar"),
                    s = /%[sdv%]/g,
                    i = function(e) {
                        var t = 1,
                            n = arguments,
                            r = n.length;
                        return e.replace(s, function(e) {
                            if (t >= r)
                                return e;
                            var s = n[t];
                            switch (t += 1, e) {
                                case "%%":
                                    return "%";
                                case "%s":
                                    return String(s);
                                case "%d":
                                    return Number(s);
                                case "%v":
                                    return ""
                            }
                        })
                    },
                    l = function(e, t, n) {
                        var r = t.format instanceof Function
                                ? t.format(t.push
                                    ? n
                                    : n[t.name])
                                : t.format,
                            s = [e + "=" + r];
                        if (t.names)
                            for (var l = 0; l < t.names.length; l += 1) {
                                var o = t.names[l];
                                t.name
                                    ? s.push(n[t.name][o])
                                    : s.push(n[t.names[l]])
                            } else
                                s.push(n[t.name]);
                    return i.apply(null, s)
                    },
                    o = [
                        "v",
                        "o",
                        "s",
                        "i",
                        "u",
                        "e",
                        "p",
                        "c",
                        "b",
                        "t",
                        "r",
                        "z",
                        "a"
                    ],
                    a = ["i", "c", "b", "a"];
                t.exports = function(e, t) {
                    t = t || {},
                    null == e.version && (e.version = 0),
                    null == e.name && (e.name = " "),
                    e.media.forEach(function(e) {
                        null == e.payloads && (e.payloads = "")
                    });
                    var n = t.outerOrder || o,
                        s = t.innerOrder || a,
                        i = [];
                    return n.forEach(function(t) {
                        r[t].forEach(function(n) {
                            n.name in e && null != e[n.name]
                                ? i.push(l(t, n, e))
                                : n.push in e && null != e[n.push] && e[n.push].forEach(function(e) {
                                    i.push(l(t, n, e))
                                })
                        })
                    }),
                    e.media.forEach(function(e) {
                        i.push(l("m", r.m[0], e)),
                        s.forEach(function(t) {
                            r[t].forEach(function(n) {
                                n.name in e && null != e[n.name]
                                    ? i.push(l(t, n, e))
                                    : n.push in e && null != e[n.push] && e[n.push].forEach(function(e) {
                                        i.push(l(t, n, e))
                                    })
                            })
                        })
                    }),
                    i.join("\r\n") + "\r\n"
                }
            }, {
                "./grammar": 37
            }
        ],
        41: [
            function(e, t, n) {
                "use strict";
                var r = {};
                r.generateIdentifier = function() {
                    return Math.random().toString(36).substr(2, 10)
                },
                r.localCName = r.generateIdentifier(),
                r.splitLines = function(e) {
                    return e.trim().split("\n").map(function(e) {
                        return e.trim()
                    })
                },
                r.splitSections = function(e) {
                    var t = e.split("\nm=");
                    return t.map(function(e, t) {
                        return (t > 0
                            ? "m=" + e
                            : e).trim() + "\r\n"
                    })
                },
                r.matchPrefix = function(e, t) {
                    return r.splitLines(e).filter(function(e) {
                        return 0 === e.indexOf(t)
                    })
                },
                r.parseCandidate = function(e) {
                    var t;
                    t = 0 === e.indexOf("a=candidate:")
                        ? e.substring(12).split(" ")
                        : e.substring(10).split(" ");
                    for (var n = {
                        foundation: t[0],
                        component: t[1],
                        protocol: t[2].toLowerCase(),
                        priority: parseInt(t[3], 10),
                        ip: t[4],
                        port: parseInt(t[5], 10),
                        type: t[7]
                    }, r = 8; r < t.length; r += 2)
                        switch (t[r]) {
                            case "raddr":
                                n.relatedAddress = t[r + 1];
                                break;
                            case "rport":
                                n.relatedPort = parseInt(t[r + 1], 10);
                                break;
                            case "tcptype":
                                n.tcpType = t[r + 1]
                        }
                    return n
                },
                r.writeCandidate = function(e) {
                    var t = [];
                    t.push(e.foundation),
                    t.push(e.component),
                    t.push(e.protocol.toUpperCase()),
                    t.push(e.priority),
                    t.push(e.ip),
                    t.push(e.port);
                    var n = e.type;
                    return t.push("typ"),
                    t.push(n),
                    "host" !== n && e.relatedAddress && e.relatedPort && (t.push("raddr"), t.push(e.relatedAddress), t.push("rport"), t.push(e.relatedPort)),
                    e.tcpType && "tcp" === e.protocol.toLowerCase() && (t.push("tcptype"), t.push(e.tcpType)),
                    "candidate:" + t.join(" ")
                },
                r.parseRtpMap = function(e) {
                    var t = e.substr(9).split(" "),
                        n = {
                            payloadType: parseInt(t.shift(), 10)
                        };
                    return t = t[0].split("/"),
                    n.name = t[0],
                    n.clockRate = parseInt(t[1], 10),
                    n.numChannels = 3 === t.length
                        ? parseInt(t[2], 10)
                        : 1,
                    n
                },
                r.writeRtpMap = function(e) {
                    var t = e.payloadType;
                    return void 0 !== e.preferredPayloadType && (t = e.preferredPayloadType),
                    "a=rtpmap:" + t + " " + e.name + "/" + e.clockRate + (1 !== e.numChannels
                        ? "/" + e.numChannels
                        : "") + "\r\n"
                },
                r.parseExtmap = function(e) {
                    var t = e.substr(9).split(" ");
                    return {
                        id: parseInt(t[0], 10),
                        uri: t[1]
                    }
                },
                r.writeExtmap = function(e) {
                    return "a=extmap:" + (e.id || e.preferredId) + " " + e.uri + "\r\n"
                },
                r.parseFmtp = function(e) {
                    for (var t, n = {}, r = e.substr(e.indexOf(" ") + 1).split(";"), s = 0; s < r.length; s++)
                        t = r[s].trim().split("="),
                        n[t[0].trim()] = t[1];
                    return n
                },
                r.writeFmtp = function(e) {
                    var t = "",
                        n = e.payloadType;
                    if (void 0 !== e.preferredPayloadType && (n = e.preferredPayloadType), e.parameters && Object.keys(e.parameters).length) {
                        var r = [];
                        Object.keys(e.parameters).forEach(function(t) {
                            r.push(t + "=" + e.parameters[t])
                        }),
                        t += "a=fmtp:" + n + " " + r.join(";") + "\r\n"
                    }
                    return t
                },
                r.parseRtcpFb = function(e) {
                    var t = e.substr(e.indexOf(" ") + 1).split(" ");
                    return {type: t.shift(), parameter: t.join(" ")}
                },
                r.writeRtcpFb = function(e) {
                    var t = "",
                        n = e.payloadType;
                    return void 0 !== e.preferredPayloadType && (n = e.preferredPayloadType),
                    e.rtcpFeedback && e.rtcpFeedback.length && e.rtcpFeedback.forEach(function(e) {
                        t += "a=rtcp-fb:" + n + " " + e.type + (e.parameter && e.parameter.length
                            ? " " + e.parameter
                            : "") + "\r\n"
                    }),
                    t
                },
                r.parseSsrcMedia = function(e) {
                    var t = e.indexOf(" "),
                        n = {
                            ssrc: parseInt(e.substr(7, t - 7), 10)
                        },
                        r = e.indexOf(":", t);
                    return r > -1
                        ? (n.attribute = e.substr(t + 1, r - t - 1), n.value = e.substr(r + 1))
                        : n.attribute = e.substr(t + 1),
                    n
                },
                r.getDtlsParameters = function(e, t) {
                    var n = r.splitLines(e);
                    n = n.concat(r.splitLines(t));
                    var s = n.filter(function(e) {
                            return 0 === e.indexOf("a=fingerprint:")
                        })[0].substr(14),
                        i = {
                            role: "auto",
                            fingerprints: [
                                {
                                    algorithm: s.split(" ")[0],
                                    value: s.split(" ")[1]
                                }
                            ]
                        };
                    return i
                },
                r.writeDtlsParameters = function(e, t) {
                    var n = "a=setup:" + t + "\r\n";
                    return e.fingerprints.forEach(function(e) {
                        n += "a=fingerprint:" + e.algorithm + " " + e.value + "\r\n"
                    }),
                    n
                },
                r.getIceParameters = function(e, t) {
                    var n = r.splitLines(e);
                    n = n.concat(r.splitLines(t));
                    var s = {
                        usernameFragment: n.filter(function(e) {
                            return 0 === e.indexOf("a=ice-ufrag:")
                        })[0].substr(12),
                        password: n.filter(function(e) {
                            return 0 === e.indexOf("a=ice-pwd:")
                        })[0].substr(10)
                    };
                    return s
                },
                r.writeIceParameters = function(e) {
                    return "a=ice-ufrag:" + e.usernameFragment + "\r\na=ice-pwd:" + e.password + "\r\n"
                },
                r.parseRtpParameters = function(e) {
                    for (var t = {
                        codecs: [],
                        headerExtensions: [],
                        fecMechanisms: [],
                        rtcp: []
                    }, n = r.splitLines(e), s = n[0].split(" "), i = 3; i < s.length; i++) {
                        var l = s[i],
                            o = r.matchPrefix(e, "a=rtpmap:" + l + " ")[0];
                        if (o) {
                            var a = r.parseRtpMap(o),
                                u = r.matchPrefix(e, "a=fmtp:" + l + " ");
                            switch (a.parameters = u.length
                                ? r.parseFmtp(u[0])
                                : {}, a.rtcpFeedback = r.matchPrefix(e, "a=rtcp-fb:" + l + " ").map(r.parseRtcpFb), t.codecs.push(a), a.name.toUpperCase()) {
                                case "RED":
                                case "ULPFEC":
                                    t.fecMechanisms.push(a.name.toUpperCase())
                            }
                        }
                    }
                    return r.matchPrefix(e, "a=extmap:").forEach(function(e) {
                        t.headerExtensions.push(r.parseExtmap(e))
                    }),
                    t
                },
                r.writeRtpDescription = function(e, t) {
                    var n = "";
                    return n += "m=" + e + " ",
                    n += t.codecs.length > 0
                        ? "9"
                        : "0",
                    n += " UDP/TLS/RTP/SAVPF ",
                    n += t.codecs.map(function(e) {
                        return void 0 !== e.preferredPayloadType
                            ? e.preferredPayloadType
                            : e.payloadType
                    }).join(" ") + "\r\n",
                    n += "c=IN IP4 0.0.0.0\r\n",
                    n += "a=rtcp:9 IN IP4 0.0.0.0\r\n",
                    t.codecs.forEach(function(e) {
                        n += r.writeRtpMap(e),
                        n += r.writeFmtp(e),
                        n += r.writeRtcpFb(e)
                    }),
                    n += "a=rtcp-mux\r\n",
                    t.headerExtensions.forEach(function(e) {
                        n += r.writeExtmap(e)
                    }),
                    n
                },
                r.parseRtpEncodingParameters = function(e) {
                    var t,
                        n = [],
                        s = r.parseRtpParameters(e),
                        i = s.fecMechanisms.indexOf("RED") !== -1,
                        l = s.fecMechanisms.indexOf("ULPFEC") !== -1,
                        o = r.matchPrefix(e, "a=ssrc:").map(function(e) {
                            return r.parseSsrcMedia(e)
                        }).filter(function(e) {
                            return "cname" === e.attribute
                        }),
                        a = o.length > 0 && o[0].ssrc,
                        u = r.matchPrefix(e, "a=ssrc-group:FID").map(function(e) {
                            var t = e.split(" ");
                            return t.shift(),
                            t.map(function(e) {
                                return parseInt(e, 10)
                            })
                        });
                    u.length > 0 && u[0].length > 1 && u[0][0] === a && (t = u[0][1]),
                    s.codecs.forEach(function(e) {
                        if ("RTX" === e.name.toUpperCase() && e.parameters.apt) {
                            var r = {
                                ssrc: a,
                                codecPayloadType: parseInt(e.parameters.apt, 10),
                                rtx: {
                                    payloadType: e.payloadType,
                                    ssrc: t
                                }
                            };
                            n.push(r),
                            i && (r = JSON.parse(JSON.stringify(r)), r.fec = {
                                ssrc: t,
                                mechanism: l
                                    ? "red+ulpfec"
                                    : "red"
                            }, n.push(r))
                        }
                    }),
                    0 === n.length && a && n.push({ssrc: a});
                    var c = r.matchPrefix(e, "b=");
                    return c.length && (0 === c[0].indexOf("b=TIAS:")
                        ? c = parseInt(c[0].substr(7), 10)
                        : 0 === c[0].indexOf("b=AS:") && (c = parseInt(c[0].substr(5), 10)), n.forEach(function(e) {
                        e.maxBitrate = c
                    })),
                    n
                },
                r.writeSessionBoilerplate = function() {
                    return "v=0\r\no=thisisadapterortc 8169639915646943137 2 IN IP4 127.0.0.1\r\ns=-\r\nt=0 0\r\n"
                },
                r.writeMediaSection = function(e, t, n, s) {
                    var i = r.writeRtpDescription(e.kind, t);
                    if (i += r.writeIceParameters(e.iceGatherer.getLocalParameters()), i += r.writeDtlsParameters(e.dtlsTransport.getLocalParameters(), "offer" === n
                        ? "actpass"
                        : "active"), i += "a=mid:" + e.mid + "\r\n", i += e.rtpSender && e.rtpReceiver
                        ? "a=sendrecv\r\n"
                        : e.rtpSender
                            ? "a=sendonly\r\n"
                            : e.rtpReceiver
                                ? "a=recvonly\r\n"
                                : "a=inactive\r\n", e.rtpSender) {
                        var l = "msid:" + s.id + " " + e.rtpSender.track.id + "\r\n";
                        i += "a=" + l,
                        i += "a=ssrc:" + e.sendEncodingParameters[0].ssrc + " " + l
                    }
                    return i += "a=ssrc:" + e.sendEncodingParameters[0].ssrc + " cname:" + r.localCName + "\r\n"
                },
                r.getDirection = function(e, t) {
                    for (var n = r.splitLines(e), s = 0; s < n.length; s++)
                        switch (n[s]) {
                            case "a=sendrecv":
                            case "a=sendonly":
                            case "a=recvonly":
                            case "a=inactive":
                                return n[s].substr(2)
                        }
                    return t
                        ? r.getDirection(t)
                        : "sendrecv"
                },
                t.exports = r
            }, {}
        ],
        42: [
            function(e, t, n) {
                "use strict";
                !function() {
                    var n = e("./utils").log,
                        r = e("./utils").browserDetails;
                    t.exports.browserDetails = r,
                    t.exports.extractVersion = e("./utils").extractVersion,
                    t.exports.disableLog = e("./utils").disableLog;
                    var s = e("./chrome/chrome_shim") || null,
                        i = e("./edge/edge_shim") || null,
                        l = e("./firefox/firefox_shim") || null,
                        o = e("./safari/safari_shim") || null;
                    switch (r.browser) {
                        case "opera":
                        case "chrome":
                            if (!s || !s.shimPeerConnection)
                                return void n("Chrome shim is not included in this adapter release.");
                            n("adapter.js shimming chrome."),
                            t.exports.browserShim = s,
                            s.shimGetUserMedia(),
                            s.shimMediaStream(),
                            s.shimSourceObject(),
                            s.shimPeerConnection(),
                            s.shimOnTrack();
                            break;
                        case "firefox":
                            if (!l || !l.shimPeerConnection)
                                return void n("Firefox shim is not included in this adapter release.");
                            n("adapter.js shimming firefox."),
                            t.exports.browserShim = l,
                            l.shimGetUserMedia(),
                            l.shimSourceObject(),
                            l.shimPeerConnection(),
                            l.shimOnTrack();
                            break;
                        case "edge":
                            if (!i || !i.shimPeerConnection)
                                return void n("MS edge shim is not included in this adapter release.");
                            n("adapter.js shimming edge."),
                            t.exports.browserShim = i,
                            i.shimGetUserMedia(),
                            i.shimPeerConnection();
                            break;
                        case "safari":
                            if (!o)
                                return void n("Safari shim is not included in this adapter release.");
                            n("adapter.js shimming safari."),
                            t.exports.browserShim = o,
                            o.shimGetUserMedia();
                            break;
                        default:
                            n("Unsupported browser!")
                    }
                }()
            }, {
                "./chrome/chrome_shim": 43,
                "./edge/edge_shim": 45,
                "./firefox/firefox_shim": 47,
                "./safari/safari_shim": 49,
                "./utils": 50
            }
        ],
        43: [
            function(e, t, n) {
                "use strict";
                var r = e("../utils.js").log,
                    s = e("../utils.js").browserDetails,
                    i = {
                        shimMediaStream: function() {
                            window.MediaStream = window.MediaStream || window.webkitMediaStream
                        },
                        shimOnTrack: function() {
                            "object" != typeof window || !window.RTCPeerConnection || "ontrack" in window.RTCPeerConnection.prototype || Object.defineProperty(window.RTCPeerConnection.prototype, "ontrack", {
                                get: function() {
                                    return this._ontrack
                                },
                                set: function(e) {
                                    var t = this;
                                    this._ontrack && (this.removeEventListener("track", this._ontrack), this.removeEventListener("addstream", this._ontrackpoly)),
                                    this.addEventListener("track", this._ontrack = e),
                                    this.addEventListener("addstream", this._ontrackpoly = function(e) {
                                        e.stream.addEventListener("addtrack", function(n) {
                                            var r = new Event("track");
                                            r.track = n.track,
                                            r.receiver = {
                                                track: n.track
                                            },
                                            r.streams = [e.stream],
                                            t.dispatchEvent(r)
                                        }),
                                        e.stream.getTracks().forEach(function(t) {
                                            var n = new Event("track");
                                            n.track = t,
                                            n.receiver = {
                                                track: t
                                            },
                                            n.streams = [e.stream],
                                            this.dispatchEvent(n)
                                        }.bind(this))
                                    }.bind(this))
                                }
                            })
                        },
                        shimSourceObject: function() {
                            "object" == typeof window && (!window.HTMLMediaElement || "srcObject" in window.HTMLMediaElement.prototype || Object.defineProperty(window.HTMLMediaElement.prototype, "srcObject", {
                                get: function() {
                                    return this._srcObject
                                },
                                set: function(e) {
                                    var t = this;
                                    return this._srcObject = e,
                                    this.src && URL.revokeObjectURL(this.src),
                                    e
                                        ? (this.src = URL.createObjectURL(e), e.addEventListener("addtrack", function() {
                                            t.src && URL.revokeObjectURL(t.src),
                                            t.src = URL.createObjectURL(e)
                                        }), void e.addEventListener("removetrack", function() {
                                            t.src && URL.revokeObjectURL(t.src),
                                            t.src = URL.createObjectURL(e)
                                        }))
                                        : void(this.src = "")
                                }
                            }))
                        },
                        shimPeerConnection: function() {
                            window.RTCPeerConnection = function(e, t) {
                                r("PeerConnection"),
                                e && e.iceTransportPolicy && (e.iceTransports = e.iceTransportPolicy);
                                var n = new webkitRTCPeerConnection(e, t),
                                    s = n.getStats.bind(n);
                                return n.getStats = function(e, t, n) {
                                    var r = this,
                                        i = arguments;
                                    if (arguments.length > 0 && "function" == typeof e)
                                        return s(e, t);
                                    var l = function(e) {
                                            var t = {},
                                                n = e.result();
                                            return n.forEach(function(e) {
                                                var n = {
                                                    id: e.id,
                                                    timestamp: e.timestamp,
                                                    type: e.type
                                                };
                                                e.names().forEach(function(t) {
                                                    n[t] = e.stat(t)
                                                }),
                                                t[n.id] = n
                                            }),
                                            t
                                        },
                                        o = function(e, t) {
                                            var n = new Map(Object.keys(e).map(function(t) {
                                                return [t, e[t]]
                                            }));
                                            return t = t || e,
                                            Object.keys(t).forEach(function(e) {
                                                n[e] = t[e]
                                            }),
                                            n
                                        };
                                    if (arguments.length >= 2) {
                                        var a = function(e) {
                                            i[1](o(l(e)))
                                        };
                                        return s.apply(this, [a, arguments[0]])
                                    }
                                    return new Promise(function(t, n) {
                                        1 === i.length && "object" == typeof e
                                            ? s.apply(r, [
                                                function(e) {
                                                    t(o(l(e)))
                                                },
                                                n
                                            ])
                                            : s.apply(r, [
                                                function(e) {
                                                    t(o(l(e), e.result()))
                                                },
                                                n
                                            ])
                                    }).then(t, n)
                                },
                                n
                            },
                            window.RTCPeerConnection.prototype = webkitRTCPeerConnection.prototype,
                            webkitRTCPeerConnection.generateCertificate && Object.defineProperty(window.RTCPeerConnection, "generateCertificate", {
                                get: function() {
                                    return webkitRTCPeerConnection.generateCertificate
                                }
                            }),
                            ["createOffer", "createAnswer"].forEach(function(e) {
                                var t = webkitRTCPeerConnection.prototype[e];
                                webkitRTCPeerConnection.prototype[e] = function() {
                                    var e = this;
                                    if (arguments.length < 1 || 1 === arguments.length && "object" == typeof arguments[0]) {
                                        var n = 1 === arguments.length
                                            ? arguments[0]
                                            : void 0;
                                        return new Promise(function(r, s) {
                                            t.apply(e, [r, s, n])
                                        })
                                    }
                                    return t.apply(this, arguments)
                                }
                            }),
                            s.version < 51 && ["setLocalDescription", "setRemoteDescription", "addIceCandidate"].forEach(function(e) {
                                var t = webkitRTCPeerConnection.prototype[e];
                                webkitRTCPeerConnection.prototype[e] = function() {
                                    var e = arguments,
                                        n = this,
                                        r = new Promise(function(r, s) {
                                            t.apply(n, [e[0], r, s])
                                        });
                                    return e.length < 2
                                        ? r
                                        : r.then(function() {
                                            e[1].apply(null, [])
                                        }, function(t) {
                                            e.length >= 3 && e[2].apply(null, [t])
                                        })
                                }
                            }),
                            ["setLocalDescription", "setRemoteDescription", "addIceCandidate"].forEach(function(e) {
                                var t = webkitRTCPeerConnection.prototype[e];
                                webkitRTCPeerConnection.prototype[e] = function() {
                                    return arguments[0] = new("addIceCandidate" === e
                                        ? RTCIceCandidate
                                        : RTCSessionDescription)(arguments[0]),
                                    t.apply(this, arguments)
                                }
                            });
                            var e = RTCPeerConnection.prototype.addIceCandidate;
                            RTCPeerConnection.prototype.addIceCandidate = function() {
                                return arguments[0]
                                    ? e.apply(this, arguments)
                                    : (arguments[1] && arguments[1].apply(null), Promise.resolve())
                            }
                        }
                    };
                t.exports = {
                    shimMediaStream: i.shimMediaStream,
                    shimOnTrack: i.shimOnTrack,
                    shimSourceObject: i.shimSourceObject,
                    shimPeerConnection: i.shimPeerConnection,
                    shimGetUserMedia: e("./getusermedia")
                }
            }, {
                "../utils.js": 50,
                "./getusermedia": 44
            }
        ],
        44: [
            function(e, t, n) {
                "use strict";
                var r = e("../utils.js").log;
                t.exports = function() {
                    var e = function(e) {
                            if ("object" != typeof e || e.mandatory || e.optional)
                                return e;
                            var t = {};
                            return Object.keys(e).forEach(function(n) {
                                if ("require" !== n && "advanced" !== n && "mediaSource" !== n) {
                                    var r = "object" == typeof e[n]
                                        ? e[n]
                                        : {
                                            ideal: e[n]
                                        };
                                    void 0 !== r.exact && "number" == typeof r.exact && (r.min = r.max = r.exact);
                                    var s = function(e, t) {
                                        return e
                                            ? e + t.charAt(0).toUpperCase() + t.slice(1)
                                            : "deviceId" === t
                                                ? "sourceId"
                                                : t
                                    };
                                    if (void 0 !== r.ideal) {
                                        t.optional = t.optional || [];
                                        var i = {};
                                        "number" == typeof r.ideal
                                            ? (i[s("min", n)] = r.ideal, t.optional.push(i), i = {}, i[s("max", n)] = r.ideal, t.optional.push(i))
                                            : (i[s("", n)] = r.ideal, t.optional.push(i))
                                    }
                                    void 0 !== r.exact && "number" != typeof r.exact
                                        ? (t.mandatory = t.mandatory || {}, t.mandatory[s("", n)] = r.exact)
                                        : ["min", "max"].forEach(function(e) {
                                            void 0 !== r[e] && (t.mandatory = t.mandatory || {}, t.mandatory[s(e, n)] = r[e])
                                        })
                                }
                            }),
                            e.advanced && (t.optional = (t.optional || []).concat(e.advanced)),
                            t
                        },
                        t = function(t, n) {
                            if (t = JSON.parse(JSON.stringify(t)), t && t.audio && (t.audio = e(t.audio)), t && "object" == typeof t.video) {
                                var s = t.video.facingMode;
                                if (s = s && ("object" == typeof s
                                    ? s
                                    : {
                                        ideal: s
                                    }), s && ("user" === s.exact || "environment" === s.exact || "user" === s.ideal || "environment" === s.ideal) && (!navigator.mediaDevices.getSupportedConstraints || !navigator.mediaDevices.getSupportedConstraints().facingMode) && (delete t.video.facingMode, "environment" === s.exact || "environment" === s.ideal))
                                    return navigator.mediaDevices.enumerateDevices().then(function(i) {
                                        i = i.filter(function(e) {
                                            return "videoinput" === e.kind
                                        });
                                        var l = i.find(function(e) {
                                            return e.label.toLowerCase().indexOf("back") !== -1
                                        }) || i.length && i[i.length - 1];
                                        return l && (t.video.deviceId = s.exact
                                            ? {
                                                exact: l.deviceId
                                            }
                                            : {
                                                ideal: l.deviceId
                                            }),
                                        t.video = e(t.video),
                                        r("chrome: " + JSON.stringify(t)),
                                        n(t)
                                    });
                                t.video = e(t.video)
                            }
                            return r("chrome: " + JSON.stringify(t)),
                            n(t)
                        },
                        n = function(e) {
                            return {
                                name: {
                                    PermissionDeniedError: "NotAllowedError",
                                    ConstraintNotSatisfiedError: "OverconstrainedError"
                                }[e.name] || e.name,
                                message: e.message,
                                constraint: e.constraintName,
                                toString: function() {
                                    return this.name + (this.message && ": ") + this.message
                                }
                            }
                        },
                        s = function(e, r, s) {
                            t(e, function(e) {
                                navigator.webkitGetUserMedia(e, r, function(e) {
                                    s(n(e))
                                })
                            })
                        };
                    navigator.getUserMedia = s;
                    var i = function(e) {
                        return new Promise(function(t, n) {
                            navigator.getUserMedia(e, t, n)
                        })
                    };
                    if (navigator.mediaDevices || (navigator.mediaDevices = {
                        getUserMedia: i,
                        enumerateDevices: function() {
                            return new Promise(function(e) {
                                var t = {
                                    audio: "audioinput",
                                    video: "videoinput"
                                };
                                return MediaStreamTrack.getSources(function(n) {
                                    e(n.map(function(e) {
                                        return {
                                            label: e.label,
                                            kind: t[e.kind],
                                            deviceId: e.id,
                                            groupId: ""
                                        }
                                    }))
                                })
                            })
                        }
                    }), navigator.mediaDevices.getUserMedia) {
                        var l = navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);
                        navigator.mediaDevices.getUserMedia = function(e) {
                            return t(e, function(e) {
                                return l(e).then(function(t) {
                                    if (e.audio && !t.getAudioTracks().length || e.video && !t.getVideoTracks().length)
                                        throw t.getTracks().forEach(function(e) {
                                            e.stop()
                                        }),
                                        new DOMException("", "NotFoundError");
                                    return t
                                }, function(e) {
                                    return Promise.reject(n(e))
                                })
                            })
                        }
                    } else
                        navigator.mediaDevices.getUserMedia = function(e) {
                            return i(e)
                        };

                    "undefined" == typeof navigator.mediaDevices.addEventListener && (navigator.mediaDevices.addEventListener = function() {
                        r("Dummy mediaDevices.addEventListener called.")
                    }),
                    "undefined" == typeof navigator.mediaDevices.removeEventListener && (navigator.mediaDevices.removeEventListener = function() {
                        r("Dummy mediaDevices.removeEventListener called.")
                    })
                }
            }, {
                "../utils.js": 50
            }
        ],
        45: [
            function(e, t, n) {
                "use strict";
                var r = e("sdp"),
                    s = e("../utils").browserDetails,
                    i = {
                        shimPeerConnection: function() {
                            if (window.RTCIceGatherer) {
                                window.RTCIceCandidate || (window.RTCIceCandidate = function(e) {
                                    return e
                                }),
                                window.RTCSessionDescription || (window.RTCSessionDescription = function(e) {
                                    return e
                                });
                                var e = Object.getOwnPropertyDescriptor(MediaStreamTrack.prototype, "enabled");
                                Object.defineProperty(MediaStreamTrack.prototype, "enabled", {
                                    set: function(t) {
                                        e.set.call(this, t);
                                        var n = new Event("enabled");
                                        n.enabled = t,
                                        this.dispatchEvent(n)
                                    }
                                })
                            }
                            window.RTCPeerConnection = function(e) {
                                var t = this,
                                    n = document.createDocumentFragment();
                                if (["addEventListener", "removeEventListener", "dispatchEvent"].forEach(function(e) {
                                    t[e] = n[e].bind(n)
                                }), this.onicecandidate = null, this.onaddstream = null, this.ontrack = null, this.onremovestream = null, this.onsignalingstatechange = null, this.oniceconnectionstatechange = null, this.onnegotiationneeded = null, this.ondatachannel = null, this.localStreams = [], this.remoteStreams = [], this.getLocalStreams = function() {
                                    return t.localStreams
                                },
                                this.getRemoteStreams = function() {
                                    return t.remoteStreams
                                },
                                this.localDescription = new RTCSessionDescription({type: "", sdp: ""}),
                                this.remoteDescription = new RTCSessionDescription({type: "", sdp: ""}),
                                this.signalingState = "stable",
                                this.iceConnectionState = "new",
                                this.iceGatheringState = "new",
                                this.iceOptions = {
                                    gatherPolicy: "all",
                                    iceServers: []
                                },
                                e && e.iceTransportPolicy)
                                    switch (e.iceTransportPolicy) {
                                        case "all":
                                        case "relay":
                                            this.iceOptions.gatherPolicy = e.iceTransportPolicy;
                                            break;
                                        case "none":
                                            throw new TypeError('iceTransportPolicy "none" not supported')
                                    }
                                if (this.usingBundle = e && "max-bundle" === e.bundlePolicy, e && e.iceServers) {
                                    var r = JSON.parse(JSON.stringify(e.iceServers));
                                    this.iceOptions.iceServers = r.filter(function(e) {
                                        if (e && e.urls) {
                                            var t = e.urls;
                                            return "string" == typeof t && (t = [t]),
                                            t = t.filter(function(e) {
                                                return 0 === e.indexOf("turn:") && e.indexOf("transport=udp") !== -1 && e.indexOf("turn:[") === -1 || 0 === e.indexOf("stun:") && s.version >= 14393
                                            })[0],
                                            !!t
                                        }
                                        return !1
                                    })
                                }
                                this._config = e,
                                this.transceivers = [],
                                this._localIceCandidatesBuffer = []
                            },
                            window.RTCPeerConnection.prototype._emitBufferedCandidates = function() {
                                var e = this,
                                    t = r.splitSections(e.localDescription.sdp);
                                this._localIceCandidatesBuffer.forEach(function(n) {
                                    var r = !n.candidate || 0 === Object.keys(n.candidate).length;
                                    if (r)
                                        for (var s = 1; s < t.length; s++)
                                            t[s].indexOf("\r\na=end-of-candidates\r\n") === -1 && (t[s] += "a=end-of-candidates\r\n");
                                else
                                        n.candidate.candidate.indexOf("typ endOfCandidates") === -1 && (t[n.candidate.sdpMLineIndex + 1] += "a=" + n.candidate.candidate + "\r\n");
                                    if (e.localDescription.sdp = t.join(""), e.dispatchEvent(n), null !== e.onicecandidate && e.onicecandidate(n), !n.candidate && "complete" !== e.iceGatheringState) {
                                        var i = e.transceivers.every(function(e) {
                                            return e.iceGatherer && "completed" === e.iceGatherer.state
                                        });
                                        i && (e.iceGatheringState = "complete")
                                    }
                                }),
                                this._localIceCandidatesBuffer = []
                            },
                            window.RTCPeerConnection.prototype.getConfiguration = function() {
                                return this._config
                            },
                            window.RTCPeerConnection.prototype.addStream = function(e) {
                                var t = e.clone();
                                e.getTracks().forEach(function(e, n) {
                                    var r = t.getTracks()[n];
                                    e.addEventListener("enabled", function(e) {
                                        r.enabled = e.enabled
                                    })
                                }),
                                this.localStreams.push(t),
                                this._maybeFireNegotiationNeeded()
                            },
                            window.RTCPeerConnection.prototype.removeStream = function(e) {
                                var t = this.localStreams.indexOf(e);
                                t > -1 && (this.localStreams.splice(t, 1), this._maybeFireNegotiationNeeded())
                            },
                            window.RTCPeerConnection.prototype.getSenders = function() {
                                return this.transceivers.filter(function(e) {
                                    return !!e.rtpSender
                                }).map(function(e) {
                                    return e.rtpSender
                                })
                            },
                            window.RTCPeerConnection.prototype.getReceivers = function() {
                                return this.transceivers.filter(function(e) {
                                    return !!e.rtpReceiver
                                }).map(function(e) {
                                    return e.rtpReceiver
                                })
                            },
                            window.RTCPeerConnection.prototype._getCommonCapabilities = function(e, t) {
                                var n = {
                                    codecs: [],
                                    headerExtensions: [],
                                    fecMechanisms: []
                                };
                                return e.codecs.forEach(function(e) {
                                    for (var r = 0; r < t.codecs.length; r++) {
                                        var s = t.codecs[r];
                                        if (e.name.toLowerCase() === s.name.toLowerCase() && e.clockRate === s.clockRate) {
                                            s.numChannels = Math.min(e.numChannels, s.numChannels),
                                            n.codecs.push(s),
                                            s.rtcpFeedback = s.rtcpFeedback.filter(function(t) {
                                                for (var n = 0; n < e.rtcpFeedback.length; n++)
                                                    if (e.rtcpFeedback[n].type === t.type && e.rtcpFeedback[n].parameter === t.parameter)
                                                        return !0;
                                            return !1
                                            });
                                            break
                                        }
                                    }
                                }),
                                e.headerExtensions.forEach(function(e) {
                                    for (var r = 0; r < t.headerExtensions.length; r++) {
                                        var s = t.headerExtensions[r];
                                        if (e.uri === s.uri) {
                                            n.headerExtensions.push(s);
                                            break
                                        }
                                    }
                                }),
                                n
                            },
                            window.RTCPeerConnection.prototype._createIceAndDtlsTransports = function(e, t) {
                                var n = this,
                                    s = new RTCIceGatherer(n.iceOptions),
                                    i = new RTCIceTransport(s);
                                s.onlocalcandidate = function(l) {
                                    var o = new Event("icecandidate");
                                    o.candidate = {
                                        sdpMid: e,
                                        sdpMLineIndex: t
                                    };
                                    var a = l.candidate,
                                        u = !a || 0 === Object.keys(a).length;
                                    u
                                        ? (void 0 === s.state && (s.state = "completed"), o.candidate.candidate = "candidate:1 1 udp 1 0.0.0.0 9 typ endOfCandidates")
                                        : (a.component = "RTCP" === i.component
                                            ? 2
                                            : 1, o.candidate.candidate = r.writeCandidate(a));
                                    var c = r.splitSections(n.localDescription.sdp);
                                    o.candidate.candidate.indexOf("typ endOfCandidates") === -1
                                        ? c[o.candidate.sdpMLineIndex + 1] += "a=" + o.candidate.candidate + "\r\n"
                                        : c[o.candidate.sdpMLineIndex + 1] += "a=end-of-candidates\r\n",
                                    n.localDescription.sdp = c.join("");
                                    var d = n.transceivers.every(function(e) {
                                        return e.iceGatherer && "completed" === e.iceGatherer.state
                                    });
                                    switch (n.iceGatheringState) {
                                        case "new":
                                            n._localIceCandidatesBuffer.push(o),
                                            u && d && n._localIceCandidatesBuffer.push(new Event("icecandidate"));
                                            break;
                                        case "gathering":
                                            n._emitBufferedCandidates(),
                                            n.dispatchEvent(o),
                                            null !== n.onicecandidate && n.onicecandidate(o),
                                            d && (n.dispatchEvent(new Event("icecandidate")), null !== n.onicecandidate && n.onicecandidate(new Event("icecandidate")), n.iceGatheringState = "complete");
                                            break;
                                        case "complete":
                                    }
                                },
                                i.onicestatechange = function() {
                                    n._updateConnectionState()
                                };
                                var l = new RTCDtlsTransport(i);
                                return l.ondtlsstatechange = function() {
                                    n._updateConnectionState()
                                },
                                l.onerror = function() {
                                    l.state = "failed",
                                    n._updateConnectionState()
                                }, {
                                    iceGatherer: s,
                                    iceTransport: i,
                                    dtlsTransport: l
                                }
                            },
                            window.RTCPeerConnection.prototype._transceive = function(e, t, n) {
                                var s = this._getCommonCapabilities(e.localCapabilities, e.remoteCapabilities);
                                t && e.rtpSender && (s.encodings = e.sendEncodingParameters, s.rtcp = {
                                    cname: r.localCName
                                }, e.recvEncodingParameters.length && (s.rtcp.ssrc = e.recvEncodingParameters[0].ssrc), e.rtpSender.send(s)),
                                n && e.rtpReceiver && ("video" === e.kind && e.recvEncodingParameters && e.recvEncodingParameters.forEach(function(e) {
                                    delete e.rtx
                                }), s.encodings = e.recvEncodingParameters, s.rtcp = {
                                    cname: e.cname
                                }, e.sendEncodingParameters.length && (s.rtcp.ssrc = e.sendEncodingParameters[0].ssrc), e.rtpReceiver.receive(s))
                            },
                            window.RTCPeerConnection.prototype.setLocalDescription = function(e) {
                                var t,
                                    n,
                                    s = this;
                                if ("offer" === e.type)
                                    this._pendingOffer && (t = r.splitSections(e.sdp), n = t.shift(), t.forEach(function(e, t) {
                                        var n = r.parseRtpParameters(e);
                                        s._pendingOffer[t].localCapabilities = n
                                    }), this.transceivers = this._pendingOffer, delete this._pendingOffer);
                                else if ("answer" === e.type) {
                                    t = r.splitSections(s.remoteDescription.sdp),
                                    n = t.shift();
                                    var i = r.matchPrefix(n, "a=ice-lite").length > 0;
                                    t.forEach(function(e, t) {
                                        var l = s.transceivers[t],
                                            o = l.iceGatherer,
                                            a = l.iceTransport,
                                            u = l.dtlsTransport,
                                            c = l.localCapabilities,
                                            d = l.remoteCapabilities,
                                            h = "0" === e.split("\n", 1)[0].split(" ", 2)[1];
                                        if (!h && !l.isDatachannel) {
                                            var p = r.getIceParameters(e, n);
                                            if (i) {
                                                var f = r.matchPrefix(e, "a=candidate:").map(function(e) {
                                                    return r.parseCandidate(e)
                                                }).filter(function(e) {
                                                    return "1" === e.component
                                                });
                                                f.length && a.setRemoteCandidates(f)
                                            }
                                            var m = r.getDtlsParameters(e, n);
                                            i && (m.role = "server"),
                                            s.usingBundle && 0 !== t || (a.start(o, p, i
                                                ? "controlling"
                                                : "controlled"), u.start(m));
                                            var g = s._getCommonCapabilities(c, d);
                                            s._transceive(l, g.codecs.length > 0, !1)
                                        }
                                    })
                                }
                                switch (this.localDescription = {
                                    type: e.type,
                                    sdp: e.sdp
                                }, e.type) {
                                    case "offer":
                                        this._updateSignalingState("have-local-offer");
                                        break;
                                    case "answer":
                                        this._updateSignalingState("stable");
                                        break;
                                    default:
                                        throw new TypeError('unsupported type "' + e.type + '"')
                                }
                                var l = arguments.length > 1 && "function" == typeof arguments[1];
                                if (l) {
                                    var o = arguments[1];
                                    window.setTimeout(function() {
                                        o(),
                                        "new" === s.iceGatheringState && (s.iceGatheringState = "gathering"),
                                        s._emitBufferedCandidates()
                                    }, 0)
                                }
                                var a = Promise.resolve();
                                return a.then(function() {
                                    l || ("new" === s.iceGatheringState && (s.iceGatheringState = "gathering"), window.setTimeout(s._emitBufferedCandidates.bind(s), 500))
                                }),
                                a
                            },
                            window.RTCPeerConnection.prototype.setRemoteDescription = function(e) {
                                var t = this,
                                    n = new MediaStream,
                                    s = [],
                                    i = r.splitSections(e.sdp),
                                    l = i.shift(),
                                    o = r.matchPrefix(l, "a=ice-lite").length > 0;
                                switch (this.usingBundle = r.matchPrefix(l, "a=group:BUNDLE ").length > 0, i.forEach(function(i, a) {
                                    var u = r.splitLines(i),
                                        c = u[0].substr(2).split(" "),
                                        d = c[0],
                                        h = "0" === c[1],
                                        p = r.getDirection(i, l),
                                        f = r.matchPrefix(i, "a=mid:");
                                    if (f = f.length
                                        ? f[0].substr(6)
                                        : r.generateIdentifier(), "application" === d && "DTLS/SCTP" === c[2])
                                        return void(t.transceivers[a] = {
                                            mid: f,
                                            isDatachannel: !0
                                        });
                                    var m,
                                        g,
                                        v,
                                        T,
                                        _,
                                        C,
                                        S,
                                        E,
                                        y,
                                        A,
                                        R,
                                        w,
                                        b = r.parseRtpParameters(i);
                                    h || (R = r.getIceParameters(i, l), w = r.getDtlsParameters(i, l), w.role = "client"),
                                    E = r.parseRtpEncodingParameters(i);
                                    var I,
                                        N = r.matchPrefix(i, "a=ssrc:").map(function(e) {
                                            return r.parseSsrcMedia(e)
                                        }).filter(function(e) {
                                            return "cname" === e.attribute
                                        })[0];
                                    N && (I = N.value);
                                    var O = r.matchPrefix(i, "a=end-of-candidates", l).length > 0,
                                        x = r.matchPrefix(i, "a=candidate:").map(function(e) {
                                            return r.parseCandidate(e)
                                        }).filter(function(e) {
                                            return "1" === e.component
                                        });
                                    if ("offer" !== e.type || h)
                                        "answer" !== e.type || h || (m = t.transceivers[a], g = m.iceGatherer, v = m.iceTransport, T = m.dtlsTransport, _ = m.rtpSender, C = m.rtpReceiver, S = m.sendEncodingParameters, y = m.localCapabilities, t.transceivers[a].recvEncodingParameters = E, t.transceivers[a].remoteCapabilities = b, t.transceivers[a].cname = I, (o || O) && x.length && v.setRemoteCandidates(x), t.usingBundle && 0 !== a || (v.start(g, R, "controlling"), T.start(w)), t._transceive(m, "sendrecv" === p || "recvonly" === p, "sendrecv" === p || "sendonly" === p), !C || "sendrecv" !== p && "sendonly" !== p
                                            ? delete m.rtpReceiver
                                            : (A = C.track, s.push([A, C]), n.addTrack(A)));
                                    else {
                                        var D = t.usingBundle && a > 0
                                            ? {
                                                iceGatherer: t.transceivers[0].iceGatherer,
                                                iceTransport: t.transceivers[0].iceTransport,
                                                dtlsTransport: t.transceivers[0].dtlsTransport
                                            }
                                            : t._createIceAndDtlsTransports(f, a);
                                        if (O && D.iceTransport.setRemoteCandidates(x), y = RTCRtpReceiver.getCapabilities(d), y.codecs = y.codecs.filter(function(e) {
                                            return "rtx" !== e.name
                                        }), S = [
                                            {
                                                ssrc: 1001 *(2 * a + 2)
                                            }
                                        ], C = new RTCRtpReceiver(D.dtlsTransport, d), A = C.track, s.push([A, C]), n.addTrack(A), t.localStreams.length > 0 && t.localStreams[0].getTracks().length >= a) {
                                            var P;
                                            "audio" === d
                                                ? P = t.localStreams[0].getAudioTracks()[0]
                                                : "video" === d && (P = t.localStreams[0].getVideoTracks()[0]),
                                            P && (_ = new RTCRtpSender(P, D.dtlsTransport))
                                        }
                                        t.transceivers[a] = {
                                            iceGatherer: D.iceGatherer,
                                            iceTransport: D.iceTransport,
                                            dtlsTransport: D.dtlsTransport,
                                            localCapabilities: y,
                                            remoteCapabilities: b,
                                            rtpSender: _,
                                            rtpReceiver: C,
                                            kind: d,
                                            mid: f,
                                            cname: I,
                                            sendEncodingParameters: S,
                                            recvEncodingParameters: E
                                        },
                                        t._transceive(t.transceivers[a], !1, "sendrecv" === p || "sendonly" === p)
                                    }
                                }), this.remoteDescription = {
                                    type: e.type,
                                    sdp: e.sdp
                                }, e.type) {
                                    case "offer":
                                        this._updateSignalingState("have-remote-offer");
                                        break;
                                    case "answer":
                                        this._updateSignalingState("stable");
                                        break;
                                    default:
                                        throw new TypeError('unsupported type "' + e.type + '"')
                                }
                                return n.getTracks().length && (t.remoteStreams.push(n), window.setTimeout(function() {
                                    var e = new Event("addstream");
                                    e.stream = n,
                                    t.dispatchEvent(e),
                                    null !== t.onaddstream && window.setTimeout(function() {
                                        t.onaddstream(e)
                                    }, 0),
                                    s.forEach(function(r) {
                                        var s = r[0],
                                            i = r[1],
                                            l = new Event("track");
                                        l.track = s,
                                        l.receiver = i,
                                        l.streams = [n],
                                        t.dispatchEvent(e),
                                        null !== t.ontrack && window.setTimeout(function() {
                                            t.ontrack(l)
                                        }, 0)
                                    })
                                }, 0)),
                                arguments.length > 1 && "function" == typeof arguments[1] && window.setTimeout(arguments[1], 0),
                                Promise.resolve()
                            },
                            window.RTCPeerConnection.prototype.close = function() {
                                this.transceivers.forEach(function(e) {
                                    e.iceTransport && e.iceTransport.stop(),
                                    e.dtlsTransport && e.dtlsTransport.stop(),
                                    e.rtpSender && e.rtpSender.stop(),
                                    e.rtpReceiver && e.rtpReceiver.stop()
                                }),
                                this._updateSignalingState("closed")
                            },
                            window.RTCPeerConnection.prototype._updateSignalingState = function(e) {
                                this.signalingState = e;
                                var t = new Event("signalingstatechange");
                                this.dispatchEvent(t),
                                null !== this.onsignalingstatechange && this.onsignalingstatechange(t)
                            },
                            window.RTCPeerConnection.prototype._maybeFireNegotiationNeeded = function() {
                                var e = new Event("negotiationneeded");
                                this.dispatchEvent(e),
                                null !== this.onnegotiationneeded && this.onnegotiationneeded(e)
                            },
                            window.RTCPeerConnection.prototype._updateConnectionState = function() {
                                var e,
                                    t = this,
                                    n = {
                                        new: 0,
                                        closed: 0,
                                        connecting: 0,
                                        checking: 0,
                                        connected: 0,
                                        completed: 0,
                                        failed: 0
                                    };
                                if (this.transceivers.forEach(function(e) {
                                    n[e.iceTransport.state]++,
                                    n[e.dtlsTransport.state]++
                                }), n.connected += n.completed, e = "new", n.failed > 0
                                    ? e = "failed"
                                    : n.connecting > 0 || n.checking > 0
                                        ? e = "connecting"
                                        : n.disconnected > 0
                                            ? e = "disconnected"
                                            : n.new > 0
                                                ? e = "new"
                                                : (n.connected > 0 || n.completed > 0) && (e = "connected"), e !== t.iceConnectionState) {
                                    t.iceConnectionState = e;
                                    var r = new Event("iceconnectionstatechange");
                                    this.dispatchEvent(r),
                                    null !== this.oniceconnectionstatechange && this.oniceconnectionstatechange(r)
                                }
                            },
                            window.RTCPeerConnection.prototype.createOffer = function() {
                                var e = this;
                                if (this._pendingOffer)
                                    throw new Error("createOffer called while there is a pending offer.");
                                var t;
                                1 === arguments.length && "function" != typeof arguments[0]
                                    ? t = arguments[0]
                                    : 3 === arguments.length && (t = arguments[2]);
                                var n = [],
                                    s = 0,
                                    i = 0;
                                if (this.localStreams.length && (s = this.localStreams[0].getAudioTracks().length, i = this.localStreams[0].getVideoTracks().length), t) {
                                    if (t.mandatory || t.optional)
                                        throw new TypeError("Legacy mandatory/optional constraints not supported.");
                                    void 0 !== t.offerToReceiveAudio && (s = t.offerToReceiveAudio),
                                    void 0 !== t.offerToReceiveVideo && (i = t.offerToReceiveVideo)
                                }
                                for (this.localStreams.length && this.localStreams[0].getTracks().forEach(function(e) {
                                    n.push({
                                        kind: e.kind,
                                        track: e,
                                        wantReceive: "audio" === e.kind
                                            ? s > 0
                                            : i > 0
                                    }),
                                    "audio" === e.kind
                                        ? s--
                                        : "video" === e.kind && i--
                                }); s > 0 || i > 0;)
                                    s > 0 && (n.push({
                                        kind: "audio",
                                        wantReceive: !0
                                    }), s--),
                                    i > 0 && (n.push({
                                        kind: "video",
                                        wantReceive: !0
                                    }), i--);
                                var l = r.writeSessionBoilerplate(),
                                    o = [];
                                n.forEach(function(t, n) {
                                    var s = t.track,
                                        i = t.kind,
                                        l = r.generateIdentifier(),
                                        a = e.usingBundle && n > 0
                                            ? {
                                                iceGatherer: o[0].iceGatherer,
                                                iceTransport: o[0].iceTransport,
                                                dtlsTransport: o[0].dtlsTransport
                                            }
                                            : e._createIceAndDtlsTransports(l, n),
                                        u = RTCRtpSender.getCapabilities(i);
                                    u.codecs = u.codecs.filter(function(e) {
                                        return "rtx" !== e.name
                                    }),
                                    u.codecs.forEach(function(e) {
                                        "H264" === e.name && void 0 === e.parameters["level-asymmetry-allowed"] && (e.parameters["level-asymmetry-allowed"] = "1")
                                    });
                                    var c,
                                        d,
                                        h = [
                                            {
                                                ssrc: 1001 *(2 * n + 1)
                                            }
                                        ];
                                    s && (c = new RTCRtpSender(s, a.dtlsTransport)),
                                    t.wantReceive && (d = new RTCRtpReceiver(a.dtlsTransport, i)),
                                    o[n] = {
                                        iceGatherer: a.iceGatherer,
                                        iceTransport: a.iceTransport,
                                        dtlsTransport: a.dtlsTransport,
                                        localCapabilities: u,
                                        remoteCapabilities: null,
                                        rtpSender: c,
                                        rtpReceiver: d,
                                        kind: i,
                                        mid: l,
                                        sendEncodingParameters: h,
                                        recvEncodingParameters: null
                                    }
                                }),
                                this.usingBundle && (l += "a=group:BUNDLE " + o.map(function(e) {
                                    return e.mid
                                }).join(" ") + "\r\n"),
                                n.forEach(function(t, n) {
                                    var s = o[n];
                                    l += r.writeMediaSection(s, s.localCapabilities, "offer", e.localStreams[0])
                                }),
                                this._pendingOffer = o;
                                var a = new RTCSessionDescription({type: "offer", sdp: l});
                                return arguments.length && "function" == typeof arguments[0] && window.setTimeout(arguments[0], 0, a),
                                Promise.resolve(a)
                            },
                            window.RTCPeerConnection.prototype.createAnswer = function() {
                                var e = this,
                                    t = r.writeSessionBoilerplate();
                                this.usingBundle && (t += "a=group:BUNDLE " + this.transceivers.map(function(e) {
                                    return e.mid
                                }).join(" ") + "\r\n"),
                                this.transceivers.forEach(function(n) {
                                    if (n.isDatachannel)
                                        return void(t += "m=application 0 DTLS/SCTP 5000\r\nc=IN IP4 0.0.0.0\r\na=mid:" + n.mid + "\r\n");
                                    var s = e._getCommonCapabilities(n.localCapabilities, n.remoteCapabilities);
                                    t += r.writeMediaSection(n, s, "answer", e.localStreams[0])
                                });
                                var n = new RTCSessionDescription({type: "answer", sdp: t});
                                return arguments.length && "function" == typeof arguments[0] && window.setTimeout(arguments[0], 0, n),
                                Promise.resolve(n)
                            },
                            window.RTCPeerConnection.prototype.addIceCandidate = function(e) {
                                if (e) {
                                    var t = e.sdpMLineIndex;
                                    if (e.sdpMid)
                                        for (var n = 0; n < this.transceivers.length; n++)
                                            if (this.transceivers[n].mid === e.sdpMid) {
                                                t = n;
                                                break
                                            }
                                        var s = this.transceivers[t];
                                    if (s) {
                                        var i = Object.keys(e.candidate).length > 0
                                            ? r.parseCandidate(e.candidate)
                                            : {};
                                        if ("tcp" === i.protocol && (0 === i.port || 9 === i.port))
                                            return;
                                        if ("1" !== i.component)
                                            return;

                                        "endOfCandidates" === i.type && (i = {}),
                                        s.iceTransport.addRemoteCandidate(i);
                                        var l = r.splitSections(this.remoteDescription.sdp);
                                        l[t + 1] += (i.type
                                            ? e.candidate.trim()
                                            : "a=end-of-candidates") + "\r\n",
                                        this.remoteDescription.sdp = l.join("")
                                    }
                                } else
                                    this.transceivers.forEach(function(e) {
                                        e.iceTransport.addRemoteCandidate({})
                                    });
                                return arguments.length > 1 && "function" == typeof arguments[1] && window.setTimeout(arguments[1], 0),
                                Promise.resolve()
                            },
                            window.RTCPeerConnection.prototype.getStats = function() {
                                var e = [];
                                this.transceivers.forEach(function(t) {
                                    ["rtpSender", "rtpReceiver", "iceGatherer", "iceTransport", "dtlsTransport"].forEach(function(n) {
                                        t[n] && e.push(t[n].getStats())
                                    })
                                });
                                var t = arguments.length > 1 && "function" == typeof arguments[1] && arguments[1];
                                return new Promise(function(n) {
                                    var r = new Map;
                                    Promise.all(e).then(function(e) {
                                        e.forEach(function(e) {
                                            Object.keys(e).forEach(function(t) {
                                                r.set(t, e[t]),
                                                r[t] = e[t]
                                            })
                                        }),
                                        t && window.setTimeout(t, 0, r),
                                        n(r)
                                    })
                                })
                            }
                        }
                    };
                t.exports = {
                    shimPeerConnection: i.shimPeerConnection,
                    shimGetUserMedia: e("./getusermedia")
                }
            }, {
                "../utils": 50,
                "./getusermedia": 46,
                sdp: 41
            }
        ],
        46: [
            function(e, t, n) {
                "use strict";
                t.exports = function() {
                    var e = function(e) {
                            return {
                                name: {
                                    PermissionDeniedError: "NotAllowedError"
                                }[e.name] || e.name,
                                message: e.message,
                                constraint: e.constraint,
                                toString: function() {
                                    return this.name
                                }
                            }
                        },
                        t = navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);
                    navigator.mediaDevices.getUserMedia = function(n) {
                        return t(n).catch(function(t) {
                            return Promise.reject(e(t))
                        })
                    }
                }
            }, {}
        ],
        47: [
            function(e, t, n) {
                "use strict";
                var r = e("../utils").browserDetails,
                    s = {
                        shimOnTrack: function() {
                            "object" != typeof window || !window.RTCPeerConnection || "ontrack" in window.RTCPeerConnection.prototype || Object.defineProperty(window.RTCPeerConnection.prototype, "ontrack", {
                                get: function() {
                                    return this._ontrack
                                },
                                set: function(e) {
                                    this._ontrack && (this.removeEventListener("track", this._ontrack), this.removeEventListener("addstream", this._ontrackpoly)),
                                    this.addEventListener("track", this._ontrack = e),
                                    this.addEventListener("addstream", this._ontrackpoly = function(e) {
                                        e.stream.getTracks().forEach(function(t) {
                                            var n = new Event("track");
                                            n.track = t,
                                            n.receiver = {
                                                track: t
                                            },
                                            n.streams = [e.stream],
                                            this.dispatchEvent(n)
                                        }.bind(this))
                                    }.bind(this))
                                }
                            })
                        },
                        shimSourceObject: function() {
                            "object" == typeof window && (!window.HTMLMediaElement || "srcObject" in window.HTMLMediaElement.prototype || Object.defineProperty(window.HTMLMediaElement.prototype, "srcObject", {
                                get: function() {
                                    return this.mozSrcObject
                                },
                                set: function(e) {
                                    this.mozSrcObject = e
                                }
                            }))
                        },
                        shimPeerConnection: function() {
                            if ("object" == typeof window && (window.RTCPeerConnection || window.mozRTCPeerConnection)) {
                                window.RTCPeerConnection || (window.RTCPeerConnection = function(e, t) {
                                    if (r.version < 38 && e && e.iceServers) {
                                        for (var n = [], s = 0; s < e.iceServers.length; s++) {
                                            var i = e.iceServers[s];
                                            if (i.hasOwnProperty("urls"))
                                                for (var l = 0; l < i.urls.length; l++) {
                                                    var o = {
                                                        url: i.urls[l]
                                                    };
                                                    0 === i.urls[l].indexOf("turn") && (o.username = i.username, o.credential = i.credential),
                                                    n.push(o)
                                                } else
                                                    n.push(e.iceServers[s])
                                        }
                                        e.iceServers = n
                                    }
                                    return new mozRTCPeerConnection(e, t)
                                },
                                window.RTCPeerConnection.prototype = mozRTCPeerConnection.prototype,
                                mozRTCPeerConnection.generateCertificate && Object.defineProperty(window.RTCPeerConnection, "generateCertificate", {
                                    get: function() {
                                        return mozRTCPeerConnection.generateCertificate
                                    }
                                }),
                                window.RTCSessionDescription = mozRTCSessionDescription,
                                window.RTCIceCandidate = mozRTCIceCandidate),
                                ["setLocalDescription", "setRemoteDescription", "addIceCandidate"].forEach(function(e) {
                                    var t = RTCPeerConnection.prototype[e];
                                    RTCPeerConnection.prototype[e] = function() {
                                        return arguments[0] = new("addIceCandidate" === e
                                            ? RTCIceCandidate
                                            : RTCSessionDescription)(arguments[0]),
                                        t.apply(this, arguments)
                                    }
                                });
                                var e = RTCPeerConnection.prototype.addIceCandidate;
                                if (RTCPeerConnection.prototype.addIceCandidate = function() {
                                    return arguments[0]
                                        ? e.apply(this, arguments)
                                        : (arguments[1] && arguments[1].apply(null), Promise.resolve())
                                },
                                r.version < 48) {
                                    var t = function(e) {
                                            var t = new Map;
                                            return Object.keys(e).forEach(function(n) {
                                                t.set(n, e[n]),
                                                t[n] = e[n]
                                            }),
                                            t
                                        },
                                        n = RTCPeerConnection.prototype.getStats;
                                    RTCPeerConnection.prototype.getStats = function(e, r, s) {
                                        return n.apply(this, [e || null]).then(function(e) {
                                            return t(e)
                                        }).then(r, s)
                                    }
                                }
                            }
                        }
                    };
                t.exports = {
                    shimOnTrack: s.shimOnTrack,
                    shimSourceObject: s.shimSourceObject,
                    shimPeerConnection: s.shimPeerConnection,
                    shimGetUserMedia: e("./getusermedia")
                }
            }, {
                "../utils": 50,
                "./getusermedia": 48
            }
        ],
        48: [
            function(e, t, n) {
                "use strict";
                var r = e("../utils").log,
                    s = e("../utils").browserDetails;
                t.exports = function() {
                    var e = function(e) {
                            return {
                                name: {
                                    SecurityError: "NotAllowedError",
                                    PermissionDeniedError: "NotAllowedError"
                                }[e.name] || e.name,
                                message: {
                                    "The operation is insecure.": "The request is not allowed by the user agent or the platform in the current context."
                                }[e.message] || e.message,
                                constraint: e.constraint,
                                toString: function() {
                                    return this.name + (this.message && ": ") + this.message
                                }
                            }
                        },
                        t = function(t, n, i) {
                            var l = function(e) {
                                if ("object" != typeof e || e.require)
                                    return e;
                                var t = [];
                                return Object.keys(e).forEach(function(n) {
                                    if ("require" !== n && "advanced" !== n && "mediaSource" !== n) {
                                        var r = e[n] = "object" == typeof e[n]
                                            ? e[n]
                                            : {
                                                ideal: e[n]
                                            };
                                        if (void 0 === r.min && void 0 === r.max && void 0 === r.exact || t.push(n), void 0 !== r.exact && ("number" == typeof r.exact
                                            ? r.min = r.max = r.exact
                                            : e[n] = r.exact, delete r.exact), void 0 !== r.ideal) {
                                            e.advanced = e.advanced || [];
                                            var s = {};
                                            "number" == typeof r.ideal
                                                ? s[n] = {
                                                    min: r.ideal,
                                                    max: r.ideal
                                                }
                                                : s[n] = r.ideal,
                                            e.advanced.push(s),
                                            delete r.ideal,
                                            Object.keys(r).length || delete e[n]
                                        }
                                    }
                                }),
                                t.length && (e.require = t),
                                e
                            };
                            return t = JSON.parse(JSON.stringify(t)),
                            s.version < 38 && (r("spec: " + JSON.stringify(t)), t.audio && (t.audio = l(t.audio)), t.video && (t.video = l(t.video)), r("ff37: " + JSON.stringify(t))),
                            navigator.mozGetUserMedia(t, n, function(t) {
                                i(e(t))
                            })
                        },
                        n = function(e) {
                            return new Promise(function(n, r) {
                                t(e, n, r)
                            })
                        };
                    if (navigator.mediaDevices || (navigator.mediaDevices = {
                        getUserMedia: n,
                        addEventListener: function() {},
                        removeEventListener: function() {}
                    }), navigator.mediaDevices.enumerateDevices = navigator.mediaDevices.enumerateDevices || function() {
                        return new Promise(function(e) {
                            var t = [
                                {
                                    kind: "audioinput",
                                    deviceId: "default",
                                    label: "",
                                    groupId: ""
                                }, {
                                    kind: "videoinput",
                                    deviceId: "default",
                                    label: "",
                                    groupId: ""
                                }
                            ];
                            e(t)
                        })
                    },
                    s.version < 41) {
                        var i = navigator.mediaDevices.enumerateDevices.bind(navigator.mediaDevices);
                        navigator.mediaDevices.enumerateDevices = function() {
                            return i().then(void 0, function(e) {
                                if ("NotFoundError" === e.name)
                                    return [];
                                throw e
                            })
                        }
                    }
                    if (s.version < 49) {
                        var l = navigator.mediaDevices.getUserMedia.bind(navigator.mediaDevices);
                        navigator.mediaDevices.getUserMedia = function(t) {
                            return l(t).then(function(e) {
                                if (t.audio && !e.getAudioTracks().length || t.video && !e.getVideoTracks().length)
                                    throw e.getTracks().forEach(function(e) {
                                        e.stop()
                                    }),
                                    new DOMException("The object can not be found here.", "NotFoundError");
                                return e
                            }, function(t) {
                                return Promise.reject(e(t))
                            })
                        }
                    }
                    navigator.getUserMedia = function(e, n, r) {
                        return s.version < 44
                            ? t(e, n, r)
                            : (console.warn("navigator.getUserMedia has been replaced by navigator.mediaDevices.getUserMedia"), void navigator.mediaDevices.getUserMedia(e).then(n, r))
                    }
                }
            }, {
                "../utils": 50
            }
        ],
        49: [
            function(e, t, n) {
                "use strict";
                var r = {
                    shimGetUserMedia: function() {
                        navigator.getUserMedia = navigator.webkitGetUserMedia
                    }
                };
                t.exports = {
                    shimGetUserMedia: r.shimGetUserMedia
                }
            }, {}
        ],
        50: [
            function(e, t, n) {
                "use strict";
                var r = !0,
                    s = {
                        disableLog: function(e) {
                            return "boolean" != typeof e
                                ? new Error("Argument type: " + typeof e + ". Please use a boolean.")
                                : (r = e, e
                                    ? "adapter.js logging disabled"
                                    : "adapter.js logging enabled")
                        },
                        log: function() {
                            if ("object" == typeof window) {
                                if (r)
                                    return;

                                "undefined" != typeof console && "function" == typeof console.log && console.log.apply(console, arguments)
                            }
                        },
                        extractVersion: function(e, t, n) {
                            var r = e.match(t);
                            return r && r.length >= n && parseInt(r[n], 10)
                        },
                        detectBrowser: function() {
                            var e = {};
                            if (e.browser = null, e.version = null, "undefined" == typeof window || !window.navigator)
                                return e.browser = "Not a browser.",
                                e;
                            if (navigator.mozGetUserMedia)
                                e.browser = "firefox",
                                e.version = this.extractVersion(navigator.userAgent, /Firefox\/([0-9]+)\./, 1);
                            else if (navigator.webkitGetUserMedia)
                                if (window.webkitRTCPeerConnection)
                                    e.browser = "chrome",
                                    e.version = this.extractVersion(navigator.userAgent, /Chrom(e|ium)\/([0-9]+)\./, 2);
                                else {
                                    if (!navigator.userAgent.match(/Version\/(\d+).(\d+)/))
                                        return e.browser = "Unsupported webkit-based browser with GUM support but no WebRTC support.",
                                        e;
                                    e.browser = "safari",
                                    e.version = this.extractVersion(navigator.userAgent, /AppleWebKit\/([0-9]+)\./, 1)
                                }
                            else {
                                if (!navigator.mediaDevices || !navigator.userAgent.match(/Edge\/(\d+).(\d+)$/))
                                    return e.browser = "Not a supported browser.",
                                    e;
                                e.browser = "edge",
                                e.version = this.extractVersion(navigator.userAgent, /Edge\/(\d+).(\d+)$/, 2)
                            }
                            return e
                        }
                    };
                t.exports = {
                    log: s.log,
                    disableLog: s.disableLog,
                    browserDetails: s.detectBrowser(),
                    extractVersion: s.extractVersion
                }
            }, {}
        ],
        51: [
            function(e, t, n) {
                t.exports = {
                    name: "jssip",
                    title: "JsSIP",
                    description: "the Javascript SIP library",
                    version: "3.0.13",
                    homepage: "http://jssip.net",
                    author: "José Luis Millán <jmillan@aliax.net> (https://github.com/jmillan)",
                    contributors: [
                        "Iñaki Baz Castillo <ibc@aliax.net> (https://github.com/ibc)", "Saúl Ibarra Corretgé <saghul@gmail.com> (https://github.com/saghul)"
                    ],
                    main: "lib/JsSIP.js",
                    keywords: [
                        "sip",
                        "websocket",
                        "webrtc",
                        "node",
                        "browser",
                        "library"
                    ],
                    license: "MIT",
                    repository: {
                        type: "git",
                        url: "https://github.com/versatica/JsSIP.git"
                    },
                    bugs: {
                        url: "https://github.com/versatica/JsSIP/issues"
                    },
                    dependencies: {
                        debug: "^2.6.8",
                        "sdp-transform": "^2.3.0",
                        "webrtc-adapter": "^3.4.3"
                    },
                    devDependencies: {
                        browserify: "^14.3.0",
                        gulp: "git+https://github.com/gulpjs/gulp.git#4.0",
                        "gulp-expect-file": "0.0.7",
                        "gulp-header": "1.8.8",
                        "gulp-jshint": "^2.0.4",
                        "gulp-nodeunit-runner": "^0.2.2",
                        "gulp-rename": "^1.2.2",
                        "gulp-uglify": "^3.0.0",
                        "gulp-util": "^3.0.8",
                        jshint: "^2.9.4",
                        "jshint-stylish": "^2.2.1",
                        pegjs: "0.7.0",
                        "vinyl-buffer": "^1.0.0",
                        "vinyl-source-stream": "^1.1.0"
                    },
                    scripts: {
                        test: "gulp test"
                    }
                }
            }, {}
        ]
    }, {}, [7])(7)
});
